// (setq c-basic-offset 4)

#include "clsFilterBase.h"
#include "clsFilterBG.h"
#include "clsFilterCtrl.h"
#include "clsFilterObject.h"
#include "clsFilterStick.h"

#include "../CONFITEM/clsConfItem.h"
#include "../UNDO/clsUndoManager.h"
#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../../clsMain.h"
#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#include "../COMMON/CommonDefinitions.h"

#include "../../wxWidgetEnumMenu.h"

FilterGUI_cls::
FilterGUI_cls(FilterBase_cls *pCParent){
    mpCParentBase = pCParent;
    mpCMNumPanel = NULL;
}

FilterGUI_cls::
~FilterGUI_cls(){
}

MultiInputPanel_cls* FilterGUI_cls::
InitializeMInputCommon(wxWindow *pCParentWindow, wxString strCustomName){
    mpCMNumPanel = new MultiInputPanel_cls(&mpCMNumPanel, pCParentWindow);

    MultiInputPanel_cls* pCurr = mpCMNumPanel;
    pCurr->mbPanelOpen = mpCParentBase->mpCData->mCbGUIPanelOpen.mbBody;
    pCurr->mUpdateBit = _COMMAND_UPDATE_DISPLAY_GL;
    //pCurr->mpCUserDef = this;
    pCurr->mUndoType = _MN_UNDO_MANUAL; 
    pCurr->mpCTgtFilterCtrlLink = mpCParentBase->mpCParentCtrl;
    
    pCurr->mItemWidth = -1;
    int boxWidth = 2;
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParentBase->GetPCData()->mCbValid.mbBody);
    pCurr->GetLastItem().mItemWidth = 16;
    wxString strMark = wxT("[+]");
    pCurr->CombinePointerButton(btnPanelHide, strMark + strCustomName);

    return pCurr;
}

std::vector < int > FilterGUI_cls::
SetMNumBasic(MultiInputPanel_cls  *pCurr,  FilterData_cls *pCData, std::vector < bool > VbValid){
    if (VbValid.size() == 0){
	for (int i = 0; i < 3; i++) VbValid.push_back(TRUE);
    }
    std::vector < int > VIndex;
	
    int boxWidth = 3;
    pCurr->mTextWidth = 20;
    pCurr->mItemWidth = 82;
    pCurr->mUndoType = _MN_UNDO_MANUAL;

    if (VbValid[0] == TRUE){
	int indexTranslate = pCurr->CombinePointer
	    (_ITEM_BOXSIZERHORIZONTAL, &boxWidth, wxT("T"));
	pCurr->CombinePointer(_ITEM_DOUBLE, &(pCData->mpCTranslate->mVCParam[X].mInterpolatedValue));
	pCurr->CombinePointer(_ITEM_DOUBLE, &(pCData->mpCTranslate->mVCParam[Y].mInterpolatedValue));
	pCurr->CombinePointer(_ITEM_DOUBLE, &(pCData->mpCTranslate->mVCParam[Z].mInterpolatedValue));
	VIndex.push_back(indexTranslate);
    }
    
    if (VbValid[1] == TRUE){
	int indexRotation = pCurr->CombinePointer
	    (_ITEM_BOXSIZERHORIZONTAL, &boxWidth, wxT("R"));
	pCurr->CombinePointer(_ITEM_DOUBLE, &(pCData->mpCRotation->mVCParam[X].mInterpolatedValue));
	pCurr->CombinePointer(_ITEM_DOUBLE, &(pCData->mpCRotation->mVCParam[Y].mInterpolatedValue));
	pCurr->CombinePointer(_ITEM_DOUBLE, &(pCData->mpCRotation->mVCParam[Z].mInterpolatedValue));
	VIndex.push_back(indexRotation);
    }
     
    if (VbValid[2] == TRUE){
	int indexScale = pCurr->CombinePointer
	    (_ITEM_BOXSIZERHORIZONTAL, &boxWidth, wxT("S"));
	pCurr->CombinePointer(_ITEM_DOUBLE, &pCData->mpCScale->mVCParam[X].mInterpolatedValue);
	pCurr->CombinePointer(_ITEM_DOUBLE, &pCData->mpCScale->mVCParam[Y].mInterpolatedValue);
	pCurr->CombinePointer(_ITEM_DOUBLE, &pCData->mpCScale->mVCParam[Z].mInterpolatedValue);
	VIndex.push_back(indexScale);
    }
    return VIndex;
}

void FilterGUI_cls::
SetHookBasic(MultiInputPanel_cls  *pCurr){
    pCurr->SetFuncHook(FilterGUI_cls::FuncHookAssign, _HOOK_CHANGE, -1, FALSE, this);
    pCurr->SetFuncHook(FilterGUI_cls::FuncHookHideButton, _HOOK_BUTTON, 2, FALSE, this);
    pCurr->SetFuncHook(FilterGUI_cls::FuncHookMouse, _HOOK_MOUSE, -1, FALSE, this);
    pCurr->SetFuncHook(FilterGUI_cls::FuncHookClick, _HOOK_PANELCLICK, -1);
    pCurr->SetFuncHook(FilterGUI_cls::FuncHookCheckBox, _HOOK_CHECKBOX, -1);
}

void FilterGUI_cls::
UpdateButtonName(){
    ((wxButton*)mpCMNumPanel->mVCItemList[2].GetPCwxWindow())->
	SetLabel(mpCParentBase->GetPCData()->mCstrCustomName.mstrBody);
}

void FilterGUI_cls::
ProcHideButton(){
    MultiInputPanel_cls* pCurr = mpCMNumPanel;
    pCurr->TogglePanelOpenStatus(3);
    mpCParentBase->mpCData->mCbGUIPanelOpen.mbBody = pCurr->mbPanelOpen;
    if (pCurr->mbPanelOpen == TRUE) mpCParentBase->CallHideAndShow();
    SendEventToTop(pCurr, wxEVT_COMMAND_MENU_SELECTED, menuFilterResize);
}

void FilterGUI_cls::
HideAndShowBegin(){
    mpCMNumPanel->Freeze();
}

void FilterGUI_cls::
HideAndShowEnd(){
    mpCMNumPanel->Layout();
    mpCMNumPanel->Thaw();
    SendEventToTop(mpCMNumPanel, wxEVT_COMMAND_MENU_SELECTED, menuFilterResize);
}

void FilterGUI_cls::
FuncHookHideButton(void *pUsrDef, void *pArg){
    FilterGUI_cls *pCThis = (FilterGUI_cls*)pUsrDef;
    pCThis->ProcHideButton();
}

void FilterGUI_cls::
FuncHookMouse(void *pUsrDef, void *pEvent){
    FilterGUI_cls *pCThis = (FilterGUI_cls*)pUsrDef;
    wxMouseEvent event = *(wxMouseEvent*)pEvent;
    
    if (event.LeftDown() == TRUE || event.RightDown() == TRUE){
	pCThis->mpCParentBase->mpCParentCtrl->mspCParentMainLink->
	    SelectFilter(pCThis->mpCParentBase);
    }

    if (event.RightDown() == TRUE){
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuFilterManipulate);
	wxGetTopLevelParent(pCThis->mpCMNumPanel)->AddPendingEvent(com);
    }
}

void FilterGUI_cls::
FuncHookAssign(void *pUsrDef, void *pArg){
    FilterGUI_cls *pCThis = (FilterGUI_cls*)pUsrDef;
    pCThis->mpCParentBase->GetPCData()->AssignSceneObjParam();
}

void FilterGUI_cls::
FuncHookClick(void *pPanel, void *pArg){
    MultiInputPanel_cls *pCurr = (MultiInputPanel_cls*)pPanel;
    pCurr->UpdateValues();

    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshGL);
    wxGetTopLevelParent(pCurr)->AddPendingEvent(com);
}

void FilterGUI_cls::
FuncHookCheckBox(void *pPanel, void *pArg){
    MultiInputPanel_cls *pCurr = (MultiInputPanel_cls*)pPanel;
    
    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshGL);
    wxGetTopLevelParent(pCurr)->AddPendingEvent(com);
}

// ------------------

FilterData_cls::
FilterData_cls(bool bDefaultParam, bool bAllParam) : SceneObj_cls(wxT("Filter"), bDefaultParam, bAllParam) { //͓{ꉻN.G.!
    mbSelected    = FALSE;
    
    mCConfList.Clear();
    mCConfList.Add(&mCbValid,    wxT("FilterValid="), L"1");
    mCConfList.Add(&mCstrCustomName, wxT("FilterName=")); // lȂ
    mCConfList.Add(&mCbGUIPanelOpen, wxT("FilterGUIOpen="), L"1");
}

FilterData_cls::
~FilterData_cls(){
    for (unsigned int i = 0; i < mVpCClrCurve.size(); i++)
	delete mVpCClrCurve[i];
}

void FilterData_cls::
ChangeCustomName(int type){
    // {eLXg̈sȂ̂ŁAtB^pɂ
    std::vector < wxString > strOrg;
    std::vector < wxString > strMLG;
    strOrg.push_back(wxT("Boolean"));strMLG.push_back(_("Boolean"));
    strOrg.push_back(wxT("DataBox"));strMLG.push_back(_("DataBox"));
    strOrg.push_back(wxT("Object")) ;strMLG.push_back(_("Object"));
    strOrg.push_back(wxT("Fog"))    ;strMLG.push_back(_("Fog"));
    strOrg.push_back(wxT("Grid"))   ;strMLG.push_back(_("Grid"));
    strOrg.push_back(wxT("Filtering")); strMLG.push_back(_("Filtering"));
    strOrg.push_back(wxT("CopyBox")); strMLG.push_back(_("CopyBox"));
    strOrg.push_back(wxT("Stick")); strMLG.push_back(_("Stick"));
    
    switch(type){
    case 0:
	for (unsigned int i = 0; i < strOrg.size(); i++)
	    mCstrCustomName.mstrBody.Replace(strMLG[i], strOrg[i]);
	break;
    case 1:
	for (unsigned int i = 0; i < strOrg.size(); i++)
	    mCstrCustomName.mstrBody.Replace(strOrg[i], strMLG[i]);
	break;
    }
}

void FilterData_cls::
ReplaceParameterName(wxString strNewName){
    mpCSceneObjParam->ReplaceID(wxT("Filter"), strNewName);
}

wxString FilterData_cls::
GetHeaderStrFromPointer(void *pValue){
    return mCConfList.GetHeaderStrFromPointer(pValue);
}

void FilterData_cls::
SetValue(wxString strTag, double valueDouble, int valueInt){
    int pos = strTag.Find(wxT("::"));
    wxString strHeader;
    wxString strComponent;
    int      dim;
    if (pos == -1) strHeader = strTag;
    else {
	strHeader = strTag.SubString(0, pos-1);
	strComponent = strTag.SubString(pos+2, strTag.Len());
	int pos2 = strComponent.Find(wxT("="));
	wxString strDim = strComponent.SubString(pos2+1, strTag.Len());
	long longDim;
	strDim.ToLong(&longDim);
	dim = (int)longDim;
    }
    ConfItem_cls *pCItem = mCConfList.GetPCItem(strHeader);
    if (pCItem == NULL) return;
    switch(pCItem->mType){
    case _CONF_ITEM_INT:
	((ConfItemINT_cls*)pCItem)->mBody = valueInt;
	break;
    case _CONF_ITEM_INTARRAY:
	((ConfItemINTARRAY_cls*)pCItem)->mpBody[dim] = valueInt;
	break;
    case _CONF_ITEM_UINT:
	((ConfItemUINT_cls*)pCItem)->mBody = (unsigned int)valueInt;
	break;
    case _CONF_ITEM_FLOAT:
	((ConfItemFLOAT_cls*)pCItem)->mBody = (float)valueDouble;
	break;
    case _CONF_ITEM_FLOATARRAY:
	((ConfItemFLOATARRAY_cls*)pCItem)->mpBody[dim] = (float)valueDouble;
	break;
    case _CONF_ITEM_DOUBLE:
	((ConfItemDOUBLE_cls*)pCItem)->mBody = valueDouble;
	break;
    case _CONF_ITEM_DOUBLEARRAY:
	((ConfItemDOUBLEARRAY_cls*)pCItem)->mpBody[dim] = valueDouble;
	break;
    }
}

void FilterData_cls::
CopyFilterDataFromP(FilterData_cls *pCFrom,
		    ParamGroup_cls *pCTranslate,
		    ParamGroup_cls *pCRotete   ,
		    ParamGroup_cls *pCScale    ,
		    ParamGroup_cls *pCAdditional){
    mCConfList.CopyListComponentFromP(&pCFrom->mCConfList);
    for (unsigned int i = 0; i < pCFrom->mVpCClrCurve.size(); i++)
	mVpCClrCurve[i]->CopyColorFromP(pCFrom->mVpCClrCurve[i]);
    
    if (pCTranslate == NULL) mpCTranslate->CopyFromP(pCFrom->mpCTranslate);
    else                     mpCTranslate->CopyFromP(pCTranslate);
    if (pCRotete    == NULL) mpCRotation ->CopyFromP(pCFrom->mpCRotation);
    else                     mpCRotation ->CopyFromP(pCRotete);
    if (pCScale     == NULL) mpCScale    ->CopyFromP(pCFrom->mpCScale);
    else                     mpCScale    ->CopyFromP(pCScale);
}

void FilterData_cls::
ReadStrLine(std::wistream& istream, wxString strLineTag){

    std::wstring wstrLine;
    wxString strLine;
    while ( std::getline (istream, wstrLine)){
	strLine = wstrLine.c_str();
	if (strLine.Find(wxT("ParamGroup=")) != wxNOT_FOUND) break;
	if (strLine.IsSameAs(wxT("-FilterEnd"))) break;
	if (strLine.IsSameAs(wxT("-ConstParamEnd"))) break;
	mCConfList.ReadStrLineAll(strLine);
    }
    
    ChangeCustomName(1);

    while(TRUE){
	if (strLine == wxT("-FilterEnd")) break;
	for (unsigned int i = 0; i < mpCSceneObjParam->mVpCParamGroup.size(); i++)
	    mpCSceneObjParam->mVpCParamGroup[i]->ReadStrLine(istream, strLine);
	for (unsigned int i = 0; i < mVpCClrCurve.size(); i++)
	    mVpCClrCurve[i]->ReadStrLine(istream, strLine);
	
	std::getline (istream, wstrLine);
	strLine = wstrLine.c_str();
    }
}

// ------------------

FilterBase_cls::
FilterBase_cls(FilterCtrl_cls *pCParentCtrl) 
{
    mpCParentCtrl = pCParentCtrl;
}

FilterBase_cls::
~FilterBase_cls(){
    delete mpCGUIPanel;
    delete mpCData;
}

bool FilterBase_cls::
Select(bool bSelected){
    if (GetPCData()->mbSelected == bSelected) return FALSE;
    
    GetPCData()->Select(bSelected);
    if (bSelected == TRUE){
	mpCGUIPanel->mpCMNumPanel->SetBackgroundColour(wxColour(240,230,180));
	if (mCFilterType.mBody == _FILTER_OBJECT)
	    ((FilterObject_cls*)this)->OnSelected();
	if (mCFilterType.mBody == _FILTER_STICK)
	    ((FilterStick_cls*)this)->OnSelected();
    }
    else
	mpCGUIPanel->mpCMNumPanel->SetBackgroundColour(wxColour(wxT("LIGHT BLUE")));
    mpCGUIPanel->mpCMNumPanel->Refresh();
    mpCGUIPanel->mpCMNumPanel->RefreshSlider();

    return TRUE;
}

void FilterBase_cls::
CallHideAndShow(){
    switch(mCFilterType.mBody){
    case _FILTER_OBJECT:
	((FilterObjectGUI_cls*)mpCGUIPanel)->HideAndShow();
	break;
    case _FILTER_STICK:
	((FilterStickGUI_cls*)mpCGUIPanel)->HideAndShow();
	break;
    case _FILTER_BG:
	((FilterBGGUI_cls*)mpCGUIPanel)->HideAndShow();
	break;
    }
}

// ------------------------

wxString FilterBase_cls::
Serialize(){
    wxString strOut;
    
    GetPCData()->ChangeCustomName(0);

    strOut << mCFilterType.Serialize();
    strOut << GetPCData()->mCConfList.SerializeAll();
    strOut << wxT("-ConstParamEnd") << ENDL;
    strOut << GetPCData()->mpCSceneObjParam->Serialize();
    for (unsigned int i = 0; i < GetPCData()->mVpCClrCurve.size(); i++)
	strOut << GetPCData()->mVpCClrCurve[i]->Serialize();
    
    GetPCData()->ChangeCustomName(1);
    
    return strOut;
}
