
#ifndef _FILTER_BASE_H_
#define _FILTER_BASE_H_

#include "../CONFITEM/clsConfItem.h"
#include "../GLATTRIB/clsColorCurve.h"
#include "../POVRAY/clsPovSerialize.h"
#include "../SCENEOBJ/clsSceneObj.h"

#include "../WIDGETCTRL/clsWidgetCommon.h"

#define _FILTER_BOOLEAN   0
#define _FILTER_DATABOX   1
#define _FILTER_OBJECT    2
#define _FILTER_GRID      3
#define _FILTER_TEXT      4
#define _FILTER_FOG       5
#define _FILTER_FILTERING 6
#define _FILTER_COPY      7
#define _FILTER_STICK     8
#define _FILTER_BG        9

#include <wx/wx.h>

class FilterBase_cls;
class FilterCtrl_cls;
class FilterData_cls;
class MultiInputPanel_cls;

class FilterGUI_cls : public WidgetCommon_cls {
 public:
    FilterGUI_cls(FilterBase_cls *pCParent);
    virtual ~FilterGUI_cls();

    FilterBase_cls *mpCParentBase;
    MultiInputPanel_cls *mpCMNumPanel;
    MultiInputPanel_cls *InitializeMInputCommon(wxWindow *pCParentWindow,
						wxString strCustomName);
    std::vector < int > SetMNumBasic(MultiInputPanel_cls  *pCurr,
				     FilterData_cls       *pCData,
				     std::vector < bool > VbValid = std::vector < bool >());
    void SetHookBasic(MultiInputPanel_cls *pCurr);
    void UpdateButtonName();
    void ProcHideButton();
    void HideAndShowBegin();
    void HideAndShowEnd();
    
    static void FuncHookHideButton(void *pUserDef, void *pArg);
    static void FuncHookMouse(void *pUserDef, void *pArg);
    static void FuncHookAssign(void *pUserDef, void *pArg);
    static void FuncHookClick(void *pPanel, void *pArg);
    static void FuncHookCheckBox(void *pPanel, void *pUsrDef);
};

class FilterData_cls : public SceneObj_cls {
 public:
    FilterData_cls(bool bDefaultParam = TRUE, bool bAllParam = TRUE);
    virtual ~FilterData_cls();
    
    ConfItemList_cls mCConfList; 
    ConfItemBOOL_cls mCbValid;
    ConfItemSTR_cls  mCstrCustomName;
    ConfItemBOOL_cls mCbGUIPanelOpen;
    std::vector < ColorCurve_cls* > mVpCClrCurve;
    
    void     ChangeCustomName(int type);
    void     ReplaceParameterName(wxString strNewName);
    wxString GetHeaderStrFromPointer(void *pValue);
    void SetValue(wxString strTag, double valueDouble, int valueInt);
    
    virtual void CopyFilterDataFromP
	(FilterData_cls *pCFrom,
	 ParamGroup_cls *pCTranslate  = NULL,
	 ParamGroup_cls *pCRotete     = NULL,
	 ParamGroup_cls *pCScale      = NULL,
	 ParamGroup_cls *pCAdditional = NULL);

    //----
    
    void ReadStrLine(std::wistream& istream, wxString strLineTag);
};

class FilterBase_cls : public PovSerialize_cls {
 public:
    FilterBase_cls(FilterCtrl_cls *pCParentCtrl);
    ~FilterBase_cls();

    void ConstructorCommon(FilterCtrl_cls *pCParentCtrl, 
			   wxString strDefaultLabel, int filterType);
    
    FilterCtrl_cls *mpCParentCtrl;
    FilterGUI_cls*  mpCGUIPanel;
    FilterData_cls* mpCData;

    ConfItemINT_cls mCFilterType;
    
    bool            Select(bool bSelected);
    virtual FilterData_cls* GetPCData() = 0; 

    void  CallHideAndShow();
    
    // ------

    wxString Serialize();
};

#endif
