// "clsFilterBoolean.h"
// (setq basic-c-ofsset 4)

#ifndef _FILTER_BOOLEAN_H_
#define _FILTER_BOOLEAN_H_

#include "clsFilterBase.h"
#include "../SCENEOBJ/clsSceneObj.h"

class ArrayAndIndex_cls;
class FilterBoolean_cls;
class FilterPanelPain_cls;

#include <wx/thread.h>

class ThreadBooleanCheckBase_cls : public wxThread {
 public:
    ThreadBooleanCheckBase_cls(wxThreadKind kind);

    void SetParameters(bool *pbFinishedFlag,
		       ArrayAndIndex_cls* pIndexAndZ, float (*pX)[3],
		       float *pAlphaFactor,
		       int operatorType, float borderFactor,
		       float dX, float dY, float dZ,
		       float scaleX, float scaleY, float scaleZ,
		       int ini, int fin);

    bool  *mpbFinishedFlagLink;
    ArrayAndIndex_cls *mpIndexAndZ;
    float (*mpX)[3];
    float *mpAlphaFactor;
    int   mDownsized;
    int   mOperatorType;
    float mBorderFactor;
    float mdX, mdY, mdZ;
    float mScaleX, mScaleY, mScaleZ;
    int   mIni, mFin;
};

class ThreadBooleanCheckBox_cls : public ThreadBooleanCheckBase_cls {
 public:
    ThreadBooleanCheckBox_cls(wxThreadKind kind);
    ExitCode Entry();
};

class ThreadBooleanCheckSphere_cls : public ThreadBooleanCheckBase_cls {
 public:
    ThreadBooleanCheckSphere_cls(wxThreadKind kind);
    ExitCode Entry();
};

// ---------------

class FilterBooleanGUI_cls : public FilterGUI_cls {
 public:
    FilterBooleanGUI_cls(FilterBoolean_cls *pCParent, 
			 FilterPanelPain_cls *pCPanelPain);
    FilterBoolean_cls *mpCParent;
    
    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      int index);
};

class FilterBooleanData_cls : public FilterData_cls {
 public:
    FilterBooleanData_cls();

    ConfItemUINT_cls  mCOperatorType;
    ConfItemUINT_cls  mCRegionType;
    ConfItemFLOAT_cls mCBorderFactor;
};

class FilterBoolean_cls : public FilterBase_cls {
 public:
    FilterBoolean_cls (FilterPanelPain_cls *pCPanelPain,
		       FilterBooleanData_cls *pCInitData = NULL);
    ~FilterBoolean_cls();

    FilterBooleanData_cls *GetPCData();

    void CheckBoolean(ArrayAndIndex_cls* pIndexAndZ, 
		      float (*pX)[3], int downsized, float *pAlphaFactor,
		      double doubleIndex);
    void GLDraw(double doubleIndex, double scale, bool bHittest);
};

#endif
