
#ifndef _FILTER_COPY_H_
#define _FILTER_COPY_H_

#include "../FILTER/clsFilterBase.h"

class ArrayAndIndex_cls;
class FilterCopy_cls;
class FilterPanelPain_cls;

#include <wx/thread.h>

class FilterCopyGUI_cls : public FilterGUI_cls {
 public:
    FilterCopyGUI_cls(FilterCopy_cls *pCParent, 
		      FilterPanelPain_cls *pCPanelPain);
    FilterCopy_cls *mpCParent;
    
    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      int index);

    static void FuncHookPeriodic(void *pUsrDef, void *pArg);
    static void FuncHookShear(void *pUsrDef, void *pArg);
};

class FilterCopyData_cls : public FilterData_cls {
public:
    FilterCopyData_cls();
    
    ConfItemINT_cls mCArrayMin[3];
    ConfItemINT_cls mCArrayMax[3];

    ConfItemFLOATARRAY_cls mCShearArray[3];
    ConfItemFLOAT_cls mCShearPhase;
};

class FilterCopy_cls : public FilterBase_cls {
public:
    FilterCopy_cls (FilterPanelPain_cls *pCPanelPain,
		    FilterCopyData_cls *pCInitData = NULL);
    ~FilterCopy_cls();
    
    FilterCopyData_cls *GetPCData();

    ArrayAndIndex_cls *mpCIndexAndZ;
    
    int GetNumber();
    int GetBitBoundary(int index);
    std::vector < float > GetVTranslate(int index, double time);
    void ZSortBegin(double cameraPos[3], double cameraDir[3], double time);
    void ZSortEnd();
    void GLTranslate(int index, double time);
    void OpenShearDialog();
    wxString GetStrPovTranslate(int index, double time);
};

#endif
