
#ifndef _FILTER_CTRL_H_
#define _FILTER_CTRL_H_

#include <wx/wx.h>
#include <list>
#include <vector>

#include "../MYGL/clsPositionAndDirection.h"

#define _FTYPE_BOOLEAN 0
#define _FTYPE_OBJECT 1
#define _FTYPE_WORLD 2

class ArrayAndIndex_cls;
class FilterBase_cls;
class FilterBG_cls;
class FilterCopy_cls;
class FilterData_cls;
class FilterFog_cls;
class FilterStick_cls;
class FilterPanelPain_cls;
class Parameters_cls;
class ParamGroup_cls;
class ParamGUICtrl_cls;
class PeriodicBoundary_cls;
class PovRayCtrl_cls;
class SceneObj_cls;
class TagObject_cls;
class Main_cls;

class FilterCtrl_cls {
 public:
    FilterCtrl_cls(Main_cls *pCParentMain, int type);
    ~FilterCtrl_cls();

    int mType;
    static Main_cls      *mspCParentMainLink;
    FilterPanelPain_cls  *mpCPanelPainLink;
    PeriodicBoundary_cls *mpCPeriodicLink;

    static void DeletePolymorph(FilterBase_cls *pCFilter);

    std::list <FilterBase_cls*> mVpCFilter;
    std::vector < wxString > mVstrFilterStatusSum;

    static FilterCtrl_cls *GetPCFilterCtrlFromType(int type);
    
    std::list< FilterBase_cls* >::iterator GetIterN(int index);
    FilterBase_cls* GetPCBase(int index);
    FilterData_cls* GetPCData(int index);
    wxString mstrInstanceTranslate;

    wxString GetHeaderStrFromPointer(void *pValue);
    void     SetValue(wxString strTag, double valueDouble, int valueInt);
    void     SetParamInit(wxString strTagFilter, wxString strTagParam,
			  int mDimension, double *pValue);
    void     UpdateValuesOnPanel();
    void     HideAndShowOnPanel();
    
    FilterBase_cls* GetPCFilter(wxString strFilterName);
    Parameters_cls* GetPCParamFromID(wxString strID);

    bool SelectFilter(FilterBase_cls *pCFilterBase);
    void DeleteSelectedFilter();
    void RemoveFilter(int pos);
    void ClearFilters();
    void MoveSelectedFilter(int direction);
    void MoveFilterExe(int pos, int direction);
    wxString GetNewName(wxString strName);
    void AddFilter(int type, int pos, FilterData_cls *pCData,
		   ParamGroup_cls *pCParamGroupTranslate = NULL,
		   ParamGroup_cls *pCParamGroupRotation = NULL,
		   ParamGroup_cls *pCParamGroupScale = NULL);

    bool IsObjectExist();
    bool IsBooleanChangeConstantColor();
    int  CheckBoolean(ArrayAndIndex_cls* pIndexAndZ, 
		      float (*pX)[3], int downsized, 
		      double doubleIndex);
    SceneObj_cls*    GetPCDataBox();
    FilterCopy_cls*  GetPCCopy();
    FilterFog_cls*   GetPCFog();
    std::vector < FilterStick_cls* > GetVpCSticks();
    std::vector < FilterBG_cls* > GetVpCBG();

    void UpdateInterpolatedValue(double doubleIndex);
    void GLDraw(double doubleIndex, double scale, bool bHittest);
    void GLDrawRealObject(int currentIndex, double doubleIndex, 
			  int lightNumber, bool bCopyInstance,
			  PositionAndDirection_cls CCamPos);
    void GLDrawRealGrid(double doubleIndex, PositionAndDirection_cls CCamPos,
			std::vector < TagObject_cls > *pVCTagObject = NULL);
    
    // ---------------

    void GetStrPovBG(wxString &strBG, double doubleIndex, 
		     PovRayCtrl_cls *pCPovRayCtrl);
    wxString GetStrPovInclude();
    void GetStrPovRealObject(wxString &strObject, double doubleIndex, bool bCopyInstance,
				 int tabDepth, PositionAndDirection_cls CCamPos);

    wxString Serialize();
    void ReadStrLineFilter(std::wistream& istream);
    void ReadStrLine(std::wistream& istream, wxString strLineTag);
    
};

#endif
