
#ifndef _FILTER_OBJECT_H_
#define _FILTER_OBJECT_H_

#include "../FILTER/clsFilterBase.h"
//#include "../GLATTRIB/clsColorCurve.h"
#include "../POVRAY/MESH/clsPovObjectMesh.h"
#include "../SCENEOBJ/clsSceneObj.h"
#include "../SCENEOBJ/clsSceneObjTexture.h"

class ArrayAndIndex_cls;
class FilterObject_cls;
class FilterPanelPain_cls;

#define _FILTER_OBJECT_BOX    0
#define _FILTER_OBJECT_PLANE  1
#define _FILTER_OBJECT_SPHERE 2
#define _FILTER_OBJECT_IMPORT 3

class FilterObjectGUI_cls : public FilterGUI_cls {
 public:
    FilterObjectGUI_cls(FilterObject_cls *pCParent, 
			 FilterPanelPain_cls *pCPanelPain);
    FilterObject_cls *mpCParent;
    int mIndexType;
    int mIndexPath;
    int mIndexArrayVector;

    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      int index);
    static void FuncHookType(void *pUsrDef, void *pArg);
    static void FuncHookButton(void *pUsrDef, void *pArg);
    static void FuncHookArrayVector(void *pUsrDef, void *pArg);
    void HideAndShow();
    void PathSelection();
};

class FilterObjectData_cls : public FilterData_cls{
 public:
    FilterObjectData_cls();

    ConfItemUINT_cls mCObjectType;
    ConfItemSTR_cls  mCstrImportPath;
    ConfItemUINT_cls mCImportType;

    SceneObjTexture_cls mCTexture;
    PovObjectMesh_cls   mCMeshObject;

    ConfItemFLOATARRAY_cls mCArray0Vector;
    ConfItemFLOATARRAY_cls mCArray1Vector;
    ConfItemFLOATARRAY_cls mCArray2Vector;
    
    wxString GetStrPovMatrix();

    void DrawMesh(int currentIndex);
};

class FilterObject_cls : public FilterBase_cls {
 public:
    FilterObject_cls (FilterPanelPain_cls *pCPanelPain,
		       FilterObjectData_cls *pCInitData = NULL);
    ~FilterObject_cls();

    FilterObjectData_cls *GetPCData();

    void GLDraw(double doubleIndex, double scale, bool bHittest);
    void GLDrawRealObject(int currentIndex, double doubleIndex, int lightNumber,
			  bool bCopyInstance);
    
    void OnSelected();

    wxString GetStrPovInclude();
    wxString GetStrPovRealObject(double doubleIndex, wxString strTranslate,
				 bool bCopyInstance, wxString strTab);
};

#endif
