// -*- c++ -*- 
// (setq c-basic-offset 4)

#include "clsFilterStick.h"
#include "clsFilterCtrl.h"

#include "../GLATTRIB/clsGLAttribute.h"
#include "../GLATTRIB/clsShaderCtrl.h"
#include "../MAINCANVAS/clsFilterPanelPain.h"
#include "../UNDO/clsUndoManager.h"
#include "../PARTICLEDATA/clsGLDrawData.h"
#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../WIDGETCTRL/EX/clsTextCtrlEX.h"

#include "../WIDGETCTRL/EX/clsFileDialogEX.h"
extern wxFileDialogEX *GpCFileDialog;

#include "../UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;
#include "../UNDO/clsUndoItemConstParam.h"

#include "../../clsMain.h"

#include "../COMMON/CommonDefinitions.h"

FilterStickGUI_cls::
FilterStickGUI_cls(FilterStick_cls *pCParent,
		       FilterPanelPain_cls *pCPanelPain) : FilterGUI_cls(pCParent){
    mpCParent = pCParent;
    SetMNumPanel((wxBoxSizer*)pCPanelPain->GetSizer(), pCPanelPain, 0);
}

void FilterStickGUI_cls::
SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow, int index){

    MultiInputPanel_cls* pCurr = InitializeMInputCommon
	(pCParentWindow, mpCParent->GetPCData()->mCstrCustomName.mstrBody);
    FilterStickData_cls *pCData = mpCParent->GetPCData();

    pCurr->mUpdateBit = _COMMAND_UPDATE_DISPLAY_GL | _COMMAND_UPDATE_DISPLAY_TL | _COMMAND_UPDATE_DISPLAY_FILTER_PARAM;

    pCurr->mTextWidth = 80;
    pCurr->mItemWidth = -1;
    //pCurr->mComboWidth = 86;
    pCurr->mUndoType = _MN_UNDO_AUTO_TAG;

    int boxWidth = 2;
    mIndexType = pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Type/Calc"));

    pCurr->mItemWidth = 90;
    wxString listType[2] = {_("Line"), _("Cylinder") };
    pCurr->CombinePointerList(_ITEM_UINT_LIST, &pCData->mCStickType.mBody, 2, listType);

    wxString listCalc[2] = {_("Load File"), _("Calculate")};
    pCurr->CombinePointerList(_ITEM_UINT_LIST, &pCData->mCCalcType.mBody, 2, listCalc);
    
    //pCurr->mItemWidth = 88;
    mIndexRadius = pCurr->SetInputAndSlider(_ITEM_FLOAT, &pCData->mCRadius.mBody, _("Radius"));
    pCurr->SetRange(_ITEM_LASTITEM, 0, 300, 100);
	
    mIndexWidth = pCurr->SetInputAndSlider(_ITEM_INTEGER, &pCData->mCWidth.mBody, _("Line Width"));
    pCurr->SetRange(_ITEM_LASTITEM, 1, 20, 1);

    wxString listCrit[3] = {_("Step"), _("Ramp"), _("Step between A and B")};
    pCurr->mItemWidth = -1;
    mIndexCritType = pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &pCData->mCCritType.mBody, 3, listCrit, _("Calculate Type"));

    pCurr->mItemWidth = 88;
    mIndexCrit = pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Crit A/B"));
    pCurr->CombinePointer(_ITEM_FLOAT, &pCData->mCCritA.mBody);
    pCurr->CombinePointer(_ITEM_FLOAT, &pCData->mCCritB.mBody);

    wxString listSpec[2] = {_("Any Type"), _("Connect between A and B")};
    pCurr->mItemWidth = -1;
    mIndexSpecType = pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &pCData->mCSpecType.mBody, 2, listSpec, _("Connection"));
    
    pCurr->mItemWidth = 88;
    mIndexSpec = pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Spec A/B"));
    pCurr->CombinePointer(_ITEM_INTEGER, &pCData->mCSpecA.mBody);
    pCurr->CombinePointer(_ITEM_INTEGER, &pCData->mCSpecB.mBody);
    
    mIndexPath = pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth);
    pCurr->mItemWidth = 260-24-4;
    pCurr->mUndoType = _MN_UNDO_MANUAL;
    pCurr->CombinePointer(_ITEM_STRING, &pCData->mCstrStickPath.mstrBody, _("Path"));
    pCurr->mItemWidth = 24;
    pCurr->CombinePointerButton(wxID_ANY, wxT(".."));

    boxWidth = 3;
    pCurr->mItemWidth = -1;
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Material"));
    ColorCurveBtn_cls *pCBtnAmbient = new ColorCurveBtn_cls
	(pCurr, pCData->mVpCClrCurve[0], TRUE, FALSE);
    ColorCurveBtn_cls *pCBtnDiffuse = new ColorCurveBtn_cls
	(pCurr, pCData->mVpCClrCurve[1], TRUE, FALSE);
    ColorCurveBtn_cls *pCBtnSpecular = new ColorCurveBtn_cls
	(pCurr, pCData->mVpCClrCurve[2], TRUE, FALSE);
    pCurr->CombinePointer(_ITEM_WXPANEL, pCBtnAmbient, wxT("Ambient"));
    pCurr->CombinePointer(_ITEM_WXPANEL, pCBtnDiffuse, wxT("Diffuse"));
    pCurr->CombinePointer(_ITEM_WXPANEL, pCBtnSpecular, wxT("Specular"));

    pCurr->FinishSetting(NULL);

    //((TextCtrlEX_cls*)(pCurr->mVCItemList[indexIndexStr].GetPCwxWindow()))->EnableHookSpace(FALSE);

    SetHookBasic(pCurr);

    pCurr->SetFuncHook(FilterStickGUI_cls::FuncHookType, _HOOK_COMBOBOX, 
		       mIndexType+1, FALSE, this);
    pCurr->SetFuncHook(FilterStickGUI_cls::FuncHookType, _HOOK_COMBOBOX, 
		       mIndexType+2, FALSE, this);
    pCurr->SetFuncHook(FilterStickGUI_cls::FuncHookType, _HOOK_COMBOBOX, 
		       mIndexCritType, FALSE, this);
    pCurr->SetFuncHook(FilterStickGUI_cls::FuncHookType, _HOOK_COMBOBOX, 
		       mIndexSpecType, FALSE, this);
    pCurr->SetFuncHook(FilterStickGUI_cls::FuncHookButton, _HOOK_BUTTON, 
		       mIndexPath+2, FALSE, this);
    HideAndShow();
}

void FilterStickGUI_cls::
FuncHookType(void *pUsrDef, void *pArg){
    ((FilterStickGUI_cls*)pUsrDef)->HideAndShow();
}

void FilterStickGUI_cls::
FuncHookButton(void *pUsrDef, void *pArg){
    ((FilterStickGUI_cls*)pUsrDef)->PathSelection();
}

void FilterStickGUI_cls::
HideAndShow(){
    HideAndShowBegin();
    FilterStickData_cls *pCData = mpCParent->GetPCData();
    
    if (pCData->mCStickType.mBody == _STICK_LINE){
	mpCMNumPanel->ShowItem(mIndexRadius, FALSE);
	mpCMNumPanel->ShowItem(mIndexWidth, TRUE);
    }
    else{
	mpCMNumPanel->ShowItem(mIndexRadius, TRUE);
	mpCMNumPanel->ShowItem(mIndexWidth, FALSE);
    }

    if (pCData->mCCalcType.mBody == _STICK_LOAD_FILE){
	mpCMNumPanel->ShowItem(mIndexPath, TRUE);
	mpCMNumPanel->ShowItem(mIndexCritType, FALSE);
	mpCMNumPanel->ShowItem(mIndexCrit, FALSE);
	mpCMNumPanel->ShowItem(mIndexSpecType, FALSE);
	mpCMNumPanel->ShowItem(mIndexSpec, FALSE);
    }
    else{
	mpCMNumPanel->ShowItem(mIndexPath, FALSE);
	mpCMNumPanel->ShowItem(mIndexCritType, TRUE);
	mpCMNumPanel->ShowItem(mIndexCrit, TRUE);
	if (pCData->mCCritType.mBody == 0)
	    mpCMNumPanel->mVCItemList[mIndexCrit+2].GetPCwxWindow()->Disable();
	else
	    mpCMNumPanel->mVCItemList[mIndexCrit+2].GetPCwxWindow()->Enable();
	mpCMNumPanel->ShowItem(mIndexSpecType, TRUE);
	mpCMNumPanel->ShowItem(mIndexSpec, TRUE);
    }

    if (pCData->mCSpecType.mBody == 0)
	mpCMNumPanel->ShowItem(mIndexSpec, FALSE);
    else
	mpCMNumPanel->ShowItem(mIndexSpec, TRUE);

    HideAndShowEnd();
}

void FilterStickGUI_cls::
PathSelection(){
    GpCFileDialog->SetMessage(wxT("Select Mesh File"));
    GpCFileDialog->SetWildcard(wxT("StickInfo (*.txt;*.bond)|*.txt;*.bond"));
    if (GpCFileDialog->ShowModal() == wxID_CANCEL) return;
    
    FilterStickData_cls *pCData = mpCParent->GetPCData();

    int updateBit = _COMMAND_UPDATE_DISPLAY_FILTER_PARAM | _COMMAND_UPDATE_DISPLAY_GL;

    GCUndoList.PushNewCommand
	(new CommandSetValue_cls(&pCData->mCstrStickPath.mstrBody, GpCFileDialog->GetPath(), updateBit), 
	 new CommandSetValue_cls(&pCData->mCstrStickPath.mstrBody, pCData->mCstrStickPath.mstrBody, updateBit));
    GCUndoList.ExecCurrent();
    
    //mpCMNumPanel->UpdateValues();
}

// ---------------------

FilterStickData_cls::
FilterStickData_cls() : FilterData_cls(FALSE) {
    mCstrCustomName.mstrBody = _("Stick");
    mCstrCustomName.mstrBody << wxT("%02d");
    mCConfList.Add(&mCStickType, wxT("StickType="), wxT("0"));
    mCConfList.Add(&mCRadius, wxT("StickRadius="), wxT("0.5"));
    mCConfList.Add(&mCWidth, wxT("StickWidth="), wxT("10"));
    mCConfList.Add(&mCCalcType, wxT("CalcType="), wxT("0"));
    mCConfList.Add(&mCstrStickPath, wxT("StickPath="), wxT("NONE"));
    mCConfList.Add(&mCCritType, wxT("CritType="), wxT("0"));
    mCConfList.Add(&mCCritA, wxT("CritA="), wxT("1"));
    mCConfList.Add(&mCCritB, wxT("CritB="), wxT("2"));
    mCConfList.Add(&mCSpecType, wxT("SpecType="), wxT("0"));
    mCConfList.Add(&mCSpecA, wxT("SpecA="), wxT("0"));
    mCConfList.Add(&mCSpecB, wxT("SpecB="), wxT("1"));

    mCConfList.Add(&mCTexture.mCShaderType, wxT("ShaderType="), wxT("2"));
    mCConfList.Add(&mCTexture.mCShininess, wxT("Shininess="), wxT("10"));
    mCConfList.Add(&mCTexture.mCTransmitType, wxT("TransmitType="), wxT("0"));
    mCConfList.Add(&mCTexture.mCAlpha, wxT("Alpha="), wxT("1"));
    mCConfList.Add(&mCTexture.mCReflectType, wxT("ReflectType="), wxT("0"));
    mCConfList.Add(&mCTexture.mCReflectMin, wxT("ReflectMin="), wxT("0.2"));
    mCConfList.Add(&mCTexture.mCReflectMax, wxT("ReflectMax="), wxT("0.5"));
    mCConfList.Add(&mCTexture.mCIOR, wxT("IOR="), wxT("1"));
    
    for (int i = 0; i < _TEX_NORMAL_MAX; i++){
	wxString strTagPattern = wxT("NormalPattern");
	strTagPattern << i << wxT("=");
	mCConfList.Add(&mCTexture.mCNormalPattern[i], strTagPattern, wxT("0"));
	wxString strTagDegree = wxT("NormalDegree");
	strTagDegree << i << wxT("=");
	mCConfList.Add(&mCTexture.mCNormalDegree[i], strTagDegree, wxT("0.3"));
	wxString strTagScale = wxT("NormalScale");
	strTagScale << i << wxT("=");
	mCConfList.Add(&mCTexture.mCNormalScale[i], strTagScale, wxT("1"));
    }

    ColorCurve_cls *pCClrCurveAmbient = new ColorCurve_cls
	(wxT("Ambient"), wxT("Ambient"), wxT("0.2 0.16 0.04 1"));
    ColorCurve_cls *pCClrCurveDiffuse = new ColorCurve_cls
	(wxT("Diffuse"), wxT("Diffuse"));
    ColorCurve_cls *pCClrCurveSpeculer = new ColorCurve_cls
	(wxT("Specular"), wxT("Specular"));
    
    mVpCClrCurve.push_back(pCClrCurveAmbient);
    mVpCClrCurve.push_back(pCClrCurveDiffuse);
    mVpCClrCurve.push_back(pCClrCurveSpeculer);
}

bool FilterStickData_cls::
IsConstantFactor(){
    return mCSticks.IsConstantFactor();
}

void FilterStickData_cls::
GLDrawSticks(SnapData_cls *pCSnapshot, PeriodicBoundary_cls *pCPeriodic, 
	     int bitBoundary, int currentIndex,
	     PositionAndDirection_cls CCamPos, int lightNumber){
    if (mCbValid.mbBody == FALSE) return;
    if (mCCalcType.mBody == _STICK_LOAD_FILE)
	mCSticks.ReadListFromFile(mCstrStickPath.mstrBody, currentIndex);
    else
	mCSticks.CalcFromData
	    (pCSnapshot, currentIndex, 
	     mCCritType.mBody, mCCritA.mBody, mCCritB.mBody,
	     mCSpecType.mBody, mCSpecA.mBody, mCSpecB.mBody);

    glDisable(GL_TEXTURE_2D);
    
    GLAttribute_cls::mspCShaderCtrl->EndShader(0);
    /*
    GLAttribute_cls::mspCShaderCtrl->
	BeginShader(mCTexture.mCShaderType.mBody, lightNumber);
    */
    
    mCSticks.CheckValidity(pCSnapshot);
    mCSticks.SetPPeriodicBoundary(pCPeriodic);

    mCSticks.GLDraw(pCSnapshot, mCStickType.mBody, mCTexture.mCAlpha.mBody,
		    mCRadius.mBody, mCWidth.mBody, bitBoundary, CCamPos,
		    mVpCClrCurve);
    
    
}

void FilterStickData_cls::
GetStrPovSticksRef(wxString &strPData, SnapData_cls *pCSnapshot){
    if (mCbValid.mbBody == FALSE) return;
    mCSticks.GetStrPovSticksRef(strPData, pCSnapshot);
}

// ---------------------

FilterStick_cls::
FilterStick_cls(FilterPanelPain_cls *pCPanelPain,
		    FilterStickData_cls *pCInitData) :
    FilterBase_cls(pCPanelPain->mpCFilterCtrlLink)
{
    wxString strInit; strInit << _FILTER_STICK;
    mCFilterType.SetItem(wxT("FilterType="), strInit);
    mpCData     = new FilterStickData_cls;
    mpCGUIPanel = new FilterStickGUI_cls(this, pCPanelPain);
}

FilterStick_cls::
~FilterStick_cls(){
}

FilterStickData_cls* FilterStick_cls::
GetPCData(){
    return (FilterStickData_cls*)mpCData;
}

void FilterStick_cls::
GLDrawStick(SnapData_cls *pCSnapshot, PeriodicBoundary_cls *pCPeriodic,
	    int bitBoundary, int currentIndex, 
	    PositionAndDirection_cls CCamPos, int lightNumber){
    FilterStickData_cls *pCData = GetPCData();
    pCData->GLDrawSticks(pCSnapshot, pCPeriodic, bitBoundary, currentIndex, 
			 CCamPos, lightNumber);
}

void FilterStick_cls::
OnSelected(){
    FilterStickData_cls *pCData = GetPCData();
    mpCParentCtrl->mspCParentMainLink->ConnectTextureToDialog(&pCData->mCTexture, pCData->mCstrCustomName.mstrBody);
}


wxString FilterStick_cls::
GetStrPovCylinderMacro(){
    FilterStickData_cls *pCData = GetPCData();
    wxString strFinishOptions = 
	pCData->mCTexture.GetStrPovFinishOptions();
    wxString strNormal = 
	pCData->mCTexture.GetStrPovNormal(wxT("\t"));
    wxString strInteriorOptions = 
	pCData->mCTexture.GetStrPovInteriorOptions();
    wxString strCylinder;

    bool bConstancFactor = pCData->IsConstantFactor();

    if (bConstancFactor == TRUE){
	strCylinder << wxT("#macro CY(VPos0,VPos1)") << ENDL
		    << wxT("cylinder{ VPos0,VPos1,") 
		    << pCData->mCRadius.mBody << wxT(" open") << ENDL
		    << wxT("\ttexture {") << ENDL
		    << wxT("\t\tpigment {rgbt <0.8,0.8,0.8,1-") << pCData->mCTexture.mCAlpha.mBody << wxT(">}") << ENDL
		    << wxT("\t\tfinish { ambient <0.2,0.16,0.04> diffuse 1 specular 1 metallic roughness 0.024336") << strFinishOptions << wxT("}") << ENDL
		    << wxT("\t}") << ENDL;
    }
    else
	strCylinder << wxT("#macro CY(VPos0,VPos1,Factor)") << ENDL
		    << wxT("cylinder{ VPos0,VPos1,") 
		    << pCData->mCRadius.mBody << wxT(" open") << ENDL
		    << wxT("\ttexture {") << ENDL
		    << wxT("\t\tpigment {rgbt <1,1,1,1-") << pCData->mCTexture.mCAlpha.mBody << wxT("*Factor>}") << ENDL
		    << wxT("\t\tfinish { ambient <0.2,0.16,0.04> diffuse 1 specular Factor metallic roughness 0.024336") << strFinishOptions << wxT("}") << ENDL
		    << wxT("\t}") << ENDL;
    if (strNormal.IsEmpty() == FALSE)
	strCylinder << strNormal;
    if (strInteriorOptions.IsEmpty() == FALSE)
	strCylinder << wxT("\tinterior {") << strInteriorOptions << wxT("}") << ENDL;
    strCylinder << wxT("}") << ENDL
		<< wxT("#end") << ENDL << ENDL;
    return strCylinder;
}

void FilterStick_cls::
GetStrPovSticksRef(wxString &strPData, SnapData_cls *pCSnapshot){
    FilterStickData_cls *pCData = GetPCData();
    pCData->GetStrPovSticksRef(strPData, pCSnapshot);
}
