// "clsColorCurveTemplate.h"

#include "clsColorCurveTemplate.h"

#include "clsColorCurve.h"
#include "clsColorCurveGUI.h"

#include "../WIDGETCTRL/clsBitmapPanel.h"
#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"

#include "../COMMON/CommonDefinitions.h"

BEGIN_EVENT_TABLE(ColorCurveTemplate_cls, wxPanel)
EVT_SIZE(ColorCurveTemplate_cls::OnSize)
END_EVENT_TABLE()

ColorCurveTemplate_cls::
ColorCurveTemplate_cls(ColorCurveGUI_cls *pCParent, wxWindow *pC, wxWindowID id) :
    wxPanel(pC, id, wxDefaultPosition, wxDefaultSize){
    SetFont(FontProvider_cls::GetFont(0));
    mpCParentGUILink = pCParent;

    wxString strTitle[_MAX_TEMPLATE_NUM] = {
	wxT("Red Yellow"),  wxT("Green Red"),
	wxT("Black White"), wxT("Cold Color"), 
	wxT("Moderate Gray"), wxT("Spectrum"),
	wxT("SpectrumRGB"), wxT("Incandescent"),
	wxT("ColdSteel") };

    wxString strInit = wxT("1 0.8 0.6 1");
    double pClr0[2][5] = {{0.00, 1.00, 0.00, 0.00, 1.00},
			  {1.00, 1.00, 1.00, 0.00, 1.00}};
    mpCTemplate[0] = new ColorCurve_cls(wxT(""), strTitle[0], strInit, 2, pClr0);

    double pClr1[2][5] = {{0.00, 0.00, 1.00, 0.00, 1.00},
			  {1.00, 1.00, 0.00, 0.00, 1.00}};
    mpCTemplate[1] = new ColorCurve_cls(wxT(""), strTitle[1], strInit, 2, pClr1);

    double pClr2[2][5] = {{0.00, 0.00, 0.00, 0.00, 1.00},
			  {1.00, 1.00, 1.00, 1.00, 1.00}};
    mpCTemplate[2] = new ColorCurve_cls(wxT(""), strTitle[2], strInit, 2, pClr2);

    double pClr3[2][5] = {{0.00, 0.00, 0.00, 1.00, 1.00},
			  {1.00, 0.00, 1.00, 1.00, 1.00}};
    mpCTemplate[3] = new ColorCurve_cls(wxT(""), strTitle[3], strInit, 2, pClr3);

    double pClr4[2][5] = {{0.00, 0.50, 0.50, 0.50, 1.00},
			  {1.00, 0.75, 0.75, 0.75, 1.00}};
    mpCTemplate[4] = new ColorCurve_cls(wxT(""), strTitle[4], strInit, 2, pClr4);

    double pClr5[7][5] = {{0.000, 0.03, 0.00, 0.07, 1.00},
			  {0.167, 0.32, 0.00, 0.77, 1.00},
			  {0.333, 0.00, 0.31, 0.59, 1.00},
			  {0.500, 0.00, 0.78, 0.00, 1.00},
			  {0.666, 0.82, 0.56, 0.00, 1.00},
			  {0.833, 0.84, 0.00, 0.00, 1.00},
			  {1.000, 0.26, 0.00, 0.00, 1.00}};
    mpCTemplate[5] = new ColorCurve_cls(wxT(""), strTitle[5], strInit, 7, pClr5);

    double pClr6[5][5] = {{0.00, 1.00, 0.00, 0.00, 1.00},
			  {0.25, 0.50, 0.00, 0.50, 1.00},
			  {0.50, 0.00, 0.00, 1.00, 1.00},
			  {0.75, 0.00, 0.50, 0.50, 1.00},
			  {1.00, 0.00, 1.00, 0.00, 1.00}};
    mpCTemplate[6] = new ColorCurve_cls(wxT(""), strTitle[6], strInit, 5, pClr6);

    double pClr7[5][5] = {{0.000, 0.00, 0.00, 0.00, 1.00},
			  {0.594, 0.73, 0.00, 0.00, 1.00},
			  {0.809, 1.00, 0.55, 0.20, 1.00},
			  {0.900, 0.97, 0.94, 0.07, 1.00},
			  {1.000, 0.97, 0.97, 0.83, 1.00}};
    mpCTemplate[7] = new ColorCurve_cls(wxT(""), strTitle[7], strInit, 5, pClr7);

    double pClr8[3][5] = {{0.000, 1.00, 1.00, 1.00, 1.00},
			  {0.645, 0.05, 0.02, 0.14, 1.00},
			  {1.000, 0.36, 0.73, 0.76, 1.00}};
    mpCTemplate[8] = new ColorCurve_cls(wxT(""), strTitle[8], strInit, 3, pClr8);
    
    
    for (int i = 0; i < _MAX_TEMPLATE_NUM; i++){
	mpCTemplate[i]->mCbColorCurve.mbBody = TRUE;
	mpCBtnTemplate[i] = new ColorCurveBtn_cls(this, mpCTemplate[i],
						  FALSE, TRUE, TRUE);
	ConnectButton(this, mpCBtnTemplate[i], wxCEH(ColorCurveTemplate_cls::OnButtonTemplate));
    }
    
    wxBoxSizer *pBoxSizerSrc = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer *pBoxSizerFolder = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer *pBoxSizerHor0 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer *pBoxSizerHor1 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer *pBoxSizerHor2 = new wxBoxSizer(wxHORIZONTAL);

    mpCBPanelFolder = new BitmapPanel_cls(this, wxID_ANY, wxDefaultPosition, wxSize(14,-1));
    mpCBPanelFolder->AddBitmapStr(wxT("wxART_OPEN_FOLDER"));
    mpCBPanelFolder->AddBitmapStr(wxT("wxART_CLOSE_FOLDER"));
    mpCBPanelFolder->SetBitmapStrDisable(wxT("wxART_CLOSE_FOLDER"));
    Connect(mpCBPanelFolder->GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(ColorCurveTemplate_cls::OnMouseL));
    wxStaticText *pFolderLabel = new wxStaticText(this, wxID_ANY, _("Color Curve Template"));
    
    pBoxSizerFolder->Add(mpCBPanelFolder, 0, wxEXPAND);
    pBoxSizerFolder->Add(pFolderLabel, 0, wxEXPAND);
    pBoxSizerSrc->Add(pBoxSizerFolder, 0, wxEXPAND);
    
    for (int i = 0; i < _MAX_TEMPLATE_NUM; i++)
	mpClrLabel[i] = new wxStaticText(this, wxID_ANY, strTitle[i], wxDPS, wxALIGN_CENTRE);
    
    for (int i = 0; i < 3; i++){
	pBoxSizerHor0->Add(mpClrLabel[i], 2, wxEXPAND);
	pBoxSizerHor0->Add(mpCBtnTemplate[i], 3, wxEXPAND);
    }
    
    for (int i = 3; i < 6; i++){
	pBoxSizerHor1->Add(mpClrLabel[i], 2, wxEXPAND);
	pBoxSizerHor1->Add(mpCBtnTemplate[i], 3, wxEXPAND);
    }
    
    for (int i = 6; i < 9; i++){
	pBoxSizerHor2->Add(mpClrLabel[i], 2, wxEXPAND);
	pBoxSizerHor2->Add(mpCBtnTemplate[i], 3, wxEXPAND);
    }
    
    pBoxSizerSrc->Add(pBoxSizerHor0, 0, wxEXPAND);
    pBoxSizerSrc->Add(pBoxSizerHor1, 0, wxEXPAND);
    pBoxSizerSrc->Add(pBoxSizerHor2, 0, wxEXPAND);

    SetSizer(pBoxSizerSrc);
    mpCBPanelFolder->SetAspect(wxVERTICAL, 1.0);
    mpCBPanelFolder->SetBoarder(2,2);
    Layout();
}

ColorCurveTemplate_cls::
~ColorCurveTemplate_cls(){
    for (int i = 0; i < _MAX_TEMPLATE_NUM; i++)
	delete mpCTemplate[i];
}

void ColorCurveTemplate_cls::
OnSize(wxSizeEvent& event){
    if (mpCBPanelFolder->mState == 0)
	for (int i = 0; i < _MAX_TEMPLATE_NUM; i++)
	    mpCBtnTemplate[i]->Refresh(FALSE);
    event.Skip();
}

void ColorCurveTemplate_cls::
OnMouseL(wxMouseEvent& event){
    mpCParentGUILink->Freeze();

    if (mpCBPanelFolder->mState == 1)
	for (int i = 0; i < _MAX_TEMPLATE_NUM; i++){
	    mpCBtnTemplate[i]->Hide();
	    mpClrLabel[i]->Hide();
	}
    else
	for (int i = 0; i < _MAX_TEMPLATE_NUM; i++){
	    mpCBtnTemplate[i]->Show();
	    mpClrLabel[i]->Show();
	}
    
    wxSize winSize = mpCParentGUILink->GetSize();
    mpCParentGUILink->SetSizerAndFit(mpCParentGUILink->GetSizer());
    mpCParentGUILink->SetSize(wxDefaultCoord, wxDefaultCoord,
			      winSize.GetWidth(), wxDefaultCoord,
			      wxSIZE_USE_EXISTING);
    mpCParentGUILink->Thaw();
}

void ColorCurveTemplate_cls::
OnButtonTemplate(wxCommandEvent& event){
    int id = event.GetId();
    int index = -1;
    for (int i = 0;  i < _MAX_TEMPLATE_NUM; i++)
	if (mpCBtnTemplate[i]->GetId() == id)
	    index = i;
    if (index == -1) return;

    mpCParentGUILink->mpCCtrlLink->
	CopyColorFromP(mpCTemplate[index], TRUE);

    mpCParentGUILink->mpCMInputPanelScale->UpdateValues();
}

