// -*- c -*-
// "clsTagObject.h"

#include "clsTagObject.h"

#include "../clsMainGLCanvas.h"

#include "../../GLATTRIB/clsColorCurve.h"
#include "../../MYGL/clsGLString2D.h"

#include "../../COMMON/CommonDefinitionsGL.h"

#include "../../COMMON/CommonDefinitions.h"

#define R 0
#define G 1
#define B 2

TagObject_cls::
TagObject_cls(wxString strTag, float x, float y, float z){
    mstrTag = strTag;
    mPos[X] = x;
    mPos[Y] = y;
    mPos[Z] = z;
}

void TagObjectCtrl_cls::
InitializeStaticMembers(){
    mspCClrCurveTag   = new ColorCurve_cls(wxT("TagColor"), wxT(""), 
					   wxT("1 1 1 1"));
    msCConfListStatic.Add(&msCTagFontIndex, wxT("TagFontIndex="), wxT("4"));
}

void TagObjectCtrl_cls::
UpdateViewInformation(){
    glGetDoublev(GL_MODELVIEW_MATRIX, mMatrixModelView);
    glGetDoublev(GL_PROJECTION_MATRIX, mMatrixProjection);
    glGetIntegerv(GL_VIEWPORT, mMatrixViewport);
}

void TagObjectCtrl_cls::
CalcTagCoordinate(){
    if (mVCObject.size() == 0) return;
    
    UpdateViewInformation();
    int tagCount = mVCObject.size();
    for (int i = 0; i < tagCount; i++){
	gluProject(mVCObject[i].mPos[X], mVCObject[i].mPos[Y], mVCObject[i].mPos[Z],
		   mMatrixModelView,
		   mMatrixProjection,
		   mMatrixViewport,
		   &mVCObject[i].mCoord[X], &mVCObject[i].mCoord[Y], &mVCObject[i].mCoord[Z]);
    }
}

void TagObjectCtrl_cls::
DrawTags(GLStrings2D_cls *pCGLString2D){
    int tagCount = mVCObject.size();
    
    void* font;
    switch(msCTagFontIndex.mBody){
    case 0:
	font = GLUT_BITMAP_HELVETICA_10;
	break;
    case 1:
	font = GLUT_BITMAP_HELVETICA_12;
	break;
    case 2:
	font = GLUT_BITMAP_HELVETICA_18;
	break;
    case 3:
	font = GLUT_BITMAP_TIMES_ROMAN_10;
	break;
    case 4:
	font = GLUT_BITMAP_TIMES_ROMAN_24;
	break;
    }

    glDisable(GL_LIGHTING);
    glColor4f(mspCClrCurveTag->mCConstantColor.mpBody[R],
	      mspCClrCurveTag->mCConstantColor.mpBody[G],
	      mspCClrCurveTag->mCConstantColor.mpBody[B],
	      1.0f);
    for (int i = 0; i < tagCount; i++){
	pCGLString2D->Draw(font, mVCObject[i].mstrTag.ToAscii(), 
			   mVCObject[i].mCoord[X],
			   mVCObject[i].mCoord[Y],
			   _STRINGS_BOTTOM_LEFT);
    }
}

wxString TagObjectCtrl_cls::
SerializeStaticMember(){
    return 
	msCConfListStatic.SerializeAll() + 
	mspCClrCurveTag->Serialize();
}

void TagObjectCtrl_cls::
ReadStrLineStaticMember(std::wistream &istream, wxString strLine){
    msCConfListStatic.ReadStrLineAll(strLine);
    mspCClrCurveTag->ReadStrLine(istream, strLine);
}

ConfItemList_cls TagObjectCtrl_cls::msCConfListStatic;
ConfItemUINT_cls TagObjectCtrl_cls::msCTagFontIndex;
ColorCurve_cls* TagObjectCtrl_cls::mspCClrCurveTag = NULL;
