// -*- c++ -*- 
// "clsDistortion.cpp"
// (setq c-basic-offset 4)

#ifndef _DISTORTION_H_
#define _DISTORTION_H_

#include <vector>
#include <fstream>
#include <sstream>
#include <wx/wx.h>

class Distortion_cls{
 public:
    Distortion_cls();

    bool  mbMeshOK;
    float mObjSizeX, mObjSizeZ;
    float mTexMinX, mTexMaxX;
    float mTexMinY, mTexMaxY;
    double mRotDeg, mTiltDeg, mAngleDeg;

    std::vector < float > mVVertexX;
    std::vector < float > mVVertexY;
    std::vector < float > mVVertexZ;
    std::vector < float > mVTexcordX;
    std::vector < float > mVTexcordY;
    std::vector < float > mVTexTransformedX;
    std::vector < float > mVTexTransformedY;
    std::vector < float > mVNormalX;
    std::vector < float > mVNormalY;
    std::vector < float > mVNormalZ;

    std::vector < int > mVIndexVert;
    std::vector < int > mVIndexCoord;
    std::vector < int > mVIndexNormal;

    void ReadWavefrontObject(wxString strFilePath);
    void CheckGeometry();

    bool IsDefault();
    void UpdateTransformedTex(double rotDeg, double tiltDeg, double angleDeg);

    void SetGLSetting(int width, int height);
    void GLDrawDistortedTextureOrg(double aspectWindow, double aspectSrc, int flipFactor);
    void GLDrawDistortedTexture(double aspectWindow, double aspectSrc, bool bUseTransform, int flipFactor = 1);
};

#endif
