// -*- c -*-
// "clsGLCanvasCtrl.cpp"

#ifndef _GL_CANVAS_CTRL_H_
#define _GL_CANVAS_CTRL_H_

#include <wx/wx.h>
#include <wx/glcanvas.h>
#include <wx/clrpicker.h>
#include "../MYGL/clsPositionAndDirection.h"
#include "../WIDGETCTRL/EX/clsCheckBoxEX.h"

#include "../COMMON/CommonDefinitionsForH.h"

#include <vector>

class FrameMain_cls; 
class MainGLCanvas_cls;

class wxToggleButton; 
class BitmapPanel_cls;

#define _GL_CANVAS_DISPLAY_FREE    _DIRECTION_FREE
#define _GL_CANVAS_DISPLAY_X_PLUS  _DIRECTION_X_PLUS
#define _GL_CANVAS_DISPLAY_X_MINUS _DIRECTION_X_MINUS
#define _GL_CANVAS_DISPLAY_Y_PLUS  _DIRECTION_Y_PLUS
#define _GL_CANVAS_DISPLAY_Y_MINUS _DIRECTION_Y_MINUS
#define _GL_CANVAS_DISPLAY_Z_PLUS  _DIRECTION_Z_PLUS
#define _GL_CANVAS_DISPLAY_Z_MINUS _DIRECTION_Z_MINUS
#define _GL_CANVAS_LINKED_CAM0 7
#define _GL_CANVAS_COPY_OF_VIEW_0 7 + _PATH_NUM_MAX

class GLCanvasCtrl_cls : public wxPanel {
 public:
    GLCanvasCtrl_cls(wxWindow *parent, FrameMain_cls *pCParentFrame,
		     long style = 0,
		     const wxString& name = wxT("MainGLCanvas"),
		     const wxGLContext *contextToShare = NULL,
		     unsigned int selfIndex = 0, 
		     int displayMode = _GL_CANVAS_DISPLAY_FREE,
		     bool bUseQuadBuffer = FALSE);
    ~GLCanvasCtrl_cls();
    
    MainGLCanvas_cls *mpCGLCanvas;
    wxString         mAChoiceStr[_GL_CANVAS_LINKED_CAM0 + 1 + _PATH_NUM_MAX];
    wxString         mstrChoiceCopyOfView0;
    wxString         mAstrView[4];
    unsigned int     mSelfIndex;
    bool             mbPanelShown;

    int GetDisplayMode();

    wxPanel          *mpCBarPanel;
    wxComboBox       *mpCComboDirection;
    wxComboBox       *mpCComboView;
    wxCheckBoxEX     *mpCBoolPivot;

    BitmapPanel_cls  *mpCPanelMessage;
    BitmapPanel_cls  *mpCPanelData;
    BitmapPanel_cls  *mpCPanelItems;
    BitmapPanel_cls  *mpCPanelGrid;
    BitmapPanel_cls  *mpCPanelNavigator;

    std::vector < wxWindow* > mVpCPanelItemLink;
    
    wxMenu           *mpCPopupMenu;
    wxBoxSizer       *mpBoxSizerBar;

    bool IsPanelShown();
    void ShowPanel();
    void UpdateWindow();
    void SyncComboBox();
    
    void OnPaint(wxPaintEvent& event);
    void AutoHideAndShow(wxWindow *pCWindow);
    void OnSize (wxSizeEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnComboBox(wxCommandEvent& event);
    void SyncDisplayModeToCombobox();
    void SyncComboboxToDisplayMode();
    void OnCheckBox(wxCommandEvent& event);

    void OnMouseLMessage  (wxMouseEvent& event);
    void OnMouseLData     (wxMouseEvent& event);
    void OnMouseLItem     (wxMouseEvent& event);
    void OnMouseLGrid     (wxMouseEvent& event);
    void OnMouseLNavigator(wxMouseEvent& event);

    void OnMenuHide(wxCommandEvent& event);
    void OnMouse(wxMouseEvent& event);

    void SetParentClass(FrameMain_cls* pCParentFrame);

    void UpdateToggleButtonsAndParams();

    //wxString GetPovStrCamPos();
    //wxString GetPovStrCamMatrix();
    //wxString GetPovStrMask(int start, int end, int height, double theta);
    void ReadStrLine(wxString strLine);
    wxString Serialize();
    
    DECLARE_EVENT_TABLE()
};

#endif
