// -*- c -*-
// "clsMouseCtrl.cpp"

#ifndef _MOUSE_CTRL_H_
#define _MOUSE_CTRL_H_

#include <wx/wx.h>

#define _MOUSE_BTN_LEFT   0
#define _MOUSE_BTN_MIDDLE 1
#define _MOUSE_BTN_RIGHT  2

#define _GYRATION_FREE 0
#define _GYRATION_FIXPOS 1

class Preference_cls;

class MouseCtrl_cls{
 public:
    MouseCtrl_cls(Preference_cls* pCPreferenceLink);
    Preference_cls* mpCPreferenceLink;

    bool mbAModifier[4];
    bool mbAMouseBTN[4];
    long mMouseX, mMouseY;
    long mPrevX , mPrevY;
    long mMouseAtDownX, mMouseAtDownY;
    bool mbGyrationMode;
    bool mbButtonDown;
    bool mbButtonUp;
    bool mbMouseDragging;
    bool mbMouseWheel;
    int  mWheelRotationNormalized;
    int  mGyrationMode;

    void SetMouseInformation(wxMouseEvent &event);
    void SetPreviousPosition();
    void SetGyrationMode(wxSize sz);

    bool IsGyration();
    bool IsZoom();
    bool IsMoveCenter();
    bool IsMoveItem();
    bool IsWheel();

    bool IsShowMenu();
    bool IsHitTest();
    bool IsButton(int btnType);
    bool IsButtonDown();
    bool IsButtonUp();
    bool IsMouseDragging();
};

class MouseNormalized_cls{
 public:
    MouseNormalized_cls(MouseCtrl_cls *pCMouseCtrl, wxSize sz);
    
    float mPrevX;
    float mPrevY;
    float mCurrX;
    float mCurrY;
    float mDownX;
    float mDownY;
    bool mGyrationMode;

    void LimitMove();
    void Invert();
    double GetDX();
    double GetDY();
};

#endif
