// -*- c -*-
// "clsGrid.h"
// (setq c-basic-offset 4)

#include "clsCircle.h"

#include "../COMMON/MyVector.h"
#include "../GLCANVAS/NAVIGATORS/clsTagObject.h"

#include <math.h>

#include "../COMMON/CommonDefinitionsGL.h"
#include "../COMMON/CommonDefinitions.h"

#ifndef M_PI
#define M_PI 3.131593f
#endif

bool Circle_cls::mbInitialized = FALSE;
int  Circle_cls::mDList = -1;

void Circle_cls::
DrawMain(){
    glBegin(GL_LINE_STRIP);
    for (int i = 0; i <= 360; i+=5){
	double radian = (double)i / 180 * 3.14159;
	glVertex3d(cos(radian), sin(radian), 0); 
    }
    glEnd();
}

int Circle_cls::
DListDraw(int GLMode){
    int    listName = 0;
	
    if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE){
	listName = glGenLists(1); // VKXg̔ԍ
	glNewList (listName, GLMode); 
    }

    DrawMain();

    if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE)
	glEndList(); 
    
    return listName;
}

void Circle_cls::
InitializeIfNot(){
    if (mbInitialized == TRUE) return;
    mDList = DListDraw(GL_COMPILE);
    mbInitialized = TRUE;
}

void Circle_cls::
Draw(){
    glCallList(mDList);
}

void Circle_cls::
DrawCircles(double min, double max, int linenum, 
	    PositionAndDirection_cls CCamPos, 
	    std::vector < TagObject_cls > *pVCTagObject){
    
    double width = max - min;
    if (width == 0) width = 1;
    if (linenum < 1) linenum = 1;
    double d = width / linenum;
    for (double r = min; r <= max + 1e-6; r+= d){
	if (r < 0) continue;
	glPushMatrix();
	glScaled(r, r, r);
	Draw();
	glPopMatrix();
	if (pVCTagObject == NULL) continue;
	wxString strTag = wxString::Format(wxT("%g"), r);
	pVCTagObject->push_back(TagObject_cls(strTag, r, 0, 0));
    }
    
}
