// -*- c -*-
// "clsGrid.h"
// (setq c-basic-offset 4)

#include "clsCube.h"

#include "../COMMON/MyVector.h"

#include <math.h>

#ifdef WIN32
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#elif defined __WXMAC__
#include <OpenGL/glu.h>
#else
#include <GL/glu.h>
#endif

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

#ifndef M_PI
#define M_PI 3.131593f
#endif

#define X 0
#define Y 1
#define Z 2

bool Cube_cls::mbInitialized = FALSE;
int  Cube_cls::mDList = -1;

void Cube_cls::
DrawMain(){
    glBegin(GL_QUADS);

    glNormal3d(0, 0, 1);
    glVertex3d(-1, -1, 1);
    glVertex3d(+1, -1, 1);
    glVertex3d(+1, +1, 1);
    glVertex3d(-1, +1, 1);
    
    glNormal3d(0, 0, -1);
    glVertex3d(-1, -1, -1);
    glVertex3d(-1, +1, -1);
    glVertex3d(+1, +1, -1);
    glVertex3d(+1, -1, -1);

    glNormal3d(1, 0, 0);
    glVertex3d(1, -1, -1);
    glVertex3d(1, +1, -1);
    glVertex3d(1, +1, +1);
    glVertex3d(1, -1, +1);

    glNormal3d(-1, 0, 0);
    glVertex3d(-1, -1, -1);
    glVertex3d(-1, -1, +1);
    glVertex3d(-1, +1, +1);
    glVertex3d(-1, +1, -1);
    
    glNormal3d(0, -1, 0);
    glVertex3d(-1, -1, -1);
    glVertex3d(+1, -1, -1);
    glVertex3d(+1, -1, +1);
    glVertex3d(-1, -1, +1);

    glNormal3d(0, 1, 0);
    glVertex3d(-1, +1, -1);
    glVertex3d(-1, +1, +1);
    glVertex3d(+1, +1, +1);
    glVertex3d(+1, +1, -1);
        
    glEnd();
}

int Cube_cls::
DListDraw(int GLMode){
    int    listName = 0;
	
    if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE){
	listName = glGenLists(1); // VKXg̔ԍ
	glNewList (listName, GLMode); 
    }

    DrawMain();

    if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE)
	glEndList(); 
    
    return listName;
}

void Cube_cls::
InitializeIfNot(){
    if (mbInitialized == TRUE) return;
    mDList = DListDraw(GL_COMPILE);
    mbInitialized = TRUE;
}

void Cube_cls::
Draw(){
    glCallList(mDList);
}
