// (setq c-basic-offset 4)

#ifndef _IMAGE_IO_H_
#define _IMAGE_IO_H_

#include <string>
#include <wx/wx.h>
#include <wx/thread.h>

#include "../CONFITEM/clsConfItem.h"

class FBO_cls;
class ImageIO_cls;

#define _IMAGE_OUT_MAX_THREAD 1

class ThreadSave_cls : public wxThread {
 public:
    ThreadSave_cls(wxThreadKind kind);
    void SetParameters(bool *pbFinishedFlag, 
		       ImageIO_cls *pCParent, int width, int height, 
		       wxString strFileOut,
		       bool bUseOverlay, bool bSideBySide = FALSE,
		       unsigned char *pBuffer = NULL,
		       bool bFreeDataAtEnd = TRUE);
    bool *mpbFinishedFlagLink;
    ImageIO_cls *mpCParent;
    unsigned char *mpBuffer;
    unsigned char *mpBufferSRC;
    unsigned char *mpOverlay;
    bool mbAllocLocal;
    bool mbAllocLocalSRC;
    bool mbUseOverlay;
    bool mbSideBySide;
    int mWidth, mHeight;
    int mBufferWidth, mBufferHeight;
    wxString mstrFileOut;

    void DeclareResizing(int bufferWidth, int bufferHeight);
    void GetAverageRGB(int widthBuffer, int heightBuffer,
		       double dIndexX, double dIndexY,
		       double dIndexX2, double dIndexY2,
		       unsigned char* pBufferSRC,
		       unsigned char* pBufferTGT);
    
    virtual ExitCode Entry();
};

class ImageIO_cls {
 public:
    ImageIO_cls();
    ~ImageIO_cls();

    ConfItemList_cls mCConfList;
    ConfItemINT_cls  mCJpegQuality;
    ConfItemUINT_cls mCMultiThread;

    int mActiveThread;
    bool mbSaveThreadFinished[_IMAGE_OUT_MAX_THREAD];
    bool mbSaveThreadActive[_IMAGE_OUT_MAX_THREAD];
    ThreadSave_cls *mpCThreadSave[_IMAGE_OUT_MAX_THREAD];
    
    wxString mstrLastSavedFile;
    wxString mstrFile;

    bool SaveImageFromData(int width, int height, wxString strFileOut,
			   unsigned char* pBuffer);
    bool SaveImageFromGL(int width, int height);
    bool SaveImageFromGL(int width, int height, wxString strFileOut,
			 int offsetX = 0, int offsetY = 0);
			  
    bool SaveImageFromFBO
	(FBO_cls *pCFBOMain, FBO_cls *pCFBOOverlay, int width, int height, 
	 wxString strFileOut, bool bSideBySide = FALSE,
	 int offsetX = 0, int offsetY = 0);
			  
    bool SelectFile(wxString strDefaultDir, wxWindow *pC);
    void SetFilenameStereo(int eyeType);
    
    void ReadStrLine(wxString strLine);
    wxString Serialize();
};

#endif
