// (setq c-basic-offset 4)

#ifndef _IMG_SEQUENCE_H_
#define _IMG_SEQUENCE_H_

#include <wx/wx.h>
#include <wx/glcanvas.h>

#include "clsImgSizeTemplate.h"

#include "../COMMON/clsFilename.h"
#include "../CONFITEM/clsConfItem.h"
#include "../MYGL/clsGLPerspective.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"
#include "../WIDGETCTRL/EX/clsButtonEX.h"

class FBO_cls;
class ImgSequence_cls;
class ImageIO_cls;
class MultiInputPanel_cls;
class TimeCtrl_cls;

class ImgSequenceGUI_cls : public wxDialogEXKey, public ImgSizeTemplate_cls {
 public:
    ImgSequenceGUI_cls(ImgSequence_cls* pCParent,
		       wxWindow *pC, wxPoint pos, wxSize size);
    
    static ImgSequenceGUI_cls *mspCThis;
    ImgSequence_cls* mpCParent;

    void OnButtonInitSeq(wxCommandEvent& event);
    void OnButtonReference(wxCommandEvent &event);
    void OnButtonRender(wxCommandEvent &event);
    void OnButtonSnap(wxCommandEvent &event);
    void OnButtonClose(wxCommandEvent &event);
    void AbortRender();
    void OutputFinish();
    
    MultiInputPanel_cls* mpCMNumImgSeqParam;
    void SetMNumImgSeqParam(wxBoxSizer *pBoxSizer);
    
    wxButtonEX *mpCButtonRender;
    wxButtonEX *mpCButtonSnap;

    void Geometry();
    static void HookGeometry(void *pPanel, void *pArg);
    
 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class ImgSequence_cls : 
public DialogControl_cls{
 public:
    ImgSequence_cls(wxWindow *pCParent, TimeCtrl_cls *pCTimeCtrl);

    ImgSequenceGUI_cls *mpCGUI;
    TimeCtrl_cls       *mpCTimeCtrlLink;
    FileSequence_cls   mCFileSequence;
    
    FBO_cls *mpCFBOBuffer[2];

    ConfItemINT_cls mCInitNum;
    int             mCurrentOffset;
    int             mCurrentStereo;
    bool            mbInRendering;
    bool            mbSnapMode;

    int   mClipWidthMax;
    int   mClipHeightMax;
    float mAngleOrg;
    int   mClipWidth;
    int   mClipHeight;

    int mOffsetX, mOffsetY;
    void SetGeom(int width, int height, float angle,
		 bool bSetTrim = FALSE);
    void CalcOffset(int widthOrg, int heightOrg);
    void SetAutoInit();
    
    wxString GetWXStrModifiedFilename();
    void SetDefaultPath(wxString strPath);
    bool SaveImageFromGL(ImageIO_cls *pCImageIO, int widthOrg, int heightOrg, int offset, int stereo);
    bool SaveImageFromFBO
	(ImageIO_cls *pCImageIO, FBO_cls *pCFBO, FBO_cls *pCFBOOverlay,
	 int widthOrg, int heightOrg, int offset, int stereo,
	 bool bSideBySide = FALSE);

    void SetToDefault();
    void InitGUI(wxWindow *pC);
    void UpdateItems(bool bForce = FALSE);

    void RenderFrameBoxInRender(int width, int height, GLPerspective_cls CGLPerspective);
    void OutputFinish();
};

#endif
