// -*- c -*-
// "clsAttribItem.h"

#ifdef _USE_HDF5

#include "clsAttribItem.h"

AttribItem_cls::
AttribItem_cls(H5::Attribute &attrib, std::string stdstrParentName){
    mstrParent = wxString::FromAscii(stdstrParentName.c_str());
    mstrName = wxString::FromAscii(attrib.getName().c_str());
    mstrType = GetStrType(attrib.getDataType());
    
    hsize_t storageSize = attrib.getStorageSize();
    if (mstrType.IsSameAs(wxT("string"))){
	char *pBuf = new char [storageSize];
	attrib.read(attrib.getDataType(), pBuf);
	mstrValue = wxString::FromAscii(pBuf);
	delete pBuf;
    }
    if (mstrType.IsSameAs(wxT("int"))){
	attrib.read(attrib.getDataType(), &mValueInt);
	mstrValue << mValueInt;
    }
    if (mstrType.IsSameAs(wxT("float"))){
	attrib.read(attrib.getDataType(), &mValueFloat);
	mstrValue << mValueFloat;
    }
}

#endif
