// -*- c -*-
// "clsReadHDF5Data.cpp"

#ifndef _READ_HDF5_H_
#define _READ_HDF5_H_

#include "clsDataSetAndName.h"

class AttribItem_cls;
class wxImage;

#include <vector>
#include <wx/wx.h>

class GrammerHDF5_cls;
namespace H5{
    class H5Location;
    class CommonFG;
}

class ReadHDF5Data_cls{
public:
    ReadHDF5Data_cls();
    ~ReadHDF5Data_cls();

    std::vector < DataSetAndName_cls* > mVpCDataSetAndName;
    std::vector < AttribItem_cls* > mVpCAttribItem;

    int *mpIndexList;
    int mIndexListSize;

    wxString mstrError;
    //bool mbOpened;
#ifdef _USE_HDF5
    //H5::H5File mCFile;
    H5::H5File *mpCFile;
#endif

    void CloseProcess();
    int  GetPNum(int snap, wxString strTag);
    bool CopyHDF5DataRGB(wxImage &CImg, int index);
    bool CopyHDF5DataMono(wxImage &CImg, int index);
    DataSetAndName_cls *GetPCDataSet(wxString stcrName, int snap);
    void ReadAttrib(H5::H5Location &CGroup, std::string stdstrName);
    void ReadGroup(H5::CommonFG &CGroup);
    void ShowErrorMessage();
    bool CheckGrammer(GrammerHDF5_cls& CGrammerHDF5);
    bool ReadHDF5Data(wxString strPath);
    void MakeIndexList(GrammerHDF5_cls &CGrammerHDF5, int snap);
    void CheckIndexList(int num);
    void MakeSimpleIndexListIfNeeded(int num);
    void CopyHDF5Data3Dim(float (*pData)[3], int snap, wxString strTag);
    void CopyHDF5Data1DimFloat(float *pData, int snap, wxString strTag);
    void CopyHDF5Data1DimInt(int *pData, int snap, wxString strTag);
    void CopyHDF5Data1DimUC(unsigned char *pData, int snap, wxString strTag);
};

#endif


