// (setq c-basic-offset 4)
// "clsPreviewPanel.h"

#include "clsBtmHalfPanel.h"
#include "clsParamGUICtrl.h"

#include "../../clsFrameMain.h"
#include "../../wxWidgetEnum.h"
#include "../PARAMETER/clsParamTL.h"
#include "../PARAMETER/clsParametersPanel.h"
#include "../TIMELINE/clsPlayCtrlGUI.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../TIMELINE/clsTimeCtrlGUI.h"
#include "../TIMELINE/clsTimeCtrlGUIAA.h"
#include "../TIMELINE/clsTimeCtrlGUIAtoi.h"
#include "../TIMELINE/clsTimeCtrlGUIButtons.h"
#include "../TIMELINE/clsTimeCtrlGUITics.h"
#include "../TIMELINE/clsTimeCtrlGUIZoom.h"
#include "../WIDGETCTRL/clsBitmapPanel.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"

#include "../COMMON/CommonDefinitions.h"

#ifdef WIN32
#define _LEFT_WIDTH 69
#define _ZOOM_WIDTH 34
#else
#define _LEFT_WIDTH 73
#define _ZOOM_WIDTH 36
#endif

#define wxDefPos wxDefaultPosition

// ÓIɃCxgт
BEGIN_EVENT_TABLE(BtmHalfPanel_cls, wxPanel)
EVT_KEY_DOWN (BtmHalfPanel_cls::OnKeyDown)
END_EVENT_TABLE()

BtmHalfPanel_cls::
BtmHalfPanel_cls(wxWindow *pC, FrameMain_cls *pCFrame) : 
wxPanel(pC, wxID_ANY, wxDefaultPosition, wxDefaultSize)
{
    mpCParentFrame = pCFrame;

    wxBoxSizer  *pCBoxSizerSRC = new wxBoxSizer(wxHORIZONTAL);

    wxBoxSizer  *pCBoxSizerBase = new wxBoxSizer(wxVERTICAL);

    mpCParentFrame->GetPCTimeCtrl()->InstantiateGUIA(this);

    mpCParamGUICtrl = new ParamGUICtrl_cls
	(pCFrame->mpCParent, this, wxID_ANY, wxDefPos, wxDefaultSize);
    
    //mpCTmpA = new wxPanel(this, wxID_ANY, wxDefPos, wxSize(_TL_LEFT_WIDTH,14));
    //mpCTmpA->SetBackgroundColour(wxT("WHITE"));
    
    wxBoxSizer  *pCBoxSizerLineA = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer  *pCBoxSizerLineB = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer  *pCBoxSizerLineC = new wxBoxSizer(wxHORIZONTAL);
    
    //pCBoxSizerLineA->Add(mpCTmpA, 0, wxEXPAND);
    pCBoxSizerLineA->Add(mpCParentFrame->GetPCTimeCtrl()->mpCGUIZoom, 0, wxEXPAND);
    pCBoxSizerLineA->Add(mpCParentFrame->GetPCTimeCtrl()->mpCGUIAA, 1, wxEXPAND);

    pCBoxSizerLineB->Add(mpCParentFrame->GetPCTimeCtrl()->mpCGUIButtons, 0, wxEXPAND);
    pCBoxSizerLineB->Add(mpCParentFrame->GetPCTimeCtrl()->mpCGUITics, 1, wxEXPAND);
    
    pCBoxSizerLineC->Add(mpCParentFrame->GetPCTimeCtrl()->mpCGUIAtoi, 0, wxEXPAND);
    pCBoxSizerLineC->Add(mpCParentFrame->GetPCTimeCtrl()->mpCGUI, 1, wxEXPAND);
    
    pCBoxSizerBase->Add(pCBoxSizerLineA, 0, wxEXPAND);
    pCBoxSizerBase->Add(pCBoxSizerLineB, 0, wxEXPAND);
    pCBoxSizerBase->Add(pCBoxSizerLineC, 0, wxEXPAND);
    
    pCBoxSizerBase->Add(mpCParamGUICtrl, 1, wxEXPAND);
    pCBoxSizerBase->Add(220 + 8, 0, 0); // _
    
    mpCScroll = new wxScrolledWindow
	(this, wxID_ANY, wxDefaultPosition, 
	 wxSize(FontProvider_cls::GetScrollBarWidth(), -1),
	 wxVSCROLL | wxALWAYS_SHOW_SB);
    mpCScroll->SetTargetWindow(mpCParamGUICtrl);
    mpCParamGUICtrl->mpCScrollLink = mpCScroll;
    mpCScroll->SetScrollbars(0, 1, 0, 140);
    
    pCBoxSizerSRC->Add(pCBoxSizerBase, 1, wxEXPAND);
    pCBoxSizerSRC->Add(mpCScroll, 0, wxEXPAND);

    SetSizer(pCBoxSizerSRC);

    /*
    SetTargetWindow(mpCParamGUICtrl);
    mpCTargetWindow = mpCParamGUICtrl;
    SetScrollbars(0, 5, 0, 50);
    */
}


BtmHalfPanel_cls::
~BtmHalfPanel_cls(){
}

void BtmHalfPanel_cls::
RecheckSize(){
    //int height = mpCParamGUICtrl->GetBestSize().GetHeight();
    //mpCScroll->SetScrollbars(0, 1, 0, height);
    mpCParamGUICtrl->RecheckSize();
}

void BtmHalfPanel_cls::
RefreshTLPanels(){
    ParametersPanel_cls::SetDoubleIndex();
    mpCParamGUICtrl->RefreshPanels();
    //mpCParentFrame->GetPCTimeCtrl()->RefreshGUI();
}

void BtmHalfPanel_cls::
OnKeyDown(wxKeyEvent& event){
    // ڂ̐eSplitterȂ̂GrandParent
    event.SetId(GetGrandParent()->GetId());
    GetGrandParent()->GetEventHandler()->AddPendingEvent(event);
}

