// -*- c -*-
// "clsExposureGUI.h"

#include "../UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;
#include "../UNDO/clsUndoItemConstParam.h"

#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "clsExposure.h"
#include "clsExposureGUI.h"


#include "../../wxWidgetEnum.h"

ExposureGUI_cls::
ExposureGUI_cls(Exposure_cls *pCExposureLink, wxWindow *pCParent){
    mspCThis = this;
    mpCExposureLink = pCExposureLink;
    mpCParent = pCParent;
    mpCMInputPanel = NULL;
}

void ExposureGUI_cls::
SetPanel(wxBoxSizer *pBoxSizer){
    mpCMInputPanel = new MultiInputPanel_cls(&mpCMInputPanel, mpCParent);

    MultiInputPanel_cls* pC = mpCMInputPanel;

    pC->mTextWidth = 70;
    pC->mItemWidth = 90;
    pC->mUpdateBit = 
	_COMMAND_UPDATE_DISPLAY_GL | _COMMAND_UPDATE_DISPLAY_DRAWOPTIONS ; 

    int boxWidth = 2;
    pC->mItemWidth = -1;
    pC->CombinePointer
	(_ITEM_DUALSLIDER, &mpCExposureLink->mCLevel.mpBody, _("Level"));
    pC->SetRange(_ITEM_LASTITEM, 0, 200, 100);
    
    pC->SetInputAndSlider(_ITEM_FLOAT, &mpCExposureLink->mCGamma.mBody,
			  _("Gamma"), 50, -1);
    pC->SetRange(_ITEM_LASTITEM, 10, 300, 100);

    pC->SetInputAndSlider(_ITEM_INTEGER, &mpCExposureLink->mCHueOffset.mBody,
			  _("Hue"), 50, -1);
    pC->SetRange(_ITEM_LASTITEM, -180, 180);

    pC->SetInputAndSlider(_ITEM_INTEGER, &mpCExposureLink->mCSaturation.mBody,
			  _("Saturation"), 50, -1);
    pC->SetRange(_ITEM_LASTITEM, -100, 100);
    
    pC->mItemWidth = 80;
    mIndexDefault = pC->CombinePointerButton(wxID_ANY, wxT("Default"));
    pC->GetLastItem().mAlign = _ITEM_ALIGN_RIGHT;

    pC->FinishSetting(pBoxSizer);

    pC->mpCHookCtrl->SetFuncHook(FuncHookButton, _HOOK_BUTTON,
				 pC->GetItemId(mIndexDefault), NULL, this);
}

void ExposureGUI_cls::
FuncHookButton(void *pPanel, void *pArg){
    double *pOrgValueDouble;
    float  *pOrgValueFloat;
    int    *pOrgValueInt;
    int updateBit = _COMMAND_UPDATE_DISPLAY_EXPOSURE | _COMMAND_UPDATE_DISPLAY_GL;
    GCUndoList.OpenBlock();
    
    pOrgValueDouble = &mspCThis->mpCExposureLink->mCLevel.mpBody[0];
    GCUndoList.PushNewCommand
	(new CommandSetValue_cls(pOrgValueDouble, 0.0, updateBit),
	 new CommandSetValue_cls(pOrgValueDouble, *pOrgValueDouble, updateBit));
    GCUndoList.ExecCurrent();

    pOrgValueDouble = &mspCThis->mpCExposureLink->mCLevel.mpBody[1];
    GCUndoList.PushNewCommand
	(new CommandSetValue_cls(pOrgValueDouble, 1.0),
	 new CommandSetValue_cls(pOrgValueDouble, *pOrgValueDouble));
    GCUndoList.ExecCurrent();

    pOrgValueFloat = &mspCThis->mpCExposureLink->mCGamma.mBody;
    GCUndoList.PushNewCommand
	(new CommandSetValue_cls(pOrgValueFloat, 1.0f),
	 new CommandSetValue_cls(pOrgValueFloat, *pOrgValueFloat));
    GCUndoList.ExecCurrent();

    pOrgValueInt = &mspCThis->mpCExposureLink->mCHueOffset.mBody;
    GCUndoList.PushNewCommand
	(new CommandSetValue_cls(pOrgValueInt, 0),
	 new CommandSetValue_cls(pOrgValueInt, *pOrgValueInt));
    GCUndoList.ExecCurrent();

    pOrgValueInt = &mspCThis->mpCExposureLink->mCSaturation.mBody;
    GCUndoList.PushNewCommand
	(new CommandSetValue_cls(pOrgValueInt, 0, updateBit),
	 new CommandSetValue_cls(pOrgValueInt, *pOrgValueInt, updateBit));
    GCUndoList.ExecCurrent();
    GCUndoList.CloseBlock();
    
    mspCThis->mpCMInputPanel->UpdateValues();
}

void ExposureGUI_cls::
UpdateStatus(){
    if (mpCMInputPanel != NULL)
	mpCMInputPanel->Enable(mpCExposureLink->mbShaderAvailable);
}

ExposureGUI_cls* ExposureGUI_cls::mspCThis;
