// (setq c-basic-offset 4)
// "clsFrameMain.h"
// "wxWidgetEnum.h"

#include "../../clsFrameMain.h"

#include "../PANELS/clsShortcut.h"
#include "../WIDGETCTRL/WX/myArtProv.h"

#include "../../wxWidgetEnumMenu.h"

void FrameMain_cls::
AddBitmapMenu(wxMenu *pMenu, int ID, wxString strMain, wxString strSub, 
	      wxString strFile){
    if (strFile.IsEmpty() != TRUE){
	wxBitmap bitMap(strFile, wxBITMAP_TYPE_PNG);
	AddBitmapMenu(pMenu, ID, strMain, strSub, bitMap);  }
    else
	AddBitmapMenu(pMenu, ID, strMain, strSub, wxNullBitmap);
}

void FrameMain_cls::
AddBitmapMenu(wxMenu *pMenu, int ID, wxString strMain, wxString strSub, 
	      wxBitmap bitmap){
    wxMenuItem *pItem = new wxMenuItem(pMenu, ID, strMain, strSub);
    if (bitmap.IsOk() == TRUE)
	pItem->SetBitmap(bitmap);
    pMenu->Append(pItem);
}

void FrameMain_cls::
InitMenu(){
    mpCMenuBar = new wxMenuBar;

    // ----- FILE(&F) -----
    mpCMenuFile = new wxMenu;
    mpCShortcut->SetMenuItem(mpCMenuFile, menuFileOpenProject);
    mpCShortcut->SetMenuItem(mpCMenuFile, menuFileSaveProject);
    mpCShortcut->SetMenuItem(mpCMenuFile, menuFileSaveProjectAs);
    
    mpCMenuFile->AppendSeparator();
    mpCShortcut->SetMenuItem(mpCMenuFile, menuFileOpenData);
    mpCMenuFile->AppendSeparator();
    mpCShortcut->SetMenuItem(mpCMenuFile, menuFileSaveImageSnap);
    mpCShortcut->SetMenuItem(mpCMenuFile, menuFileSaveImageSeq);
    wxMenu *pCMenuExport = new wxMenu;
    mpCMenuFile->Append(menuFileExport, 
			wxString::Format(_T("%s(&E)"), _("Export")),
			pCMenuExport, _("Export"));
    mpCShortcut->SetMenuItem(pCMenuExport, menuFileExportData);
    mpCShortcut->SetMenuItem(pCMenuExport, menuFileExportPathPov);
        
    mpCMenuFile->AppendSeparator();
    mpCShortcut->SetMenuItem(mpCMenuFile, menuFileCloseData);
    
    mpCMenuFile->AppendSeparator();
    mpCShortcut->SetMenuItem(mpCMenuFile, Minimal_Quit, wxEmptyString, _("Quit this application"));
    
    // ----- EDIT(&E) -----
    mpCMenuEdit = new wxMenu;
    mpCShortcut->SetMenuItem(mpCMenuEdit, menuEditUndo);
    mpCShortcut->SetMenuItem(mpCMenuEdit, menuEditRedo);

    mpCMenuEdit->AppendSeparator();
    mpCShortcut->SetMenuItem(mpCMenuEdit, menuEditGo);

    mpCMenuEdit->AppendSeparator();
    mpCMenuEdit->AppendCheckItem
	(menuEditTimeRemap, 
	 wxString::Format(_T("%s(&R)"), _("Time Remap")), _("Time Remap"));
    
    mpCMenuEdit->AppendSeparator();
    wxMenu *pCMenuRemoveCache = new wxMenu;
    mpCMenuEdit->Append(menuEditRemoveCache, 
			wxString::Format(_T("%s(&D)"),_("Remove Cache")),
			pCMenuRemoveCache, _("Remove Cache"));
    mpCShortcut->SetMenuItem(pCMenuRemoveCache, menuEditRemoveCacheSnap);
    mpCShortcut->SetMenuItem(pCMenuRemoveCache, menuEditRemoveCacheAll);
    
    wxSize iconSize = wxSize(16, 16);
    mpCMenuEdit->AppendSeparator();
    mpCShortcut->SetMenuItem(mpCMenuEdit, menuEditScene, wxT("wxART_SCENE"));
    mpCShortcut->SetMenuItem(mpCMenuEdit, menuEditPreference, wxT("wxART_PREFERENCE"));
	 
    // ----- FILTER(&F) ----
    mpCMenuFilter = new wxMenu;
    mpCMenuFilterBoolean = new wxMenu;
    mpCMenuFilterBoolean->Append
	(menuFilterBoolean, wxString::Format(_T("%s(&B)"),_("Boolean")));
    mpCMenuFilterBoolean->Append
	(menuFilterFiltering, wxString::Format(_T("%s(&T)"), _("Filtering")));
    mpCMenuFilter->Append(menuFilterMenuBoolean, 
			  wxString::Format(_T("%s(&B)"),_("Bool")),
			  mpCMenuFilterBoolean, _("Boolean"));

    mpCMenuFilterObject = new wxMenu;
    mpCMenuFilterObject->Append
	(menuFilterObject, wxString::Format(_T("%s(&O)"), _("Object")));
    mpCMenuFilterObject->Append
	(menuFilterText, wxString::Format(_T("%s(&G)"), _("Text")));
    mpCMenuFilterObject->Append
	(menuFilterStick, wxString::Format(_T("%s(&S)"), _("Stick")));
    mpCMenuFilterObject->Append
	(menuFilterGrid, wxString::Format(_T("%s(&G)"), _("Grid")));
    
    mpCMenuFilter->Append(menuFilterMenuObject,
			  wxString::Format(_T("%s(&B)"), _("Object")),
			  mpCMenuFilterObject, _("Object"));

    mpCMenuFilterWorld = new wxMenu;
    mpCMenuFilterWorld->Append
	(menuFilterDataBox, wxString::Format(_T("%s(&C)"),_("DataBox")));
    mpCMenuFilterWorld->Append
	(menuFilterCopy, wxString::Format(_T("%s(&C)"),_("CopyBox")));
    mpCMenuFilterWorld->Append
	(menuFilterFog, wxString::Format(_T("%s(&F)"), _("Fog")));
    mpCMenuFilterWorld->Append
	(menuFilterBG, wxString::Format(_T("%s(&F)"), _("BG")));
    mpCMenuFilter->Append(menuFilterMenuWorld,
			  wxString::Format(_T("%s(&W)"), _("World")),
			  mpCMenuFilterWorld, _("World"));
    
    mpCMenuFilterManipulate = new wxMenu;
    mpCMenuFilterManipulate->Append
	(menuFilterUp, wxString::Format(_T("%s(&U)"), _("Up")));
    mpCMenuFilterManipulate->Append
	(menuFilterDown, wxString::Format(_T("%s(&D)"), _("Down")));
    mpCMenuFilterManipulate->AppendSeparator();
    mpCMenuFilterManipulate->Append
	(menuFilterDelete, wxString::Format(_T("%s(&X)"), _("Delete")));
    
    // ----- PovRay(&V) -----
    mpCMenuPovRay = new wxMenu;
    AddBitmapMenu
	(mpCMenuPovRay, menuDialogPovRay,
	 wxString::Format(_T("%s(&R)\tCtrl-R"), _("Pov-Ray Rendering Configure")),
	 _("PovRay"), ARTWXSIZE("wxART_POVRAY", iconSize));
    mpCMenuPovRay->AppendSeparator();
    
    mpCMenuPovRay->Append
	(menuPovExportSnap, wxString::Format(_T("%s (%s)"),
					     _("Export"), _("Snapshot")),
	 _("Export Pov-Ray scene file"));
    mpCMenuPovRay->Append
	(menuPovExportAnim, wxString::Format(_T("%s (%s)"),
					     _("Export"), _("Animation")),
	 _("Export Pov-Ray scene file"));
    mpCMenuPovRay->Append
	(menuPovRenderSnap, wxString::Format(_T("%s (%s)"),
					     _("Render"), _("Snapshot")),
	 _("Render scene using Pov-Ray"));
    mpCMenuPovRay->Append
	(menuPovRenderAnim, wxString::Format(_T("%s (%s)"),
					     _("Render"), _("Animation")),
	 _("Render scene using Pov-Ray"));
    
    // ----- VIEW(&V) -----
    wxString strViewIcons[5] = {
	wxT(""), wxT("wxART_SPLIT_V"), wxT("wxART_SPLIT_H"),
	wxT("wxART_SPLIT_4"), wxT("wxART_SPLIT_4") };
    
    mpCMenuView = new wxMenu;
    for (int i = 0; i < 5; i++)
	mpCShortcut->SetMenuItem(mpCMenuView, menuViewMainPanelType0 + i, strViewIcons[i]);

    mpCMenuView->AppendSeparator();
    mpCShortcut->SetMenuItem(mpCMenuView, menuViewExtraPanel);
    /*
    mpCMenuView->Append(menuViewExtraPanel, wxString::Format(_T("%s(&0)\tAlt-0"), _("Extra Panel")));
    */

    // ----- Dialog(&D) -----
    mpCMenuDialog = new wxMenu;
    mpCShortcut->SetMenuItem(mpCMenuDialog, menuDialogCameraPath, 
			     wxT("wxART_CAMERA"));
    mpCShortcut->SetMenuItem(mpCMenuDialog, menuDialogLightSRC,
			     wxT("wxART_LIGHT"));
    mpCShortcut->SetMenuItem(mpCMenuDialog, menuDialogColorCurve,
			     wxT("wxART_COLOR"));
    mpCShortcut->SetMenuItem(mpCMenuDialog, menuDialogTexProperty,
			     wxT("wxART_TEXTURE"));
    mpCShortcut->SetMenuItem(mpCMenuDialog, menuDialogStereogram,
			     wxT("wxART_STEREOGRAM"));
    mpCShortcut->SetMenuItem(mpCMenuDialog, menuDialogPeriodic,
			     wxT("wxART_PERIODIC"));
    
    // ----- HELP(&H) -----
    mpCMenuHelp = new wxMenu;
    mpCShortcut->SetMenuItem(mpCMenuHelp, menuHelp);
    mpCShortcut->SetMenuItem(mpCMenuHelp, Minimal_About);
    mpCShortcut->SetMenuItem(mpCMenuHelp, menuAboutGL);
    mpCShortcut->SetMenuItem(mpCMenuHelp, menuAboutNetwork);
    mpCMenuHelp->Append(menuUnlock, 
			wxString::Format(_T("%s(&U)"), _("Unlock (for Debug)")),
			_("Unlock (for Debug)"));
    mpCMenuHelp->Append(menuSpecial,
			wxString::Format(_T("%s(&S)"), _("Special (for Debug)")),
			_("Special (for Debug)"));
    
    mpCMenuBar->Append(mpCMenuFile, _("File(&F)"));
    mpCMenuBar->Append(mpCMenuEdit, _("Edit(&E)"));
    mpCMenuBar->Append(mpCMenuFilter, _("Filter(&L)"));
    mpCMenuBar->Append(mpCMenuPovRay, wxT("Pov-Ray(&P)"));
    mpCMenuBar->Append(mpCMenuView, _("View(&V)"));
    mpCMenuBar->Append(mpCMenuDialog, _("Dialog(&D)"));
    mpCMenuBar->Append(mpCMenuHelp, _("Help(&H)"));

    SetMenuBar(mpCMenuBar);
}

