// -*- c++ -*- 
// "clsGLExtraFrame.h"
// (setq c-basic-offset 4)

#include "clsGLExtraFrame.h"

#include "../GLCANVAS/clsGLCanvasCtrl.h"
#include "../PANELS/clsPreference.h"

#include "../../clsFrameMain.h"

#include "../COMMON/CommonDefinitions.h"

BEGIN_EVENT_TABLE(GLExtraFrame_cls, wxFrame)
EVT_CLOSE(wxFrameEX_cls::OnClose)
END_EVENT_TABLE();

GLExtraFrame_cls::
GLExtraFrame_cls(FrameMain_cls *pCFrameMain, wxGLContext *pCGLContext):
    wxFrameEX_cls(pCFrameMain, wxID_ANY, wxT("Extra"), wxPoint(-620, 240), wxSize(640, 120), wxNullBitmap, wxMINIMIZE_BOX | wxMAXIMIZE_BOX | wxRESIZE_BORDER | wxSYSTEM_MENU | wxCAPTION | wxCLIP_CHILDREN | wxFRAME_FLOAT_ON_PARENT | wxCLOSE_BOX) 
{
    bool bUseQuadBuffer = (pCFrameMain->mpCPreference->mCUseQuadBuffer.mBody == 0);
    
    mpCGLCtrl = new GLCanvasCtrl_cls
	(this, pCFrameMain, 
	 wxWANTS_CHARS, wxT("Extra"), pCGLContext, 4, 
	 _GL_CANVAS_DISPLAY_FREE, bUseQuadBuffer);
}

void GLExtraFrame_cls::
FullScreenMode(){
    if (IsShownOnScreen() == FALSE) return;

    if (IsFullScreen() == TRUE){
	FullScreenModeOff();
	return;
    }

    ShowFullScreen(TRUE);
    mpCGLCtrl->mpCBarPanel->Hide();
    mpCGLCtrl->Layout();
    Layout();
    Refresh(TRUE);
}

void GLExtraFrame_cls::
FullScreenModeOff(){
    if (IsShownOnScreen() == FALSE) return;
    ShowFullScreen(FALSE);
    mpCGLCtrl->mpCBarPanel->Show();
    mpCGLCtrl->Layout();
    Layout();
    Refresh(TRUE);
}
