// -*- c -*-
// "clsOverlay.h"

#ifndef _OVERRAY_H_
#define _OVERRAY_H_

#ifndef _TOP_LEFT
#define _TOP_LEFT 0
#define _TOP_RIGHT 1
#define _BTM_LEFT 2
#define _BTM_RIGHT 3
#endif

#include "../CONFITEM/clsConfItem.h"

#include <wx/wx.h>

class ColorCurve_cls;
class OverlayGUI_cls;
class Tics_cls;

class Overlay_cls{
 public:
    Overlay_cls();
    ~Overlay_cls();

    void InstantiateGUI(wxWindow *pCParent);
    
    OverlayGUI_cls *mpCGUI;

    ConfItemList_cls mCConfList;
    //ConfItemBOOL_cls mCbShowTime;
    ConfItemUINT_cls mCTimeFontFamily;
    ConfItemINT_cls  mCTimeFontPoint;
    ConfItemUINT_cls mCTimePosition;
    ConfItemSTR_cls  mCTimeTag;
    ConfItemSTR_cls  mCTimeCustomFont;
    ConfItemBOOLARRAY_cls mCbShowLegend;
    ConfItemUINT_cls mCLegendPosition;
    ConfItemUINT_cls mCLegendIgnoreAlpha;
    ConfItemUINT_cls mCLegendIgnoreTics;
    
    void SetCustomFont();

    void ReadStrLine(wxString strLine);
    wxString Serialize();
};

// ----------------------

class OverlayBase_cls {
 public:
    OverlayBase_cls(Overlay_cls* pCOverlayLink);
    Overlay_cls* mpCOverlayLink;

    int mScaleX, mScaleY;
    int mOffsetX, mOffsetY;
    void SetOffsetPos(int postype, int index, int width, int height);

    unsigned char *mpBufferRGBA;
    int mBufferWidth, mBufferHeight;

    void GenerateBufferRGBA(wxImage *pCImage, wxImage *pCImage2 = NULL);
    void DeleteBufferRGBA();
    
};

// -----------------------

class DrawTimeIndex_cls : public OverlayBase_cls {
 public:
    DrawTimeIndex_cls(Overlay_cls* pCOverlayLink);
    ~DrawTimeIndex_cls();

    void GetTimeOnBitmap(double time, wxBitmap *pCBitmap);
    void MakeTimeTexture(double time);

    void DrawTimeInfo(double time, int width, int height);

    void Initialize();
    unsigned int  mTexID;
};

// ------------------------

class DrawClrLegend_cls : public OverlayBase_cls {
 public:
    DrawClrLegend_cls(Overlay_cls* pCOverlayLink);
    ~DrawClrLegend_cls();
    
    void GetClrCurveOnBitmap(ColorCurve_cls *pCClrCurve, wxBitmap *pCBitmap);
    void GetTicsOnBitmap(Tics_cls *pCTics, wxBitmap *pCBitmap);

    void MakeClrCurveTexture(ColorCurve_cls *pCClrCurve, int texID);
    
    void DrawClrLegend(ColorCurve_cls *pCClrCurve[4], int width, int height);

    void Initialize();
    unsigned int mTexID[4];
};

#endif
