// -*- c -*-
// "clsOverlayGUI.h"

#include "../UNDO/clsUndoManager.h"

#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../WIDGETCTRL/EX/clsTextCtrlEX.h"
#include "clsOverlay.h"
#include "clsOverlayGUI.h"

OverlayGUI_cls::
OverlayGUI_cls(Overlay_cls *pCOverLayLink, wxWindow *pCParent){
    mspCThis = this;
    mpCOverlayLink = pCOverLayLink;
    mpCParent = pCParent;
    mpCMInputPanel = NULL;
}

void OverlayGUI_cls::
SetPanel(wxBoxSizer *pBoxSizer){
    mpCMInputPanel = new MultiInputPanel_cls(&mpCMInputPanel, mpCParent);

    MultiInputPanel_cls* pC = mpCMInputPanel;

    pC->mUpdateBit |= _COMMAND_UPDATE_DISPLAY_DRAWOPTIONS;

    pC->mTextWidth = 70;
    pC->mItemWidth = 90;
    pC->mUpdateBit = 
	_COMMAND_UPDATE_DISPLAY_GL | _COMMAND_UPDATE_DISPLAY_DRAWOPTIONS ; 

    wxString listPos[5] = {_("Top Left"), _("Top Right"), _("Btm Left"), _("Btm Right"), _("Do not show") };
    
    int boxWidth = 2;
    pC->CombinePointer
	(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Time"));
    pC->CombinePointerList
	(_ITEM_UINT_LIST, &mpCOverlayLink->mCTimePosition.mBody, 5, listPos);
    
    int indexTimeStr = pC->CombinePointer
	(_ITEM_STRING, &mpCOverlayLink->mCTimeTag.mstrBody);
    
    wxString listFont[8] = {wxT("Default"), wxT("Decorative"), wxT("Roman"), wxT("Script"), wxT("Swiss"), wxT("Modern"), wxT("Teletype"), wxT("Custom") };
    
    boxWidth = 2;
    pC->CombinePointer
	(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Time Style"));

    mIndexFontFamily = pC->CombinePointerList
	(_ITEM_UINT_LIST, &mpCOverlayLink->mCTimeFontFamily.mBody, 8, listFont);
    pC->CombinePointer
	(_ITEM_INTEGER_SPIN, &mpCOverlayLink->mCTimeFontPoint.mBody);
    
    boxWidth = 5;
    pC->CombinePointer
	(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Legend"));
    pC->CombinePointerList
	(_ITEM_UINT_LIST, &mpCOverlayLink->mCLegendPosition.mBody, 4, listPos);
    pC->CombinePointer
	(_ITEM_BOOL, &mpCOverlayLink->mCbShowLegend.mpbBody[0]);
    pC->GetLastItem().mItemWidth = 16;
    pC->CombinePointer
	(_ITEM_BOOL, &mpCOverlayLink->mCbShowLegend.mpbBody[1]);
    pC->GetLastItem().mItemWidth = 16;
        pC->CombinePointer
	(_ITEM_BOOL, &mpCOverlayLink->mCbShowLegend.mpbBody[2]);
    pC->GetLastItem().mItemWidth = 16;
    pC->CombinePointer
	(_ITEM_BOOL, &mpCOverlayLink->mCbShowLegend.mpbBody[3]);
    pC->GetLastItem().mItemWidth = 16;

    /*
    boxWidth = 2;
    pC->CombinePointer
	(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, wxT(" "));
    */
    
    wxString listAlpha[4] = {
	_("Show Alpha"), _("Hide Alpha") };
    pC->CombinePointerList
	(_ITEM_UINT_LIST, &mpCOverlayLink->mCLegendIgnoreAlpha.mBody, 
	 2, listAlpha, _("Alpha"));
    pC->GetLastItem().mItemWidth = -1;
    wxString listTics[4] = {
	_("Show Tics"), _("Hide Tics") };
    pC->CombinePointerList
	(_ITEM_UINT_LIST, &mpCOverlayLink->mCLegendIgnoreTics.mBody, 
	 2, listTics, _("Tics"));
    pC->GetLastItem().mItemWidth = -1;
    
    pC->FinishSetting(pBoxSizer);

    ((TextCtrlEX_cls*)(pC->mVCItemList[indexTimeStr].GetPCwxWindow()))->EnableHookSpace(FALSE);
    pC->mpCHookCtrl->SetFuncHook
	(OverlayGUI_cls::FuncHookComboBox, _HOOK_COMBOBOX);
}

void OverlayGUI_cls::
FuncHookComboBox(void *pPanel, void *pArg){
    wxCommandEvent* pEvent = (wxCommandEvent*)pArg;
    
    if (pEvent->GetId() == mspCThis->mpCMInputPanel->
	mVCItemList[mspCThis->mIndexFontFamily].mId &&
	mspCThis->mpCOverlayLink->mCTimeFontFamily.mBody == 7)
	mspCThis->mpCOverlayLink->SetCustomFont();
}

OverlayGUI_cls* OverlayGUI_cls::mspCThis = NULL;
