// -*- c -*-
// "clsParamGUICtrl.cpp"
// (setq c-basic-offset 4)

#include "../PARAMETER/clsParamGroup.h"
#include "../PARAMETER/clsParamGroupGUI.h"
#include "../PARAMETER/clsParametersPanel.h"
#include "../SCENEOBJ/clsSceneObj.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../WIDGETCTRL/clsBitmapPanel.h"
#include "clsParamGUICtrl.h"

#include "../../clsMain.h"

#include "../../wxWidgetEnumMenu.h"

BEGIN_EVENT_TABLE(ParamGUICtrl_cls, wxPanel)
#ifdef WIN32
EVT_SIZE        (ParamGUICtrl_cls::OnSize)
#endif 
EVT_PAINT       (ParamGUICtrl_cls::OnPaint)
END_EVENT_TABLE()

ParamGUICtrl_cls::
ParamGUICtrl_cls(Main_cls *pCMain,
		 wxWindow *pCParent, wxWindowID Id, 
		 wxPoint pos, wxSize size) :
wxPanel(pCParent, Id, pos, size)
{
    SetBackgroundColour(wxColour(255, 255, 128));

    mpCParent = pCParent;
    mpCMainLink = pCMain;
    mScrollPosCache = -1;
    
    mpCSizer = new wxBoxSizer(wxVERTICAL);
    SetSizer(mpCSizer);
}

void ParamGUICtrl_cls::
AddParamGroup(ParamGroup_cls* pCParamGroup){
    pCParamGroup->MakeParamGUI(this, mpCSizer);
    mVpCParamGroup.push_back(pCParamGroup);

    for (unsigned int i = 0; i < pCParamGroup->mVpCParamGroup.size(); i++){
	pCParamGroup->mVpCParamGroup[i]->MakeParamGUI(this, mpCSizer, 1);
	mVpCParamGroup.push_back(pCParamGroup->mVpCParamGroup[i]);
	
	if (pCParamGroup->mbShownOnTL == FALSE){
	    pCParamGroup->mVpCParamGroup[i]->mbShownOnTL = FALSE;
	    pCParamGroup->mVpCParamGroup[i]->mpCGUI->Hide();
	    for (unsigned int j = 0; j < pCParamGroup->mVpCParamGroup[i]->mCDimension.mBody; j++)
		pCParamGroup->mVpCParamGroup[i]->mVpCParamGUI[j]->Hide();
	}
    }
    
    if (pCParamGroup->mbShownOnTL == FALSE)
	pCParamGroup->HideItems();

    HideAndShow();
}

void ParamGUICtrl_cls::
RemoveItem(int index){
    for (int i = index; i < (int)mVpCParamGroup.size() - 1; i++)
	mVpCParamGroup[i] = mVpCParamGroup[i+1];
    mVpCParamGroup.pop_back();
}

void ParamGUICtrl_cls::
RemoveParamGroup(ParamGroup_cls* pCParamGroup){
    for (unsigned int j = 0; j < pCParamGroup->mVpCParamGroup.size(); j++)
	RemoveParamGroup(pCParamGroup->mVpCParamGroup[j]);
    for (unsigned int j = 0; j < pCParamGroup->mVpCParamGUI.size(); j++){
	bool success = mpCSizer->Detach(pCParamGroup->mVpCParamGUI[j]);
    }
    bool sccess = mpCSizer->Detach(pCParamGroup->mpCGUI);
    pCParamGroup->DestroyGUI();

    for (int i = 0; i < (int)mVpCParamGroup.size(); i++)
	if (mVpCParamGroup[i] == pCParamGroup)
	    RemoveItem(i);
}

void ParamGUICtrl_cls::
RefreshPanels(){
    for (unsigned int i = 0; i < mVpCParamGroup.size(); i++)
	mVpCParamGroup[i]->RefreshPanels();
}

void ParamGUICtrl_cls::
ChangeOtherSelector(int objIndex){
    mpCMainLink->ThisObjectIsSelected(objIndex);
}

SceneObj_cls* ParamGUICtrl_cls::
SelectObject(SceneObj_cls* pCSceneObj){
    bool bRefesh = FALSE;
    SceneObj_cls *pCSelectedObject = NULL;
    for (unsigned int i = 0; i < mVpCParamGroup.size(); i++){
	bool bSelected = mVpCParamGroup[i]->SelectObject(pCSceneObj);
	if (bSelected == TRUE && pCSceneObj != NULL &&
	    pCSceneObj->mbSelected == TRUE)
	    pCSelectedObject = pCSceneObj;
	bRefesh |= bSelected;
    }

    if (bRefesh == TRUE){
	SendEventToTop(this, wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshGL);
	SendEventToTop(this, wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshTL);
    }

    if (pCSelectedObject != NULL)
	ChangeOtherSelector(pCSelectedObject->mObjIndex);
    return pCSelectedObject;
}

SceneObj_cls* ParamGUICtrl_cls::
SelectObject(int objectIndex, int guideIndex){
    bool bRefesh = FALSE;
    SceneObj_cls *pCSelectedObject = NULL;
    for (unsigned int i = 0; i < mVpCParamGroup.size(); i++){
	bool bSelected = mVpCParamGroup[i]->SelectObject(objectIndex, guideIndex);
	if (bSelected == TRUE &&
	    mVpCParamGroup[i]->GetPCObject(objectIndex) != NULL &&
	    mVpCParamGroup[i]->GetPCObject(objectIndex)->mbSelected)
	    pCSelectedObject = mVpCParamGroup[i]->GetPCObject(objectIndex);
	
	bRefesh |= bSelected;
    }

    if (bRefesh == TRUE){
	SendEventToTop(this, wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshGL);
	SendEventToTop(this, wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshTL);
    }
    
    if (pCSelectedObject != NULL)
	ChangeOtherSelector(pCSelectedObject->mObjIndex);
    return pCSelectedObject;
}

void ParamGUICtrl_cls::
HideAndShow(){
    Freeze();

    bool bGlobalModeShy = mpCMainLink->mpCTime->mbModeShy;

    for (int i = 0; i < mVpCParamGroup.size(); i++){
	ParamGroup_cls *pCGroup = mVpCParamGroup[i];
	if (pCGroup->mpCGUI->mDepth != 0 ) continue;
	bool bShy    = pCGroup->mbModeShy & bGlobalModeShy;
	bool bFolder = pCGroup->mpCGUI->mpCBPanelFolder->mState;
	
	if (pCGroup->mbShownOnTL == TRUE && bShy == FALSE){
	    pCGroup->mpCGUI->Show();
	    if (bFolder == 0 && bShy == FALSE){
		for (int j = 0; j < mVpCParamGroup[i]->mCDimension.mBody; j++)
		    pCGroup->mVpCParamGUI[j]->Show();
	    }
	    else
		for (int j = 0; j < mVpCParamGroup[i]->mCDimension.mBody; j++)
		    pCGroup->mVpCParamGUI[j]->Hide();
	    
	    for (int j = 0; j < pCGroup->mVpCParamGroup.size(); j++){
		bool bShyj = (pCGroup->mVpCParamGroup[j]->mbModeShy | bShy) & bGlobalModeShy;
		if (bFolder == 0 && bShyj == FALSE)
		    pCGroup->mVpCParamGroup[j]->mpCGUI->Show();
		else
		    pCGroup->mVpCParamGroup[j]->mpCGUI->Hide();
		
		if (bFolder == 0 && pCGroup->mVpCParamGroup[j]->mpCGUI->mpCBPanelFolder->mState == 0 && bShyj == FALSE){
		    pCGroup->mVpCParamGroup[j]->ShowItems();
		}
		else{
		    pCGroup->mVpCParamGroup[j]->HideItems();
		}
	    }
	}
	else{
	    pCGroup->mpCGUI->Hide();
	    for (int j = 0; j < mVpCParamGroup[i]->mCDimension.mBody; j++){
		pCGroup->mVpCParamGUI[j]->Hide();
	    }
	    for (int j = 0; j < mVpCParamGroup[i]->mVpCParamGroup.size(); j++){
		pCGroup->mVpCParamGroup[j]->mpCGUI->Hide();
		pCGroup->mVpCParamGroup[j]->HideItems();
	    }
	}
    }

    //TimeRemap͕ʂ̏
    mpCMainLink->mpCTime->HideAndShowRemap();
    ResizeTL();
    Layout();

    Thaw();
}

void ParamGUICtrl_cls::
RecheckSize(){
    if (mScrollPosCache != -1){
	mpCScrollLink->Scroll(0, mScrollPosCache);
	mScrollPosCache = -1;
	Thaw();
    }
}

void ParamGUICtrl_cls::
ResizeTL(){
    int x, y;
    mpCScrollLink->GetViewStart(&x, &y);
    
    int height =  GetBestSize().GetHeight();
    mpCScrollLink->SetScrollbars(0, 1, 0, height, 0, 0, TRUE);
    if (mScrollPosCache == -1){
	mScrollPosCache = y;
	Freeze();
    }

    SendEventToTop(this, wxEVT_COMMAND_MENU_SELECTED, menuEditResizedTL);
}

void ParamGUICtrl_cls::
UpdateSnippingTag(std::vector < bool > *pVbSnipTag){
    for (unsigned int i = 0; i < mVpCParamGroup.size(); i++)
	mVpCParamGroup[i]->CheckSnippingTag(pVbSnipTag);
}

void ParamGUICtrl_cls::
OnSize(wxSizeEvent& event){
    ResizeTL();
    event.Skip();
}

void ParamGUICtrl_cls::
OnPaint(wxPaintEvent& event){
    RefreshPanels();
    event.Skip();
}
