// (setq c-basic-offset 4)
// "clsTopHalfPanel.h"

#include "clsFilterPanelPain.h"
#include "clsTopHalfPanel.h"

#include "../../clsFrameMain.h"
#include "../../clsMain.h"
#include "../../wxWidgetEnum.h"
#include "../GLATTRIB/clsGLAttributeGUI.h"
#include "../GLCANVAS/clsGLCanvasCtrl.h"
#include "../GLCANVAS/clsMainGLCanvas.h"
#include "../FILTER/clsFilterBase.h"
#include "../FILTER/clsFilterCtrl.h"
#include "../MAINCANVAS/clsDrawOption.h"
#include "../MAINCANVAS/clsDrawOptionGUI.h"
#include "../MAINCANVAS/clsExposure.h"
#include "../MAINCANVAS/clsExposureGUI.h"
#include "../MAINCANVAS/clsInformation.h"
#include "../MAINCANVAS/clsInformationGUI.h"
#include "../MAINCANVAS/clsOverlay.h"
#include "../MAINCANVAS/clsOverlayGUI.h"
#include "../MYAPI/MsgBox.h"
#include "../PARTICLEDATA/clsParticleDataSequence.h"
#include "../PANELS/clsPreference.h"
#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"

#include <wx/notebook.h>
#include <wx/sizer.h>

#include "../COMMON/CommonDefinitions.h"

/*
BEGIN_EVENT_TABLE(TopHalfPanel_cls, wxPanel)
END_EVENT_TABLE()
*/

TopHalfPanel_cls::
TopHalfPanel_cls(wxWindow *pC, FrameMain_cls *pCFrame) : 
wxPanel(pC, wxID_ANY, wxDefaultPosition, wxDefaultSize)
{
    mspCThis = this;
    mpCParentFrame = pCFrame;

    wxBoxSizer  *mpBoxSizerTop = new wxBoxSizer(wxHORIZONTAL);

    // ̃TCU[
    wxBoxSizer  *pBoxSizerLFT = new wxBoxSizer(wxVERTICAL);

    bool bUseQuadBuffer = (pCFrame->mpCPreference->mCUseQuadBuffer.mBody == 0);
    
#ifdef _NO_PANEL02
    mpCSplitterMain = NULL;
    mpCSplitterChildA = NULL;
    mpCSplitterChildB = NULL;

    mpCGLCtrl[0] = new GLCanvasCtrl_cls
	(this, mpCParentFrame,
	 wxWANTS_CHARS, wxT("MainGLCanvas 0"), NULL, 0, 
	 _GL_CANVAS_DISPLAY_FREE, bUseQuadBuffer);
    mpCGLCtrl[1] = new GLCanvasCtrl_cls
	(this, mpCParentFrame,
	 wxWANTS_CHARS, wxT("MainGLCanvas 1"), 
	 mpCGLCtrl[0]->mpCGLCanvas->mpCGLContext, 1,
	 _GL_CANVAS_DISPLAY_Z_MINUS, bUseQuadBuffer);
    mpCGLCtrl[2] = new GLCanvasCtrl_cls
	(this, mpCParentFrame,
	 wxWANTS_CHARS, wxT("MainGLCanvas 2"), 
	 mpCGLCtrl[0]->mpCGLCanvas->mpCGLContext, 2,
	 _GL_CANVAS_DISPLAY_X_PLUS, bUseQuadBuffer);
    mpCGLCtrl[3] = new GLCanvasCtrl_cls
	(this, mpCParentFrame,
	 wxWANTS_CHARS, wxT("MainGLCanvas 3"), 
	 mpCGLCtrl[0]->mpCGLCanvas->mpCGLContext, 3, 
	 _GL_CANVAS_DISPLAY_Y_PLUS, bUseQuadBuffer);
    mpCGLCtrl[1]->Hide();
    mpCGLCtrl[2]->Hide();
    mpCGLCtrl[3]->Hide();

    mpCGLCtrl[0]->Hide();
    //pBoxSizerLFT->Add( mpCGLCtrl[0], 1, wxEXPAND);

#else
    mpCSplitterMain = new
	wxSplitterWindow(this, wxID_ANY, wxDefaultPosition, 
			 wxDefaultSize, wxSP_BORDER | wxSP_3DSASH );
    mpCSplitterChildA = new
	wxSplitterWindow(mpCSplitterMain, wxID_ANY, wxDefaultPosition, 
			 wxDefaultSize, wxSP_NOBORDER | wxSP_3DSASH );
    mpCSplitterChildB = new
	wxSplitterWindow(mpCSplitterMain, wxID_ANY, wxDefaultPosition,
			 wxDefaultSize, wxSP_NOBORDER | wxSP_3DSASH );
    mpCSplitterChildA->SetSashGravity(0.5);
    mpCSplitterChildB->SetSashGravity(0.5);
    mpCSplitterMain->SetSashGravity(0.5);
    
    mpCSplitterMain->SplitHorizontally(mpCSplitterChildA, mpCSplitterChildB, 0);

    mpCGLCtrl[0] = new GLCanvasCtrl_cls
	(mpCSplitterChildA, mpCParentFrame,
	 wxWANTS_CHARS, wxT("MainGLCanvas 0"), NULL, 0, 
	 _GL_CANVAS_DISPLAY_FREE, bUseQuadBuffer);
    mpCGLCtrl[1] = new GLCanvasCtrl_cls
	(mpCSplitterChildA, mpCParentFrame,
	 wxWANTS_CHARS, wxT("MainGLCanvas 1"), 
	 mpCGLCtrl[0]->mpCGLCanvas->mpCGLContext, 1,
	 _GL_CANVAS_DISPLAY_Z_MINUS, bUseQuadBuffer);
    mpCGLCtrl[2] = new GLCanvasCtrl_cls
	(mpCSplitterChildB, mpCParentFrame,
	 wxWANTS_CHARS, wxT("MainGLCanvas 2"), 
	 mpCGLCtrl[0]->mpCGLCanvas->mpCGLContext, 2,
	 _GL_CANVAS_DISPLAY_X_PLUS, bUseQuadBuffer);
    mpCGLCtrl[3] = new GLCanvasCtrl_cls
	(mpCSplitterChildB, mpCParentFrame,
	 wxWANTS_CHARS, wxT("MainGLCanvas 3"), 
	 mpCGLCtrl[0]->mpCGLCanvas->mpCGLContext, 3, 
	 _GL_CANVAS_DISPLAY_Y_PLUS, bUseQuadBuffer);
    

    mpCSplitterChildA->SplitVertically(mpCGLCtrl[0],
				       mpCGLCtrl[1]);
    mpCSplitterChildB->SplitVertically(mpCGLCtrl[2],
				       mpCGLCtrl[3]);
    mpCSplitterChildA->Unsplit();
    mpCSplitterChildB->Unsplit();
    mpCSplitterMain->Unsplit();

    pBoxSizerLFT->Add( mpCSplitterMain, 1, wxEXPAND);

    for (int i = 0; i < 4; i++)
	for (int j = 0; j < 4; j++){
	    if (i == j) continue;
	    mpCGLCtrl[i]->mpCGLCanvas->
		mVPOtherCanvas.push_back(mpCGLCtrl[j]->mpCGLCanvas);
	}
#endif
    
    // ẼTCU[
    mpCBoxSizerRGT = new wxBoxSizer(wxVERTICAL);

    PDataSequence_cls* pCFileSeqLink = 
	mpCParentFrame->GetPCActiveFileSequence();

    // NoteBookA
    mpCNotebookGLAttrib = new wxNotebook(this, ID_BOOK_GLATTRIB);
    mpCNotebookGLAttrib->SetFont(FontProvider_cls::GetFont(3));
    pCFileSeqLink->InstantiateGLAttribGUI(mpCNotebookGLAttrib);
    
    for (int i = 0; i < _MAX_PARTICLE_TYPE; i++){
	wxString strNotebookTag;
	if (_MAX_PARTICLE_TYPE == 4)
	    strNotebookTag = wxT("Attrib ");
	else
	    strNotebookTag = wxT("P");
	strNotebookTag << i;
	pCFileSeqLink->mpCGLAttribute[i]->mpCGUI->SetPanel();
	mpCNotebookGLAttrib->AddPage
	    (pCFileSeqLink->mpCGLAttribute[i]->mpCGUI->mpCMInputPanel,
	     strNotebookTag);
    }
    
    mpCBoxSizerRGT->Add(mpCNotebookGLAttrib, 0, wxEXPAND);

    // NoteBookB
    Main_cls *pCMain = mpCParentFrame->mpCParent;
    mpCNotebookSetting = new wxNotebook(this, ID_BOOK_SETTING);
    mpCNotebookSetting->SetFont(FontProvider_cls::GetFont(3));
    
    pCMain->mpCDrawOption->InstantiateGUI(mpCNotebookSetting);
    pCMain->mpCDrawOption->mpCGUI->SetPanel(NULL);
    mpCNotebookSetting->AddPage
	(pCMain->mpCDrawOption->mpCGUI->mpCMInputPanel, _("Option"));
    
    pCMain->mpCOverlay->InstantiateGUI(mpCNotebookSetting);
    pCMain->mpCOverlay->mpCGUI->SetPanel(NULL);
    mpCNotebookSetting->AddPage
	(pCMain->mpCOverlay->mpCGUI->mpCMInputPanel, _("Overlay"));

    pCMain->mpCExposure->InstantiateGUI(mpCNotebookSetting);
    pCMain->mpCExposure->mpCGUI->SetPanel(NULL);
    mpCNotebookSetting->AddPage
	(pCMain->mpCExposure->mpCGUI->mpCMInputPanel, _("Exposure"));

    pCMain->mpCInformation->InstantiateGUI(mpCNotebookSetting);
    pCMain->mpCInformation->mpCGUI->SetPanel(NULL);
    mpCNotebookSetting->AddPage
	(pCMain->mpCInformation->mpCGUI->mpCMInputPanel, _("Info"));
    
    mpCBoxSizerRGT->Add(mpCNotebookSetting, 0, wxEXPAND);

    mpCNotebookFilter = new wxNotebook(this, ID_BOOK_FILTER);
    mpCNotebookFilter->SetFont(FontProvider_cls::GetFont(3));

    for (int i = 0; i < _MAX_FILTER_CTRL; i++)
	mpCFilterPanelPain[i] = new FilterPanelPain_cls(mpCNotebookFilter, pCMain->mpCFilterCtrl[i]);
    
    mpCNotebookFilter->AddPage(mpCFilterPanelPain[0], _("Boolean"));
    mpCNotebookFilter->AddPage(mpCFilterPanelPain[1], _("Object"));
    mpCNotebookFilter->AddPage(mpCFilterPanelPain[2], _("World"));
    
    mpCBoxSizerRGT->Add(mpCNotebookFilter, 0, wxEXPAND);
    mpCBoxSizerRGT->Add(220 + 8 + 4, 128, 0); // _
    
    mpBoxSizerTop->Add( pBoxSizerLFT, 1, wxEXPAND);
    mpBoxSizerTop->Add( mpCBoxSizerRGT, 0, wxEXPAND);
    this->SetSizer(mpBoxSizerTop);
}


TopHalfPanel_cls::
~TopHalfPanel_cls(){
    if (mpCSplitterChildA != NULL) delete mpCSplitterChildA;
    if (mpCSplitterChildB != NULL) delete mpCSplitterChildB;
    if (mpCSplitterMain   != NULL) delete mpCSplitterMain;
}

void TopHalfPanel_cls::
RecalcSize(){
    int panelHeight  = GetSize().GetHeight();
    int attribHeight = mpCNotebookGLAttrib->GetSize().GetHeight();
    int setHeight    = mpCNotebookSetting->GetSize().GetHeight();
    int setWidth     = mpCNotebookSetting->GetSize().GetWidth();
    int candidateHeight = panelHeight - attribHeight - setHeight - /*40*/60;
    
    int minSize = 0;
    for (unsigned int i = 0; i < mpCNotebookFilter->GetPageCount(); i++){
	mpCFilterPanelPain[i]->Layout();
	wxSize size = mpCFilterPanelPain[i]->GetSizer()->GetMinSize();
			 
	if (minSize < size.GetHeight())
	    minSize = size.GetHeight();
    }

    int hintSize = minSize;
    //if (hintSize > 260) hintSize = 260;
    if (hintSize > candidateHeight) hintSize = candidateHeight;
    mpCFilterPanelPain[0]->EnableScrolling(FALSE, FALSE);
    mpCNotebookFilter->SetSizeHints(/*-1*/setWidth, hintSize + 60);
    GetSizer()->Layout();

    for (int i = 0; i < _MAX_FILTER_CTRL; i++){
	mpCFilterPanelPain[i]->SetScrollbars
	    (5, 5, (setWidth) / 5, (minSize + 20) / 5);
	mpCFilterPanelPain[i]->EnableScrolling(TRUE, TRUE);
    }
}

void TopHalfPanel_cls::
SplitPanel(unsigned int type){
    mCPreviewPanelType.mBody = type;

    switch (type){
    case 0:
	mpCSplitterMain->Unsplit();
	mpCSplitterChildA->Unsplit(mpCGLCtrl[1]);
	break;
    case 1:
	mpCSplitterChildA->Unsplit();
	mpCSplitterMain->Unsplit(mpCSplitterChildB);
	mpCSplitterChildA->SplitHorizontally(mpCGLCtrl[0],
					     mpCGLCtrl[1]);
	break;
    case 2:
	mpCSplitterChildA->Unsplit();
	mpCSplitterMain->Unsplit();
	mpCSplitterChildA->SplitVertically(mpCGLCtrl[0],
					   mpCGLCtrl[1]);
	break;
    case 3:
	mpCSplitterChildA->Unsplit();
	mpCSplitterChildB->Unsplit();
	mpCSplitterMain->Unsplit();
	mpCSplitterMain->SplitHorizontally(mpCSplitterChildA, mpCSplitterChildB, 0);
	mpCSplitterChildA->SplitVertically(mpCGLCtrl[0],
					   mpCGLCtrl[1]);
	mpCSplitterChildB->SplitVertically(mpCGLCtrl[2],
					   mpCGLCtrl[3]);
	break;
    case 4:
	mpCSplitterChildA->Unsplit();
	mpCSplitterChildB->Unsplit();
	mpCSplitterMain->Unsplit();
	mpCSplitterMain->SplitVertically(mpCSplitterChildA, mpCSplitterChildB, 0);
	mpCSplitterChildA->SplitHorizontally(mpCGLCtrl[0],
					     mpCGLCtrl[1]);
	mpCSplitterChildB->SplitHorizontally(mpCGLCtrl[2],
					     mpCGLCtrl[3]);
	break;
    }
}

GLAttributeGUI_cls* TopHalfPanel_cls::
GetPCGLAttribGUI(int index){
    return 
	mpCParentFrame->GetPCActiveFileSequence()->mpCGLAttribute[index]->mpCGUI;
}

bool TopHalfPanel_cls::
CheckGLRefresh(int frame, int interpStep){
    bool bRet = TRUE;
    for (int i = 0; i <4 ;i++)
	bRet &= mpCGLCtrl[i]->mpCGLCanvas->CheckGLRefresh(frame, interpStep);
    return bRet;
}

void TopHalfPanel_cls::
ClearStatusGLPanels(){
    for (int i = 0; i <4 ;i++){
	mpCGLCtrl[i]->mpCGLCanvas->mPrevFrame = -1;
	mpCGLCtrl[i]->mpCGLCanvas->mPrevStep = -1;
    }
}

void TopHalfPanel_cls::
RefreshGLPanels(){
    for (int i = 0; i <4 ;i++){
	mpCGLCtrl[i]->UpdateToggleButtonsAndParams();
	mpCGLCtrl[i]->mpCGLCanvas->mPrevFrame = -1; // Jʒu̒Ǐ]

	mpCGLCtrl[i]->mpCGLCanvas->Refresh(FALSE);
    }
}

void TopHalfPanel_cls::
RefreshAttrib(){
    for (int i = 0; i < _MAX_PARTICLE_TYPE ;i++){
	GetPCGLAttribGUI(i)->HideAndShow();
	GetPCGLAttribGUI(i)->mpCMInputPanel->UpdateValues();
    }
    mpCParentFrame->mpCParent->mpCDrawOption->mpCGUI->mpCMInputPanel->UpdateValues();
    mpCParentFrame->mpCParent->mpCExposure->mpCGUI->mpCMInputPanel->UpdateValues();
}

void TopHalfPanel_cls::
FuncHookAttribHideAndShow(void *pPanel, void *pArg){
    for (int i = 0; i < _MAX_PARTICLE_TYPE ;i++){
	mspCThis->GetPCGLAttribGUI(i)->HideAndShow();
	mspCThis->mpCNotebookGLAttrib->GetPage(i)->Layout();
    }

    mspCThis->mpCBoxSizerRGT->Layout();
}

// ----------------------

void TopHalfPanel_cls::
OnMouse(wxMouseEvent& event){
    if (event.RightDown() == TRUE){
	/*
	for (std::list<FilterBase_cls*>::iterator itr = mpCParentFrame->mpCFilterCtrl->mVpCFilter.begin(); 
	     itr != mpCParentFrame->mpCFilterCtrl->mVpCFilter.end(); itr++)
	    if (event.GetId() == (*itr)->mpCGUIPanel->mpBTNShow->GetId()){
		PopupMenu(FilterGUI_cls::mspoPpupMenu, wxDefaultPosition);
		return;
	    }
	*/
    
	/*
	if (event.GetId() == GetId()){
	    mpCParentFrame->PopupMenu(mpCParentFrame->mpCMenuFilter, wxDefaultPosition);
	}
	*/
    }
}

/*
void TopHalfPanel_cls::
OnKeyDown(wxKeyEvent& event){
    if (event.GetKeyCode() == WXK_DELETE)
	mpCParentFrame->mpCFilterCtrl->DeleteSelectedItem();
}
*/

void     TopHalfPanel_cls::
ReDefineConfList(){
    mCConfList.Clear();
    mCConfList.Add(&mCPreviewPanelType, wxT("PreviewPanelType="), wxT("0"));
}

void     TopHalfPanel_cls::
ReadStrLine(wxString strLine){
    mCConfList.ReadStrLineAll(strLine);
    for (int i = 0; i < _GLCANVAS_INDEX_MAX; i++)
	mpCParentFrame->GetPCGLCanvasCtrl(i)->ReadStrLine(strLine);
}

wxString TopHalfPanel_cls::
Serialize(){
    wxString sOut;
    sOut << mCConfList.SerializeAll(); 
    for (int i = 0; i < _GLCANVAS_INDEX_MAX; i++)
	sOut << mpCParentFrame->GetPCGLCanvasCtrl(i)->Serialize();
    return sOut;
}

TopHalfPanel_cls* TopHalfPanel_cls::mspCThis = NULL;
