// -*- c -*-
// (setq c-basic-offset 4)
// "MsgBox.h"

#include <string>
#include <stdarg.h>

#include "MsgBox.h"

#include <iostream>

#ifdef WXWIDGETS 
//WXWIDGTES$B$N>l9g(B;

#ifdef WIN32
#define WCHARCONV(x) (wxString)wxConvLibc.cMB2WC(x)
#else
#define WCHARCONV(x) (wxString)wxConvUTF8.cMB2WC(x)
#endif

void MsgBoxf(wxWindow *pC, std::string titleStr, std::string formatStr, ...){
    va_list	argp;
    char pszBuf[1024];
    va_start(argp, formatStr);
    vsprintf( pszBuf, formatStr.c_str(), argp);
    va_end(argp);
    wxMessageBox( wxString::FromAscii(pszBuf),
		  wxString::FromAscii(titleStr.c_str()),
		  wxOK);
}

void MsgBoxf(wxWindow *pC, wxString titleStr, std::string formatStr, ...){
    va_list	argp;
    char pszBuf[1024];
    va_start(argp, formatStr);
    vsprintf( pszBuf, formatStr.c_str(), argp);
    va_end(argp);
    wxMessageBox( wxString::FromAscii(pszBuf),
		  titleStr,
		  wxOK);
}

void MsgBox(wxWindow *pC, std::string titleStr, std::string messageStr){
    wxMessageDialog* pCMsgBox
	= new wxMessageDialog(pC, 
			      WCHARCONV(messageStr.c_str()),
			      //wxString::FromAscii(messageStr.c_str()),
			      WCHARCONV(titleStr.c_str()),
			      //wxString::FromAscii(titleStr.c_str()),
			      wxOK);
    pCMsgBox->ShowModal();
    delete pCMsgBox;
}

void MsgBox(wxWindow *pC, wxString titleStr, wxString messageStr){
    wxMessageDialog* pCMsgBox
	= new wxMessageDialog(pC, titleStr, messageStr,
			      wxOK);
    pCMsgBox->ShowModal();
    delete pCMsgBox;
}

void MsgBoxfExit(wxWindow *pC, std::string titleStr, std::string formatStr, ...){
    va_list	argp;
    char pszBuf[1024];
    va_start(argp, formatStr);
    vsprintf( pszBuf, formatStr.c_str(), argp);
    va_end(argp);
    wxMessageBox( wxString::FromAscii(pszBuf),
		  wxString::FromAscii(titleStr.c_str()),
		  wxOK);
    exit(0);
}

void MsgBoxExit(wxWindow *pC, std::string titleStr, std::string messageStr){
    MsgBox(pC, titleStr, messageStr);
    exit(0);
}

int MsgBoxfYesno(wxWindow *pC, std::string titleStr, std::string formatStr, ...){
    va_list	argp;
    char pszBuf[1024];
    va_start(argp, formatStr);
    vsprintf( pszBuf, formatStr.c_str(), argp);
    va_end(argp);
    
    int retval = FALSE;
    if (wxMessageBox( wxString::FromAscii(pszBuf),
		      wxString::FromAscii(titleStr.c_str()),
		      wxOK) == wxYES)
	retval = TRUE;
    return retval;
}

int MsgBoxYesno(wxWindow *pC, std::string titleStr, std::string messageStr){
    // $B0LCV;XDj$O$7$F$bJQ$o$i$J$$!)(B(win)
    int retval = FALSE;
    wxMessageDialog* pCMsgBox
	= new wxMessageDialog(pC, 
			      //wxString::FromAscii(messageStr.c_str()),
			      WCHARCONV(messageStr.c_str()),
			      //wxString::FromAscii(titleStr.c_str()),
			      WCHARCONV(titleStr.c_str()),
			      wxYES_NO | wxICON_QUESTION );
    if (pCMsgBox->ShowModal() == wxID_YES) retval = TRUE;
    delete pCMsgBox;
    return retval;
}

int MsgBoxYesno(wxWindow *pC, const wxChar *pTitle, const wxChar *pMessage){
    // $B0LCV;XDj$O$7$F$bJQ$o$i$J$$!)(B(win)
    int retval = FALSE;
    wxMessageDialog* pCMsgBox
	= new wxMessageDialog(pC, pMessage, pTitle, wxYES_NO | wxICON_QUESTION );
    if (pCMsgBox->ShowModal() == wxID_YES) retval = TRUE;
    delete pCMsgBox;
    return retval;
}

#else
#ifdef WIN32
//WIN32NATIVE$B$N>l9g(B;

void MsgBoxf(HWND hWnd, std::string titleStr, std::string formatStr, ...){
    va_list	argp;
    char pszBuf[1024];
    va_start(argp, formatStr);
    vsprintf( pszBuf, formatStr.c_str(), argp);
    va_end(argp);
    MessageBoxA( hWnd, pszBuf, titleStr.c_str(), MB_OK);
}

void MsgBox(HWND hWnd, std::string titleStr, std::string messageStr){
    MessageBoxA( hWnd, messageStr.c_str(), titleStr.c_str(), MB_OK);
}

void MsgBoxfExit(HWND hWnd, std::string titleStr, std::string formatStr, ...){
    va_list	argp;
    char pszBuf[1024];
    va_start(argp, formatStr);
    vsprintf( pszBuf, formatStr.c_str(), argp);
    va_end(argp);
    MessageBoxA( hWnd, pszBuf, titleStr.c_str(), MB_OK);
    exit(0);
}

void MsgBoxExit(HWND hWnd, std::string titleStr, std::string messageStr){
    MsgBox(hWnd, titleStr, messageStr);
    exit(0);
}

int MsgBoxfYesno(HWND hWnd, std::string titleStr, std::string formatStr, ...){
    va_list	argp;
    char pszBuf[1024];
    va_start(argp, formatStr);
    vsprintf( pszBuf, formatStr.c_str(), argp);
    va_end(argp);
    return MessageBoxA( hWnd, pszBuf, titleStr.c_str(), MB_YESNO);
}

int MsgBoxYesno(HWND hWnd, std::string titleStr, std::string messageStr){
    return MessageBoxA( hWnd, messageStr.c_str(), titleStr.c_str(), MB_YESNO);
}

#else
//STDOUT$B$N>l9g(B;

void MsgBoxf(void* pDummy, std::string titleStr, const char *pFormat, ...){
    va_list	argp;
    char pszBuf[1024];
    va_start(argp, pFormat);
    vsprintf( pszBuf, pFormat, argp);
    va_end(argp);
    printf("%s", pszBuf);
}

void MsgBox(void* pDummy, std::string titleStr, std::string messageStr){
    std::cout << titleStr << ":" << messageStr << std::endl;
}

void MsgBoxfExit(void* pDummy, std::string titleStr, const char *pFormat, ...){
    va_list	argp;
    char pszBuf[1024];
    va_start(argp, pFormat);
    vsprintf( pszBuf, pFormat, argp);
    va_end(argp);
    printf("%s", pszBuf);
    exit(0);
}

void MsgBoxExit(void *pDummy, std::string titleStr, std::string messageStr){
    MsgBox(pDummy, titleStr, messageStr);
    exit(0);
}

#endif
#endif
