
#ifndef _MSGBOX_H
#define _MSGBOX_H

#include <string>

#ifdef WXWIDGETS

#include <wx/wx.h>

void MsgBoxf(wxWindow *pC, std::string titleStr, std::string formatStr, ...);
void MsgBoxf(wxWindow *pC, wxString titleStr, std::string formatStr, ...);
void MsgBox (wxWindow *pC, std::string titleStr, std::string messageStr);
void MsgBox (wxWindow *pC, wxString titleStr, wxString messageStr);

void MsgBoxfExit(wxWindow *pC, std::string titleStr, std::string formatStr, ...);
void MsgBoxExit (wxWindow *pC, std::string titleStr, std::string messageStr);

int  MsgBoxfYesno(wxWindow *pC, std::string titleStr, std::string formatStr, ...);
int  MsgBoxYesno (wxWindow *pC, std::string titleStr, std::string messageStr);
int  MsgBoxYesno (wxWindow *pC, const wxChar *pTitle, const wxChar *pMessage);

#else
#ifdef WIN32

#include <windows.h>

void MsgBoxf(HWND hWnd, std::string titleStr, std::string formatStr, ...);
void MsgBox (HWND hWnd, std::string titleStr, std::string messageStr);

void MsgBoxfExit(HWND hWnd, std::string titleStr, std::string formatStr, ...);
void MsgBoxExit (HWND hWnd, std::string titleStr, std::string messageStr);

int  MsgBoxfYesno(HWND hWnd, std::string titleStr, std::string formatStr, ...);
int  MsgBoxYesno (HWND hWnd, std::string titleStr, std::string messageStr);

#else

void MsgBoxf(void* pDummy, std::string titleStr, const char *pFormat, ...);
void MsgBox (void* pDummy, std::string titleStr, std::string messageStr);

void MsgBoxfExit(void* pDummy, std::string titleStr, const char *pFormat, ...);
void MsgBoxExit (void* pDummy, std::string titleStr, std::string messageStr);

#endif // WIN32
#endif

#endif // _MSGBOX_H
