// -*- c -*-
// "clsGLGuides.cpp"

#ifndef _GL_GUIDES_H_
#define _GL_GUIDES_H_

#ifdef WIN32
#include <windows.h>
#endif

#include "clsPositionAndDirection.h"

#ifdef WIN32
#include <GL/glu.h>
#elif defined __WXMAC__
#define GL_GLEXT_PROTOTYPES 
#include <OpenGL/glu.h>
#else
#define GL_GLEXT_PROTOTYPES 
#include <GL/glu.h>
#endif

#include <vector>

#define _GL_GUIDES_NOLIMIT_FOR_BOX false
#define _GL_GUIDES_WITH_LIMIT true

#define _GUIDES_TRANSLATE 0
#define _GUIDES_SCALE 1
#define _GUIDES_ROTATE 2

class GLGuides_cls{
 public:
    GLGuides_cls(int type = _GUIDES_TRANSLATE/*, int rotationDim = 4*/);

    double mArrowDir[3];
    GLuint mBuffer4Selection[100];
    GLint mHitNum;
    int  mType;
    //int  mRotationDim;
    static int msTableU[3][3];
    static int msTableV[3][3];
    bool mbDirectionInv;

    double mMatrixModelView[16];
    double mMatrixProjection[16];
    int    mMatrixViewport[4];
    void GetGLMatrixInfo();
    
    void SetArrowDir(double xlength, double ylength, double zlength);
    void DrawArrow(double length, int type = _GUIDES_TRANSLATE);
    void DrawGuide(PositionAndDirection_cls CObj,double scale,
		   PositionAndDirection_cls CParentObjPos,
		   int dragMode = -1, 
		   double *pYPR = NULL);

    void DrawAxisAndCalcDirection(double X0, double Y0, double Z0,
				  double X1, double Y1, double Z1);
    void DrawRing(double radius, int axis);
    //static void SetGLColor(int dragMode, int tgtMode);
    void DrawGuideRotation(PositionAndDirection_cls CObj, 
			   double scale, double *pYPR,
			   PositionAndDirection_cls CParentObjPos,
			   int dragMode);
    void DrawGuideArrowBox(double posBox[3], double scale, 
			   double boxScale[3], bool bLimitBox = true);
    std::vector < int > GetObjectFromList();

    void InitializeProjection();
    std::vector < int > GetSelection();
};

#endif
