// -*- c -*- 
// (setq c-basic-offset 4)
// "clsDataExporter.h"

#include "clsDataExporter.h"
#include "clsDataLoader.h"

#include "../MYAPI/MsgBox.h"
#include "../PARTICLEDATA/clsParticleDataBlock.h"
#include "../PARTICLEDATA/clsParticleDataSnap.h"
#include "../UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;
#include "../UNDO/clsUndoItemConstParam.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../WIDGETCTRL/EX/clsFileDialogEX.h"
extern wxFileDialogEX*   GpCFileDialog;
#include "../WIDGETCTRL/EX/clsListCtrlEX.h"

#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#ifdef WIN32
#define DELIM L"\\"
#define DELIMWX wxT("\\")
#else
#define DELIM L"/"
#define DELIMWX wxT("/")
#endif

#define X 0
#define Y 1
#define Z 2

BEGIN_EVENT_TABLE(DataExporterGUI_cls, wxDialog)
EVT_LIST_ITEM_RIGHT_CLICK(wxID_ANY, DataExporterGUI_cls::OnClick) 
EVT_LIST_KEY_DOWN        (wxID_ANY, DataExporterGUI_cls::OnListKeyDown)
EVT_KEY_DOWN                       (DataExporterGUI_cls::OnKeyDown)
EVT_RIGHT_UP                       (DataExporterGUI_cls::OnMouseRGT)
EVT_BUTTON(btnDataLoaderUpHead,    DataExporterGUI_cls::OnBtnUpHead)
EVT_BUTTON(btnDataLoaderDownHead,  DataExporterGUI_cls::OnBtnDownHead)
EVT_BUTTON(btnDataLoaderUpBody,    DataExporterGUI_cls::OnBtnUpBody)
EVT_BUTTON(btnDataLoaderDownBody,  DataExporterGUI_cls::OnBtnDownBody)
EVT_BUTTON(btnDataLoaderDefault,   DataExporterGUI_cls::OnBtnDefault)
EVT_MENU(menuGrammerSwapUpHead,    DataExporterGUI_cls::OnBtnUpHead)
EVT_MENU(menuGrammerSwapDownHead,  DataExporterGUI_cls::OnBtnDownHead)
EVT_MENU(menuGrammerSwapUpBody,    DataExporterGUI_cls::OnBtnUpBody)
EVT_MENU(menuGrammerSwapDownBody,  DataExporterGUI_cls::OnBtnDownBody)
EVT_MENU(menuGrammerInsertDummy1,  DataExporterGUI_cls::OnInsertDummy1)
EVT_MENU(menuGrammerInsertDummy3,  DataExporterGUI_cls::OnInsertDummy3)
EVT_MENU(menuGrammerInsertDummy10, DataExporterGUI_cls::OnInsertDummy10)
EVT_MENU(menuGrammerInsertXYZ,     DataExporterGUI_cls::OnInsertXYZ)
EVT_MENU(menuGrammerInsertVxVyVz,  DataExporterGUI_cls::OnInsertVXVYVZ)
EVT_MENU(menuGrammerInsertRadius,  DataExporterGUI_cls::OnInsertRadius)
EVT_MENU(menuGrammerInsertType,    DataExporterGUI_cls::OnInsertType)
EVT_MENU(menuGrammerInsertId,      DataExporterGUI_cls::OnInsertId)
EVT_MENU(menuGrammerInsertValue1,  DataExporterGUI_cls::OnInsertValue1)
EVT_MENU(menuGrammerInsertTime,    DataExporterGUI_cls::OnInsertTime)
EVT_MENU(menuGrammerInsertNumber,  DataExporterGUI_cls::OnInsertNumber)
EVT_MENU(menuGrammerDelete,        DataExporterGUI_cls::OnDelete)
EVT_BUTTON(btnDataExportExport,    DataExporterGUI_cls::OnButtonExport)
EVT_BUTTON(btnDataExportReference, DataExporterGUI_cls::OnButtonReference)
EVT_BUTTON(btnDataExportCopyFrom,  DataExporterGUI_cls::OnButtonCopyFromLoader)
//EVT_BUTTON(wxID_CANCEL, DataExporterGUI_cls::OnButtonClose)
END_EVENT_TABLE()

DataExporterGUI_cls::
DataExporterGUI_cls(DataExporter_cls *pCCtrl, wxWindow *pC,
		    wxPoint pos, wxSize size) :
wxDialogEXKey(pC, wxID_ANY, _("Data Exporter"), pos, size),
    GrammerBaseGUI_cls(pCCtrl)
{
    mpCCtrl = pCCtrl;
    SetScreenRectPos(&pCCtrl->mCScreenRect);
    
    wxIcon icon(wxT("ICONS/ImgSequence.png"), wxBITMAP_TYPE_PNG); //!!
    SetIcon(icon);

    // TCU[
    wxBoxSizer       *pBoxSizerSrc      = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer       *pBoxSizerParam    = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer       *pBoxSizerFormat   = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer       *pBoxSizerFormatL  = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer       *pBoxSizerFormatLT = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer       *pBoxSizerFormatLB = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer       *pBoxSizerFormatR  = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer       *pBoxSizerFormatRT = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer       *pBoxSizerFormatRB = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer       *pBoxSizerButtons  = new wxBoxSizer(wxHORIZONTAL);

    SetMNumExportParam(pBoxSizerParam);

    wxStaticText *pStaticTextHead = new wxStaticText
	(this, wxID_ANY, _("Header Format"));
    wxStaticText *pStaticTextBody = new wxStaticText
	(this, wxID_ANY, _("Body Format"));
    
    pBoxSizerFormatLT->Add(4, -1, 0, wxEXPAND);
    pBoxSizerFormatLT->Add(pStaticTextHead, 0, wxEXPAND);
    pBoxSizerFormatRT->Add(4, -1, 0, wxEXPAND);
    pBoxSizerFormatRT->Add(pStaticTextBody, 0, wxEXPAND);

    pBoxSizerFormatL->Add(pBoxSizerFormatLT, 0, wxEXPAND);
    pBoxSizerFormatR->Add(pBoxSizerFormatRT, 0, wxEXPAND);

#ifdef WIN32
    int listCtrlWidth = 260;
#else
    int listCtrlWidth = 280;
#endif
    mpCListCtrlHead = new wxListCtrlEX
	(this, wxID_ANY, wxDefaultPosition, wxSize(listCtrlWidth, 180),
	 wxLC_REPORT | wxSUNKEN_BORDER);
    SetColumn(mpCListCtrlHead);
    UpdateList(mpCListCtrlHead, mpCCtrl->mCGrammerHead); 

    mpCListCtrlBody = new wxListCtrlEX
	(this, wxID_ANY, wxDefaultPosition, wxSize(listCtrlWidth, 180),
	 wxLC_REPORT | wxSUNKEN_BORDER);
    SetColumn(mpCListCtrlBody);
    UpdateList(mpCListCtrlBody, mpCCtrl->mCGrammerBody);
    
    pBoxSizerFormatL->Add(mpCListCtrlHead, 1, wxEXPAND);
    pBoxSizerFormatR->Add(mpCListCtrlBody, 1, wxEXPAND);

    mpCBtnUpHead = new wxButtonEX(this, btnDataLoaderUpHead, wxT("Up"));
    mpCBtnDownHead = new wxButtonEX(this, btnDataLoaderDownHead, wxT("Down"));

    pBoxSizerFormatLB->Add(mpCBtnUpHead, 0, wxEXPAND);
    pBoxSizerFormatLB->Add(mpCBtnDownHead, 0, wxEXPAND);

    mpCBtnUpBody = new wxButtonEX(this, btnDataLoaderUpBody, wxT("Up"));
    mpCBtnDownBody = new wxButtonEX(this, btnDataLoaderDownBody, wxT("Down"));
    mpCBtnDefault = new wxButtonEX(this, btnDataLoaderDefault, wxT("Default"));
    
    pBoxSizerFormatRB->Add(mpCBtnUpBody, 0, wxEXPAND);
    pBoxSizerFormatRB->Add(mpCBtnDownBody, 0, wxEXPAND);
    pBoxSizerFormatRB->Add(-1, 0, wxEXPAND);
    pBoxSizerFormatRB->Add(mpCBtnDefault, 0, wxEXPAND);

    pBoxSizerFormatL->Add(pBoxSizerFormatLB, 0, wxEXPAND);
    pBoxSizerFormatR->Add(pBoxSizerFormatRB, 0, wxEXPAND);

#ifdef WIN32
    int buttonWidth=100;
#else
    int buttonWidth=140;
#endif
    mpCButtonExport =
	new wxButtonEX(this, btnDataExportExport, wxT("Export Data"),
		       wxDefaultPosition, wxSize(buttonWidth, -1));
    
    wxButtonEX *pCButtonCopy =
	new wxButtonEX(this, btnDataExportCopyFrom, wxT("Copy From Loader"),
		       wxDefaultPosition, wxSize(buttonWidth*1.5, -1));
    
    pBoxSizerButtons->Add(mpCButtonExport, 0, wxEXPAND);
    pBoxSizerButtons->Add(-1, -1, 1, wxEXPAND);
    pBoxSizerButtons->Add(pCButtonCopy, 0, wxEXPAND);

    pBoxSizerSrc->Add(pBoxSizerParam, 0, wxEXPAND);

    pBoxSizerFormat->Add(pBoxSizerFormatL, 1, wxEXPAND);
    pBoxSizerFormat->Add(pBoxSizerFormatR, 1, wxEXPAND);

    pBoxSizerSrc->Add(pBoxSizerFormat, 0, wxEXPAND);
    pBoxSizerSrc->Add(pBoxSizerButtons, 0, wxEXPAND);

    SetSizerAndFit(pBoxSizerSrc);
    
    SetMenu();

    mpCButtonExport->SetFocus();
}

void DataExporterGUI_cls::
SetMNumExportParam(wxBoxSizer *pBoxSizer){
    mpCMNumExportParam = new MultiInputPanel_cls(&mpCMNumExportParam, this);
    
    MultiInputPanel_cls *pCurr = mpCMNumExportParam;
    //pCurr->mUpdateBit = ????

    int boxWidth = 3;
    pCurr->mTextWidth = 160/*-1*/;
    pCurr->mItemWidth = -1;

    wxString strListType[2] = {
	wxT("Simple Binary"),wxT("Simple Ascii") };
    pCurr->CombinePointerList(_ITEM_UINT_LIST, &mpCCtrl->mCDataType.mBody,
			      2, strListType, _("Data Type"));

    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth,
			  _("Initial sequence"));
    pCurr->CombinePointer(_ITEM_INTEGER_SLIDER, &mpCCtrl->mCInitNum.mBody);
    pCurr->SetRange(_ITEM_LASTITEM, 0, 9999);
    pCurr->CombinePointer(_ITEM_INTEGER, &mpCCtrl->mCInitNum.mBody);
    //pCurr->mButtonWidth = -1;
    pCurr->CombinePointerButton(btnDataExportReference, _("Reference"));
    
    pCurr->mItemWidth = -1;
    pCurr->CombinePointer(_ITEM_STRING, &mpCCtrl->mCFileSequence.mstrFormat);
    
#ifdef WIN32
    pCurr->mMinimumWidth = 520;
#else
    pCurr->mMinimumWidth = 560;
#endif

    pCurr->FinishSetting(pBoxSizer);

    pCurr->mpCHookCtrl->SetFuncHook(FuncHookCombobox, _HOOK_COMBOBOX,
				    wxID_ANY, FALSE, this);
}

void DataExporterGUI_cls::
OnButtonReference(wxCommandEvent& event){
    GpCFileDialog->SetMessage(_("Select filename to export data"));
    GpCFileDialog->SetWildcard(wxT("data(*.*)|*.*"));
    GpCFileDialog->SetStyle(wxFD_SAVE | wxFD_OVERWRITE_PROMPT);
    GpCFileDialog->SetInitPathFull(mpCCtrl->mCFileSequence.GetPathStr(_FN_FULLPATH));
    
    if (GpCFileDialog->ShowModal() == wxID_OK){
	GCUndoList.PushNewCommand
	    (new CommandSetValue_cls(&mpCCtrl->mCFileSequence.mstrFormat, GpCFileDialog->GetPath(), _COMMAND_UPDATE_DISPLAY_EXPORTER),
	     new CommandSetValue_cls(&mpCCtrl->mCFileSequence.mstrFormat, mpCCtrl->mCFileSequence.mstrPath, _COMMAND_UPDATE_DISPLAY_EXPORTER));
	GCUndoList.ExecCurrent();
	mpCCtrl->mCFileSequence.Set(mpCCtrl->mCFileSequence.mstrFormat);
	//mpCCtrl->mCFileSequence.Set(GpCFileDialog->GetPath());
	if (mpCCtrl->mCFileSequence.mDigitLength != -1)
	    mpCCtrl->mCInitNum.mBody = mpCCtrl->mCFileSequence.mDigit;
	mpCMNumExportParam->UpdateValues();
    }
}

void DataExporterGUI_cls::
OnButtonCopyFromLoader(wxCommandEvent& event){
    mpCCtrl->CopyFromLoader();
    UpdateList(mpCListCtrlHead, mpCCtrlBase->mCGrammerHead);
    UpdateList(mpCListCtrlBody, mpCCtrlBase->mCGrammerBody);
}

void DataExporterGUI_cls::
OnButtonExport(wxCommandEvent& event){
    if (mpCCtrl->mbInExporting == TRUE){ 
	AbortExport(); return; }

    mpCMNumExportParam->AssignBase();
    
    mpCCtrl->mCFileSequence.Set(mpCCtrl->mCFileSequence.GetFormat());
    mpCMNumExportParam->UpdateValues();

    if (mpCCtrl->mCFileSequence.mDigitLength == -1){
	if (MsgBoxYesno(this, _("Sequence Format error"),
			_("Not Sequence. Append 4-digit tag ?")) == FALSE)
	    return;
	mpCCtrl->mCFileSequence.AppendDefaultSequenceTag();
	mpCMNumExportParam->UpdateValues();
    }

    mpCCtrlBase->SetHeaderGrammer(GetVGrammer(mpCListCtrlHead));
    mpCCtrlBase->SetBodyGrammer(GetVGrammer(mpCListCtrlBody));

    wxCommandEvent cmd(wxEVT_COMMAND_MENU_SELECTED, menuItemExportDataBegin);
    GetParent()->AddPendingEvent(cmd);
    mpCButtonExport->SetLabel(wxT("Abort Export"));
    mpCButtonExport->SetBackgroundColour(wxColour(wxT("RED")));
    mpCButtonExport->SetForegroundColour(wxColour(wxT("WHITE")));
    mpCCtrl->mbInExporting = TRUE;
}

void DataExporterGUI_cls::
OnButtonClose(wxCommandEvent& event){
    mpCMNumExportParam->UpdateValues();
    CloseEXKey();
}

void DataExporterGUI_cls::
AbortExport(){
    wxCommandEvent cmd(wxEVT_COMMAND_MENU_SELECTED, menuPlayStop);
    GetParent()->AddPendingEvent(cmd);
    ExportFinish();
}

void DataExporterGUI_cls::
ExportFinish(){
    mpCButtonExport->SetLabel(wxT("Export Data"));
    mpCButtonExport->SetBackgroundColour(wxNullColour);
    mpCButtonExport->SetForegroundColour(wxNullColour);
    mpCCtrl->mbInExporting = FALSE;
}

//--

void DataExporterGUI_cls::
OnBtnUpHead(wxCommandEvent& event){
    SwapList(mpCListCtrlHead, 0, -1);
}

void DataExporterGUI_cls::
OnBtnDownHead(wxCommandEvent& event){
    SwapList(mpCListCtrlHead, 0, +1);
}

void DataExporterGUI_cls::
OnBtnUpBody(wxCommandEvent& event){
    SwapList(mpCListCtrlBody, 1, -1);
}

void DataExporterGUI_cls::
OnBtnDownBody(wxCommandEvent& event){
    SwapList(mpCListCtrlBody, 1, +1);
}

void DataExporterGUI_cls::
OnBtnDefault(wxCommandEvent& event){
    SetToDefault(this, mpCCtrl->mCGrammerHead, mpCCtrl->mCGrammerBody);
}

void DataExporterGUI_cls::
OnInsertDummy1(wxCommandEvent &event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_DUMMY1, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataExporterGUI_cls::
OnInsertDummy3(wxCommandEvent &event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_DUMMY3, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataExporterGUI_cls::
OnInsertDummy10(wxCommandEvent &event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_DUMMY10, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataExporterGUI_cls::
OnInsertXYZ(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_XYZ, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataExporterGUI_cls::
OnInsertVXVYVZ(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_VXVYVZ, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataExporterGUI_cls::
OnInsertRadius(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_RADIUS, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataExporterGUI_cls::
OnInsertType(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_TYPE, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataExporterGUI_cls::
OnInsertId(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_ID, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataExporterGUI_cls::
OnInsertValue1(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_VALUE1, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataExporterGUI_cls::
OnInsertTime(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_TIME, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataExporterGUI_cls::
OnInsertNumber(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_NUMBER, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataExporterGUI_cls::
OnDelete(wxCommandEvent &event){
    DeleteSelectedItem(GetPActiveListCtrl());
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataExporterGUI_cls::
OnClick(wxListEvent& event){
    if (event.GetId() == mpCListCtrlHead->GetId()){
	mActiveList = 0;
	UpdateMenuHead();
	PopupMenu(mpPopupMenuHeader);
    }
    else{
	mActiveList = 1;
	UpdateMenuBody();
	PopupMenu(mpPopupMenuBody);
    }
}

void DataExporterGUI_cls::
OnListKeyDown(wxListEvent& event){
    if (event.GetKeyCode() == WXK_DELETE){
	DeleteSelectedItem(GetPActiveListCtrl());
	UpdateIndexAndColor(GetPActiveListCtrl());
    }
    event.Skip();
}

void DataExporterGUI_cls::
OnKeyDown(wxKeyEvent& event){
    /*
    if (event.GetModifiers() == wxMOD_CONTROL)
	switch(event.GetKeyCode()){
	case 'O': {
	    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuFileOpenProject);
	    GpCMainFrameCLS->AddPendingEvent(com);
	    break; }
	}
    */
}

void DataExporterGUI_cls::
OnMouseRGT(wxMouseEvent& event){
    if (event.GetId() == mpCListCtrlHead->GetId()){
	mActiveList = 0;
	UpdateMenuHead();
	PopupMenu(mpMenuInsertHead);
    }
    else if (event.GetId() == mpCListCtrlBody->GetId()){
	mActiveList = 1;
	UpdateMenuBody();
	PopupMenu(mpMenuInsertBody);
    }
}

void DataExporterGUI_cls::
FuncHookCombobox(void *pEvent, void *pArg){
    DataExporterGUI_cls *pThis = (DataExporterGUI_cls*)pEvent;
    pThis->OnHookCombobox();
}

// ---

DataExporter_cls::
DataExporter_cls(Main_cls *pCMain, DataLoader_cls *pCDataLoaderLink) :
//mCFileSequence(wxGetCwd() + DELIMWX + wxT("Data%04d.bin3")),
GrammerBase_cls(wxT("DataExport"))
{
    mpCGUI = NULL;
    mpCMainLink = pCMain;
    mpCDataLoaderLink = pCDataLoaderLink;

    mCConfList.Add(&mCLastSavedFile, wxT("DataExportLastSavedFile="), wxT("NONE"));
    mCConfList.Add(&mCInitNum, wxT("DataExportInitNum="), wxT("0"));
}

void DataExporter_cls::
InitGUI(wxWindow *pC){
    mpCGUI = new DataExporterGUI_cls(this, pC,
				     mCScreenRect.GetPosition(),
				     mCScreenRect.GetSize());
    SetPDialog(mpCGUI);
}

void DataExporter_cls::
OpenWindow(wxWindow *pCParent){
    if (mpCGUI == NULL) InitGUI(pCParent);
    if (mpCGUI->IsShownOnScreen() == FALSE){
	mpCGUI->Show(TRUE);
	mpCGUI->SetFocus();
    }
    else
	mpCGUI->SetFocus();

    mpCGUI->Raise();
}

void DataExporter_cls::
UpdateItems(bool bForce){
    mpCGUI->mpCMNumExportParam->UpdateValues(_MN_ALLITEM);
}

void DataExporter_cls::
ExportFinish(){
    if (mpCGUI != NULL)
	mpCGUI->ExportFinish();
}

bool DataExporter_cls::
ExportBinary(wxString strFilename, PDataBlock_cls *pCDataBlock, int downsize){
    FILE *fp = fopen(strFilename.char_str(), "wb");
    if (fp == NULL) return FALSE;

    std::vector < int > VGrammerHead, VGrammerBody;
    for (int i = 0; i < (int)mCGrammerHead.mDimension; i++)
	VGrammerHead.push_back(mCGrammerHead.mpBody[i]);
    for (int i = 0; i < (int)mCGrammerBody.mDimension; i++)
	VGrammerBody.push_back(mCGrammerBody.mpBody[i]);

    float  time = pCDataBlock->mpCParentSnap->mTime;
    int    PNum = pCDataBlock->mPNumBlock;

    int    PNumDownsized = PNum/downsize;
    if (PNum % downsize != 0) PNumDownsized++;

    printf("%S time=%f\n", strFilename.c_str(), time);

    float dummy[10];

    if (PNum == 0 || pCDataBlock->mbAllocated == FALSE) {
	fclose(fp);
	return FALSE;
    }

    int headNumber = VGrammerHead.size();
    for (int i = 0; i < headNumber; i++){
	switch(VGrammerHead[i]){
	case _GRAMMER_TIME:
	    fwrite(&time, sizeof(float), 1, fp);
	    break;
	case _GRAMMER_NUMBER:
	    fwrite(&PNumDownsized, sizeof(int), 1, fp);
	    break;
	case _GRAMMER_DUMMY1:
	    fwrite(&dummy, sizeof(float), 1, fp);
	    break;
	case _GRAMMER_DUMMY3:
	    fwrite(&dummy, sizeof(float), 3, fp);
	    break;
	case _GRAMMER_DUMMY10:
	    fwrite(&dummy, sizeof(float), 10, fp);
	    break;
	}
    }

    float (*pX)[3] = pCDataBlock->mpX;
    float (*pV)[3] = pCDataBlock->mpV;
    float *pRadius = pCDataBlock->mpRadius;
    float *pValue1 = pCDataBlock->mpValue1;
    unsigned char *pTypeChar = pCDataBlock->mpType;
    int   *pID     = pCDataBlock->mpID;
    bool  bUseID   = pCDataBlock->mbUseID;

    int itemNumber = VGrammerBody.size();
    for (int i = 0; i < PNum; i+=downsize){
	for (int j = 0; j < itemNumber; j++){
	    switch(VGrammerBody[j]){
	    case _GRAMMER_XYZ:
		fwrite(&pX[i], sizeof(float), 3, fp);
		break;
	    case _GRAMMER_VXVYVZ:
		fwrite(&pV[i], sizeof(float), 3, fp);
		break;
	    case _GRAMMER_RADIUS:
		fwrite(&pRadius[i], sizeof(float), 1, fp);
		break;
	    case _GRAMMER_TYPE: {
		int type = (int)pTypeChar[i];
		fwrite(&type, sizeof(int), 1, fp);
		break; }
	    case _GRAMMER_ID:
		if (bUseID == TRUE)
		    fwrite(&pID[i], sizeof(int), 1, fp);
		else
		    fwrite(&i, sizeof(int), 1, fp);
		break;
	    case _GRAMMER_VALUE1:
		fwrite(&pValue1[i], sizeof(int), 1, fp);
		break;
	    case _GRAMMER_DUMMY1:
		fwrite(&dummy, sizeof(float), 1, fp);
		break;
	    case _GRAMMER_DUMMY3:
		fwrite(&dummy, sizeof(float), 3, fp);
		break;
	    case _GRAMMER_DUMMY10:
		fwrite(&dummy, sizeof(float), 10, fp);
		break;
	    }
	}
    }
    
    fclose(fp);
    mCurrentOffset++;
    return TRUE;
}

bool DataExporter_cls::
ExportAscii(wxString strFilename, PDataBlock_cls *pCDataBlock, int downsize){
    FILE *fp = fopen(strFilename.char_str(), "wt");
    if (fp == NULL) return FALSE;

    std::vector < int > VGrammerHead, VGrammerBody;
    for (int i = 0; i < (int)mCGrammerHead.mDimension; i++)
	VGrammerHead.push_back(mCGrammerHead.mpBody[i]);
    for (int i = 0; i < (int)mCGrammerBody.mDimension; i++)
	VGrammerBody.push_back(mCGrammerBody.mpBody[i]);

    float  time = pCDataBlock->mpCParentSnap->mTime;
    int    PNum = pCDataBlock->mPNumBlock;

    int    PNumDownsized = PNum/downsize;
    if (PNum % downsize != 0) PNumDownsized++;

    printf("%S time=%f\n", strFilename.c_str(), time);

    int headNumber = VGrammerHead.size();
    for (int i = 0; i < headNumber; i++){
	switch(VGrammerHead[i]){
	case _GRAMMER_TIME:
	    fprintf(fp, "%f\n", time);
	    break;
	case _GRAMMER_NUMBER:
	    fprintf(fp, "%d\n", PNumDownsized);
	    break;
	case _GRAMMER_DUMMY1:
	    fprintf(fp, "dummy");
	    break;
	case _GRAMMER_DUMMY3:
	    for (int i = 0; i < 3; i++)
		fprintf(fp, "dummy");
	    break;
	case _GRAMMER_DUMMY10:
	    for (int i = 0; i < 10; i++)
		fprintf(fp, "dummy");
	    break;
	}
    }
    
    float (*pX)[3] = pCDataBlock->mpX;
    float (*pV)[3] = pCDataBlock->mpV;
    float *pRadius = pCDataBlock->mpRadius;
    float *pValue1 = pCDataBlock->mpValue1;
    unsigned char *pTypeChar = pCDataBlock->mpType;
    int   *pID     = pCDataBlock->mpID;
    bool  bUseID   = pCDataBlock->mbUseID;

    int itemNumber = VGrammerBody.size();
    for (int i = 0; i < PNum; i+=downsize){
	for (int j = 0; j < itemNumber; j++){
	    switch(VGrammerBody[j]){
	    case _GRAMMER_XYZ:
		fprintf(fp, "%f %f %f ", pX[i][X], pX[i][Y], pX[i][Z]);
		break;
	    case _GRAMMER_VXVYVZ:
		fprintf(fp, "%f %f %f ", pV[i][X], pV[i][Y], pV[i][Z]);
		break;
	    case _GRAMMER_RADIUS:
		fprintf(fp, "%f ", pRadius[i]);
		break;
	    case _GRAMMER_TYPE: {
		int type = (int)pTypeChar[i];
		fprintf(fp, "%d ", type);
		break; }
	    case _GRAMMER_ID:
		if (bUseID == TRUE)
		    fprintf(fp, "%d ", pID[i]);
		else
		    fprintf(fp, "%d ", i);
		break;
	    case _GRAMMER_VALUE1:
		fprintf(fp, "%f ", pValue1[i]);
		break;
	    case _GRAMMER_DUMMY1:
		fprintf(fp, "0 ");
		break;
	    case _GRAMMER_DUMMY3:
		fprintf(fp, "0 ");
		break;
	    case _GRAMMER_DUMMY10:
		fprintf(fp, "0 ");
		break;
	    }
	}
	fprintf(fp, "\n");
    }
    
    fclose(fp);
    mCurrentOffset++;
    return TRUE;
}

wxString DataExporter_cls::
GetWXStrModifiedFilename(){
    return mCFileSequence.GetModifiedStr(mCurrentOffset + mCInitNum.mBody);
}

void DataExporter_cls::
ExportData(PDataBlock_cls *pCDataBlock, int downsize, int index){
    if (index == mCurrentIndex) return;
    if (mCDataType.mBody == _DATA_SIMPLEBINARY)
	ExportBinary(GetWXStrModifiedFilename(), pCDataBlock, downsize);
    else
	ExportAscii(GetWXStrModifiedFilename(), pCDataBlock, downsize);
    mCurrentIndex = index;
}

void DataExporter_cls::
CopyFromLoader(){
    mCGrammerHead.mDimension = mpCDataLoaderLink->mCGrammerHead.mDimension;
    for (unsigned int i = 0; i < mCGrammerHead.mDimension; i++)
	mCGrammerHead.mpBody[i] = mpCDataLoaderLink->mCGrammerHead.mpBody[i];
    mCGrammerBody.mDimension = mpCDataLoaderLink->mCGrammerBody.mDimension;
    for (unsigned int i = 0; i < mCGrammerBody.mDimension; i++)
	mCGrammerBody.mpBody[i] = mpCDataLoaderLink->mCGrammerBody.mpBody[i];
}

//----

void DataExporter_cls::
ReadStrLine(wxString strLine){
    mCConfList.ReadStrLineAll(strLine);
}

wxString DataExporter_cls::
Serialize(){
    return mCConfList.SerializeAll();
}
