// -*- c++ -*- 
// "clsDataLoader.cpp"
// (setq c-basic-offset 4)

#ifndef _DATA_LOADER_H_
#define _DATA_LOADER_H_

#define _GRAMMER_XYZ 0
#define _GRAMMER_VXVYVZ 1
#define _GRAMMER_DUMMY1 2
#define _GRAMMER_DUMMY3 3
#define _GRAMMER_DUMMY10 4
#define _GRAMMER_RADIUS 5
#define _GRAMMER_ID 6
#define _GRAMMER_TYPE 7
#define _GRAMMER_VALUE1 8
#define _GRAMMER_INDEX  9
#define _GRAMMER_AXAYAZ 10
#define _GRAMMER_JXJYJZ 11
#define _GRAMMER_DRADIUS 12
#define _GRAMMER_DVALUE1 13

#define _GRAMMER_TIME 0
#define _GRAMMER_NUMBER 1

#include "../CONFITEM/clsConfItem.h"

#include "clsGrammerBase.h"
#include "../HDF5/clsGrammerHDF5.h"

#include <wx/wx.h>

class DataLoaderGUI_cls;
class Main_cls;
class PeriodicBoundary_cls;

#define _DATA_SIMPLEBINARY 0
#define _DATA_SIMPLEASCII  1
#define _DATA_HDF5_SIMPLE  2
#define _DATA_HDF5_TOKI    3

#define _PNUM_CONSTANT  0
#define _PNUM_VARIABLE  1
#define _PNUM_ID_SORTED 2

class DataLoader_cls;

class DataLoaderInfo_cls{
public:
    void SetInfo(DataLoader_cls *pCParent);
    int mDataType;
    int mInterpType;
    int mVariablePNum;
    int mPNumLimit;
    int mSearchLimit;
};

class DataLoader_cls : public GrammerBase_cls {
 public: 
    DataLoader_cls(Main_cls *pCMain);
    ~DataLoader_cls();

    Main_cls *mpCMainLink;
    PeriodicBoundary_cls *mpCPeriodicLink;
    
    DataLoaderGUI_cls *mpCGUI;
    GrammerHDF5_cls   mCGrammerHDF5;

    DataLoaderInfo_cls mCLoadInfo;

    ConfItemSTR_cls   mCLastOpenedFile;
    ConfItemUINT_cls  mCInterpType;
    ConfItemUINT_cls  mCVariablePNum;
    ConfItemUINT_cls  mCReadSequence;
    ConfItemUINT_cls  mCPNumLimit;
    ConfItemUINT_cls  mCSearchLimit;
    ConfItemFLOATARRAY_cls mCAdjustTranslate;
    ConfItemFLOAT_cls mCAdjustScale;
    ConfItemFLOAT_cls mCAdjustValue1;
    ConfItemUINT_cls  mCLogarithmValue1;

    void SetToDefault();
    void InitGUI(wxWindow *pCParent);
    void OpenWindow(wxWindow *pCParent);
    void UpdateListFromGrammer();

    int  GetHDF5Order();
    
    void SetLoadInfo();
    bool OpenDataFileHDF5(wxString strFilePath);
    void OpenDataFile(wxString strFilePath);

    void ReadStrLine(wxString strLine);
    wxString Serialize();
};

#endif
