// -*- c++ -*- 
// "clsDataLoader.cpp"
// (setq c-basic-offset 4)

#ifndef _DATA_LOADER_GUI_H_
#define _DATA_LOADER_GUI_H_

#include "clsGrammerBase.h"

#include "../HDF5/clsHDF5GUI.h"

#include "../WIDGETCTRL/clsDialogEXKey.h"
#include <wx/wx.h>
#include <wx/notebook.h>

class DataLoader_cls;
class MultiInputPanel_cls;
class wxButtonEX;

class DataLoaderGUI_cls : public wxDialogEXKey, GrammerBaseGUI_cls
{
 public: 
    DataLoaderGUI_cls(wxWindow *pCParent, DataLoader_cls *pCCtrl);
    ~DataLoaderGUI_cls();

    wxWindow *mpCParent;
    DataLoader_cls *mpCCtrl;

    HDF5GUI_cls *mpCHDF5GUI;
    
    wxButton *mpCButtonCheckHDF5;

    wxStaticText   *mpCStaticTextHead;
    wxStaticText   *mpCStaticTextBody;
    
    wxNotebook *mpCBook1;

    MultiInputPanel_cls* mpCMInput;
    MultiInputPanel_cls* mpCMInputManipulate;
    MultiInputPanel_cls* mpCMInputLimitter;
    MultiInputPanel_cls* mpCMInputPeriodic;
    void SetMInput(wxBoxSizer *pBoxSizer);
    void SetMInputModifier(wxWindow *pCParent);
    void SetMInputLimitter(wxWindow *pCParent);
    void SetMInputPeriodic(wxBoxSizer *pBoxSizer);
    
    void HideAndShow();
    void UpdateListFromGrammer();
    
    bool CheckDataHDF5(wxString strFilePath);

    void SetFileDialogInfo();
    void OnBtnCheckHDF5(wxCommandEvent& event);
    void OnBtnOpenFile(wxCommandEvent& event);
    void OnBtnUpHead(wxCommandEvent& event);
    void OnBtnDownHead(wxCommandEvent& event);
    void OnBtnUpBody(wxCommandEvent& event);
    void OnBtnDownBody(wxCommandEvent& event);
    void OnBtnDefault(wxCommandEvent& event);
    //void UpdatePeriodicButtonLabel();
    void OnBtnPeriodic(wxCommandEvent &event);
    void OnInsertDummy1(wxCommandEvent &event);
    void OnInsertDummy3(wxCommandEvent &event);
    void OnInsertDummy10(wxCommandEvent &event);
    void OnInsertXYZ(wxCommandEvent &event);
    void OnInsertVXVYVZ(wxCommandEvent &event);
    void OnInsertRadius(wxCommandEvent &event);
    void OnInsertType(wxCommandEvent &event);
    void OnInsertId(wxCommandEvent &event);
    void OnInsertValue1(wxCommandEvent &event);
    void OnInsertTime(wxCommandEvent &event);
    void OnInsertNumber(wxCommandEvent &event);
    void OnDelete(wxCommandEvent &event);
    void OnClick(wxListEvent& event);
    void OnListKeyDown(wxListEvent& event);
    void OnKeyDown(wxKeyEvent& event);

    static void FuncHookCombobox(void *pEvent, void *pArg);
    
    DECLARE_EVENT_TABLE()
};

#endif
