// -*- c++ -*- 
// "clsGrammerBase.cpp"
// (setq c-basic-offset 4)

#ifndef _GRAMMER_BASE_H_
#define _GRAMMER_BASE_H_

#include "../CONFITEM/clsConfItem.h"
#include "../WIDGETCTRL/EX/clsButtonEX.h"

#include <vector>
#include <wx/wx.h>
#include <wx/listctrl.h>

class GrammerBase_cls;
class wxListCtrlEX;

// ----

class GrammerBaseGUI_cls{
 public:
    GrammerBaseGUI_cls(GrammerBase_cls *mpCCtrlBase);
    ~GrammerBaseGUI_cls();

    GrammerBase_cls *mpCCtrlBase;

    wxListCtrlEX   *mpCListCtrlHead;
    wxListCtrlEX   *mpCListCtrlBody;

    wxButtonEX     *mpCBtnUpHead;
    wxButtonEX     *mpCBtnDownHead;
    wxButtonEX     *mpCBtnUpBody;
    wxButtonEX     *mpCBtnDownBody;
    wxButtonEX     *mpCBtnDefault;
    wxButtonEX     *mpCBtnLoad;
    wxButtonEX     *mpCBtnSave;

    wxMenu         *mpPopupMenuHeader;
    wxMenu         *mpPopupMenuBody;
    wxMenu         *mpMenuInsertHead;
    wxMenu         *mpMenuInsertBody;

    int mActiveList;

    wxListCtrl*     GetPActiveListCtrl();
    std::vector < int > GetVGrammer(wxListCtrl* pCList);
    
    void SetMenu();
    void SetColumn(wxListCtrl *pCList);
    void SetToDefault(wxWindow *pCParent, 
		      ConfItemINTARRAY_cls &CGrammerHead, 
		      ConfItemINTARRAY_cls &CGrammerBody);
    void UpdateList(wxListCtrl *pCList, ConfItemINTARRAY_cls &Grammer);
    void DeleteSelectedItem(wxListCtrl *pCList);
    void AddListItem(wxListCtrl *pCList, wxInt32 nID, 
		     int typeItem, int typeFormat);
    void UpdateIndexAndColor(wxListCtrl *pCList);
    void SwapList(wxListCtrl *pCList, int typeFormat, int direction);

    void ClearMenu(wxMenu *pMenu);
    void UpdateMenuHead();
    void UpdateMenuBody();
    void OnHookCombobox();

    std::vector < wxString > mstrItemName[2];
    std::vector < wxString > mstrItemDescript[2];
    std::vector < wxString > mstrItemByte[2];
};

class GrammerBase_cls{
public:
    GrammerBase_cls(wxString strTag = wxT(""));
    
    wxString mstrTag;
    ConfItemList_cls  mCConfList;

    ConfItemINT_cls   mCDataType;
    ConfItemINTARRAY_cls mCGrammerBody;
    ConfItemINTARRAY_cls mCGrammerHead;

    bool IsItemExistHead(int itemID);
    bool IsItemExistBody(int itemID);
    void SetHeaderGrammer(std::vector < int > VHeader);
    void SetBodyGrammer(std::vector < int > VBody);
    int  GetHeaderByte();
    int  GetHeaderLine();
};

#endif
