// -*- c -*-
// "clsPreference.cpp"

#ifndef _PREFERENCE_H_
#define _PREFERENCE_H_

#include "../CONFITEM/clsConfItem.h"
#include "../WIDGETCTRL/clsFrameEXController.h"

#define _PREF_NO_FBO 0
#define _PREF_USE_FBO_16 1
#define _PREF_USE_FBO_8 2

class FrameMain_cls;
class PreferenceGUI_cls;
class Shortcut_cls;

class Preference_cls 
: public FrameEXController_cls
{ 
 public:
    Preference_cls(FrameMain_cls *pCParentFrame, Shortcut_cls *pCShortcutLink,
		   wxString strBitmap);
    ~Preference_cls();
    
    void InitGUI(wxWindow *pC);
    void UpdateItems(bool bForce = FALSE);
    void OpenWindow(wxWindow *pC);
    
    FrameMain_cls*     mpCParentFrame;
    Shortcut_cls*      mpCShortcutLink;
    PreferenceGUI_cls* mpCGUI;
    wxString           mstrBitmap;
    //wxBitmap*          mpBitmapLink;

    void ModulateBTN     (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4Gyration(bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4Zoom    (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4MoveCenter(bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4MoveItem(bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4Menu    (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4HitTest (bool bAModifier[4], bool bAMouseBTN[4]);
    void SetToDefaultMouse(int type);
    void SetToDefaultParam();

    int  GetFBODepth();

    // -- Mouse --
    ConfItemList_cls       mCConfListMouse;

    ConfItemUINT_cls       mCGyrationMouse;
    ConfItemBOOLARRAY_cls  mCbGyrationMod;
    ConfItemUINT_cls       mCZoomMouse;
    ConfItemBOOLARRAY_cls  mCbZoomMod;
    ConfItemUINT_cls       mCCenterMouse;
    ConfItemBOOLARRAY_cls  mCbCenterMod;
    ConfItemUINT_cls       mCItemMouse;
    ConfItemBOOLARRAY_cls  mCbItemMod;
    ConfItemUINT_cls       mCMenuMouse;
    ConfItemBOOLARRAY_cls  mCbMenuMod;
    ConfItemUINT_cls       mCHitTestMouse;
    ConfItemBOOLARRAY_cls  mCbHitTestMod;
    ConfItemBOOL_cls       mCbZoomInvert, mCbGyrationInvert;    
    ConfItemUINT_cls       mCMButtonEmulate;

    ConfItemList_cls       mCConfListParam;
    ConfItemUINT_cls       mCSortType;
    ConfItemUINT_cls       mCUseFBO;
    ConfItemUINT_cls       mCUseQuadBuffer;
    ConfItemINT_cls        mCIOThreadNumber;
    
    void ReadStrLine(wxString strLine);
    wxString Serialize();

    wxString SerializeForConfigure();
};

#endif
