// -*- c -*-
// "clsPreferenceGUI.h"
// (setq c-basic-offset 4)

#include "clsPreferenceGUI.h"
#include "clsPreference.h"

#include "../GRAPHIC/clsImageIO.h"
extern ImageIO_cls GCImgIO;
#include "../PANELS/clsShortcut.h"
#include "../PARTICLEDATA/clsParticleDataSeqCtrl.h"
#include "../WIDGETCTRL/EX/clsButtonEX.h"
#include "../WIDGETCTRL/EX/clsListCtrlEX.h"
#include "../WIDGETCTRL/WX/myArtProv.h"

#include "../../clsFrameMain.h"
#include "../../wxWidgetEnum.h"

#include <wx/notebook.h>

//extern int GThreadNumberReadAscii;

// ÓIɃCxgт
BEGIN_EVENT_TABLE(PreferenceGUI_cls, wxFrame)
EVT_CLOSE(wxFrameEX_cls::OnClose)
END_EVENT_TABLE()

PreferenceGUI_cls::
PreferenceGUI_cls(Preference_cls* pCParent, wxWindow *pC) :
    wxFrameEX_cls(pC, wxID_ANY, _("Preference"), 
		  wxDPS, ART(pCParent->mstrBitmap)) {
	
    mpCParent = pCParent;
    //SetScreenRectPos(&pCParent->mCScreenRect);
    mTemplateSetting = 0;
    
    // TCU[
    wxBoxSizer    *pBoxSizerSrc  = new wxBoxSizer(wxVERTICAL);
    //wxBoxSizer    *pBoxSizerBTM  = new wxBoxSizer(wxHORIZONTAL);

    mpCBook = new wxNotebook(this, ID_BOOK_PREFERENCE);

    SetMNumMouseParam();
    mpCBook->AddPage(mpCMNumMouseParam, _("Mouse"));
    
    SetMNumMemParam();
    mpCBook->AddPage(mpCMNumMemParam, _("Performance"));

    wxSize bestSize = mpCMNumMouseParam->GetBestSize();
    int listCtrlWidth = bestSize.GetWidth();
    int listCtrlHeight = bestSize.GetHeight();
    mpCListCtrl = new wxListCtrlEX(mpCBook, wxID_ANY, wxDP, wxSize(listCtrlWidth, listCtrlHeight),
	 wxLC_REPORT | wxSUNKEN_BORDER);
    mpCParent->mpCShortcutLink->SetList(mpCListCtrl);
    mpCBook->AddPage(mpCListCtrl, _("Shortcut"));

    pBoxSizerSrc->Add( mpCBook, 0, wxEXPAND);
    /*
    wxButtonEX *pCButtonClose = new wxButtonEX (this, wxID_CANCEL,
						wxT("Close"));

    pBoxSizerBTM->Add( -1, -1, 1, wxEXPAND);

    pBoxSizerBTM->Add( pCButtonClose,  0, wxEXPAND);

    pBoxSizerSrc->Add( pBoxSizerBTM, 0, wxEXPAND);
    */

    SetSizerAndFit(pBoxSizerSrc);
}

PreferenceGUI_cls::
~PreferenceGUI_cls(){
    MakeModal(FALSE);
}

void PreferenceGUI_cls::
SetMNumMouseParam(){
    MultiInputPanel_cls* pCurr = 
	MultiInputPanel_cls::Initialize(&mpCMNumMouseParam, mpCBook);
    int boxWidth = 4;
    
    pCurr->mTextWidth = 100;
    pCurr->mItemWidth = -1;
    pCurr->mComboWidth = 130;
    pCurr->mCheckBoxWidth = 55;

    wxString strList[4] = {
	_("Left Mouse BTN"), _("Middle Mouse BTN"), _("Right Mouse BTN"), _("Not Assigned")};
    wxString strListB[4] = { _("Left BTN + Shift"), _("Left BTN + Ctrl"), _("Left BTN + Alt"), _("Not Assigned")};
    wxString strListC[2] = { _("Defalut"), _("Blender Like")};
    
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Gyration"));
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCGyrationMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbGyrationMod.mpbBody[0],
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbGyrationMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbGyrationMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Zoom"));
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCZoomMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbZoomMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbZoomMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbZoomMod.mpbBody[2],
			  wxT("Alt"));
    
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Move Center"));
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCCenterMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbCenterMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbCenterMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbCenterMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Move Item"));
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCItemMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbItemMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbItemMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbItemMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Menu"));
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCMenuMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbMenuMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbMenuMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbMenuMod.mpbBody[2],
			  wxT("Alt"));
    
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Item Selection"));
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCHitTestMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbHitTestMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbHitTestMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbHitTestMod.mpbBody[2],
			  wxT("Alt"));
    
    int indexMButton = pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCMButtonEmulate.mBody, 4, strListB, _("MButton Emulate"));

    boxWidth = 2;
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Invert"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbZoomInvert.mbBody,
			  _("Zoom"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbGyrationInvert.mbBody,
			  _("Gyration"));

    int indexTemplate = pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mTemplateSetting, 2, strListC,  _("Template"));
    
    pCurr->FinishSetting();

    Connect(pCurr->GetItemId(indexTemplate), wxEVT_COMMAND_COMBOBOX_SELECTED,
	    wxCommandEventHandler(PreferenceGUI_cls::OnTemplate));
    Connect(pCurr->GetItemId(indexMButton), wxEVT_COMMAND_COMBOBOX_SELECTED,
	    wxCommandEventHandler(PreferenceGUI_cls::OnEmulateMiddleButton));
}

void PreferenceGUI_cls::
SetMNumMemParam(){
    MultiInputPanel_cls* pCurr = 
	MultiInputPanel_cls::Initialize(&mpCMNumMemParam, mpCBook);
    pCurr->mTextWidth = 140;
    pCurr->mItemWidth = -1;

    int boxWidth = 2;
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Memory Limit(MB)"));
    pCurr->CombinePointer(_ITEM_INTEGER, 
			  &mpCParent->mpCParentFrame->GetPCDataSeqCtrl()->mMemoryLimitationMB,
			  wxT("Critical"));
    pCurr->CombinePointer(_ITEM_INTEGER, 
			  &mpCParent->mpCParentFrame->GetPCDataSeqCtrl()->mTotalUsedMemoryMB,
			  wxT("NowUsed"), FALSE);

    pCurr->CombinePointer(_ITEM_INTEGER_SPIN,
			  &mpCParent->mCIOThreadNumber.mBody/*GThreadNumberReadAscii*/, _("Thread (Data I/O)"));
    pCurr->SetRange(_ITEM_LASTITEM, 1, 4);
    
    pCurr->CombinePointer(_ITEM_INTEGER_SPIN,
			  &GCImgIO.mCJpegQuality.mBody, _("JPEG Quality"));
    wxString strListThread[2] = { wxT("off"), wxT("on")};
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &GCImgIO.mCMultiThread.mBody, 2, strListThread,  _("Thread (Image I/O)"));
    
    wxString strListSort[4] = { _("Precise"), _("Approximate 10"), _("Approximate 100"), _("Approximate 1000")};
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCSortType.mBody, 4, strListSort,  _("Z-Sort Algorithm"));

    wxString strListFBO[3] = { _("Direct Drawing"), _("Use 16bit FBO as buffers"), _("Use 8bit FBO as buffers")};
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCUseFBO.mBody, 3, strListFBO, wxT("FBO"));
    
    wxString strListQuad[2] = { _("Use Quad Buffer if able"), _("Do not use Quad Buffer")};
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCUseQuadBuffer.mBody, 2, strListQuad, _("Quad Buffer Stereo"));
    
    pCurr->FinishSetting();
}

void PreferenceGUI_cls::
SetColoring(){
    MultiInputPanel_cls* pCurr = mpCMNumMouseParam;
    for (int i = 2; i <=29; i+=5){
	pCurr->GetPCwxWindow(i+0)->SetBackgroundColour(wxNullColour);
	pCurr->GetPCwxWindow(i+1)->SetBackgroundColour(wxNullColour);
	pCurr->GetPCwxWindow(i+2)->SetBackgroundColour(wxNullColour);
    }
    
    int button = mpCParent->mCMButtonEmulate.mBody;
    if (button <= 2)
	for (int i = 2; i <=29; i+=5)
	    pCurr->GetPCwxWindow(i+button)->
		SetBackgroundColour(wxColour(216, 191, 191));

    for (int i = 2; i <=29; i+=5){
	pCurr->GetPCwxWindow(i+0)->Refresh();
	pCurr->GetPCwxWindow(i+1)->Refresh();
	pCurr->GetPCwxWindow(i+2)->Refresh();
    }
}

void PreferenceGUI_cls::
OnTemplate(wxCommandEvent &event){
    mpCParent->SetToDefaultMouse(mTemplateSetting);
    mpCMNumMouseParam->UpdateValues();
}

void PreferenceGUI_cls::
OnEmulateMiddleButton(wxCommandEvent& event){
    SetColoring();
}
