// (setq c-basic-offset 4)
// "clsScene.h"

#include "clsScene.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;
#include "../WIDGETCTRL/EX/clsButtonEX.h"
#include "../WIDGETCTRL/WX/myArtProv.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"

#include "../COMMON/CommonDefinitions.h"

// --------------------

Scene_cls::
Scene_cls(wxWindow* pCParent, TimeCtrl_cls *pCTimeCtrlLink,
	  wxString strIcon){
    mpCParent = pCParent;
    mstrIcon = strIcon;
    mpCTimeCtrlLink = pCTimeCtrlLink;
    mCPos = wxDefaultPosition;
}

void Scene_cls::
Open(){
    MultiInputDialog_cls *pCDLG = new
	MultiInputDialog_cls(&pCDLG, mpCParent, wxID_ANY, _("Scene Config"),
			     mCPos, wxDS, FontProvider_cls::GetFont(0),
			     ARTSIZE(mstrIcon, wxSize(16,16)));
    
    pCDLG->SetPCPosInforAtClose(&mCPos);

    MultiInputPanel_cls* pCurr = pCDLG->mpCPanel;

    int tmpMaxFrame = mpCTimeCtrlLink->mCMaxFrame.mBody;
    int tmpWAMin = mpCTimeCtrlLink->mCWAMin.mBody;
    int tmpWAMax = mpCTimeCtrlLink->mCWAMax.mBody;
    int tmpType = mpCTimeCtrlLink->mCSceneLengthType.mBody;

    pCurr->mTextWidth = 100;
    pCurr->mItemWidth = -1;

    pCurr->CombinePointer(_ITEM_INTEGER_SPIN, &tmpMaxFrame, _("Scene Length"));
    pCurr->SetRange(_ITEM_LASTITEM, 0, 65535);

    int boxWidth = 2;
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Work Area"));
    pCurr->CombinePointer(_ITEM_INTEGER_SPIN, &tmpWAMin);
    pCurr->SetRange(_ITEM_LASTITEM, 0, 65535);
    pCurr->CombinePointer(_ITEM_INTEGER_SPIN, &tmpWAMax);
    pCurr->SetRange(_ITEM_LASTITEM,0, 65535);

    wxString strType[2] = {_("do remap"), _("do not remap")};
    pCurr->CombinePointerList(_ITEM_UINT_LIST, &tmpType,
			      2, strType, _("key remap"));
    pCDLG->MakeGeometry();
    pCDLG->UpdateValues();
    
    if (pCDLG->ShowModal() != wxID_OK) return;
    
    unsigned int initMaxFrame = mpCTimeCtrlLink->mCMaxFrame.mBody;
    if (tmpWAMin > tmpMaxFrame) tmpWAMin = tmpMaxFrame;
    if (tmpWAMax > tmpMaxFrame) tmpWAMax = tmpMaxFrame;
    if (tmpWAMax < tmpWAMin) {
	int tmp = tmpWAMax;
	tmpWAMax = tmpWAMin;
	tmpWAMin = tmp;
    }
    GCUndoList.OpenBlock();
    mpCTimeCtrlLink->SetWAMinCommand(tmpWAMin);
    mpCTimeCtrlLink->SetWAMaxCommand(tmpWAMax);//mCWAMax.mBody = tmpWAMax;
    mpCTimeCtrlLink->SetMaxFrameCommand(tmpMaxFrame);
    mpCTimeCtrlLink->mCSceneLengthType.mBody = tmpType;
    if (tmpType == 1 &&
	tmpMaxFrame != initMaxFrame && tmpMaxFrame != 0){
	mpCTimeCtrlLink->RemapParameterKeys
	    (((double)initMaxFrame) / (tmpMaxFrame));
    }
    GCUndoList.CloseBlock();
}
