// "clsShortcut.h"

#include "clsShortcut.h"
#include "../MAINCANVAS/clsTopHalfPanel.h"
#include "../GLCANVAS/clsGLCanvasCtrl.h"
#include "../GLCANVAS/clsMainGLCanvas.h"
#include "../GLCANVAS/clsMoveItem.h"
#include "../GLCANVAS/NAVIGATORS/clsNavigators.h"
#include "../SCENEOBJ/clsSceneObj.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../WIDGETCTRL/EX/clsListCtrlEX.h"
#include "../WIDGETCTRL/WX/myArtProv.h"

#include "../../clsMain.h"
#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"


ShortcutItem_cls::
ShortcutItem_cls(int type, wxString strName, int charactor, 
		 bool bShift, bool bCtrl, bool bAlt){
    mType = type;
    mstrName = strName;
    mChar = charactor;
    mbShift = bShift;
    mbCtrl = bCtrl;
    mbAlt = bAlt;
}

int ShortcutItem_cls::
GetType(int code, bool bShift, bool bCtrl, bool bAlt){
    if ((code == mChar) && (bShift == mbShift) && (bCtrl == mbCtrl) && (bAlt == mbAlt))
	return mType;
    
    return -1;
}

// ------

MenuCommandItem_cls::
MenuCommandItem_cls(int type, int menuID){
    mType = type;
    mMenuID = menuID;
}

// ------

Shortcut_cls::
Shortcut_cls(FrameMain_cls *pCParentFrame){
    mpCParentFrame = pCParentFrame;

    AddItem(_SC_OPEN_PROJECT, _("Open Project"), 'O', FALSE, TRUE);
    AddItem(_SC_SAVE_PROJECT, _("Save Project"), 'S', FALSE, TRUE);
    AddItem(_SC_SAVE_PROJECT_AS, _("Save Project As"), 'S', TRUE, TRUE);
    AddItem(_SC_OPEN_DATA, _("Load Particle Data"), 'O', FALSE, TRUE, TRUE);
    AddItem(_SC_SAVE_SNAPSHOT, _("Save Snapshot"), WXK_F7);
    AddItem(_SC_SAVE_IMGSEQ, _("Save Image Sequence"), WXK_F8);
    AddItem(_SC_EXPORT_PDATA, _("Export Particle Data"), 'E', FALSE, TRUE);
    AddItem(_SC_EXPORT_PATH, _("Export Path to Clipboard (.pov)"), 'E', FALSE, TRUE, TRUE);
    AddItem(_SC_CLOSE_DATA, _("Close Particle Data"), 'W', FALSE, TRUE);
    AddItem(_SC_QUIT, _("Quit"), 'Q');
    AddItem(_SC_UNDO, _("Undo"), 'Z', FALSE, TRUE);
    AddItem(_SC_REDO, _("Redo"), 'Y', FALSE, TRUE);
    AddItem(_SC_GO, _("Move Frame"), 'G', FALSE, TRUE);
    AddItem(_SC_TIMEREMAP, _("Time Remap"));
    AddItem(_SC_REMOVE_SNAPSHOT, _("Snapshot"), WXK_F5);
    AddItem(_SC_REMOVE_ALLCACHE, _("All Cache"), WXK_F5, FALSE, TRUE, TRUE);
    AddItem(_SC_SCENE, _("Scene Config"), 'K', FALSE, TRUE);
    AddItem(_SC_PREFERENCE, _("Preference"), 'P', FALSE, TRUE, TRUE);
    AddItem(_SC_SPLIT1, _("1 panel"), '1', FALSE, FALSE, TRUE);
    AddItem(_SC_SPLIT2, _("2 panels (vertical)"), '2', FALSE, FALSE, TRUE);
    AddItem(_SC_SPLIT3, _("2 panels (horizontal)"), '3', FALSE, FALSE, TRUE);
    AddItem(_SC_SPLIT4, _("4 panelsA"), '4', FALSE, FALSE, TRUE);
    AddItem(_SC_SPLIT5, _("4 panelsB"), '5', FALSE, FALSE, TRUE);
    AddItem(_SC_EXTRA, _("Extra Panel"), '0', FALSE, FALSE, TRUE);

    AddItem(_SC_CAMERAPATH, _("View and Camera Config"), 'U', FALSE, TRUE);
    AddItem(_SC_LIGHTSOURCE, _("Light Source Editor"), 'L', FALSE, TRUE);
    AddItem(_SC_COLORCURVE, _("Color Curve Editor"), 'J', FALSE, TRUE);
    AddItem(_SC_TEXPROPERTY, _("Texture Editor"), 'T', FALSE, TRUE);
    AddItem(_SC_STEREOGRAM, _("Stereogram Config"), 'M', FALSE, TRUE);
    AddItem(_SC_PERIODIC, _("Periodic Boundary"), 'B', FALSE, TRUE);
    
    AddItem(_SC_HELP, _("Help"), WXK_F1);
    AddItem(_SC_ABOUT, _("About"), WXK_F1, FALSE, TRUE);
    AddItem(_SC_ABOUT_GL, _("About Open GL"), WXK_F1, FALSE, FALSE, TRUE);
    AddItem(_SC_ABOUT_NETWORK, _("About Networtk"), WXK_F1, TRUE, TRUE);
    
    AddItem(_SC_VIEW_0, wxT("Free"), '0');
    AddItem(_SC_VIEW_0, wxT("Free"), WXK_NUMPAD0);
    AddItem(_SC_VIEW_5, _("Perspective"), '5');
    AddItem(_SC_VIEW_5, _("Perspective"), WXK_NUMPAD5);
    AddItem(_SC_VIEW_1, wxT("+X to -X"), '1');
    AddItem(_SC_VIEW_1, wxT("+X to -X"), WXK_NUMPAD1);
    AddItem(_SC_VIEW_1_CTRL, wxT("-X to +X"), '1', FALSE, TRUE);
    AddItem(_SC_VIEW_1_CTRL, wxT("-X to +X"), WXK_NUMPAD1, FALSE, TRUE);
    AddItem(_SC_VIEW_3, wxT("+Y to -Y"), '3');
    AddItem(_SC_VIEW_3, wxT("+Y to -Y"), WXK_NUMPAD3);
    AddItem(_SC_VIEW_3_CTRL, wxT("-Y to +Y"), '3', FALSE, TRUE);
    AddItem(_SC_VIEW_3_CTRL, wxT("-Y to +Y"), WXK_NUMPAD3, FALSE, TRUE);
    AddItem(_SC_VIEW_7, wxT("-Z to +Z"), '7');
    AddItem(_SC_VIEW_7, wxT("-Z to +Z"), WXK_NUMPAD7);
    AddItem(_SC_VIEW_7_CTRL, wxT("+Z to -Z"), '7', FALSE, TRUE);
    AddItem(_SC_VIEW_7_CTRL, wxT("+Z to -Z"), WXK_NUMPAD7, FALSE, TRUE);
    AddItem(_SC_DRAG_X, wxT("Drag X"), 'X');
    AddItem(_SC_DRAG_Y, wxT("Drag Y"), 'Y');
    AddItem(_SC_DRAG_Z, wxT("Drag Z"), 'Z');
    AddItem(_SC_ROTATION, wxT("Mode Rotation"), 'R');
    AddItem(_SC_SCALE, wxT("Mode Scale"), 'S');
    AddItem(_SC_TRANSLATION, wxT("Mode Translation"), 'T');
    AddItem(_SC_NEXT_KEY, _("Next Key"), 'K');
    AddItem(_SC_PREV_KEY, _("Prev Key"), 'J');
    AddItem(_SC_SET_WA_MIN, _("Set Working Area Min"), 'B');
    AddItem(_SC_SET_WA_MAX, _("Set Working Area Max"), 'N');
    AddItem(_SC_TL_ZOOM_OUT, wxT("Timeline Zoom Out"), '-');
    AddItem(_SC_TL_ZOOM_IN, wxT("Timeline Zoom In"), 39/*'^'*/);
    AddItem(_SC_PLAY, _("Play"), WXK_SPACE);
    AddItem(_SC_LEFT, _("Prev Frame"), WXK_LEFT);
    AddItem(_SC_RIGHT, _("Next Frame"), WXK_RIGHT);
    AddItem(_SC_FULLSCREEN, _("Full Screen"), WXK_RETURN, FALSE, FALSE, TRUE);
    AddItem(_SC_ESCAPE, _("Full Screen Off"), WXK_ESCAPE);

    AddMenuCommand(_SC_OPEN_PROJECT, menuFileOpenProject);
    AddMenuCommand(_SC_SAVE_PROJECT, menuFileSaveProject);
    AddMenuCommand(_SC_SAVE_PROJECT_AS, menuFileSaveProjectAs);
    AddMenuCommand(_SC_OPEN_DATA, menuFileOpenData);
    AddMenuCommand(_SC_SAVE_SNAPSHOT, menuFileSaveImageSnap);
    AddMenuCommand(_SC_SAVE_IMGSEQ, menuFileSaveImageSeq);
    AddMenuCommand(_SC_EXPORT_PDATA, menuFileExportData);
    AddMenuCommand(_SC_EXPORT_PATH, menuFileExportPathPov);
    AddMenuCommand(_SC_CLOSE_DATA, menuFileCloseData);
    AddMenuCommand(_SC_QUIT, Minimal_Quit);
    AddMenuCommand(_SC_UNDO, menuEditUndo);
    AddMenuCommand(_SC_REDO, menuEditRedo);
    AddMenuCommand(_SC_GO, menuEditGo);
    AddMenuCommand(_SC_TIMEREMAP, menuEditTimeRemap);
    AddMenuCommand(_SC_REMOVE_SNAPSHOT, menuEditRemoveCacheSnap);
    AddMenuCommand(_SC_REMOVE_ALLCACHE, menuEditRemoveCacheAll);
    AddMenuCommand(_SC_SCENE, menuEditScene);
    AddMenuCommand(_SC_PREFERENCE, menuEditPreference);
    AddMenuCommand(_SC_SPLIT1, menuViewMainPanelType0);
    AddMenuCommand(_SC_SPLIT2, menuViewMainPanelType1);
    AddMenuCommand(_SC_SPLIT3, menuViewMainPanelType2);
    AddMenuCommand(_SC_SPLIT4, menuViewMainPanelType3);
    AddMenuCommand(_SC_SPLIT5, menuViewMainPanelType4);
    AddMenuCommand(_SC_EXTRA,  menuViewExtraPanel);

    AddMenuCommand(_SC_CAMERAPATH, menuDialogCameraPath);
    AddMenuCommand(_SC_LIGHTSOURCE, menuDialogLightSRC);
    AddMenuCommand(_SC_COLORCURVE, menuDialogColorCurve);
    AddMenuCommand(_SC_TEXPROPERTY, menuDialogTexProperty);
    AddMenuCommand(_SC_STEREOGRAM, menuDialogStereogram);
    AddMenuCommand(_SC_PERIODIC, menuDialogPeriodic);

    AddMenuCommand(_SC_HELP, menuHelp);
    AddMenuCommand(_SC_ABOUT, Minimal_About);
    AddMenuCommand(_SC_ABOUT_GL, menuAboutGL);
    AddMenuCommand(_SC_ABOUT_NETWORK, menuAboutNetwork);
    
    AddMenuCommand(_SC_FULLSCREEN, menuFullScreen);
    AddMenuCommand(_SC_ESCAPE, menuEscape);
    
}

void Shortcut_cls::
AddItem(int type, wxString strName, int charactor, 
	bool bShift, bool bCtrl, bool bAlt){
    mVCItems.push_back(ShortcutItem_cls(type, strName, charactor,
					bShift, bCtrl, bAlt));
}

void Shortcut_cls::
AddMenuCommand(int type, int menuID){
    mVCMenuCommand.push_back(MenuCommandItem_cls(type, menuID));
}

wxString Shortcut_cls::
GetSpecialKey(int keyChar){
    switch(keyChar){
    case WXK_F1: return wxT("F1");
    case WXK_F2: return wxT("F2");
    case WXK_F3: return wxT("F3");
    case WXK_F4: return wxT("F4");
    case WXK_F5: return wxT("F5");
    case WXK_F6: return wxT("F6");
    case WXK_F7: return wxT("F7");
    case WXK_F8: return wxT("F8");
    case WXK_F9: return wxT("F9");
    case WXK_F10: return wxT("F10");
    case WXK_F11: return wxT("F11");
    case WXK_F12: return wxT("F12");
    case WXK_LEFT: return wxT("LEFT");
    case WXK_RIGHT: return wxT("RIGHT");
    case WXK_SPACE: return wxT("SPACE");
    case WXK_ESCAPE: return wxT("ESC");
    case WXK_RETURN: return wxT("RET");
    case WXK_NUMPAD0: return wxT("NUM0");
    case WXK_NUMPAD1: return wxT("NUM1");
    case WXK_NUMPAD2: return wxT("NUM2");
    case WXK_NUMPAD3: return wxT("NUM3");
    case WXK_NUMPAD4: return wxT("NUM4");
    case WXK_NUMPAD5: return wxT("NUM5");
    case WXK_NUMPAD6: return wxT("NUM6");
    case WXK_NUMPAD7: return wxT("NUM7");
    case WXK_NUMPAD8: return wxT("NUM8");
    case WXK_NUMPAD9: return wxT("NUM9");
    }
    return wxEmptyString;
}

wxString Shortcut_cls::
GetStrFullString(int type, bool bShortCut){
    for (unsigned int i = 0; i < mVCItems.size(); i++){
	if (type == mVCItems[i].mType){
	    wxString strCommand = mVCItems[i].mstrName;
	    if (mVCItems[i].mChar == '\0') return strCommand;
	    if (bShortCut == TRUE){
		strCommand << wxT("\t");
		if (mVCItems[i].mbAlt == TRUE) strCommand << wxT("Alt-");
		if (mVCItems[i].mbShift == TRUE) strCommand << wxT("Shift-");
		if (mVCItems[i].mbCtrl == TRUE) strCommand << wxT("Ctrl-");	    
		wxString strSpecialKey = GetSpecialKey(mVCItems[i].mChar);
		if (strSpecialKey.IsEmpty() == TRUE)
		    strCommand << wxString::FromAscii((char)mVCItems[i].mChar);
		else
		    strCommand << strSpecialKey;
	    }
	    return strCommand;
	}
    }
    return wxEmptyString;
}

wxString Shortcut_cls::
GetMenuString(int ID){
    for (unsigned int i = 0; i < mVCMenuCommand.size(); i++){
	if (mVCMenuCommand[i].mMenuID == ID)
	    return GetStrFullString(mVCMenuCommand[i].mType);
    }
    return wxT("!!");//wxEmptyString;
}

wxString Shortcut_cls::
GetMenuHelpString(int ID){
    for (unsigned int i = 0; i < mVCMenuCommand.size(); i++){
	if (mVCMenuCommand[i].mMenuID == ID)
	    return GetStrFullString(mVCMenuCommand[i].mType, FALSE);
    }
    return wxT("!!");//wxEmptyString;
}

wxMenuItem* Shortcut_cls::
GetPNewMenuItem(wxMenu *pMenu, int ID, wxString strHelpString, bool bChackItem){
    if (strHelpString == wxEmptyString){
	if (bChackItem == TRUE)
	    return new wxMenuItem(pMenu, ID, GetMenuString(ID), GetMenuHelpString(ID), wxITEM_CHECK );
	else
	    return new wxMenuItem(pMenu, ID, GetMenuString(ID), GetMenuHelpString(ID));
    }
    if (bChackItem == TRUE)
	return new wxMenuItem(pMenu, ID, GetMenuString(ID), strHelpString, wxITEM_CHECK);
    else
	return new wxMenuItem(pMenu, ID, GetMenuString(ID), strHelpString);
}

void Shortcut_cls::
SetMenuItem(wxMenu *pMenu, int ID, wxString strMenuBitmap, wxString strHelpString){
    wxMenuItem *pItem = GetPNewMenuItem(pMenu, ID, strHelpString);
    if (strMenuBitmap.IsEmpty() != TRUE)
	pItem->SetBitmap(ART(strMenuBitmap));
    pMenu->Append(pItem);
}

void Shortcut_cls::
SetMenuCheckItem(wxMenu *pMenu, int ID, wxString strMenuBitmap, wxString strHelpString){
    wxMenuItem *pItem = GetPNewMenuItem(pMenu, ID, strHelpString, TRUE);
    if (strMenuBitmap.IsEmpty() != TRUE)
	pItem->SetBitmap(ART(strMenuBitmap));
    pMenu->Append(pItem);
}

// return TRUE ƑSplXV
bool Shortcut_cls::
ProcFromList(int code, bool bShift, bool bCtrl, bool bAlt){
    int type = -1;
    int size = (int)mVCItems.size();
    for (int i = 0; i < size; i++){
	type = mVCItems[i].GetType(code, bShift, bCtrl, bAlt);
	if (type != -1){
	    i = size; continue;
	}
    }
    if (type == -1) return FALSE;

    FrameMain_cls *pC = mpCParentFrame;
    //int comR = wxEVT_COMMAND_RIBBONTOOL_CLICKED;
    int comM = wxEVT_COMMAND_MENU_SELECTED;
    MainGLCanvas_cls *pCGL = pC->mpCActiveGLCanvasLink;

    for (unsigned int i = 0; i < mVCMenuCommand.size(); i++)
	if (type == mVCMenuCommand[i].mType)
	    SendEvent(pC, comM, mVCMenuCommand[i].mMenuID);

    switch(type){
	/*
    case _SC_UNDO:
	SendMenuEvent(pC, menuEditUndo); break;
    case _SC_REDO:
	SendMenuEvent(pC, menuEditRedo); break;
	*/
    case _SC_VIEW_0:
	pCGL->SetDisplayMode(_GL_CANVAS_DISPLAY_FREE);
	pCGL->mpCGLCtrl->UpdateWindow(); break;
    case _SC_VIEW_5:
	pCGL->TogglePerspective();
	SendMenuEvent(pC, menuEditSyncGLCtrl);
	/*pCGL->mpCGLCtrl->UpdateWindow();*/ break;
    case _SC_VIEW_1:
	pCGL->SetDisplayMode(_GL_CANVAS_DISPLAY_X_PLUS);
	pCGL->mpCGLCtrl->UpdateWindow(); break;
    case _SC_VIEW_3:
	pCGL->SetDisplayMode(_GL_CANVAS_DISPLAY_Y_PLUS);
	pCGL->mpCGLCtrl->UpdateWindow(); break;
    case _SC_VIEW_7:
	pCGL->SetDisplayMode(_GL_CANVAS_DISPLAY_Z_MINUS);
	pCGL->mpCGLCtrl->UpdateWindow(); break;
    case _SC_VIEW_1_CTRL:
	pCGL->SetDisplayMode(_GL_CANVAS_DISPLAY_X_MINUS);
	pCGL->mpCGLCtrl->UpdateWindow(); break;
    case _SC_VIEW_3_CTRL:
	pCGL->SetDisplayMode(_GL_CANVAS_DISPLAY_Y_MINUS);
	pCGL->mpCGLCtrl->UpdateWindow(); break;
    case _SC_VIEW_7_CTRL:
	pCGL->SetDisplayMode(_GL_CANVAS_DISPLAY_Z_PLUS);
	pCGL->mpCGLCtrl->UpdateWindow(); break;
    case _SC_DRAG_X:
	pCGL->mpCNavigators->SetDragMode(_ROTATE_MOVE_R); return TRUE;
    case _SC_DRAG_Y:
	pCGL->mpCNavigators->SetDragMode(_ROTATE_MOVE_P); return TRUE;
    case _SC_DRAG_Z:
	pCGL->mpCNavigators->SetDragMode(_ROTATE_MOVE_Y); return TRUE;
    case _SC_ROTATION:
	pCGL->mpCNavigators->RotationMode(); return TRUE;
    case _SC_SCALE:
	pCGL->mpCNavigators->ScaleMode(); return TRUE;
    case _SC_TRANSLATION:
	pCGL->mpCNavigators->TranslationMode(); return TRUE;
    case _SC_NEXT_KEY:
	pC->GetPCTimeCtrl()->MoveFrameCommandSnip(+1); break;
    case _SC_PREV_KEY:
	pC->GetPCTimeCtrl()->MoveFrameCommandSnip(-1); break;
    case _SC_SET_WA_MIN:
	pC->GetPCTimeCtrl()->SetWAMinCommand(pC->GetPCTimeCtrl()->mFrame, _TIME_CTRL_CURRENT); break;
    case _SC_SET_WA_MAX:
	pC->GetPCTimeCtrl()->SetWAMaxCommand(pC->GetPCTimeCtrl()->mFrame, _TIME_CTRL_CURRENT); break;
    case _SC_TL_ZOOM_IN:
	pC->GetPCTimeCtrl()->ExpandAACommand(TRUE); break;
    case _SC_TL_ZOOM_OUT:
	pC->GetPCTimeCtrl()->ExpandAACommand(FALSE); break;
    case _SC_PLAY:
	pC->mpCParent->mpCTime->StartPlayCommand(+1); break;
    case _SC_RIGHT:
	pC->mpCParent->mpCTime->MoveFrameCommand(+1); break;
    case _SC_LEFT:
	pC->mpCParent->mpCTime->MoveFrameCommand(-1); break;
    }
    return FALSE;
}

void Shortcut_cls::
ProcShortcutKey(int modifier, int code){
    bool bRefreshGLPanel = FALSE;

    bool bShift = ((modifier & wxMOD_SHIFT) != 0) ? TRUE : FALSE;
    bool bCtrl = ((modifier & wxMOD_CONTROL) != 0) ? TRUE : FALSE;
    bool bAlt = ((modifier & wxMOD_ALT) != 0) ? TRUE : FALSE;

    //if (bShift == TRUE && bCtrl == TRUE)return;
    
    bRefreshGLPanel |= ProcFromList(code, bShift, bCtrl, bAlt);
    
    if (bRefreshGLPanel == TRUE) 
	mpCParentFrame->mpCTopHalfPanel->RefreshGLPanels();
}

void Shortcut_cls::
SetList(wxListCtrlEX *pCList){
    pCList->InsertColumn(0,wxT(""), wxLIST_FORMAT_CENTER, 35);
    pCList->InsertColumn(1,wxT(""), wxLIST_FORMAT_CENTER, 30);
    pCList->InsertColumn(2,wxT(""), wxLIST_FORMAT_CENTER, 25);
    pCList->InsertColumn(3,wxT(""), wxLIST_FORMAT_LEFT, 50);
    pCList->InsertColumn(4,wxT("function"), wxLIST_FORMAT_LEFT, 240);

    int num = mVCItems.size();
    for (int i = 0; i < num; i++){
	std::vector < wxString > VstrItem;
	
	if (mVCItems[i].mbShift == TRUE) VstrItem.push_back(wxT("shift"));
	else                             VstrItem.push_back(wxT(" "));
	if (mVCItems[i].mbCtrl  == TRUE) VstrItem.push_back(wxT("ctrl"));
	else                             VstrItem.push_back(wxT(" "));
	if (mVCItems[i].mbAlt   == TRUE) VstrItem.push_back(wxT("alt"));
	else                             VstrItem.push_back(wxT(" "));

	wxString strChar;
	wxString strSpecialKey = GetSpecialKey(mVCItems[i].mChar);
	if (strSpecialKey.IsEmpty() == TRUE)
	    strChar << wxString::FromAscii((char)mVCItems[i].mChar);
	else
	    strChar << strSpecialKey;
	VstrItem.push_back(strChar);

	VstrItem.push_back(mVCItems[i].mstrName);
	    
	pCList->AddListItem(-1, VstrItem);
    }
}


