// -*- c -*-
// "clsParamCommands.cpp"

#ifndef _PARAM_COMMANDS_H
#define _PARAM_COMMANDS_H

#include "../UNDO/clsUndoManager.h"

#include <wx/wx.h>

class ComParamBase_cls : public CommandItem_cls {
 public:
    ComParamBase_cls(Parameters_cls* pCTgt);

    Parameters_cls* mpCTgt;
    //wxString mstrID;
};

class ComParamSetKey_cls : public ComParamBase_cls {
 public:
    ComParamSetKey_cls(Parameters_cls* pCTgt, double doubleIndex,
		       double value, double DValue1, double DValue2,
		       unsigned int type);
    double mDoubleIndex;
    double mValue;
    double mDValue1;
    double mDValue2;
    unsigned int mType;
    void Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamSetKeyC_cls : public ComParamBase_cls {
 public:
    ComParamSetKeyC_cls(Parameters_cls *pCTgt, KeyFrame_cls CKey);

    KeyFrame_cls mCKey;
    void Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamDelKey_cls : public ComParamBase_cls {
 public:
    ComParamDelKey_cls(Parameters_cls* pCTgt, unsigned int index);
    
    unsigned int mIndex;
    void Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamOvwtKeyC_cls : public ComParamBase_cls {
 public:
    ComParamOvwtKeyC_cls(Parameters_cls* pCTgt, unsigned int index,
			 KeyFrame_cls CKey);
    unsigned int mIndex;
    KeyFrame_cls mCKey;
    void Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamMoveKey_cls : public ComParamBase_cls {
 public:
    ComParamMoveKey_cls(Parameters_cls* pCTgt, 
			double doubleIndexFrom, double doubleIndexTo,
			double resolution);
    
    double mDoubleIndexFrom, mDoubleIndexTo, mResolution;
    void Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamSetKeyType_cls : public ComParamBase_cls {
 public:
    ComParamSetKeyType_cls(Parameters_cls* pCTgt, 
			   unsigned int index, unsigned int type);
    
    unsigned int mIndex, mType;
    void Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamSetKeyTypeMulti_cls : public ComParamBase_cls {
 public:
    ComParamSetKeyTypeMulti_cls(Parameters_cls* pCTgt,
				unsigned int listnum,
				unsigned int *listIndex,
				unsigned int *listType);
    ~ComParamSetKeyTypeMulti_cls();

    unsigned int mListnum;
    unsigned int *mAIndex, *mAType;
    void Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamClearKey_cls : public ComParamBase_cls {
 public:
    ComParamClearKey_cls(Parameters_cls* pCTgt, double value, double doubleIndex);
    ~ComParamClearKey_cls();
    
    double mValue;
    double mDoubleIndex;
    void Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamSetTimeDependent_cls : public ComParamBase_cls {
 public:
    ComParamSetTimeDependent_cls(Parameters_cls *pCTgt, bool bDependent);

    bool mbDependent;
    void Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamMemento_cls : public ComParamBase_cls {
 public:
    ComParamMemento_cls(Parameters_cls* pCTgt, Parameters_cls* pCFrom = NULL);
    ~ComParamMemento_cls();
    
    Parameters_cls *mpCParamMemento;
    void Execute(bool bFlag = _COMMAND_REDO);
};

#endif
