// -*- c -*-
// "clsTimeLinePanel.h"
// (setq c-basic-offset 4)

#include "clsParamTL.h"
#include "clsParameters.h"
#include "clsParametersPanel.h"
#include "clsParamGroup.h"
#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../WIDGETCTRL/WX/clsFontProvider.h"
#include "../WIDGETCTRL/WX/clsSizeAdjuster.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../../clsFrameMain.h"
#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"
#include "../UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;

#include <wx/dcbuffer.h>

#include "../COMMON/CommonDefinitions.h"

#ifdef WIN32
#define _MEM_PANEL_OFFSET 14
#else
#define _MEM_PANEL_OFFSET 10
#endif

#ifdef WIN32
#define WCHARCONV(x) (wxString)wxConvLibc.cMB2WC(x)
#else
#define WCHARCONV(x) (wxString)wxConvUTF8.cMB2WC(x)
#endif

BEGIN_EVENT_TABLE(ParamTL_cls, wxPanel)
     EVT_PAINT       (ParamTL_cls::OnPaint)
     EVT_MOUSE_EVENTS(ParamTL_cls::OnMouse)
     EVT_KEY_DOWN    (ParamTL_cls::OnKeyDown)
     EVT_MENU        (menuTLInsert ,   ParamTL_cls::OnMenuInsert)
     EVT_MENU        (menuTLEditKey,   ParamTL_cls::OnMenuEditKey)
     EVT_MENU        (menuTLExport,    ParamTL_cls::OnMenuExport)
     //EVT_MENU        (TLMenuHide,   ParamTL_cls::OnMenuHide)
     //EVT_MENU        (TLMenuImport, ParamTL_cls::OnMenuImport)
     //EVT_MENU        (TLMenuCustom01, ParamTL_cls::OnMenuCustom)
END_EVENT_TABLE()

ParamTL_cls::
     ParamTL_cls(Parameters_cls *pCParam, ParametersPanel_cls *parent, /*TimeCtrl_cls *pCTimeCtrl,*/ wxPoint pos, wxSize size, wxWindowID id) :
     wxPanel(parent, id, pos, size, wxWANTS_CHARS),
	 mpCParam(pCParam), mpCParentPanel(parent),
	 mstrLabel(pCParam->mstrLabel),
	 mbSelected(FALSE),
	 mpCCustomTarget(NULL)
     {
    this->SetBackgroundColour(wxColour(216, 216, 216));
    //mOffset = _MEM_PANEL_OFFSET;
    mbCaptureMouse = FALSE;
    mbDragging = FALSE;
    mbOnPanel = FALSE;
    mSelected = -1;
    mpCParam->mpCParamTLLink = this;

    mpCMenu = new wxMenu;
    mpCMenu->Append(menuTLInsert, _("Insert/Remove Key"));
    mpCMenu->Append(menuTLEditKey, _("Edit Key"));
    mpCMenu->Append(menuTLExport, _("Export to clipborad (.pov)"));
    //mpCMenu->Append(TLMenuHide  , _("Hide this panel"));
    //mpCMenu->Append(TLMenuImport, _("Import from file"));
    
    if (msbIsLoadIcon == FALSE){
	msbIsLoadIcon = TRUE;
	msCIcon.LoadFile(wxT("ICONS/Numerical.png"), wxBITMAP_TYPE_PNG);
    }

    SetBackgroundStyle(wxBG_STYLE_CUSTOM);
}

ParamTL_cls::
~ParamTL_cls(){
    delete mpCMenu;
}

void ParamTL_cls::
LinkParameter(Parameters_cls *pCParam){
    mpCParam = pCParam;
    mpCParam->mpCParamTLLink = this;
}

void ParamTL_cls::
AppendMenu(wxWindow *pCCustomTarget, int menuID,
	   wxString strTitle, int type){
    mpCCustomTarget = pCCustomTarget;
    mCustumMenuID = menuID;
    switch(type){
    case _PARAM_TL_MENU_APPEND:
	//mpCMenu->Append(TLMenuCustom01, strTitle);
	break;
    case _PARAM_TL_MENU_INSERT:
	//mpCMenu->Append(TLMenuCustom01, strTitle);
	break;
    }
}

void ParamTL_cls::
GrayOutUnusedMenu(){
    mpCMenu->FindItemByPosition(1)->SetItemLabel(_("Edit Key"));
    if (mpCParam == NULL){
	mpCMenu->FindItemByPosition(0)->Enable(FALSE);
	mpCMenu->FindItemByPosition(1)->Enable(FALSE);
	return; }
    if (mpCParam->mCbTimeDependent.mbBody == FALSE){
	mpCMenu->FindItemByPosition(0)->Enable(FALSE);
	mpCMenu->FindItemByPosition(1)->Enable(TRUE);
	mpCMenu->FindItemByPosition(1)->SetItemLabel(_("Edit Value"));
	return; }
    if (mSelected == -1){
	mpCMenu->FindItemByPosition(0)->Enable(TRUE);
	mpCMenu->FindItemByPosition(1)->Enable(FALSE);
	return; }
    if (mpCParam->GetSelectedKeyNum() == 1){
	mpCMenu->FindItemByPosition(0)->Enable(TRUE);
	mpCMenu->FindItemByPosition(1)->Enable(TRUE);
	return; }
    mpCMenu->FindItemByPosition(0)->Enable(TRUE);
    mpCMenu->FindItemByPosition(1)->Enable(FALSE);
    
}

void ParamTL_cls::
SetDoubleIndex(){
    msMaxFrame = mspCTimeCtrlLink->mCMaxFrame.mBody;
    msAAMin = mspCTimeCtrlLink->mCAAMin.mBody;
    msAAMax = mspCTimeCtrlLink->mCAAMax.mBody;
    msWAMin = mspCTimeCtrlLink->mCWAMin.mBody;
    msWAMax = mspCTimeCtrlLink->mCWAMax.mBody;
    msCurrentDoubleIndex = mspCTimeCtrlLink->GetDoubleIndex();
    msDoubleIndexAAMin = mspCTimeCtrlLink->GetDoubleIndex(msAAMin);
    msDoubleIndexAAMax = mspCTimeCtrlLink->GetDoubleIndex(msAAMax);
    msDoubleIndexWAMin = mspCTimeCtrlLink->GetDoubleIndex(msWAMin);
    msDoubleIndexWAMax = mspCTimeCtrlLink->GetDoubleIndex(msWAMax);
}

void ParamTL_cls::
Select(bool bSelected){
    mbSelected = bSelected;
}

void ParamTL_cls::
OnPaint(wxPaintEvent& event){
    // must always be here
    wxAutoBufferedPaintDC dc(this);
    
    dc.SetBackground(wxBrush(wxColor(216, 216, 216), wxSOLID));
    dc.Clear();
    
    SetMemberSize(GetClientSize());

    int posWAmin = GetCoordinateFromDouble(msDoubleIndexWAMin);
    int posWAmax = GetCoordinateFromDouble(msDoubleIndexWAMax);

    if (msDoubleIndexWAMax == 0)
	posWAmax = GetDeviceX(1);

    dc.SetPen(*wxTRANSPARENT_PEN);
    /*
    if (mbActive == TRUE)
	dc.SetBrush(wxBrush(wxColour(191,216,216)));
    else
    */
    if (mbSelected == TRUE)
	dc.SetBrush(wxBrush(wxColour(216, 232, 232)));
    else
	dc.SetBrush(*wxWHITE_BRUSH);
    
    dc.DrawRectangle(posWAmin, 0, posWAmax - posWAmin, mHeight);

    if (mbDragging == TRUE &&  mSelected == -1){
	int posDrag0 = GetCoordinateFromDouble(mRegionOrigin);
	int posDrag1 = GetCoordinateFromDouble(mDragDoubleIndex);
	if (posDrag0 != posDrag1){
	    dc.SetPen(wxPen(wxColour(128, 128, 128)));
	    dc.DrawRectangle(posDrag0, 2, posDrag1-posDrag0, mHeight-4);
	}
    }

    /*
    if (mbActive == TRUE)
	dc.SetTextForeground(wxColour(64, 64, 64));
    else
    */
    if (mbSelected == TRUE)
	dc.SetTextForeground(wxColour(96, 96, 96));
    else
	dc.SetTextForeground(wxColour(128, 128, 128));
    
    dc.SetFont(wxFont(11, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL));
    dc.DrawText(mstrLabel, _MEM_PANEL_OFFSET + 5, -2);
    //dc.DrawText(mpCParam->mstrID, _MEM_PANEL_OFFSET + 320, -2);
    
    /*
    if (mbActive == TRUE)
	dc.SetTextForeground(wxColour(64, 64, 64));
    else
    */
	dc.SetTextForeground(*wxLIGHT_GREY);
    wxString Mes;
    
    dc.SetPen(msCPenVeryLightGrey);
    dc.DrawRectangle(0, 0, mWidth, 1);

    if (mpCParam == NULL) {
	Mes << wxT("Not Assigned");
	dc.DrawText(Mes, _MEM_PANEL_OFFSET + 100, -2);
	event.Skip();
	return;
    }

    if (msbShowParameter == TRUE){
	Mes << mpCParam->GetInterpolatedValue(_PARAM_CURRENT);
	dc.DrawText(Mes, _MEM_PANEL_OFFSET + 140, -2);
    }
    
    if (mpCParam->mCbTimeDependent.mbBody == TRUE){
	dc.SetPen(*wxBLACK_PEN);
	for (int i = 0; i < mpCParam->GetKeyNumber(); i++){
	    CalcCoordinateFromDouble(mpCParam->mVCKeys[i].mDoubleIndex);
	    mpCParam->mVCKeys[i].DrawKey(dc, mX0, _KEY_NORMAL);
	}
    }

    if (mbDragging == TRUE /*&& mbCaptureMouse == TRUE && mSelected != -1*/)
	for (int i = 0; i < mpCParam->GetKeyNumber(); i++)
	    if (mpCParam->mVCKeys[i].mbSelected == TRUE){
		CalcCoordinateFromDouble
		    (mDragDoubleIndex 
		     - mDragDoubleIndexOrigin
		     //- mpCParam->mVCKeys[mSelected].mDoubleIndex
		     + mpCParam->mVCKeys[i].mDoubleIndex);
		mpCParam->mVCKeys[i].DrawKey(dc, mX0, _KEY_DRAG, mbOnPanel);
	    }
    
    dc.SetPen(*wxRED_PEN);
    CalcCoordinateFromDouble(msCurrentDoubleIndex);
    dc.DrawRectangle(mX0, 0, 1, mHeight);

    /*
    Mes = wxT("");
    Mes << mDragDoubleIndex << wxT(":") << mDraggingFrame ;
    dc.SetPen(*wxGREY_PEN);
    dc.DrawText(Mes, _MEM_PANEL_OFFSET + 500, 0);
    */

    event.Skip();
}

void ParamTL_cls::
CreateKeyDLGAtMousePos(){
    if (mSelected != -1 && mpCParam->GetSelectedKeyNum() == 1){
	CalcCoordinateFromDouble(mpCParam->mVCKeys[mSelected].mDoubleIndex);
	mMenuPosX = mX0 + 60;
    }
    
    CreateKeyDLG(mMenuPosX-40, mMenuPosY-30);
}

void ParamTL_cls::
CreateKeyDLG(int xpos, int ypos, wxPoint posPanel){
    if (mpCParam == NULL) return;

    double doubleFrame;
    if (mpCParam->mCbTimeDependent.mbBody == FALSE)
	doubleFrame = 0;
    else if (mSelected == -1)
	doubleFrame = msCurrentDoubleIndex;
    else
	doubleFrame = mpCParam->mVCKeys[mSelected].mDoubleIndex;
    int frame = (msMaxFrame * doubleFrame) + 1e-5;

    if (mpCParam->mpCParentGroupLink->mbLinking == TRUE){
	mpCParam->mpCParentGroupLink->CreateKeyDLG
	    (GetScreenPosition(), xpos, ypos, frame, doubleFrame) ;
	return;
    }

    if (posPanel == wxDefaultPosition) 
	posPanel = GetScreenPosition();
    else // Filter$BB&$+$i8F$P$l$?$iA*Br$5$l$?(BKey$B$H$O4X78$J$/$9$k(B
	mSelected = -1; 

    wxString strLabel;
    if (mpCParam->mpCParentGroupLink != NULL)
	strLabel << mpCParam->mpCParentGroupLink->mstrGroupLabel;
    else
	strLabel << _("Numerical Input");
	    
    MultiInputDialog_cls *pCDLG = new
	MultiInputDialog_cls(&pCDLG, this, wxID_ANY, strLabel,
			     posPanel + wxPoint(xpos, ypos), wxDS,
			     FontProvider_cls::GetFont(0));
    MultiInputPanel_cls *pCurr = pCDLG->mpCPanel;
    pCDLG->SetIcon(msCIcon);
    //pCDLG->mpCUserDefinedClueDialog = this;
    
    double paramCache;
    if (mSelected == -1)
	paramCache = mpCParam->GetInterpolatedValue(msCurrentDoubleIndex);
    else
	paramCache = mpCParam->mVCKeys[mSelected].mValue;
    
    pCurr->mTextWidth = 80;
    pCurr->mItemWidth = -1;

    wxString strItem = mpCParam->mstrLabel;
    wxString strItemV = wxT("v");
    strItemV << strItem;
    pCurr->CombinePointer(_ITEM_INTEGER, &frame, _("Frame"), FALSE);
    pCurr->CombinePointer(_ITEM_DOUBLE, &paramCache, strItem);
    
    mTypeCache = mpCParam->GetInterpTypeFromDouble(msCurrentDoubleIndex);
    int indexType = pCurr->CombinePointerList(_ITEM_UINT_LIST, &mTypeCache, 
			      5, KeyFrame_cls::msAstrInterp, _("Interpolate Type"));
    
    int boxWidth = 2;

    double DValue2Cache;
    if (mSelected == -1)
	DValue2Cache = 0;
    else
	DValue2Cache = mpCParam->mVCKeys[mSelected].mDValue2;
    mIndexHermiteParam = 
	pCurr->SetInputAndSlider(_ITEM_DOUBLE, &DValue2Cache, wxT("Ease Factor"));
    pCurr->SetRange(_ITEM_LASTITEM, 0, 30, 10);
    
    double DValue1Cache;
    if (mSelected == -1)
	DValue1Cache = 0;
    else
	DValue1Cache = mpCParam->mVCKeys[mSelected].mDValue1;
    mIndexVelocity = pCurr->CombinePointer(_ITEM_DOUBLE, &DValue1Cache, strItemV);
    
    pCurr->MakeGeometry();
    pCurr->SetFuncHook(&HideAndShowParameters, _HOOK_COMBOBOX, indexType, FALSE, pCDLG, this);
    HideAndShowParameters(pCDLG, this);
    pCurr->UpdateValues();

    if (pCDLG->ShowModal() == wxID_OK){
	GCUndoList.OpenBlock();
	mpCParam->mInterpolatedValue = paramCache;
	if (mSelected != -1){
	    // $B%-!<%U%l!<%`$rJQ99(B
	    if (mpCParam->IsValueChanged() == TRUE ||
		DValue1Cache != mpCParam->mVCKeys[mSelected].mDValue1 ||
		DValue2Cache != mpCParam->mVCKeys[mSelected].mDValue2)
		mpCParam->SetChangedValueKey(_PARAM_CURRENT, DValue1Cache, DValue2Cache);
	    mpCParam->SetKeyType(mSelected, mTypeCache);
	}
	else{
	    mpCParam->SetChangedValueKey(_PARAM_CURRENT, 0, DValue2Cache);
	    int index = mpCParam->GetKeyFrameIndexFromDouble(msCurrentDoubleIndex);
	    mpCParam->SetKeyType(index, mTypeCache);
	}
	GCUndoList.CloseBlock();
    }
}

#include "../MYAPI/MsgBox.h"

void ParamTL_cls::
HideAndShowParameters(void* pArg, void *pEvent){
    // $B<!85(Bproof$B$K$9$k(B!!
    MultiInputDialog_cls* pCDLG = (MultiInputDialog_cls*)pArg;
    ParamTL_cls* pC = (ParamTL_cls*)pEvent;
    
    pCDLG->HideItem(pC->mIndexHermiteParam);
    pCDLG->HideItem(pC->mIndexVelocity);

    int candid = pC->mpCParam->GetKeyFrameIndexFromDouble(msCurrentDoubleIndex);

    if (pC->mTypeCache == _PARAM_HERMITE_ADJ){
	pC->mDValue2Cache = 0;
	int candid = pC->mpCParam->GetKeyFrameIndexFromDouble(msCurrentDoubleIndex);
	if (candid != -1)
	    if (pC->mpCParam->mVCKeys[candid].mType == _PARAM_HERMITE_ADJ)
		pC->mDValue2Cache = pC->mpCParam->mVCKeys[candid].mDValue2;
	
	pCDLG->ShowItem(pC->mIndexHermiteParam);
    }

    if (pC->mTypeCache == _PARAM_HERMITE)
	pCDLG->ShowItem(pC->mIndexVelocity);

    /*
    if (pC->mpCParam->mCbTimeDependent.mbBody == FALSE){
	pCDLG->HideItem(0);
	pCDLG->HideItem(dim+1);
    }
    */

    pCDLG->Layout();
    pCDLG->ResizeDialog();
    pCDLG->UpdateValues();
    SizeAdjuster_cls::AdjustWindowFitting(pCDLG);
}


void ParamTL_cls::
ShowMenu(wxMouseEvent& event){
    //GetParent()->AddPendingEvent(event);
    GrayOutUnusedMenu();
    PopupMenu(mpCMenu, mMenuPosX-2, mMenuPosY-2);
}

bool ParamTL_cls::
ChangeKeyInterpolateType(bool bCtrlDown, bool bAltDown){
    bool bMainFrameRefresh = FALSE;
    if (bCtrlDown && !bAltDown){
	if (mpCParam->mVCKeys[mSelected].mType == _PARAM_HERMITE_AUTO)
	    mpCParam->SetKeyTypeMulti(_PARAM_LINEAR);
	else
	    mpCParam->SetKeyTypeMulti(_PARAM_HERMITE_AUTO);
	bMainFrameRefresh |= TRUE;
    }
    // $B%$!<%:78?t$r#0$K$9$k=hM}$rIU$1$J$$$H!"JQ$JJd4V$K$J$k!#(B
    /*
    if (event.m_controlDown && event.m_shiftDown){
	mpCParam->SetKeyTypeMulti(_PARAM_HERMITE_ADJ);
	bMainFrameRefresh |= TRUE;
    }
    */
    if (bCtrlDown && bAltDown){
	mpCParam->SetKeyTypeMulti(_PARAM_STEP);
	bMainFrameRefresh |= TRUE;
    }
    return bMainFrameRefresh;
}

void ParamTL_cls::
ProcStartDragging(double origin, bool bCtrl, bool bAlt){
    ChangeKeyInterpolateType(bCtrl, bAlt);
    mDragDoubleIndexOrigin = origin;
    mDragDoubleIndex = origin;
}

void ParamTL_cls::
ProcDragging(wxMouseEvent& event){
        
    mbDragging = event.m_leftDown;
    mDragDoubleIndex = 
	Quantize(CalcDoubleIndexFromPosition(event.GetX()));
    if (event.m_shiftDown){
	int frame = mDragDoubleIndex * msMaxFrame;
	mDraggingFrame = frame;
	int snipWidth = (msAAMax - msAAMin) / 100;
	for (int candid = frame - snipWidth; candid <= frame + snipWidth; candid++){
	    if (candid < 0) continue;
	    if (candid >= (int)msVBSnippingTag.size()) continue;
	    if (msVBSnippingTag[candid] == TRUE) frame = candid;
	}
	mDragDoubleIndex = Quantize(CalcDoubleIndexFromFrame(frame));
    }
    /*
      if (mSelected != -1)
      mspCDF3SeqGUILink->mpCPanelList->DragAllPanel
      (mbDragging, mDragDoubleIndexOrigin, mDragDoubleIndex);
      else
      Refresh(TRUE);
    */
    mbOnPanel = (event.GetY() > -2 * mHeight && event.GetY() < mHeight * 3);
}

void ParamTL_cls::
SetRegionOrigin(double origin){
    mRegionOrigin = origin;
}

void ParamTL_cls::
TurnOffDragging(){
    mbDragging = FALSE;
}

void ParamTL_cls::
OnMouse(wxMouseEvent& event){

    bool bGroupRefresh = FALSE;
    double doubleIndex = CalcDoubleIndexFromPosition(event.GetX());
    mMenuPosX = event.GetX(); mMenuPosY = event.GetY();
    
    if (event.ButtonUp(wxMOUSE_BTN_RIGHT)) ShowMenu(event);

    if (event.LeftDClick() == TRUE) CreateKeyDLGAtMousePos();

    if (mpCParam == NULL) {
	GetParent()->AddPendingEvent(event);
	event.Skip();
	return;
    }

    if (event.ButtonDown(wxMOUSE_BTN_RIGHT)){
	if (mpCParam->OnWhichKeyFrame(doubleIndex, CalcResolutionFor1Pixel() * 3) != -1)
	    mpCParam->SelectKeyFrameQueue(doubleIndex, CalcResolutionFor1Pixel() * 3, FALSE, !event.m_shiftDown);
	bGroupRefresh = TRUE;
	if (mbSelected == FALSE)
	    GetParent()->AddPendingEvent(event);
    }

    // ---Start Dragging---
    if (event.ButtonDown(wxMOUSE_BTN_LEFT)){
	mpCParam->SetRegionOriginQueue(doubleIndex);
	mpCParam->SelectKeyFrameQueue(doubleIndex, CalcResolutionFor1Pixel() * 3, event.m_shiftDown, !event.m_shiftDown);
	if (mSelected != -1 && mpCParam->mCbTimeDependent.mbBody == TRUE){
	    double dragDoubleIndex = mpCParam->mVCKeys[mSelected].mDoubleIndex;
	    mpCParam->ProcStartDraggingQueue
		(dragDoubleIndex, event.m_controlDown, event.m_altDown);
	}
	else{
	    GetParent()->AddPendingEvent(event);
	}
	CaptureMouse();
	mbCaptureMouse = TRUE;
	mbOnPanel = TRUE;
	bGroupRefresh = TRUE;
	//Refresh(FALSE);
    }

    if (event.Dragging() == TRUE){
	//ProcDragging(event);
	mpCParam->ProcDraggingQueue(event);
	bGroupRefresh = TRUE;
    }
    
    if (event.ButtonUp(wxMOUSE_BTN_LEFT)){
	if (mbCaptureMouse == TRUE){
	    ReleaseMouse();
	    mbCaptureMouse = FALSE;
	    if (mSelected == -1)
		if (mpCParam->
		    SelectKeyFrameRegionQueue(mRegionOrigin, doubleIndex, 0, 0) == TRUE)
		    bGroupRefresh = TRUE;
	    
	    if (mbOnPanel == TRUE && mSelected != -1){
		GCUndoList.OpenBlock();
		if (mpCParam->MoveSelectedKeyByXYQueue
		    (mDragDoubleIndex - mDragDoubleIndexOrigin) == TRUE){
		    /*
		    mspCDF3SeqGUILink->mpCPanelList->MoveTimeSelectedKeyAllPanel
			(mDragDoubleIndex - mDragDoubleIndexOrigin, this);
		    */
		}
		else { // $B0\F0$,L5$1$l$P!"B>$N(Bkey$B$N(Bdeselect
		    mpCParam->SelectKeyFrameQueue(doubleIndex, CalcResolutionFor1Pixel() * 3, event.m_shiftDown, TRUE);		
		}
		GCUndoList.CloseBlock();
		bGroupRefresh = TRUE;
	    }
	}
	mpCParam->TurnOffDraggingQueue();//mbDragging = FALSE;
	bGroupRefresh = TRUE;
    }

    if (mbDragging == TRUE)
	if (bGroupRefresh == FALSE) Refresh(FALSE);

    if (bGroupRefresh == TRUE) mpCParam->GroupRefresh();
    
    event.Skip();
}

void ParamTL_cls::
OnKeyDown(wxKeyEvent& event){
    int code = event.GetKeyCode();
    
    if (code == WXK_DELETE){
	if (mpCParam->mpCParentGroupLink != NULL)
	    mpCParam->mpCParentGroupLink->DeleteSelectedKey();
	else
	    mpCParam->DeleteSelectedKey();
	return;
    }

    if (event.GetModifiers() == wxMOD_CONTROL){
	switch(code){
	case 'X':
	    mpCParam->CopyKeyFrameToClipBoard(); 
	    if (mpCParam->DeleteSelectedKey() == TRUE)
		;//GpCMainFrame->Refresh(FALSE);
	    return; // $B=hM}$7$?$iH4$1$k(B
	case 'C':
	    mpCParam->CopyKeyFrameToClipBoard(); 
	    return; // $B=hM}$7$?$iH4$1$k(B
	case 'V':
	    mpCParam->PasteKeyFrameFromClipBoard();
	    Refresh(TRUE);
	    return; // $B=hM}$7$?$iH4$1$k(B
	}
    }
    
    wxGetTopLevelParent(this)->AddPendingEvent(event);
}

void ParamTL_cls::
OnMenuInsert(wxCommandEvent& WXUNUSED(event)){
    mpCParentPanel->EmuCheckBox();
    mSelected = mpCParam->GetSelectedKeyIndex();
}

void ParamTL_cls::
OnMenuEditKey(wxCommandEvent& WXUNUSED(event)){
    CreateKeyDLGAtMousePos();
}

void ParamTL_cls::
OnMenuExport(wxCommandEvent& WXUNUSED(event)){
    mpCParam->mpCParentGroupLink->Export();
}

void ParamTL_cls::
OnMenuHide(wxCommandEvent& WXUNUSED(event)){
    //mpCParentPanel->HidePanel();
}

void ParamTL_cls::
OnMenuImport(wxCommandEvent& WXUNUSED(event)){
    ;
}

void ParamTL_cls::
OnMenuCustom(wxCommandEvent& event){
    if (mpCCustomTarget != NULL){
	event.SetId(mCustumMenuID);
	mpCCustomTarget->AddPendingEvent(event);
    }
}

// -----

int ParamTL_cls::
GetCoordinateFromDouble(double doubleIndex){
    if (msDoubleIndexAAMax == msDoubleIndexAAMin)
	return GetDeviceX(0);
    double indexWA = 
	(doubleIndex - msDoubleIndexAAMin) / 
	(msDoubleIndexAAMax - msDoubleIndexAAMin);
    return GetDeviceX((float)indexWA);
}

void ParamTL_cls::
CalcCoordinateFromDouble(double doubleIndex){
    mX0 = GetCoordinateFromDouble(doubleIndex);
}

double ParamTL_cls::
CalcResolutionFor1Pixel(){
    return (msDoubleIndexAAMax - msDoubleIndexAAMin) / (mWidth - 2 * mOffset);
}

double ParamTL_cls::
Quantize(double doubleIndex){
    return mpCParam->Quantize(doubleIndex); 
}

double ParamTL_cls::
CalcDoubleIndexFromPosition(int x){
    double coordinate = ((double)x - mOffset) / (mWidth - 2 * mOffset);
    double doubleIndex = coordinate * (msDoubleIndexAAMax - msDoubleIndexAAMin) + 
	msDoubleIndexAAMin;
    
    return doubleIndex;
}

double ParamTL_cls::
CalcDoubleIndexFromFrame(int frame){
    return (double)frame / msMaxFrame;
}

bool   ParamTL_cls::msbIsLoadIcon = FALSE;
wxIcon ParamTL_cls::msCIcon;
bool   ParamTL_cls::msbShowParameter = TRUE;
wxPen  ParamTL_cls::msCPenVeryLightGrey(wxColour(236, 236, 236));
std::vector < bool > ParamTL_cls::msVBSnippingTag;
double ParamTL_cls::msCurrentDoubleIndex;
double ParamTL_cls::msDoubleIndexAAMin = 0;
double ParamTL_cls::msDoubleIndexAAMax = 1;
double ParamTL_cls::msDoubleIndexWAMin = 0;
double ParamTL_cls::msDoubleIndexWAMax = 1;
int    ParamTL_cls::msMaxFrame;
int    ParamTL_cls::msAAMin;
int    ParamTL_cls::msAAMax;
int    ParamTL_cls::msWAMin;
int    ParamTL_cls::msWAMax;
ParamTL_cls*  ParamTL_cls::mspCurrentThis;
TimeCtrl_cls* ParamTL_cls::mspCTimeCtrlLink = NULL;

