// -*- c -*-
// "clsTiParamTL.cpp"
// (setq c-basic-offset 4)

#ifndef _PARAM_TL_H
#define _PARAM_TL__H

#include <wx/wx.h>
#include <vector>

#include "../TIMELINE/clsTLPanelBase.h"

#define _PARAM_TL_MENU_APPEND 0
#define _PARAM_TL_MENU_INSERT 1

class Parameters_cls; 
class ParametersPanel_cls; 
class TimeCtrl_cls;
class MultiNumericalInputs_cls; 


class ParamTL_cls : public wxPanel, public TLPanelGeom_cls {
 public:
    ParamTL_cls(Parameters_cls *pCParam, ParametersPanel_cls *parent, wxPoint pos = wxDefaultPosition, wxSize size = wxDefaultSize, wxWindowID id = wxID_ANY);
    ~ParamTL_cls();

    static ParamTL_cls  *mspCurrentThis;
    Parameters_cls      *mpCParam;
    ParametersPanel_cls *mpCParentPanel;
    static TimeCtrl_cls *mspCTimeCtrlLink;

    static bool     msbIsLoadIcon;
    static wxIcon   msCIcon;
    
    static bool     msbShowParameter;

    wxString        mstrLabel;
    void LinkParameter(Parameters_cls *pCParam);
    void AppendMenu(wxWindow *pCCustomTarget, int menuID,
		    wxString strTitle, int type);
    void GrayOutUnusedMenu();
    wxWindow*       mpCCustomTarget;
    int             mCustumMenuID;

    static wxPen    msCPenVeryLightGrey;
    wxMenu          *mpCMenu;
    int             mMenuPosX, mMenuPosY;

    static std::vector < bool > msVBSnippingTag;
    static double msCurrentDoubleIndex;
    static double msDoubleIndexAAMin, msDoubleIndexAAMax;
    static double msDoubleIndexWAMin, msDoubleIndexWAMax;
    static int msMaxFrame, msAAMin, msAAMax, msWAMin, msWAMax;
    static void SetDoubleIndex();
    /*
	(int maxFrame, int AAMin, int AAMax, double doubleIndex,
	 double doubleIndexAAMin, double doubleIndexAAMax,
	 double doubleIndexWAMix, double doubleIndexWAMax);
    */

    //void Activate(bool bActive, bool bExclusive = TRUE);
    void   Select(bool bSelected);
    
    int    mIndexHermiteParam;
    int    mIndexVelocity;
    /*
    double *mpParamCache;
    double *mpDValue1Cache;
    */
    double       mDValue2Cache;
    unsigned int mTypeCache;
    void  CreateKeyDLGAtMousePos();
    void  CreateKeyDLG(int posx, int poxy, wxPoint posPanel = wxDefaultPosition);
    void  ConnectParameters(MultiNumericalInputs_cls* pCDLG,
			    int *pFrame);
    static void  HideAndShowParameters(void* pArg, void *pEvent);

    void  OnPaint(wxPaintEvent& event);
    void  ShowMenu(wxMouseEvent& event);
    bool  ChangeKeyInterpolateType(bool bCtrlDown, bool bAltDown);
    void  ProcStartDragging(double origin, bool bCtrl, bool bAlt);
    void  ProcDragging(wxMouseEvent& event);
    void  SetRegionOrigin(double origin);
    void  TurnOffDragging();
    void  OnMouse(wxMouseEvent& event);
    void  OnKeyDown(wxKeyEvent& event);
    void  OnMenuInsert(wxCommandEvent& event);
    void  OnMenuEditKey(wxCommandEvent& event);
    void  OnMenuExport(wxCommandEvent& event);
    void  OnMenuHide(wxCommandEvent& event);
    void  OnMenuImport(wxCommandEvent& event);
    void  OnMenuCustom(wxCommandEvent& event);

    // -----

    int   GetCoordinateFromDouble(double doubleIndex);
    void  CalcCoordinateFromDouble(double doubleIndex);
    double CalcResolutionFor1Pixel();
    double Quantize(double doubleIndex);
    double CalcDoubleIndexFromPosition(int x);
    double CalcDoubleIndexFromFrame(int frame);

    //bool  mbActive; 
    bool  mbSelected;
    bool  mbCaptureMouse;
    bool  mbDragging, mbOnPanel;
    int    mSelected; // KeyFrame
    int    mDraggingFrame;
    double mRegionOrigin;
    double mDragDoubleIndex;
    double mDragDoubleIndexOrigin;
    
    DECLARE_EVENT_TABLE()
};

#endif
