// -*- c -*-
// "clsParametersPanel.h"
// (setq c-basic-offset 4)

#include "clsParametersPanel.h"
#include "clsParameters.h"
#include "clsParamGroup.h"
#include "clsParamTL.h"
#include "../WIDGETCTRL/clsBitmapPanel.h"
#include "../WIDGETCTRL/EX/clsBitmapButtonEX.h"
#include "../WIDGETCTRL/EX/clsCheckBoxEX.h"
#include "../WIDGETCTRL/WX/myArtProv.h"

#include "../TIMELINE/clsTimeCtrl.h"
#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#include "../COMMON/CommonDefinitions.h"

#ifdef WIN32
#define _MEM_PANEL_OFFSET 14
#define _CHECKBOX_WIDTH 13
#else
#define _MEM_PANEL_OFFSET 10
#define _CHECKBOX_WIDTH 17
#endif

BEGIN_EVENT_TABLE(ParametersPanel_cls, wxPanel)
     EVT_PAINT       (ParametersPanel_cls::OnPaint)
     EVT_KEY_DOWN    (ParametersPanel_cls::OnKeyDown)
END_EVENT_TABLE()

ParametersPanel_cls::
     ParametersPanel_cls(Parameters_cls *pCParam, wxWindow *parent, 
			 bool bShow, wxPoint pos, wxSize size, wxWindowID id) :
    wxPanel(parent, id, pos, size),
    mpCParam(pCParam)
{
    mOffset = _MEM_PANEL_OFFSET;
    
    // TCU[
    wxBoxSizer  *pBoxSizerSrc = new wxBoxSizer(wxHORIZONTAL);

    mpCBPanelTime = new BitmapPanel_cls(this, wxID_ANY, wxDP, wxSize(14,16));
    mpCBPanelTime->AddBitmapStr(wxT("wxART_TIME_N"));
    mpCBPanelTime->AddBitmapStr(wxT("wxART_TIME_P"));
    mpCBPanelTime->SetBitmapStrDisable(wxT("wxART_TIME_D"));
    Connect(mpCBPanelTime->GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(ParametersPanel_cls::OnMouseL));
    Connect(mpCBPanelTime->GetId(), wxEVT_RIGHT_UP,
	    wxMouseEventHandler(ParametersPanel_cls::OnMouseR));
    
#ifdef WIN32
    mpButtonLFT   = new wxBitmapButtonEX
      (this, wxID_ANY, wxArtProvider::GetBitmap(wxT("wxART_LEFT")),
       wxDP, wxSize(14, 16), wxBORDER_NONE);
    mpButtonLFT->SetBitmapHover(ARTWX("wxART_LEFT_HOVER"));
    mpButtonLFT->SetBitmapDisabled(ARTWX("wxART_LEFT_DISABLED"));
    mpButtonRGT   = new wxBitmapButtonEX
	(this, wxID_ANY, wxArtProvider::GetBitmap(wxT("wxART_RIGHT")),
	 wxDP, wxSize(14, 16), 0);
    mpButtonRGT->SetBitmapHover(ARTWX("wxART_RIGHT_HOVER"));
    mpButtonRGT->SetBitmapDisabled(ARTWX("wxART_RIGHT_DISABLED"));
    
    Connect(mpButtonLFT->GetId(), wxEVT_COMMAND_BUTTON_CLICKED,
	    wxCommandEventHandler(ParametersPanel_cls::OnButtonKeyLFT));
    Connect(mpButtonRGT->GetId(), wxEVT_COMMAND_BUTTON_CLICKED,
	    wxCommandEventHandler(ParametersPanel_cls::OnButtonKeyRGT));
#else
    mpButtonLFT = new BitmapPanel_cls(this, wxID_ANY, wxDP, wxSize(14,16));
    mpButtonLFT->AddBitmapStr(wxT("wxART_LEFT"));
    mpButtonLFT->SetBitmapStrDisable(wxT("wxART_LEFT_DISABLED"));
    mpButtonRGT = new BitmapPanel_cls(this, wxID_ANY, wxDP, wxSize(14,16));
    mpButtonRGT->AddBitmapStr(wxT("wxART_RIGHT"));
    mpButtonRGT->SetBitmapStrDisable(wxT("wxART_RIGHT_DISABLED"));

    Connect(mpButtonLFT->GetId(), wxEVT_LEFT_UP,
	    wxCommandEventHandler(ParametersPanel_cls::OnButtonKeyLFT));
    Connect(mpButtonRGT->GetId(), wxEVT_LEFT_UP,
	    wxCommandEventHandler(ParametersPanel_cls::OnButtonKeyRGT));
    
#endif

    Connect(mpButtonLFT->GetId(), wxEVT_KEY_DOWN,
	    wxKeyEventHandler(ParametersPanel_cls::OnKeyDown));
    Connect(mpButtonRGT->GetId(), wxEVT_KEY_DOWN,
	    wxKeyEventHandler(ParametersPanel_cls::OnKeyDown));
    
    mpCheckBoxKey = new wxCheckBoxEX(this, wxID_ANY, wxT(""),
				     wxDP, wxSize(_CHECKBOX_WIDTH,14));
    Connect(mpCheckBoxKey->GetId(), wxEVT_KEY_DOWN,
	    wxKeyEventHandler(ParametersPanel_cls::OnKeyDown));
    Connect(mpCheckBoxKey->GetId(), wxEVT_COMMAND_CHECKBOX_CLICKED,
	    wxCommandEventHandler(ParametersPanel_cls::OnCheckBoxKey));
    
    mpCParamTL = new ParamTL_cls(mpCParam, this, wxDP, wxSize(-1, 16));
    
    Connect(mpCParamTL->GetId(), wxEVT_LEFT_DOWN,
	    wxMouseEventHandler(ParametersPanel_cls::OnMouseL));
    Connect(mpCParamTL->GetId(), wxEVT_RIGHT_DOWN,
	    wxMouseEventHandler(ParametersPanel_cls::OnMouseR));

    //pBoxSizerSrc->Add(mpButtonHide, 0, 0);
    pBoxSizerSrc->Add(12, -1, 0, wxEXPAND);
    pBoxSizerSrc->Add(mpCBPanelTime, 0, 0);
    pBoxSizerSrc->Add(mpButtonLFT  , 0, 0);
    pBoxSizerSrc->Add(mpCheckBoxKey, 0, wxALIGN_CENTER_VERTICAL);
    pBoxSizerSrc->Add(mpButtonRGT  , 0, 0);
    pBoxSizerSrc->Add(2, -1, 0, wxEXPAND);
    //pBoxSizerSrc->Add(mpCBPanelVisible, 0, 0);
    pBoxSizerSrc->Add(mpCParamTL  , 1, wxEXPAND);
    
    SetSizerAndFit(pBoxSizerSrc);
    mpCBPanelTime->SetAspect(wxHORIZONTAL, 1.0f);
    SetSizerAndFit(pBoxSizerSrc);
    
    UpdatePanelBitmapState();
    Show(bShow);
}

/*
void ParametersPanel_cls::
LinkParameter(Parameters_cls *pCParam){
    mpCParam = pCParam;
    mpCParamTL->LinkParameter(pCParam);
    UpdatePanelBitmapState();
    Refresh(TRUE);
}
*/

void ParametersPanel_cls::
UpdatePanelBitmapState(){
    if (mpCParam != NULL) {
	mpCBPanelTime->mState = 
	    (unsigned int)mpCParam->mCbTimeDependent.mbBody;
	/*
	mpCBPanelVisible->mState = 
	    (unsigned int)mpCParam->mCbVisible.mbBody;
	*/
    }
    else {
	mpCBPanelTime->mState = 0;
	//mpCBPanelVisible->mState = 0;
    }
    mpCBPanelTime->Refresh(FALSE);
}

void ParametersPanel_cls::
SetDoubleIndex(){
    ParamTL_cls::SetDoubleIndex();
    msMaxFrame = ParamTL_cls::msMaxFrame;
    msAAMin = ParamTL_cls::msAAMin;
    msAAMax = ParamTL_cls::msAAMax;
    msCurrentDoubleIndex = ParamTL_cls::msCurrentDoubleIndex;
    msDoubleIndexAAMin = ParamTL_cls::msDoubleIndexAAMin;
    msDoubleIndexAAMax = ParamTL_cls::msDoubleIndexAAMax;
    msDoubleIndexWAMin = ParamTL_cls::msDoubleIndexWAMin;
    msDoubleIndexWAMax = ParamTL_cls::msDoubleIndexWAMax;
}

void ParametersPanel_cls::
OnButtonKeyLFT(wxCommandEvent& event){
    if (mpCParam == NULL) return;
    ParamTL_cls::mspCTimeCtrlLink->SetFrameFromDoubleCommand
	(mpCParam->GetPrevKeyPosDoubleIndex(msCurrentDoubleIndex));
    event.Skip();
}

void ParametersPanel_cls::
OnButtonKeyRGT(wxCommandEvent& event){
    if (mpCParam == NULL) return;
    ParamTL_cls::mspCTimeCtrlLink->SetFrameFromDoubleCommand
	(mpCParam->GetNextKeyPosDoubleIndex(msCurrentDoubleIndex));
    event.Skip();
}

void ParametersPanel_cls::
OnCheckBoxKey(wxCommandEvent& event){
    
    if (mpCParam == NULL) return;

    if (mpCheckBoxKey->GetValue() == FALSE)
	mpCParam->DeleteKeyQueue(msCurrentDoubleIndex);
    else
	mpCParam->InsertKeyQueue(-1);
    
    wxMouseEvent com(wxEVT_LEFT_DOWN);
    com.SetId(mpCParamTL->GetId());
    com.m_shiftDown = TRUE;
    GetParent()->ProcessEvent(com);
    
    mpCParamTL->Refresh(TRUE);
    event.Skip();
}

void ParametersPanel_cls::
EmuCheckBox(){
    if (mpCParam == NULL) return;
    mpCheckBoxKey->SetValue(!mpCheckBoxKey->GetValue());
    wxCommandEvent 
	event(wxEVT_COMMAND_CHECKBOX_CLICKED, mpCheckBoxKey->GetId());
#ifdef WIN32
    AddPendingEvent(event);
#else
    OnCheckBoxKey(event);
#endif
}

void ParametersPanel_cls::
UpdateDisplay(){
    if (mpCParamTL != NULL){
	mpCParamTL->Refresh(FALSE);
    }
    UpdatePanelBitmapState();
    /*
    if (mpCBPanelTime != NULL){
	mpCBPanelTime->Refresh(FALSE);
    }
    */
    /*
    if (mpCBPanelVisible != NULL)
	mpCBPanelVisible->Refresh(FALSE);
    */
    if (mpCParam == NULL) {
	mpCheckBoxKey->Disable();
	mpButtonLFT->Disable();
	mpButtonRGT->Disable();
	mpCBPanelTime->Disable();
	//mpCBPanelVisible->Disable();
	return;
    } 
    else{
	if (mpCParam->mCbTimeDependent.mbBody == TRUE){
	    mpCheckBoxKey->Enable();
	    mpButtonLFT->Enable();
	    mpButtonRGT->Enable();
	    mpCBPanelTime->Enable();
	    //mpCBPanelVisible->Enable();
	}
	else{
	    mpCheckBoxKey->Disable();
	    mpButtonLFT->Disable();
	    mpButtonRGT->Disable();
	    mpCBPanelTime->Enable();
	    //mpCBPanelVisible->Enable();
	}
    }
    mpCheckBoxKey->SetValue(IsKeyFrame(msCurrentDoubleIndex));
}

bool ParametersPanel_cls::
IsKeyFrame(double doubleIndex){
    return mpCParam->IsKeyFrame(doubleIndex);
}

void ParametersPanel_cls::
SetMemberSize(wxSize size){
    mWidth = size.GetWidth();
    mHeight = size.GetHeight();
}

int ParametersPanel_cls::
GetDeviceX(float x){
    return (int)(x * (mWidth - 2 * mOffset) + mOffset);
}

void ParametersPanel_cls::
OnPaint(wxPaintEvent& event){
    // must always be here
    wxPaintDC dc(this);
    SetMemberSize(dc.GetSize());
    UpdateDisplay();
    event.Skip();
}

void ParametersPanel_cls::
OnKeyDown(wxKeyEvent& event){
    event.SetId(GetParent()->GetId());
    GetParent()->GetEventHandler()->AddPendingEvent(event);
    //int code = event.GetKeyCode();
    //GetParent()->AddPendingEvent(event);
}

void ParametersPanel_cls::
OnMouseL(wxMouseEvent& event){

    if (event.GetId() == mpCBPanelTime->GetId()){

	if (mpCParamTL->mbSelected == FALSE){
	    if (mpCParam == NULL) return;
	    ParamGroup_cls *pCGroup = mpCParam->mpCParentGroupLink;
	    if (pCGroup != NULL && pCGroup->mbLinking == TRUE)
		pCGroup->SetTimeDependent(mpCBPanelTime->mState == 1);
	    else
		mpCParam->SetTimeDependent(mpCBPanelTime->mState == 1);
	}
	
	
	/*
	else
	    mspCDF3SeqGUILink->SetTimeDependent(mpCBPanelTime->mState == 1);
	wxCommandEvent dummy(wxEVT_COMMAND_MENU_SELECTED, menuItemRefresh);
	GetGrandParent()->AddPendingEvent(dummy);
	*/
	
    }
    

    /*
    if (event.GetId() == mpCBPanelVisible->GetId()){
	if (mpCParamTL->mbSelected == FALSE){
	    if (mpCParam == NULL) return;
	    mpCParam->mCbVisible.mbBody = (mpCBPanelVisible->mState == 1);
	}
	else
	    mspCDF3SeqGUILink->SetVisibility(mpCBPanelVisible->mState == 1);
	wxCommandEvent dummy(wxEVT_COMMAND_MENU_SELECTED, menuItemRefresh);
	GetGrandParent()->AddPendingEvent(dummy);
    }
    */

    //GetParent()->AddPendingEvent(event);
    event.Skip();
}

void ParametersPanel_cls::
OnMouseR(wxMouseEvent& event){
    GetParent()->AddPendingEvent(event);
    event.Skip();
}

double ParametersPanel_cls::msCurrentDoubleIndex;
double ParametersPanel_cls::msDoubleIndexAAMin;
double ParametersPanel_cls::msDoubleIndexAAMax;
double ParametersPanel_cls::msDoubleIndexWAMin;
double ParametersPanel_cls::msDoubleIndexWAMax;
int    ParametersPanel_cls::msMaxFrame;
int    ParametersPanel_cls::msAAMin;
int    ParametersPanel_cls::msAAMax;

