// -*- c -*-
// "clsParametersPanel.cpp"
// (setq c-basic-offset 4)

#ifndef _PARAMETERS_PANEL_H
#define _PARAMETERS_PANEL_H

#include <wx/wx.h>
#include <wx/image.h>

class Parameters_cls; 
class ParamTL_cls; 
class TimeCtrl_cls;
class BitmapPanel_cls; 
class wxBitmapButtonEX;
class wxCheckBoxEX;

class ParametersPanel_cls : public wxPanel {
 public:
    ParametersPanel_cls
	(Parameters_cls *pCParam, wxWindow *parent, bool bShow = TRUE, 
	 wxPoint pos = wxDefaultPosition, wxSize size = wxDefaultSize, 
	 wxWindowID id = wxID_ANY);
    Parameters_cls *mpCParam;
    //void LoadBitmap();
    /*
    void LinkParameter(Parameters_cls *pCParam);
    */
    void UpdatePanelBitmapState();
    
    static double msCurrentDoubleIndex;
    static double msDoubleIndexWAMin, msDoubleIndexWAMax;
    static double msDoubleIndexAAMin, msDoubleIndexAAMax;
    static int msMaxFrame, msAAMin, msAAMax;
    static void SetDoubleIndex();

    ParamTL_cls *mpCParamTL;
    BitmapPanel_cls *mpCBPanelTime;
    BitmapPanel_cls *mpCBPanelTimeDisable;
#ifdef WIN32
    wxBitmapButtonEX *mpButtonLFT;
    wxBitmapButtonEX *mpButtonRGT;
#else
    BitmapPanel_cls *mpButtonLFT;
    BitmapPanel_cls *mpButtonRGT;
#endif
    //wxButton *mpButtonLFT;
    //wxButton *mpButtonRGT;
    wxCheckBoxEX *mpCheckBoxKey;
    
    void OnButtonToggleTime(wxCommandEvent& event);

    void OnButtonKeyLFT(wxCommandEvent& event);
    void OnButtonKeyRGT(wxCommandEvent& event);
    void OnCheckBoxKey(wxCommandEvent& event);
    void EmuCheckBox();

    void UpdateDisplay();

    bool IsKeyFrame(double doubleIndex);    

    void SetMemberSize(wxSize size);
    int  GetDeviceX(float x);

    int  mWidth, mHeight;
    int  mOffset;

    void OnPaint(wxPaintEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnMouseL(wxMouseEvent& event);
    void OnMouseR(wxMouseEvent& event);

    DECLARE_EVENT_TABLE()
};

#endif
