// -*- c -*- 
// "clsTics.cpp"

#ifndef _PARAMETER_TICS_H_
#define _PARAMETER_TICS_H_

#include "clsParamDrawBase.h"

#include <wx/wx.h>
#include <wx/dcbuffer.h>

class Tics_cls : public ParamDrawBase_cls {
 public:
    Tics_cls();

    void SetParameter(wxSize size, float min, float max, int offset);
    void SetColorParameter
	(wxColour BGColor, wxColour FGColor1, wxColour FGColor2);
    void Swap(int &tics0, int &tics1);
    void DrawTics(wxDC &dc);

    int GetTicDeviceX(float x);
    void CalcTicDeviceCoordinate(int *pX0, int *pX1, 
				 float frame0, float frame1);

    wxColour mBGColor, mFGColor1, mFGColor2;

    bool mbUseFloat;
    float mRegionMin;
    float mRegionMax;

    int mTicWidth, mTicHeight;
    int mTicOffset;

    int mStepLarge;
    int mStepMiddle;
    int mStepSmall;

    float mStepFloatScaling;
    int mStepFloatOrder;

    float mFloatStepLarge;
    float mFloatStepSmall;
    
    int mTicsX0, mTicsX1;
};

#endif
