
#ifndef _THREAD_INTERPOLATE_HERMITE_H_
#define _THREAD_INTERPOLATE_HERMITE_H_

#include "clsThreadInterpolateCommon.h"

#include <wx/wx.h>
#include <wx/thread.h>

class BasicDataPointers_cls;
class DataLoader_cls;
class PeriodicBoundary_cls;

class ThreadInterpBlockHermite_cls : public wxThread, public ThreadInterporateCommon_cls {
 public:
    ThreadInterpBlockHermite_cls(wxThreadKind kind);

    void SetParameters(int PInit, int PFin,
		       int PNumNext, float dtime, int variablePNum,
		       int searchLimit,
		       PeriodicBoundary_cls *pCPeriodicLink,
		       BasicDataPointers_cls *pCDataPointers,
		       BasicDataPointers_cls *pCDataPointersNext);

    int   mVariablePNum;
    int   mPeriodicType;
    float mPeriodicSize[3]; // R͂e\
    int   mPeriodicEffect;

    float (*mpX)[3], (*mpV)[3], (*mpA)[3], (*mpJ)[3];
    unsigned char *mpType;
    float *mpRadius, *mpDRadius;
    float *mpValue1, *mpDValue1;
    int   *mpID;
    
    float (*mpXNext)[3];
    float (*mpVNext)[3];
    float (*mpANext)[3];
    float (*mpJNext)[3];
    unsigned char *mpTypeNext;
    float *mpRadiusNext, *mpDRadiusNext;
    float *mpValue1Next, *mpDValue1Next;
    //int   *mpIDNext;

    int   mPIni, mPFin;
    //int   mPNumNext;
    float  mDTime;
    
    /*
    int SearchIDNear(int index, int ID, int range);
    int SearchIDFull(int ID);
    int SearchIDFrom(int *pTgtIndex, int ID); 
    */
    
    void InterpolateDataHermiteCore(int i, int iNext, float dtime);
    /*
    void InterpolateDataHermiteCorePeriodicXYEeffect0(int i, int iNext, float dtime);
    void InterpolateDataHermiteCorePeriodicXYEeffect1(int i, int iNext, float dtime);
    void InterpolateDataHermiteCorePeriodicXYZEeffect0(int i, int iNext, float dtime);
    void InterpolateDataHermiteCorePeriodicXYZEeffect1(int i, int iNext, float dtime);
    */
    void InterpolateDataHermite();
    void InterpolateDataHermitePeriodic();
    void InterpolateDataHermiteSearchingID();
    void InterpolateDataHermiteSearchingIDSorted();

    virtual ExitCode Entry();
};

#endif
