// -*- c -*- 
// "clsGLDrawBillboard.cpp"

#ifndef _GL_DRAW_BILLBOARD_H_
#define _GL_DRAW_BILLBOARD_H_

#include "../WIDGETCTRL/WX/clsUpdateStatusBar.h"

#define PACKNUM 300
#define _GL_DRAW_BILLBOARD_BUFFER 200000

#include <wx/thread.h>

class ArrayAndIndex_cls;
class GLAttribute_cls;
class SnapData_cls;

class ThreadCaleVertex_cls : public wxThread {
 public:
    ThreadCaleVertex_cls(wxThreadKind kind);

    void SetParameters(bool *pbFinishedFlag, int offset, int pnumber,
		       float *pVertexBuffer, float *pColorBuffer,
		       float *pRotatedArray,
		       GLAttribute_cls   *pCGLAttribute,
		       ArrayAndIndex_cls *pArrayIndexAndZ,
		       SnapData_cls      *pCDataSnap,
		       bool bConstantRadius,
		       float radiusFactor, float steppingAlphaFactor);

    bool *mpbFinishedFlagLink;
    int mOffset, mPNumber;
    float *mpVertexBuffer, *mpColorBuffer;
    float *mpRotatedArray;
    GLAttribute_cls   *mpCGLAttribute;
    ArrayAndIndex_cls *mpArrayIndexAndZ;
    SnapData_cls      *mpCDataSnap;
    bool mbConstantRadius;
    float mRadiusFactor;
    float mSteppingAlphaFactor;

    virtual ExitCode Entry();
};

class GLDrawBillboard_cls : public UpdateStatusBar_cls {
 public:
    GLDrawBillboard_cls();
    ~GLDrawBillboard_cls();

    static unsigned int mspIndices[PACKNUM * 4];
    static float        msTexCoordArray[PACKNUM * 4 * 2];
    static float        msVertexArray[PACKNUM * 4 * 3];

    static int msDownsizedAtFBO0;
    static ArrayAndIndex_cls *mspIndexAndZ;

    float  *mpVertexArrayBufferA;
    float  *mpVertexArrayBufferB;
    float  *mpColorBufferA;
    float  *mpColorBufferB;

    // q0ƂĂ܂Ƃ߂ĕ\
    void GLDrawBillboardBlockMain
	(int offset, int pnumber, 
	 float *pRotatedArray, float radiusFactor,
	 bool bConstantRadius, bool bConstantColor,
	 float steppingAlphaFactor,
	 SnapData_cls *pCDataSnap,
	 GLAttribute_cls *pCGLAttribute, float *pValue1);

    void GLDrawBillboardBlock
	(int downsized, 
	 float *pRotatedArray, float radiusFactor, 
	 bool bConstantRadius, bool bConstantColor,
	 float steppingAlphaFactor,
	 SnapData_cls *pCDataSnap,
	 GLAttribute_cls *pCGLAttribute, float *pValue1);

    // q0ƂĂ܂Ƃ߂ĕ\iqj
    void GLDrawBillboardMultitheadDraw
	(float *pVertex, float *pColor, int number);

    void GLDrawBillboardMultithead
	(int downsized, 
	 float *pRotatedArray, float radiusFactor, 
	 bool bConstantRadius, bool bConstantColor,
	 float steppingAlphaFactor,
	 SnapData_cls *pCDataSnap,
	 GLAttribute_cls *pCGLAttribute, float *pValue1);

    // Xɕ\ꍇ
    void GLDrawBillboardSequential(float *pParticleX, float vertexArray[12],
				   int drawType, int prevDrawType);
	

};

#endif
