// -*- c -*- 
// "clsGLDrawData.cpp"

#ifndef _GL_DRAW_DATA_H_
#define _GL_DRAW_DATA_H_

#include "../MYGL/clsPositionAndDirection.h"
#include "../WIDGETCTRL/WX/clsUpdateStatusBar.h"

#include "clsGLDrawBillboard.h"


#include <wx/thread.h>
#include <wx/stopwatch.h>

class GLAttribute_cls;
class FilterCtrl_cls;
class InformationGUI_cls;
class PDataBlock_cls;
class ShadowVolume_cls;
class SnapData_cls;
class ZSort_cls;

#include "../COMMON/CommonDefinitions.h"
#include "../COMMON/CommonDefinitionsGL.h"

#define _SORT_RADIAL 0
#define _SORT_ORTHO  1

class ThreadA_cls : public wxThread {
 public:
    ThreadA_cls(wxThreadKind kind);

    void SetParameters(bool *pbFinishedFlag, float *pX, int offset, int pnumber, 
		       float *vertexArray, float *pRotatedArray);
    
    bool  *mpbFinishedFlagLink;
    float *mpX;
    int    mOffset;
    int    mPNumber;
    float *mvertexArray;
    float *mpRotatedArray;
    
    virtual ExitCode Entry();
};

class GLDrawData_cls : public GLDrawBillboard_cls {
 public:
    GLDrawData_cls();
    ~GLDrawData_cls();

    static float        msVertexArrayOrg[12];
    static bool         msbInitialized;
    static SnapData_cls *mspCSnapShot;
    static InformationGUI_cls* mspCInfoPanel;
    static float             *mspAlphaMask;
    static FilterCtrl_cls    *mspCFilterCtrlBooleanLink;
    static double       msCurrentDoubleIndex;
    static int          msAbortLimitMS;
    static bool         msbUseAbortion;
    static wxString     msstrWarning; 
    
    ShadowVolume_cls *mpCShadowVolume;
    ZSort_cls *mpCZSort;
    int    mSortType;

    wxStopWatch mCStopWatch;
    
    float  mpZero4[4];
    float  mCameraPos[3], mCameraDir[3];

    int    mLightNum;
    double mLightPos[3];
    
    double mLightPhi, mLightTheta;
    
    PositionAndDirection_cls mCLightPos;
    PositionAndDirection_cls mCParticlePos;

    bool  mbShadowVolume;
    bool  mbMainFrame;
        
    //void UpdateStatusBar();
    void SetCameraPos(double *pCamPos);
    void SetCameraDir(double *pCamDir);
    void SetLightSourceInfo(int lightNumber,
			    float *pLightPos, //float *pLightClr,
			    double lightPhi, double lightTheta);
    float GetSteppingAlphaFactor(int step);
    float GetSteppingRadiusFactor(int step);

    void GLDraw(int fboIndex, PDataBlock_cls *pCDataBlock, 
		GLAttribute_cls **ppCGLAttribute, double dT);

    void GLDrawPointArrayElement(int fboIndex,
				 SnapData_cls *pCDataSnap,
				 GLAttribute_cls *pCGLAttribute);
    void GLDrawPointAll(int fboIndex,
			SnapData_cls *pCDataSnap,
			GLAttribute_cls *pCGLAttribute);

    void GetVertexArrayLookAtCamera(float pParticlePos[3], float array[12]);
    void MultiplyMatrixOnVertexArrayOrg(GLfloat matrix[16], float array[3]);
    void GLDrawBillboardAll(int fboIndex, SnapData_cls *pCDataSnap, 
			    GLAttribute_cls *pCGLAttribute);

    void GLDrawSphereConstRadiusConstantColor
	(int downsized, float (*pPos)[3], 
	 float radiusFactor, float quality);
    void GLDrawSphereConstRadiusVariableColor
	(int downsized, float (*pPos)[3], float *pValue1,
	 float radiusFactor, float quality, float steppingAlphaFactor,
	 GLAttribute_cls *pCGLAttribute);
    void GLDrawSphereVariableRadiusConstColor
	(int downsized, float (*pPos)[3], float *pRadius,
	 float radiusFactor, float quality);
    void GLDrawSphereVariableRadiusVariableColor
	(int downsized, float (*pPos)[3], float *pRadius, float *pValue1,
	 float radiusFactor, float quality, float steppingAlphaFactor,
	 GLAttribute_cls *pCGLAttribute);
    void GLDrawCylindeConstantRadius
	(int downsized, float (*pPos)[3], float *pRadius,
	 float radiusFactor, float quality);
    void GLDrawCylinderVariableRadius
	(int downsized, float (*pPos)[3], float *pRadius,
	 float radiusFactor, float quality);
    void DrawCylinder(float pos[3], float scale, int quality);
	 
    void GLDrawSphereAll(int fboIndex, SnapData_cls *pCDataBlock, 
			 GLAttribute_cls *pCGLAttribute);
    
    
    void DrawSphere(float pos[3], float scale, int quality);
    int  ZSortSphericalA(int PNum, int step, float (*pX)[3], int sortType);
    void ZSortAtFBO0(int PNum, int step, float (*pX)[3],
		     int sortOrder/*, int sortType*/);
    int  ZSort(int fboIndex, 
	       SnapData_cls* pCDataSnap, GLAttribute_cls *pCGLAttribute);

    void GLDrawSequential(int fboIndex, 
			  SnapData_cls *pCDataSnap, 
			  GLAttribute_cls **ppCGLAttribute);
    void GLDrawShadowVolumeSequential
	(SnapData_cls *pCDataSnap, int downsized, 
	 int drawTypeList[_MAX_PARTICLE_TYPE],
	 int radiusTypeList[_MAX_PARTICLE_TYPE], 
	 float radiusFactorList[_MAX_PARTICLE_TYPE], 
	 unsigned char *pType, float (*pPos)[3], float *pRadius);
};

#endif
