// (setq c-basic-offset 4)
// "clsParticleDataSeqCtrl.h"

#include "clsParticleDataSeqCtrl.h"
#include "clsParticleDataSequence.h"

#include "../COMMON/CommonDefinitions.h"

PDataSeqCtrl_cls::
PDataSeqCtrl_cls(DrawOption_cls *pCDrawOptionLink, bool bIs64bit){
    mActiveChannel = 0;
    mTotalUsedMemoryMB = 0;
    if (bIs64bit){
	wxMemorySize mem_size_msz = wxGetFreeMemory(); 
	double memSize = mem_size_msz.ToDouble();
	memSize /= 1024*1024;
	int memSizeMB = memSize;
	if (memSizeMB >= 32768)
	    mMemoryLimitationMB = 16384;
	else if (memSizeMB >= 16384)
	    mMemoryLimitationMB = 8192;
	else
	    mMemoryLimitationMB = 4096; // FIX_ME!! Ƃ̌ˍ
    }
    else
	mMemoryLimitationMB = 768;

    for (int i = 0; i < _MAX_PDATA_CHANNEL; i++)
	mpCPDataSequence[i] = new PDataSequence_cls(i, pCDrawOptionLink);
}

PDataSeqCtrl_cls::
~PDataSeqCtrl_cls(){
    for (int i = 0; i < _MAX_PDATA_CHANNEL; i++)
	delete mpCPDataSequence[i];
}

PDataSequence_cls* PDataSeqCtrl_cls::
GetPCActiveFileSequence(){
    return mpCPDataSequence[mActiveChannel];
}

void PDataSeqCtrl_cls::
ClearData(int channel, int index, bool bClearFileInfo){
    if (channel == _ALL_SEQUENCE){
	for (int i = 0; i < _MAX_PDATA_CHANNEL; i++)
	    mpCPDataSequence[i]->Clear(index, bClearFileInfo);
	return;
    }
    if (channel == _ACTIVE_SEQUENCE){
	mpCPDataSequence[mActiveChannel]->Clear(index, bClearFileInfo);
	return;
    }
    mpCPDataSequence[channel]->Clear(_SEQUENCE_ALL_INDEX, bClearFileInfo);
}

int PDataSeqCtrl_cls::
OpenDataFile(wxString strFilePathInit, bool bSequential){
    return mpCPDataSequence[mActiveChannel]->
	OpenDataFile(strFilePathInit, bSequential);
}

wxString PDataSeqCtrl_cls::
GetStrActiveFileSequencePath(){
    return GetPCActiveFileSequence()->mCFileSequence.mstrPath;
}

int PDataSeqCtrl_cls::
GetActiveFileSequenceLength(){
    return GetPCActiveFileSequence()->mCFileSequence.mSeqLength;
}

void PDataSeqCtrl_cls::
CleanUpMemory(int currentIndex, int animStep){
    mTotalUsedMemoryMB = CalcAndGetUsedTotalMemoryMB();

    GetPCActiveFileSequence()->ReleaseMemoryOutofStep(animStep);
    while (mTotalUsedMemoryMB > mMemoryLimitationMB){
	if (GetPCActiveFileSequence()->
	    ReleaseMemoryAStep(currentIndex, animStep) == FALSE)
	    break;
	mTotalUsedMemoryMB = CalcAndGetUsedTotalMemoryMB();
    }
}

void PDataSeqCtrl_cls::
PrepareIndex(int index, double indexmod, bool bUseBlur, bool bWaitFinish){
    //
    GetPCActiveFileSequence()->PrepareIndex
	(index, indexmod, bUseBlur, bWaitFinish);
}

int  PDataSeqCtrl_cls::
CalcAndGetUsedTotalMemoryMB(){
    // FIX_ME!! FileSequenceƂ͈Ⴄ
    return GetPCActiveFileSequence()->GetUsedTotalMemoryMB();
}

int  PDataSeqCtrl_cls::
GetLoadedFrameNumber(){
    // FIX_ME!! FileSequenceƂ͈Ⴄ
    return GetPCActiveFileSequence()->GetLoadedFrameNumber();
}

bool PDataSeqCtrl_cls::
IsTheIndexReady(int index, double indexmod, bool bUseBlur){
    return GetPCActiveFileSequence()->IsTheIndexReady(index, indexmod, bUseBlur);
}

bool PDataSeqCtrl_cls::
IsTheIndexReading(int index){
    return GetPCActiveFileSequence()->IsTheIndexReading(index);
}

bool PDataSeqCtrl_cls::
IsTheIndexLoaded(int index){
    return GetPCActiveFileSequence()->IsTheIndexLoaded(index);
}

void PDataSeqCtrl_cls::
ClearSnipping(){
    for (int i = 0; i < _MAX_PDATA_CHANNEL; i++)
	mpCPDataSequence[i]->ClearSnipping();
}

void PDataSeqCtrl_cls::
SetSnipping(int index){
    for (int i = 0; i < _MAX_PDATA_CHANNEL; i++)
	mpCPDataSequence[i]->SetSnipping(index);
}

// ----

wxString PDataSeqCtrl_cls::
Serialize(){
    wxString strOut;
    for (int i = 0; i < _MAX_PDATA_CHANNEL; i++){
	strOut << mpCPDataSequence[i]->Serialize();
    }
    return strOut;
}

void PDataSeqCtrl_cls::
ReadStrLine(std::wistream &istream, wxString strLine, bool bSequential){
    for (int i = 0; i < _MAX_PDATA_CHANNEL; i++){
	mpCPDataSequence[i]->ReadStrLine(istream, strLine, bSequential);
    }
}
