// -*- c++ -*- 
// "clsPeriodicBoundary.cpp"
// (setq c-basic-offset 4)

#ifndef _PERIODIC_BOUNDARY_H_
#define _PERIODIC_BOUNDARY_H_

#include "../CONFITEM/clsConfItem.h"
#include "../WIDGETCTRL/clsDialogController.h"

class FrameMain_cls;
class PeriodicBoundaryGUI_cls;

class PeriodicBoundary_cls 
    : public DialogControl_cls
{
public:
    PeriodicBoundary_cls(wxWindow *pCParentFrame, wxString strBitmap);
    
    void InitGUI(wxWindow *pC);
    void UpdateItems(bool bForce = FALSE);
    void OpenWindow(wxWindow *pC);

    PeriodicBoundaryGUI_cls* mpCGUI;
    wxString mstrBitmap;
    
    void SetToDefault();
    
    ConfItemList_cls  mCConfList;
    ConfItemUINT_cls mCType;
    ConfItemUINT_cls mCEffect;
    ConfItemFLOATARRAY_cls mCSize;
    ConfItemFLOATARRAY_cls mCBaseVector[3];

    void GetBoundaryVector(float vec[3], int axis);

    void ReadStrLine(wxString strLine);
    wxString Serialize();
};

#endif
