// -*- c -*- 
// "clsSnapData.cpp"

#ifndef _SNAP_DATA_H_
#define _SNAP_DATA_H_

class ColorCurve_cls;
class GLAttribute_cls;
class PDataBlock_cls;

#include <wx/thread.h>

#include "../COMMON/CommonDefinitionsForH.h"

class ThreadSnapInterpHermite_cls : public wxThread {
 public:
    ThreadSnapInterpHermite_cls(wxThreadKind kind);

    void SetParameters(bool *pbFinishedFlag,
		       int PInit, int PFin,
		       int downsizeStep,
		       float DTime,
		       float (*pX)[3], float (*pV)[3],
		       float (*pA)[3], float (*pJ)[3], 
		       float *pRadius, float *pDRadius,
		       float *pValue1, float *pDValue1,
		       float (*pXMem)[3],// float (*pVMem)[3],
		       float *pRadiusMem, 
		       float *pValue1Mem,
		       unsigned char   *pTypeLinkMem,
		       float (*pColorMem)[4], 
		       float *pValue1ForColor[_MAX_PARTICLE_TYPE],
		       ColorCurve_cls* pColorCurveCol[_MAX_PARTICLE_TYPE],
		       int alphaType[_MAX_PARTICLE_TYPE],
		       float alphaDependBase[_MAX_PARTICLE_TYPE], 
		       float alphaFactor[_MAX_PARTICLE_TYPE]);

    bool *mpbFinishedFlagLink;
    float mDTime;
    float (*mpX)[3];
    float (*mpV)[3];
    float (*mpA)[3];
    float (*mpJ)[3];
    float *mpRadius, *mpDRadius;
    float *mpValue1, *mpDValue1;
    
    float (*mpXMem)[3];
    //float (*mpVMem)[3];
    float *mpRadiusMem;
    float *mpValue1Mem;
    unsigned char  *mpTypeLinkMem;
    float (*mpColorMem)[4];
    float *mpValue1ForColor[_MAX_PARTICLE_TYPE];
    ColorCurve_cls *mpCClrCurveCol[_MAX_PARTICLE_TYPE];

    int  mAlphaType[_MAX_PARTICLE_TYPE];
    float mAlphaDependBase[_MAX_PARTICLE_TYPE];
    float mAlphaFactor[_MAX_PARTICLE_TYPE];
    
    int   mPIni, mPFin;
    int   mDownsizeStep;

    void InterpolateDataHermite();

    virtual ExitCode Entry();
};

class ThreadSnapInterpLinear_cls : public wxThread {
 public:
    ThreadSnapInterpLinear_cls(wxThreadKind kind);

    void SetParameters(bool *pbFinishedFlag,
		       int PInit, int PFin,
		       int downsizeStep,
		       float DTime,
		       float (*pX)[3], float (*pV)[3],
		       //float (*pA)[3], float (*pJ)[3], 
		       float *pRadius, float *pDRadius,
		       float *pValue1, float *pDValue1,
		       float (*pXMem)[3],// float (*pVMem)[3],
		       float *pRadiusMem, 
		       float *pValue1Mem,
		       unsigned char   *pTypeLinkMem,
		       float (*pColorMem)[4], 
		       float *pValue1ForColor[_MAX_PARTICLE_TYPE],
		       ColorCurve_cls* pColorCurveCol[_MAX_PARTICLE_TYPE],
		       int alphaType[_MAX_PARTICLE_TYPE],
		       float alphaDependBase[_MAX_PARTICLE_TYPE], 
		       float alphaFactor[_MAX_PARTICLE_TYPE]);

    bool *mpbFinishedFlagLink;
    float mDTime;
    float (*mpX)[3];
    float (*mpV)[3];
    float (*mpA)[3];
    float (*mpJ)[3];
    float *mpRadius, *mpDRadius;
    float *mpValue1, *mpDValue1;
    
    float (*mpXMem)[3];
    //float (*mpVMem)[3];
    float *mpRadiusMem;
    float *mpValue1Mem;
    unsigned char  *mpTypeLinkMem;
    float (*mpColorMem)[4];
    float *mpValue1ForColor[_MAX_PARTICLE_TYPE];
    ColorCurve_cls *mpCClrCurveCol[_MAX_PARTICLE_TYPE];

    int  mAlphaType[_MAX_PARTICLE_TYPE];
    float mAlphaDependBase[_MAX_PARTICLE_TYPE];
    float mAlphaFactor[_MAX_PARTICLE_TYPE];
    
    int   mPIni, mPFin;
    int   mDownsizeStep;

    void InterpolateDataLinear();

    virtual ExitCode Entry();
};

class SnapData_cls{
 public:
    SnapData_cls(PDataBlock_cls *pCDataBlockLink,
		 GLAttribute_cls **ppCGLAttribute,
		 double DT, int downsizeStep);
    ~SnapData_cls();

    void Allocate(int pNum);
    void ReleaseData();
    
    bool IsItSameSnap(PDataBlock_cls *pCDataBlockLink, double dT,
		      int downsizeStep);
    static bool IsInterpolateRequired(GLAttribute_cls **ppCGLAttribute);
    void SetPValue1(float **ppValue1, //PDataBlock_cls *pCDataBlockLink,
		    GLAttribute_cls *pCGLAttribut, int type);
    void InterpolateNot(PDataBlock_cls *pCDataBlockLink,  
			GLAttribute_cls **ppCGLAttribute);
    void Interpolate(GLAttribute_cls **ppCGLAttribute,
		     double dT);
    void SetValue1Dash(int type);
    void AllocateValue1Dash();
    
    PDataBlock_cls *mpCDataBlockLink;

    bool mbAllocated;
    bool mbValue1dash;
    int  mPNumBlock;
    double mTime;
    int    mDownsizeStep;
    //int    mInterpolateType;
    int   mOrder;
    
    float (*mpX)[3];
    float *mpRadius;
    float *mpValue1;
    float *mpValue1dash;
    float (*mpColor)[4];
    unsigned char *mpTypeLink;

};

#endif
