// (setq c-basic-offset 4)

#include "clsThreadFileReader.h"
#include "clsThreadFileReaderAscii.h"
#include "../HDF5/clsReadHDF5Data.h"
#include "../HDF5/clsGrammerHDF5.h"
#include "../MYAPI/MsgBox.h"
#include "../PANELS/clsDataLoader.h"
#include "../PANELS/clsPreference.h"
#include "../PARTICLEDATA/clsParticleDataBlock.h"
#include "../PARTICLEDATA/clsParticleDataSnap.h"

#include "../COMMON/CommonDefinitions.h"

#include "../../wxWidgetEnumMenu.h"

#include <algorithm>
#include <fstream>
#include <sstream>
#include <string.h>

//0=NULL(?)ŏ͂
ThreadFileReader_cls *GApCThreadReader[_MAX_READ_THREAD] = {}; 
bool                 GAbThreadReaderFinished[_MAX_READ_THREAD] = {};
int                  GAThreadReaderPercentage[_MAX_READ_THREAD] = {};
int                  GAThreadReaderIndex[_MAX_READ_THREAD] = {};
extern wxFrame       *GpCMainFrameCLS;
extern int           GThreadNumberReadAscii;

ThreadReadBuffer_cls::
ThreadReadBuffer_cls(wxThreadKind kind) :
    wxThread(kind) {
}

void ThreadReadBuffer_cls::
SetParameters(bool *pbFinishedFlagLink,
	      std::fstream *pifstream, char *pBuf, int size){
    mpbFinishedFlagLink = pbFinishedFlagLink;
    mpifstream = pifstream;
    mpBuf = pBuf;
    mSize = size;

    if ( Create() != wxTHREAD_NO_ERROR) 
	MsgBoxExit(NULL, "Error!", "Can't create thread");
}

wxThread::ExitCode ThreadReadBuffer_cls::
Entry(){
    mpifstream->read(mpBuf, mSize);
    
    *mpbFinishedFlagLink = TRUE;

    return 0;
}

// ------

ThreadFileReader_cls::
ThreadFileReader_cls(wxThreadKind kind) :
    wxThread(kind) {
}

void ThreadFileReader_cls::
SetParameters(int selfThreadIndex,//bool *pbFinishedFlagLink, 
	      DataLoader_cls *pCDataLoder,
	      PDataBlock_cls *pCDataBlock,
	      wxString strFilePath, int  pNum,
	      bool bUseID){
    
    //mpbFinishedFlagLink = pbFinishedFlagLink;
    mSelfThreadIndex = selfThreadIndex;
    mstrFilePath = strFilePath;

    mpCDataBlockLink = pCDataBlock;

    mpX = pCDataBlock->mpX;
    mpV = pCDataBlock->mpV;
    mpJ = pCDataBlock->mpJ;
    mpA = pCDataBlock->mpA;
    mpRadius = pCDataBlock->mpRadius;
    mpDRadius = pCDataBlock->mpDRadius;
    mpType   = pCDataBlock->mpType;
    mpID     = pCDataBlock->mpID;
    mpValue1 = pCDataBlock->mpValue1;
    mpDValue1 = pCDataBlock->mpDValue1;

    int snapInFile = mpCDataBlockLink->mpCParentSnap->mVpCSnapsInFile.size();
    for (int i = 0; i < snapInFile; i++){
	PDataBlock_cls *pCLinkedBlock = pCDataBlock->GetPCLinkedBlock(i);
	mVpXList.push_back(pCLinkedBlock->mpX);
	mVpVList.push_back(pCLinkedBlock->mpV);
	mVpAList.push_back(pCLinkedBlock->mpA);
	mVpJList.push_back(pCLinkedBlock->mpJ);
	mVpRadiusList.push_back(pCLinkedBlock->mpRadius);
	mVpDRadiusList.push_back(pCLinkedBlock->mpDRadius);
	mVpTypeList.push_back(pCLinkedBlock->mpType);
	mVpIDList.push_back(pCLinkedBlock->mpID);
	mVpValue1List.push_back(pCLinkedBlock->mpValue1);
	mVpDValue1List.push_back(pCLinkedBlock->mpDValue1);
    }
    
    mbUseID = bUseID;

    mPNum = pNum;
    mpCDataLoaderLink = pCDataLoder;
    mDataType = mpCDataLoaderLink->mCDataType.mBody;
    for (int i = 0; i < mpCDataLoaderLink->mCGrammerBody.mDimension; i++)
	mVGrammerBody.push_back(mpCDataLoaderLink->mCGrammerBody.mpBody[i]);
    mHeaderByte = mpCDataLoaderLink->GetHeaderByte();
    mHeaderLine = mpCDataLoaderLink->GetHeaderLine();

    LOOP_XYZ mTranslate[xyz] = 
	mpCDataLoaderLink->mCAdjustTranslate.mpBody[xyz];
    mScaling = 
	mpCDataLoaderLink->mCAdjustScale.mBody;
    mScalingValue1 = 
	mpCDataLoaderLink->mCAdjustValue1.mBody;
    mLogarithmValue1 = 
	mpCDataLoaderLink->mCLogarithmValue1.mBody;
    mbSortById = FALSE;
    if (mpCDataLoaderLink->mCVariablePNum.mBody == 2)
	mbSortById = TRUE;
    
    mbTranslate     = TRUE;
    mbScaling       = TRUE;
    mbScalingValue1 = TRUE;
    if (mTranslate[X] == 0 && mTranslate[Y] == 0 && mTranslate[Z] == 0)
	mbTranslate = FALSE;
    if (mScaling == 0)       mbScaling       = FALSE;
    if (mScalingValue1 == 0) mbScalingValue1 = FALSE;
    
    int defaultFormat[6] = {0, 1, 5, 6, 7, 8};
    std::vector < int > VDefaultFormat;
    VDefaultFormat.push_back(0);
    VDefaultFormat.push_back(1);
    VDefaultFormat.push_back(5);
    VDefaultFormat.push_back(6);
    VDefaultFormat.push_back(7);
    VDefaultFormat.push_back(8);
    if (mVGrammerBody == VDefaultFormat)
	mbUseDefaultFormat = TRUE;
    else
	mbUseDefaultFormat = FALSE;

    if ( Create() != wxTHREAD_NO_ERROR) 
	MsgBoxExit(NULL, "Error!", "Can't create thread");
}

void ThreadFileReader_cls::
DoAdjusting(){
    if (mbTranslate == TRUE){
	float (*pX)[3] = mpX;
	float translateX = mTranslate[X];
	float translateY = mTranslate[Y];
	float translateZ = mTranslate[Z];
	for (int i = 0; i < mPNum; i++){	
	    pX[i][X] += translateX;
	    pX[i][Y] += translateY;
	    pX[i][Z] += translateZ;
	}
    }

    if (mbScaling == TRUE){
	float (*pX)[3] = mpX;
	float (*pV)[3] = mpV;
	float (*pA)[3] = mpA;
	float (*pJ)[3] = mpJ;
	float *pRadius = mpRadius;
	float *pDRadius = mpDRadius;
	float scaling = mScaling;
	for (int i = 0; i < mPNum; i++){
	    pX[i][X] *= scaling;
	    pX[i][Y] *= scaling;
	    pX[i][Z] *= scaling;
	    pV[i][X] *= scaling;
	    pV[i][Y] *= scaling;
	    pV[i][Z] *= scaling;
	    pRadius[i] *= scaling;
	    pDRadius[i] *= scaling;
	}
	if (pA != NULL){
	    for (int i = 0; i < mPNum; i++){
		pA[i][X] *= scaling;
		pA[i][Y] *= scaling;
		pA[i][Z] *= scaling;
		pJ[i][X] *= scaling;
		pJ[i][Y] *= scaling;
		pJ[i][Z] *= scaling;
	    }
	}

    }

    if (mbScalingValue1 == TRUE){
	float scaling = mScalingValue1;
	float *pValue1 = mpValue1;
	float *pDValue1 = mpDValue1;
	for (int i = 0; i < mPNum; i++){
	    pValue1[i] *= scaling;
	    pDValue1[i] *= scaling;
	}
    }

    if (mLogarithmValue1 == TRUE){
	float *pValue1 = mpValue1;
	// pDValue1 ͌vZłȂ
	for (int i = 0; i < mPNum; i++){
	    if (pValue1[i] <= 0)
		pValue1[i] = 0;
	    else
		pValue1[i] = (float)log10(pValue1[i]);
	}
    }
}
    
void ThreadFileReader_cls::
DoAdjustingHDF5(GrammerHDF5_cls &CGrammerHDF5){
    for (int i = 0; i < mVpXList.size(); i++){
	mpX = mVpXList[i];
	mpV = mVpVList[i];
	mpA = mVpAList[i];
	mpJ = mVpJList[i];
	mpRadius = mVpRadiusList[i];
	mpValue1 = mVpValue1List[i];
	mPNum = CGrammerHDF5.mVPNum[i];
	DoAdjusting();
    }
}

void ThreadFileReader_cls::
MakeListSearchingID(bool *pbCheck, bool *pbCheckSrc, int *pPrevIndex, 
		    int snap, int src){
    int *pIDTgt = mVpIDList[snap], *pIDSrc = mVpIDList[src];

    // next  srcɂȂ
    mPNumNext = mPNum;
    mpIDNext = pIDSrc;

    // XVf[^ɐڑf[^`FbN
    for (int i = 0; i < mPNum; i++){
	if (pbCheck[i] == FALSE) continue;
	int ID = pIDTgt[i];
	int iNext = -1;
	if (i < mPNumNext && ID == mpIDNext[i]) iNext = i;
	else
	    iNext = SearchIDNearBy(i, ID, mSearchLimit);
	if (iNext != -1) pbCheckSrc[iNext] = TRUE;
    }

    int srcIndex = 0;
    for (int i = 0; i < mPNum; i++){
	if (pbCheck[i] == TRUE) continue;
	while (srcIndex < mPNumNext -1 &&
	       pbCheckSrc[srcIndex] == TRUE) srcIndex++;
	pPrevIndex[i] = srcIndex;
	srcIndex++;
    }
}

void ThreadFileReader_cls::
MakeListSearchingIDSorted(bool *pbCheck, bool *pbCheckSrc, int *pPrevIndex,
			  int snap, int src){
    int *pIDTgt = mVpIDList[snap], *pIDSrc = mVpIDList[src];

    // next  srcɂȂ
    mPNumNext = mPNum;
    mpIDNext = pIDSrc;

    // XVf[^ɐڑf[^`FbN
    int tgtIndex = 0;
    for (int i = 0; i < mPNum; i++){
	if (pbCheck[i] == FALSE) continue;
	int ID = pIDTgt[i];
	int iNext = SearchIDFrom(&tgtIndex, ID);
	if (iNext != -1) pbCheckSrc[iNext] = TRUE;
    }

    int srcIndex = 0;
    for (int i = 0; i < mPNum; i++){
	if (pbCheck[i] == TRUE) continue;
	while (srcIndex < mPNumNext -1 &&
	       pbCheckSrc[srcIndex] == TRUE) srcIndex++;
	pPrevIndex[i] = srcIndex;
	srcIndex++;
    }
    
    /*
    int tgtIndex = 0;
    for (int i = 0; i < mPNum; i++){
	int ID = pIDTgt[i];
	int iNext = -1;
	iNext = SearchIDFrom(&tgtIndex, ID);
	pPrevIndex[i] = iNext;
    }
    */
}

void ThreadFileReader_cls::
InterpolateTOKI(int snap, ReadHDF5Data_cls& CRead, GrammerHDF5_cls& CGrammerHDF5){
    if (snap == 0) return;

    mVariablePNum = mpCDataLoaderLink->mCLoadInfo.mVariablePNum;
    mSearchLimit = mpCDataLoaderLink->mCLoadInfo.mSearchLimit;

    // Find empty index();
    int  *pIndexList = CRead.mpIndexList;
    int  indexListSize = CRead.mIndexListSize;

    int src = snap-1;

    mPNumSrc = CGrammerHDF5.mVPNum[src];

    bool *pbCheckSrc = new bool [mPNumSrc];
    bool *pbCheck = new bool [mPNum];
    int  *pPrevIndex = new int [mPNum];

    printf("%d %d\n", mPNum, indexListSize);

    for (int i = 0; i < mPNum; i++)    pbCheck[i] = FALSE;
    for (int i = 0; i < mPNumSrc; i++) pbCheckSrc[i] = FALSE;
    
    for (int i = 0; i < indexListSize; i++)
	pbCheck[pIndexList[i]] = TRUE;

    if (mVariablePNum == _INTERPOLATE_PNUM_VARIABLE)
	MakeListSearchingID(pbCheck, pbCheckSrc, pPrevIndex, 
			    snap, src);
    else if (mVariablePNum == _INTERPOLATE_PNUM_ID_SORTED)
	MakeListSearchingIDSorted(pbCheck, pbCheckSrc, pPrevIndex, 
				  snap, src);
    else 
	for (int i = 0; i < mPNum; i++)
	    pPrevIndex[i] = i;
    
    double dt = CGrammerHDF5.mVTime[snap] - CGrammerHDF5.mVTime[src];

    float (*pXTgt)[3] = mVpXList[snap], (*pXSrc)[3] = mVpXList[src];
    float (*pVTgt)[3] = mVpVList[snap], (*pVSrc)[3] = mVpVList[src];
    float (*pATgt)[3] = mVpAList[snap], (*pASrc)[3] = mVpAList[src];
    float (*pJTgt)[3] = mVpJList[snap], (*pJSrc)[3] = mVpJList[src];
    
    float *pRadiusTgt = mVpRadiusList[snap],  *pRadiusSrc = mVpRadiusList[src];
    float *pDRadiusTgt = mVpRadiusList[snap], *pDRadiusSrc = mVpRadiusList[src];
    unsigned char *pTypeTgt = mVpTypeList[snap], *pTypeSrc = mVpTypeList[src];
    int *pIDTgt = mVpIDList[snap], *pIDSrc = mVpIDList[src];
    float *pValue1Tgt = mVpValue1List[snap],  *pValue1Src = mVpValue1List[src];
    float *pDValue1Tgt = mVpValue1List[snap], *pDValue1Src = mVpValue1List[src];

    for (int i = 0; i < mPNum; i++){
	if (pbCheck[i] == TRUE) continue;

	int iSrc = pPrevIndex[i];
	
	LOOP_XYZ pXTgt[i][xyz] = pXSrc[iSrc][xyz] +
	    dt * (pVSrc[iSrc][xyz] + dt * (pASrc[iSrc][xyz] + dt * pJSrc[iSrc][xyz]));
	LOOP_XYZ pVTgt[i][xyz] = pVSrc[iSrc][xyz] +
	    dt * (2 * pASrc[iSrc][xyz] + 3 * dt * pJSrc[iSrc][xyz]);
	LOOP_XYZ pATgt[i][xyz] = pASrc[iSrc][xyz] +
	    6 * pJSrc[iSrc][xyz] * dt;
	LOOP_XYZ pJTgt[i][xyz] = pJSrc[iSrc][xyz];
	
	pRadiusTgt [i] = pRadiusSrc[iSrc] + pDRadiusSrc[iSrc] * dt;
	pDRadiusTgt[i] = pDRadiusSrc[iSrc];
	pTypeTgt[i] = pTypeSrc[iSrc];
	pIDTgt[i]   = pIDSrc[iSrc];
	pValue1Tgt[i] = pValue1Src[iSrc] + pDValue1Src[iSrc] * dt;
	pDValue1Tgt[i] = pDValue1Src[iSrc];
    }

    delete [] pbCheckSrc;
    delete [] pbCheck;
    delete [] pPrevIndex;
}

void ThreadFileReader_cls::
ReadBinaryBodyDefaultFormat(std::fstream& ifstream, int progressInterval){
    
    if (mbUseID == TRUE)
	for (int i = 0; i < mPNum; i++){
	    if (i % progressInterval == 0)
		GAThreadReaderPercentage[mSelfThreadIndex]
		    = (long long)i * 100 / mPNum;
	    ifstream.read((char*)mpX[i], sizeof(float)*3);
	    ifstream.read((char*)mpV[i], sizeof(float)*3);
	    ifstream.read((char*)&mpRadius[i], sizeof(float));
	    ifstream.read((char*)&mpID[i], sizeof(int));

	    int type;
	    ifstream.read((char *)&type, sizeof(int));
	    if (type < 0) type = 0;
	    if (type >= _MAX_PARTICLE_TYPE) type = _MAX_PARTICLE_TYPE - 1;
	    mpType[i] = (unsigned char)type;

	    ifstream.read((char*)&mpValue1[i], sizeof(float));
	    
	}
    else
	for (int i = 0; i < mPNum; i++){	
	    if (i % progressInterval == 0)
		GAThreadReaderPercentage[mSelfThreadIndex]
		    = (long long)i * 100 / mPNum;
	    ifstream.read((char*)mpX[i], sizeof(float)*3);
	    ifstream.read((char*)mpV[i], sizeof(float)*3);
	    ifstream.read((char*)&mpRadius[i], sizeof(float));
	    int   ID;
	    ifstream.read((char*)&ID, sizeof(int));

	    int   type;
	    ifstream.read((char*)&type, sizeof(int));
	    if (type < 0) type = 0;
	    if (type >= _MAX_PARTICLE_TYPE) type = _MAX_PARTICLE_TYPE - 1;
	    mpType[i] = (unsigned char)type;
	    
	    ifstream.read((char*)&mpValue1[i], sizeof(float));
	}
    
    DoAdjusting();
}

void ThreadFileReader_cls::
ReadBinaryBody(){
    if (this == NULL) return; 

    std::fstream ifstream(wxFNCONV(mstrFilePath),
			  std::ios::in | std::ios::binary);

    if (ifstream.fail()){
	printf("Read Main Fails!!\n");
	exit(0);
    }

    int bufferSize = 60*1024*1024;//5*1024*1024;
    char *pBuffer = new char [bufferSize];
    ifstream.rdbuf()->pubsetbuf(pBuffer, bufferSize);

    size_t fileSize = (size_t)ifstream.seekg(0, std::ios::end).tellg();
    ifstream.seekg(mHeaderByte, std::ios::beg);
    
    int progressInterval = 100000;
    if (mPNum > 2000000) progressInterval = 200000;

    if (mbUseDefaultFormat == TRUE){
	ReadBinaryBodyDefaultFormat(ifstream, progressInterval);
	ifstream.close();
	delete [] pBuffer;
	return; 
    }

    int   dummyType = 0;
    float dummy[10];
    char *pAPointer[24];
    int   AItemSize[24];
    int   AItemOffset[24];
    int itemNumber = mVGrammerBody.size();
    
    // !! _FIX_ME !! {͕@`FbNĕKvȂɂ
    for (int i = 0; i < mPNum; i++){
	mpValue1[i] = 0;
	mpRadius[i] = 0;
    }

    for (int i = 0; i < itemNumber; i++){
	switch(mVGrammerBody[i]){
	case _GRAMMER_XYZ:
	    pAPointer[i] = (char*)mpX[0];
	    AItemSize[i] = 12;
	    AItemOffset[i] = 12;
	    break;
	case _GRAMMER_VXVYVZ:
	    pAPointer[i] = (char*)mpV[0];
	    AItemSize[i] = 12;
	    AItemOffset[i] = 12;
	    break;
	case _GRAMMER_RADIUS:
	    pAPointer[i] = (char*)mpRadius;
	    AItemSize[i] = 4;
	    AItemOffset[i] = 4;
	    break;
	case _GRAMMER_TYPE:
	    pAPointer[i] = (char*)&dummyType;
	    AItemSize[i] = 4;
	    AItemOffset[i] = 0;
	    break;
	case _GRAMMER_ID:
	    if (mbUseID == TRUE){
		pAPointer[i] = (char*)mpID;
		AItemSize[i] = 4;
		AItemOffset[i] = 4;
	    }
	    else{
		pAPointer[i] = (char*)dummy;
		AItemSize[i] = 4;
		AItemOffset[i] = 0;
	    }
	    break;
	case _GRAMMER_VALUE1:
	    pAPointer[i] = (char*)mpValue1;
	    AItemSize[i] = 4;
	    AItemOffset[i] = 4;
	    break;
	case _GRAMMER_DUMMY1:
	    pAPointer[i] = (char*)dummy;
	    AItemSize[i] = 4;
	    AItemOffset[i] = 0;
	    break;
	case _GRAMMER_DUMMY3:
	    pAPointer[i] = (char*)dummy;
	    AItemSize[i] = 12;
	    AItemOffset[i] = 0;
	    break;
	case _GRAMMER_DUMMY10:
	    pAPointer[i] = (char*)dummy;
	    AItemSize[i] = 40;
	    AItemOffset[i] = 0;
	    break;
	}
    }

    int eachItemSize = 0;
    for (int j = 0; j < itemNumber; j++)
	eachItemSize += AItemSize[j];
    
    int packSize = 1000000;
    if (mPNum > 20000000) packSize = mPNum / 20;
    if (mPNum > 50000000) packSize = mPNum / 50;
    if (mPNum < packSize) packSize = mPNum;

    char *pItemBuffer[2];
    pItemBuffer[0] = new char [eachItemSize * packSize];
    pItemBuffer[1] = new char [eachItemSize * packSize];
    char *pCurrent;

    bool bFinished[2] = {FALSE, FALSE};
    int currentMode = 0;

    for (int i_ = 0; i_ < mPNum; i_ += packSize){
	
	GAThreadReaderPercentage[mSelfThreadIndex]
	    = (long long)i_ * 100 / mPNum;
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshSB);
	GpCMainFrameCLS->AddPendingEvent(com);
	
	int currentSize = packSize;
	int nextSize    = packSize;
	if (i_ + currentSize > mPNum){
	    currentSize = mPNum - i_;
	    nextSize = -1;
	}
	else
	    if (i_ + currentSize + nextSize > mPNum)
		nextSize = mPNum - i_ - currentSize;
	
	if (i_ == 0){
	    bFinished[currentMode] = FALSE;
	    ThreadReadBuffer_cls *pCReadBuffer = 
		new ThreadReadBuffer_cls(wxTHREAD_DETACHED);
	    pCReadBuffer->SetParameters(&bFinished[currentMode], &ifstream, 
					pItemBuffer[currentMode],
					eachItemSize*currentSize);
	    pCReadBuffer->Run();
	    while (bFinished[currentMode] == FALSE){
		wxMilliSleep(2);
	    }
	}

	if (nextSize != -1){
	    bFinished[1-currentMode] = FALSE;
	    ThreadReadBuffer_cls *pCReadBuffer = 
		new ThreadReadBuffer_cls(wxTHREAD_DETACHED);
	    pCReadBuffer->SetParameters(&bFinished[1-currentMode], &ifstream, 
					pItemBuffer[1-currentMode],
					eachItemSize*nextSize);
	    pCReadBuffer->Run();
	}
	else
	    bFinished[1-currentMode] = TRUE;

	/*
	ifstream.read(pItemBuffer[0], eachItemSize * currentSize);
	*/
	
	pCurrent = pItemBuffer[currentMode];
	int iFin = i_ + currentSize;

	for (int i = i_; i < iFin; i++){
	    for (int j = 0; j < itemNumber; j++){
		memcpy(pAPointer[j] + (long long)AItemOffset[j]*i, pCurrent, AItemSize[j]);
		pCurrent += AItemSize[j];
	    }

	    mpType[i] = dummyType;
	}

	while (bFinished[1-currentMode] == FALSE){
	    wxMilliSleep(2);
	}
	
	currentMode = 1-currentMode;
    }

    unsigned char *pType = mpType;
    for (int i = 0; i < mPNum; i++){
	if (pType[i] < 0) mpType[i] = 0;
	if (pType[i] >= _MAX_PARTICLE_TYPE) pType[i] = _MAX_PARTICLE_TYPE - 1;
    }
    
    delete [] pItemBuffer[0];
    delete [] pItemBuffer[1];
    delete [] pBuffer;
    
    ifstream.close();
    DoAdjusting();
}


void ThreadFileReader_cls::
ReadAsciiBody(){
    std::fstream ifstream(wxFNCONV(mstrFilePath),
			  std::ios::in);
    
    // !! _FIX_ME !! {͕@`FbNĕKvȂɂ
    for (int i = 0; i < mPNum; i++){
	mpValue1[i] = 0;
	mpRadius[i] = 0;
    }

    // USɂ߂Ă݂B
    int len;
    ifstream.seekg (0, std::ios::end); 
    len = ifstream.tellg ();
    ifstream.seekg (0, std::ios::beg);
    std::string strBuf; strBuf.reserve(len); strBuf.resize(len);
    
    ifstream.read (&(strBuf[0]), len);

    int threadNumber = GThreadNumberReadAscii;
    if (threadNumber == 0) threadNumber = 1;
    bool *bAFinished = new bool [threadNumber];
    for (int core = 0; core < threadNumber; core++)
	bAFinished[core] = FALSE;

    ThreadAsciiReader_cls **ppACAsciiReader = 
	new ThreadAsciiReader_cls* [threadNumber];
    for (int core = 0; core < threadNumber; core++){
	ppACAsciiReader[core] = new ThreadAsciiReader_cls(wxTHREAD_DETACHED);
	ppACAsciiReader[core]->SetParameters
	    (mSelfThreadIndex, &bAFinished[core], &strBuf, mPNum, mHeaderLine, 
	     threadNumber, core, mVGrammerBody, mbUseDefaultFormat,
	     mpX, mpV, mpA, mpJ, mpRadius, mpType, mpID, mpValue1);
	ppACAsciiReader[core]->Run();
    }
    
    bool bFinishedAll = FALSE;
    while (bFinishedAll == FALSE){
	wxMilliSleep(3);
	bFinishedAll = TRUE;
	for (int core = 0; core < threadNumber; core++)
	    bFinishedAll &= bAFinished[core];
    }

    delete [] bAFinished;
    delete [] ppACAsciiReader;

    DoAdjusting();
}

void ThreadFileReader_cls::
ReadHDF5Body(){

    ReadHDF5Data_cls CRead;
    GrammerHDF5_cls CGrammerHDF5;
    CRead.ReadHDF5Data(mstrFilePath);
    if (CRead.CheckGrammer(CGrammerHDF5) == FALSE){
	return;
    }

    int snapInFile = (int)CGrammerHDF5.mVTime.size();
    for (int snap = 0; snap < snapInFile; snap++){

	// mPNum HDF5̏ꍇ͈ł͂Ȃ
	mPNum = CGrammerHDF5.mVPNum[snap];
	
	if (CGrammerHDF5.IsItemExistBody(_GRAMMER_VXVYVZ) == FALSE)
	    for (int i = 0; i < mPNum; i++)
		LOOP_XYZ mVpVList[snap][i][xyz] = 0;
	if (mpCDataBlockLink->mOrder == _DATABLOCK_ORDER_3){
	    if (CGrammerHDF5.IsItemExistBody(_GRAMMER_AXAYAZ) == FALSE)
		for (int i = 0; i < mPNum; i++)
		    LOOP_XYZ mVpAList[snap][i][xyz] = 0;
	    if (CGrammerHDF5.IsItemExistBody(_GRAMMER_JXJYJZ) == FALSE)
		for (int i = 0; i < mPNum; i++)
		    LOOP_XYZ mVpJList[snap][i][xyz] = 0;
	}
	
	if (CGrammerHDF5.IsItemExistBody(_GRAMMER_RADIUS) == FALSE)
	    for (int i = 0; i < mPNum; i++) mVpRadiusList[snap][i] = 0;
	if (CGrammerHDF5.IsItemExistBody(_GRAMMER_DRADIUS) == FALSE)
	    for (int i = 0; i < mPNum; i++) mVpDRadiusList[snap][i] = 0;
	if (CGrammerHDF5.IsItemExistBody(_GRAMMER_VALUE1) == FALSE)
	    for (int i = 0; i < mPNum; i++) mVpValue1List[snap][i] = 0;
	if (CGrammerHDF5.IsItemExistBody(_GRAMMER_DVALUE1) == FALSE)
	    for (int i = 0; i < mPNum; i++) mVpDValue1List[snap][i] = 0;
	if (CGrammerHDF5.IsItemExistBody(_GRAMMER_TYPE) == FALSE)
	    for (int i = 0; i < mPNum; i++) mVpTypeList[snap][i] = 0;
	if (CGrammerHDF5.IsItemExistBody(_GRAMMER_ID) == FALSE)
	    for (int i = 0; i < mPNum; i++) mVpIDList[snap][i] = i;
	
	CRead.MakeIndexList(CGrammerHDF5, snap);
	CRead.CheckIndexList(CRead.mIndexListSize);
	CRead.MakeSimpleIndexListIfNeeded(mPNum);
	CRead.CopyHDF5Data3Dim(mVpXList[snap], snap, wxT("xyz"));
	CRead.CopyHDF5Data3Dim(mVpVList[snap], snap, wxT("vxvyvz"));
	if (mpCDataBlockLink->mOrder == _DATABLOCK_ORDER_3){
	    CRead.CopyHDF5Data3Dim(mVpAList[snap], snap, wxT("axayaz"));
	    CRead.CopyHDF5Data3Dim(mVpJList[snap], snap, wxT("jxjyjz"));
	}
	CRead.CopyHDF5Data1DimFloat(mVpRadiusList[snap], snap, wxT("radius"));
	CRead.CopyHDF5Data1DimFloat(mVpDRadiusList[snap], snap, wxT("dradius"));
	CRead.CopyHDF5Data1DimFloat(mVpValue1List[snap], snap, wxT("value1"));
	CRead.CopyHDF5Data1DimFloat(mVpDValue1List[snap], snap, wxT("dvalue1"));
	CRead.CopyHDF5Data1DimInt(mVpIDList[snap], snap, wxT("ID"));
	CRead.CopyHDF5Data1DimUC(mVpTypeList[snap], snap, wxT("type"));
	
	// CfbNXނ瓮Ȃ
	//if (mbSortById == TRUE) this->SortByIdHDF5(snap);
	
	if (mDataType == _DATA_HDF5_TOKI) InterpolateTOKI(snap, CRead, CGrammerHDF5);
    }
    
    DoAdjustingHDF5(CGrammerHDF5);

    //!!_FIX_ME_!!//
    //G[bZ[WO[oϐɔ΂ׂB
    //mutexȎdg݂ȂƂȂB
    //CRead.ShowErrorMessage();
}

class ArrayAndIndexInt_cls{
public:
    int index;
    int ID;
    int operator < (ArrayAndIndexInt_cls rhs) const {
	return (ID < rhs.ID); }
    int operator > (ArrayAndIndexInt_cls rhs) const {
	return (ID > rhs.ID); }
};

void ThreadFileReader_cls::
SortById(){
    int PNum = mPNum;
    ArrayAndIndexInt_cls *pIndexAndID = new ArrayAndIndexInt_cls [PNum];

    int *pID = mpID;
    for (int i = 0; i < PNum; i++){
	pIndexAndID[i].index = i;
	pIndexAndID[i].ID = pID[i];
    }
    
    std::sort(pIndexAndID, pIndexAndID + PNum);

    float (*pXtmp)[3] = new float [PNum][3];
    float (*pXorg)[3] = mpX;
    memcpy(pXtmp, pXorg, (size_t)PNum * sizeof(float) * 3);
    for (int i = 0; i < PNum; i++){
	int indexOrg = pIndexAndID[i].index;
	memcpy(pXorg[i], pXtmp[indexOrg], sizeof(float) * 3);
    }
    delete [] pXtmp;

    int  *pIDtmp = new int [PNum];
    int  *pIDorg = mpID;
    memcpy(pIDtmp, pIDorg, PNum * sizeof(int));
    for (int i = 0; i < PNum; i++){
	int indexOrg = pIndexAndID[i].index;
	pIDorg[i] = pIDtmp[indexOrg];
    }
    delete [] pIDtmp;

    delete [] pIndexAndID;
}

void ThreadFileReader_cls::
SortByIdHDF5(int snap){
    mpX = mVpXList[snap];
    mpV = mVpVList[snap];
    mpA = mVpAList[snap];
    mpJ = mVpJList[snap];
    mpRadius = mVpRadiusList[snap];
    mpDRadius = mVpDRadiusList[snap];
    mpValue1 = mVpValue1List[snap];
    mpDValue1 = mVpDValue1List[snap];
    mpType = mVpTypeList[snap];
    mpID = mVpIDList[snap];
    SortById();
}

wxThread::ExitCode ThreadFileReader_cls::
Entry(){
    GAThreadReaderPercentage[mSelfThreadIndex] = 0;

    printf("Begin Reading %d --------\n", mpCDataBlockLink->mpCParentSnap->mSelfIndex);
    
    // \[ĝ́A\[gƖꂽƂɍsB
    switch(mDataType){
    case _DATA_SIMPLEBINARY:
	this->ReadBinaryBody();
	//if (mbSortById == TRUE) this->SortById();
	break;
    case _DATA_SIMPLEASCII:
	this->ReadAsciiBody();
	//if (mbSortById == TRUE) this->SortById();
	break;
    case _DATA_HDF5_SIMPLE:
    case _DATA_HDF5_TOKI:{
	this->ReadHDF5Body(); 
	break; }
    }

    printf("End Reading %d -------\n", mpCDataBlockLink->mpCParentSnap->mSelfIndex);

    mpCDataBlockLink->mpCParentSnap->MarkLoadingStateFinished();
    //*mpbFinishedFlagLink = TRUE;

    GAbThreadReaderFinished[mSelfThreadIndex] = TRUE;

    GAThreadReaderPercentage[mSelfThreadIndex] = 100;
    wxCommandEvent comA(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshSB);
    GpCMainFrameCLS->AddPendingEvent(comA);
    
    wxCommandEvent comB(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshTL);
    GpCMainFrameCLS->AddPendingEvent(comB);
    GApCThreadReader[mSelfThreadIndex] = NULL;
    GAThreadReaderIndex[mSelfThreadIndex] = -1;
    //Delete();
    
    return 0;
}

bool ThreadFileReader_cls::
IsReadThreadIdleAny(){
    int num = mspCPreferenceLink->mCIOThreadNumber.mBody;
    bool bIdle = FALSE;
    for (int i = 0; i < num; i++)
	if (GApCThreadReader[i] == NULL) bIdle = TRUE;
    return bIdle;
}

bool ThreadFileReader_cls::
IsReadThreadIdleAll(){
    int num = mspCPreferenceLink->mCIOThreadNumber.mBody;
    bool bIdle = TRUE;
    for (int i = 0; i < num; i++)
	if (GApCThreadReader[i] != NULL) bIdle = FALSE;
    return bIdle;
}

int  ThreadFileReader_cls::
GetIdleThreadIndex(){
    int num = mspCPreferenceLink->mCIOThreadNumber.mBody;
    for (int i = 0; i < num; i++)
	if (GApCThreadReader[i] == NULL) return i;
    return -1;
}

int  ThreadFileReader_cls::
GetThreadIndexReading(int snapIndex){
    int num = mspCPreferenceLink->mCIOThreadNumber.mBody;
    for (int i = 0; i < num; i++){
	if (GApCThreadReader[i] != NULL &&
	    GAThreadReaderIndex[i] == snapIndex) return i;
    }
    return -1;
}

Preference_cls *ThreadFileReader_cls::mspCPreferenceLink = NULL;
