// -*- c -*- 
// "clsGLDrawData.cpp"

#ifndef _GL_ZSORT_DATA_H_
#define _GL_ZSORT_DATA_H_

#include <wx/thread.h>

class ArrayAndIndex_cls;
class FilterDataBoxData_cls;
class Preference_cls;
//class SceneObj_cls;

class ThreadSortPrepare_cls : public wxThread {
public:
    ThreadSortPrepare_cls(wxThreadKind kind);

    void SetParameters(bool *pbFinishedFlag, 
		       ArrayAndIndex_cls *pCIndexAndZ, int PNum,
		       int step, float (*pX)[3], float cameraPos[3],
		       float cameraDir[3], int ini, int fin,
		       int downSizeIni, int type);

    bool *mpbFinishedFlagLink;
    ArrayAndIndex_cls *mpCIndexAndZ;
    int mPNum;
    int mStep;
    float (*mpX)[3];
    float *mCameraPos;
    float *mCameraDir;
    int mIni, mFin, mDownSizeIni;
    int mType;

    virtual ExitCode Entry();
};

class ThreadSortParallel_cls : public wxThread {
public:
    ThreadSortParallel_cls(wxThreadKind kind);

    void SetParameters(bool *pbFinishedFlag,
		       ArrayAndIndex_cls *pCIndexAndZ, int ini, int fin);
    
    bool *mpbFinishedFlagLink;
    ArrayAndIndex_cls *mpCIndexAndZ;
    int mIni, mFin;

    virtual ExitCode Entry();
};

class ThreadSortMergeOrd_cls : public wxThread {
public:
    ThreadSortMergeOrd_cls(wxThreadKind kind);

    void SetParameters(bool *pbFinishedFlag,
		       ArrayAndIndex_cls *pCSrc, 
		       ArrayAndIndex_cls *pCTgt,
		       int cacheIni0, int cacheFin0,
		       int cacheIni1, int cacheFin1,
		       int block);

    bool *mpbFinishedFlagLink;
    ArrayAndIndex_cls *mpCSrc;
    ArrayAndIndex_cls *mpCTgt;

    int mCacheIni0, mCacheFin0;
    int mCacheIni1, mCacheFin1;
    int mBlock;

    virtual ExitCode Entry();
};

class ThreadSortMergeInv_cls : public wxThread {
public:
    ThreadSortMergeInv_cls(wxThreadKind kind);

    void SetParameters(bool *pbFinishedFlag,
		       ArrayAndIndex_cls *pCSrc, 
		       ArrayAndIndex_cls *pCTgt,
		       int cacheIni0, int cacheFin0,
		       int cacheIni1, int cacheFin1,
		       int block);

    bool *mpbFinishedFlagLink;
    ArrayAndIndex_cls *mpCSrc;
    ArrayAndIndex_cls *mpCTgt;

    int mCacheIni0, mCacheFin0;
    int mCacheIni1, mCacheFin1;
    int mBlock;
    
    virtual ExitCode Entry();
};

// -----

class ZSort_cls{
public:
    static Preference_cls *mspCPreferenceLink;
    static FilterDataBoxData_cls *mspCSceneLink;
    static double         msDoubleIndex;

    int ZSortPrepare(ArrayAndIndex_cls *pCIndexAndZ, int PNum, 
		     int step, float (*pX)[3], float cameraPos[3],
		     float cameraDir[3], int type);

    void ZSortParallel(ArrayAndIndex_cls *pCIndexAndZ,
		       int size);

    static void SetSceneCoordinateInfo(FilterDataBoxData_cls *pCScene, double doubleIndex);

};



#endif
