// "clsPovObjectGrid.h"
// (setq c-basic-offset 4)

#include "clsPovObjectGrid.h"

#include "../clsPovRay.h"

#include "../../COMMON/CommonDefinitions.h"

#define ENDL wxT("\n")
#define CLOSE_ENDL wxT("}\n")

void PovObjectGrid_cls::
GetStrPovTexture(wxString &strObject, float ambient[4]){
    float clr[3][4] = {{ambient[0], ambient[1], ambient[2], ambient[3]},
		       {0, 0, 0, 0}, {0, 0, 0, 0}};
    strObject << PovRayCtrl_cls::GetStrPovTextureGLColor(mstrTab, clr, 0.156*0.156, wxT(""), FALSE);
    strObject << mstrTab << wxT("no_shadow") << ENDL;
}

void PovObjectGrid_cls::
GetStrPovBasicGridZ(wxString &strObject, double min, double max,
		    int linenum, double offset, double lineWidth){
    
    double width = max - min;
    if (width == 0) width = 1;
    if (linenum < 1) linenum = 1;
    double d = width / linenum;
    
    for (double y = min; y <= max + 1e-6; y+= d){
	float pos0[3] = {min, y-lineWidth, offset-lineWidth};
	float pos1[3] = {max, y+lineWidth, offset+lineWidth};
    	strObject << mstrTab << PovOut3fS(wxT("box{"), pos0, 6) << wxT(",") << PovOut3fS(pos1, 6) << CLOSE_ENDL;
    }
    for (double x = min; x <= max + 1e-6; x+= d){
	float pos0[3] = {x-lineWidth, min, offset-lineWidth};
	float pos1[3] = {x+lineWidth, max, offset+lineWidth};
	strObject << mstrTab << PovOut3fS(wxT("box{"), pos0, 6) << wxT(",") << PovOut3fS(pos1, 6) << CLOSE_ENDL;
    }
    
    //GetStrPovTexture(strObject);
    //strObject << wxT("\t") << CLOSE_ENDL;
}
   
void PovObjectGrid_cls::
GetStrPovBasicGridY(wxString &strObject, double min, double max,
		    int linenum, double offset, double lineWidth){
    
    double width = max - min;
    if (width == 0) width = 1;
    if (linenum < 1) linenum = 1;
    double d = width / linenum;
    
    //strObject << wxT("union {") << ENDL;
    for (double x = min; x <= max + 1e-6; x+= d){
	float pos0[3] = {x-lineWidth, offset-lineWidth, min};
	float pos1[3] = {x+lineWidth, offset+lineWidth, max};
    	strObject << mstrTab << PovOut3fS(wxT("box{"), pos0, 6) << wxT(",") << PovOut3fS(pos1, 6) << CLOSE_ENDL;
    }
    for (double z = min; z <= max + 1e-6; z+= d){
	float pos0[3] = {min, offset-lineWidth, z-lineWidth};
	float pos1[3] = {max, offset+lineWidth, z+lineWidth};
	strObject << mstrTab << PovOut3fS(wxT("box{"), pos0, 6) << wxT(",") << PovOut3fS(pos1, 6) << CLOSE_ENDL;
    }
    
    //GetStrPovTexture(strObject);
    //strObject << CLOSE_ENDL;
}

void PovObjectGrid_cls::
GetStrPovBasicGridX(wxString &strObject, double min, double max,
		    int linenum, double offset, double lineWidth){
    
    double width = max - min;
    if (width == 0) width = 1;
    if (linenum < 1) linenum = 1;
    double d = width / linenum;
    
    //strObject << wxT("union {") << ENDL;
    for (double y = min; y <= max + 1e-6; y+= d){
	float pos0[3] = {offset-lineWidth, y-lineWidth, min};
	float pos1[3] = {offset+lineWidth, y+lineWidth, max};
    	strObject << mstrTab << PovOut3fS(wxT("box{"), pos0, 6) << wxT(",") << PovOut3fS(pos1, 6) << CLOSE_ENDL;
    }
    for (double z = min; z <= max + 1e-6; z+= d){
	float pos0[3] = {offset-lineWidth, min, z-lineWidth};
	float pos1[3] = {offset+lineWidth, max, z+lineWidth};
	strObject << mstrTab << PovOut3fS(wxT("box{"), pos0, 6) << wxT(",") << PovOut3fS(pos1, 6) << CLOSE_ENDL;
    }
    
    //GetStrPovTexture(strObject);
    //strObject << CLOSE_ENDL;
}

void PovObjectGrid_cls::
GetStrPovBasicGridCubic(wxString &strObject, double min, double max,
			int linenum, double lineWidth, PositionAndDirection_cls CCamPos){

    if (CCamPos.mTgt[Z] <= 0)
	GetStrPovBasicGridZ(strObject, min, max, linenum, min, lineWidth);
    else
	GetStrPovBasicGridZ(strObject, min, max, linenum, max, lineWidth);
    
    if (CCamPos.mTgt[X] <= 0)
	GetStrPovBasicGridX(strObject, min, max, linenum, min, lineWidth);
    else
	GetStrPovBasicGridX(strObject, min, max, linenum, max, lineWidth);

    if (CCamPos.mTgt[Y] <= 0)
	GetStrPovBasicGridY(strObject, min, max, linenum, min, lineWidth);
    else
	GetStrPovBasicGridY(strObject, min, max, linenum, max, lineWidth);
}

void PovObjectGrid_cls::
GetStrPovGridCircular(wxString &strObject, double min, double max, int linenum,
		      double lineWidth, PositionAndDirection_cls CCamPos){
    
    double width = max - min;
    if (width == 0) width = 1;
    if (linenum < 1) linenum = 1;
    double d = width / linenum;

    //strObject << wxT("union {") << ENDL;
    for (double r = min; r <= max + 1e-6; r+= d){
	if (r < 0) continue;
	strObject << wxT("\ttorus{") << r << wxT(",") << lineWidth << CLOSE_ENDL;
    }

    strObject << wxT("\trotate <90, 0, 0>") << ENDL;
    //GetStrPovTexture(strObject);
    //strObject << CLOSE_ENDL;
}
