// "clsPovObjectMesh.cpp"
// (c-basic-offset 4)

#ifndef _POV_MESH_H_
#define _POV_MESH_H_

#include "../../COMMON/clsAsciiReader.h"

#include <wx/wx.h>
#include <vector>

#include <wx/thread.h>

class PovRayCtrl_cls;

class ThreadReadMesh2Sub : public wxThread, public AsciiReader_cls {
 public:
    ThreadReadMesh2Sub(char *pBuffer, int fileSize, int posStart,
		       int itemNum, int skipLine, 
		       std::vector < float > *pVNormals,
		       bool *pbFinishedFlagLink);

    virtual ExitCode Entry();

    bool *mpbFinishedFlagLink;
    char *mpBuffer;
    int mFileSize;
    int mPosStart, mItemNum, mSkipLine;

    //float ReadFloat(char **ptr, char pDelim);
    std::vector < float > *mpVData;
};



// -----

class PovObjectMesh_cls : public AsciiReader_cls {
 public:

    static PovRayCtrl_cls *mspCPovRayLink;
    
    // -- Mesh
    std::vector < unsigned int > mVIndex;
    std::vector < unsigned int > mVIndexNormal;
    std::vector < float > mVVertices;
    //std::vector < float > mVUV1D;
    std::vector < float > mVNormals;
    wxString mstrLoaded;
    wxString mstrPovLabel;
    long     mFileSize;

    void ClearMesh();

    char* GetMemoryBufferFromFile(wxString strFile);
    void ReadMesh2File(wxString strFile);
    void ConstructNormalVectors();
    void ReadObjFile(wxString strFile);
    void ReadMeshFromFile(wxString strFile);

    void GLDraw();

    wxString GetStrPovInclude();

    static void GetMesh2FormatRef
	(wxString &strMesh2, wxString strTag, bool bNormal, 
	 std::vector < float > *pVVertices,
	 std::vector < float > *pVNormals,
	 std::vector < unsigned int > *pVIndices);
    
};

#endif
