// -*- c -*- 
// (setq c-basic-offset 4)
// "clsPovPhotons.h"

#include "clsPovPhotons.h"

#include "../clsPovRay.h"
#include "../clsPovRayGUI.h"
#include "../../../wxWidgetEnum.h"
#include "../../WIDGETCTRL/clsAtoSTextCtrl.h"
#include "../../WIDGETCTRL/clsDialogEXKey.h"
#include "../../WIDGETCTRL/clsHookCtrl.h"
#include "../../WIDGETCTRL/clsMultiInputPanel.h"


#define ENDLWX wxT("\n")

PovPhotons_cls::
PovPhotons_cls(){
    mspCThis = this;
    SetToDefault();
}

void PovPhotons_cls::
SetToDefault(){
    mCConfList.Clear();
    mCConfList.Add(&mCType, wxT("PovPhotonsType="), L"0");
    mCConfList.Add(&mCCount, wxT("PovPhotonsCount="), L"20");
    mCConfList.Add(&mCMaxTrace, wxT("PovPhotonsMaxTrace="), L"5");
}

void PovPhotons_cls::
SetMNumPhotons(wxWindow* pCParentPanel, wxString *psWorkingDir){
    MultiInputPanel_cls* pCurr = 
	MultiInputPanel_cls::Initialize(&mpCMNum, pCParentPanel);

    pCurr->mTextWidth  = -1;
    pCurr->mItemWidth = 180;

    wxString photonsType[2] = {_("No Photons"), _("Use Photons") };
    mIndexType = pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mCType.mBody, 2, photonsType, _("Photon Mapping"));
    
    pCurr->mTextWidth = 120;
    pCurr->mItemWidth = -1;
    int boxWidth = 2;
    mIndexCount = pCurr->SetInputAndSlider
	(_ITEM_INTEGER, &mCCount.mBody, _("photon (x1000)"));
    pCurr->SetRange(_ITEM_LASTITEMx2, 2, 2500);

    mIndexMaxTrace = pCurr->SetInputAndSlider
	(_ITEM_INTEGER, &mCMaxTrace.mBody, wxT("max_trace_level"));
    pCurr->SetRange(_ITEM_LASTITEMx2, 2, 10);
    
#ifdef WIN32
    pCurr->mMinimumWidth = 320;
#else
    pCurr->mMinimumWidth = 340;
#endif
    pCurr->FinishSetting();

    pCurr->mpCHookCtrl->SetFuncHook
	(PovPhotons_cls::HookHideAndShow, _HOOK_COMBOBOX);

    HideAndShow();
}

void PovPhotons_cls::
HideAndShow(){
    HideAndShowBegin();
    MultiInputPanel_cls *pCurr = mpCMNum;
    bool bShow = (mCType.mBody > _POV_PHOTONS_NOUSE);
    pCurr->ShowItem(mIndexCount, bShow);
    pCurr->ShowItem(mIndexMaxTrace, bShow);
    HideAndShowEnd();
}

void PovPhotons_cls::
HookHideAndShow(void *pUsrDef, void *pEvent){
    MultiInputPanel_cls* pCPanel = (MultiInputPanel_cls*)pUsrDef;
    mspCThis->HideAndShow();
    RecalcSize(pCPanel);
}

wxString PovPhotons_cls::
GetStrPovGlobal(){
    if (mCType.mBody == _POV_PHOTONS_NOUSE) return wxT("");
    wxString strPov;

    strPov << wxT("\tphotons {") << ENDLWX;
    strPov << wxT("\t\tcount ") << mCCount.mBody * 1000;
    strPov << wxT("\t\tautostop ") << 0;
    strPov << wxT("\t\tjitter ") << .4;
    strPov << wxT("\t\tmax_trace_level ") << mCMaxTrace.mBody;

    strPov << wxT("\t}") << ENDLWX;

    return strPov;
}

wxString PovPhotons_cls::
GetStrPovIni(){
    wxString strIni;
    return strIni;
}

wxString PovPhotons_cls::
GetStrPovPhotonSetting(double alpha, double reflectMin, double reflectMax,
		       bool bKillTarget){
    wxString strPhoton;
    if (mCType.mBody == _POV_PHOTONS_NOUSE) return strPhoton;
    wxString strTarget = wxT("target ");
    wxString strReflection = wxT("reflection ");
    wxString strRefraction = wxT("refraction ");
    wxString strCollect = wxT("collect ");

    if (alpha > 0.8) strRefraction << wxT("off ");
    else             strRefraction << wxT("on ");

    if (reflectMin < 0.1 && reflectMax < 0.2) strReflection << wxT("off ");
    else                                      strReflection << wxT("on ");
    
    if (bKillTarget) strTarget << wxT("off ");
    else {
	if (strRefraction == wxT("refraction off ") && 
	    strReflection == wxT("reflection off "))
	    strTarget << wxT("off ");
	else
	    strTarget << wxT("on ");
    }
    if (alpha < 0.1) strCollect << wxT("off ");
    else             strCollect << wxT("on ");

    strPhoton << wxT("\tphotons{ ") << strTarget << strReflection << strRefraction << strCollect << wxT("}") << ENDLWX;

    /*
    if (alpha > 0.8) // 0.8 ȏł͕sȂ̂targetɂȂ
	strPhoton << wxT("\tphotons{ reflection on refraction}") << ENDLWX;
    else if (alpha < 0.1) // 0.1 ȉłcollectȂ
	strPhoton << wxT("\tphotons{ target reflection on refraction on collect off}") << ENDLWX;
    else
	strPhoton << wxT("\tphotons{ target reflection on refraction on collect on}") << ENDLWX;
    */

    return strPhoton;
}

PovPhotons_cls *PovPhotons_cls::mspCThis = NULL;
