// -*- c -*- 
// (setq c-basic-offset 4)
// "clsPovFormat.h"

#include "clsPovRender.h"

#include "../clsPovRay.h"
#include "../clsPovRayGUI.h"
#include "../../COMMON/clsFilename.h"
#include "../../TIMELINE/clsTimeCtrl.h"
#include "../../WIDGETCTRL/clsDialogEXKey.h"
#include "../../WIDGETCTRL/clsMultiInputPanel.h"
#include "../../WIDGETCTRL/clsHookCtrl.h"

#include "../../../wxWidgetEnum.h"
#include "../../COMMON/CommonDefinitions.h"

PovRender_cls::
PovRender_cls(PovRayCtrl_cls *pCCtrlLink){
    mspCThis = this;
    mpCCtrlLink = pCCtrlLink;

    SetToDefault();
}

void PovRender_cls::
SetToDefault(){
    mCConfList.Clear();
    mCConfList.Add(&mCRegionType,   wxT("PovRenderRegion="), L"0");
    mCConfList.Add(&mCRegionCustomMin, wxT("PovRegionCustomMin="), L"0");
    mCConfList.Add(&mCRegionCustomMax, wxT("PovRegionCustomMax="), L"100");
    mCConfList.Add(&mCAnimInit, wxT("PovRenderAnimNinit="), L"0");
}

void PovRender_cls::
SetMNumFormat(wxWindow* pCParentPanel){
    MultiInputPanel_cls* pCurr = 
	MultiInputPanel_cls::Initialize(&mpCMNum, pCParentPanel);
    

    pCurr->mTextWidth  = 108;
    pCurr->mComboWidth = -1;
    pCurr->mItemWidth = -1;

    wxString listRegion[3] = {_("Render Working Area"), _("Render All Scene"), _("Custum")};

    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mCRegionType.mBody, 
	 3, listRegion, _("Region to render"));

    int boxWidth = 3;
    mIndexCustomArea = pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Custom Region"));
    wxString strText = wxT(" - ");
    pCurr->CombinePointer(_ITEM_INTEGER, &mCRegionCustomMin.mBody);
    pCurr->mItemWidth = 30;
    pCurr->CombinePointer(_ITEM_STATIC_TEXT, &strText);
    pCurr->mItemWidth = -1;
    pCurr->CombinePointer(_ITEM_INTEGER, &mCRegionCustomMax.mBody);
    
    boxWidth = 2;
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Initial sequence"));
    pCurr->CombinePointer(_ITEM_INTEGER_SPIN, &mCAnimInit.mBody);
    pCurr->CombinePointerButton(btnPovRenderInitSeq, _("Calc. Auto"));
    
  
    pCurr->FinishSetting();

    //pCurr->mVCItemList[mIndexStereo].GetPCwxWindow()->Disable();

    pCurr->mpCHookCtrl->SetFuncHook
	(&PovRender_cls::HookHideAndShow, _HOOK_COMBOBOX);
    pCurr->mpCHookCtrl->SetFuncHook
	(&PovRender_cls::HookAutoCalc, _HOOK_BUTTON);

    HideAndShow();
}

void PovRender_cls::
HideAndShow(){
    HideAndShowBegin();
    MultiInputPanel_cls* pCurr = mpCMNum;

    if (mCRegionType.mBody == _RENDER_REGION_CUSTOM)
	pCurr->ShowItem(mIndexCustomArea);
    else
	pCurr->HideItem(mIndexCustomArea);
    
    //pCurr->UpdateValues();
    HideAndShowEnd();
}

void PovRender_cls::
HookHideAndShow(void *pUsrDef, void *pEvent){
    MultiInputPanel_cls* pCPanel = (MultiInputPanel_cls*)pUsrDef;
    mspCThis->HideAndShow();
    RecalcSize(pCPanel);
}

void PovRender_cls::
HookAutoCalc(void *pUsrDef, void *pEvent){
    mspCThis->AutoCalc();
}

void PovRender_cls::
AutoCalc(){
    if (mCRegionType.mBody == 0)
	mCAnimInit.mBody = -mpCCtrlLink->
	    GetPCTimeCtrl()->GetOffsetForImgSeq(0, 0);
    if (mCRegionType.mBody == 1) mCAnimInit.mBody = 0;
    if (mCRegionType.mBody == 2)
	mCAnimInit.mBody = mCRegionCustomMin.mBody /
	    mpCCtrlLink->GetPCTimeCtrl()->mCAnimStep.mBody *
	    mpCCtrlLink->GetPCTimeCtrl()->mCAnimInterp.mBody;
    
    mpCMNum->UpdateValues();
}

PovRender_cls* PovRender_cls::mspCThis = NULL;
