
#ifndef _POV_SERIALIZE_H_
#define _POV_SERIALIZE_H_

#include <string>
#include <wx/wx.h>

class PovSerialize_cls {
 public:

    static wxString PovOutf(float value, int digit = 8);
    
    static wxString PovOut3d(wxString str, double vec[3], int digit = 12);
    static wxString PovOut3dS(wxString str, double vec[3], int digit = 12);
    static wxString PovOut3f(wxString str, float vec[3], int digit = 8);
    static wxString PovOut3fS(wxString str, float vec[3], int digit = 8);
    static wxString PovOut3ui(wxString str, unsigned int vec[3]);

    static wxString PovOut3f(float vec[3], int digit = 8);
    static wxString PovOut3fS(float vec[3], int digit = 8);

    static wxString PovOut4f(wxString str, float vec[4], int digit = 8);
    
    static wxString PovOut3(wxString str,
			    float a, float b, float c);
    static wxString PovOut4(wxString str,
			    float a, float b, float c, float d);
    static wxString PovOutRotation(wxString strTab, double pRot[4]);
    static wxString PovOut4fRGBTfromRGBA(float vec[4], int digit = 8, bool bAddRGBT = TRUE);

    static void PushBackPovOut3f(wxString *pstrTgt, 
				 wxString str, float vec[3], int digit = 8);

    static wxString mAstrAxis[3];
    static wxString mAstrAxisUC[3];

    static wxString GetCutoffString(float value, int digit = 4);
    static wxString GetShortString(float value);
    static wxString GetShortString(wxString str);

    static wxString GetTab(int depth);
};

#endif
