// "clsCameraPathGUI.cpp"

#ifndef _CAMERA_PATH_GUI_H
#define _CAMERA_PATH_GUI_H

#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"
#include "../WIDGETCTRL/clsMinimizeButton.h"

#include <wx/notebook.h>

class AnchorPath_cls;
class CameraPath_cls;
class CameraPathCtrl_cls;
class FrameMain_cls;
class MainGLCanvas_cls;
class StereoGram_cls;

class CameraPathGUI_cls : public wxDialogEXKey, public MinimizeButton_cls {
 public:
    CameraPathGUI_cls(CameraPathCtrl_cls* pCCtrl, 
		      wxWindow *pC, wxPoint pos, wxSize size);

    static CameraPathGUI_cls *mspCThis;
    CameraPathCtrl_cls *mpCCtrl;

    wxButtonEX *mpCBTNAdv, *mpCBTNPath;
    wxNotebook *mpCBook1;

    MultiInputPanel_cls* mpCMNumView[5];
    MultiInputPanel_cls* mpCMNumAdv;
    MultiInputPanel_cls* mpCMNumPath;

    int mIndexAnglePath;
    int mIndexFishEyeOffset;
    int mIndexGrid;
    int mIndexBG0, mIndexBG1;
    int mIndexFBOSize;
    int mIndexTagFont;
    int mIndexDistortion;

    MainGLCanvas_cls* GetPCActiveGLCanvas();
    bool HideAndShowView(int i);
    void HideAndShowAll();

    void SetMNumView(int i, wxWindow *pCWindow);
    void SetMNumAdv (wxBoxSizer *pBoxSizer);
    void SetMNumPath(wxBoxSizer *pBoxSizer);
    void ReconnectView();
    void ReconnectViewAdv();

    void OnNotebookChanged(wxNotebookEvent &event);
    void OnButtonViewDefault(wxCommandEvent &event);

    static void FuncHookShow(void *pPanel, void *pArg);
    static void FuncHookAssign(void *pPanel, void *pArg);
    static void FuncHookHideButton(void *pPanel, void *pArg);
    static void HookHideAndShowView(void *pPanel, void *pArg);
    static void HookSyncGLCanvasCtrl(void *pPanel, void *pArg);

    void UpdateValuesAll();

private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class CameraPathCtrl_cls : public DialogControl_cls {
 public:
    CameraPathCtrl_cls(FrameMain_cls *pCParentFrame, 
		       StereoGram_cls *pCStereoGram,
		       CameraPath_cls *pCCameraPath,
		       AnchorPath_cls *pCAnchorPath, 
		       wxString strBitmap);

    FrameMain_cls *mpCParentFrame;
    //wxBitmap *mpBitmapLink;
    wxString mstrBitmap;

    CameraPathGUI_cls *mpCGUI;

    //CameraPath_cls* GetActivePath();
    AnchorPath_cls *mpCAnchorPathLinked;
    CameraPath_cls *mpCCameraPathLinked;
    
    int mActiveView;

    void InitGUI(wxWindow *pC);
    void UpdateItems(bool bForce = FALSE);
};

#endif
