// -*- c -*-
// "clsSceneObj.cpp"

#ifndef _SCENE_OBJ_H
#define _SCENE_OBJ_H

#include "../POVRAY/clsPovSerialize.h"

#include "../MYGL/clsPositionAndDirection.h"
#include "../PARAMETER/clsParamGroup.h"

#include "../COMMON/CommonDefinitionsGL.h"

#include <vector>

#define _SCENEOBJ_CAMERA 0
#define _SCENEOBJ_LIGHT  1

#define _SCENEOBJ_IDBASE_CAMERA 0
#define _SCENEOBJ_IDBASE_LIGHT  10

#define _SCENEOBJ_TARGET_NONE   0
#define _SCENEOBJ_TARGET_ORIGIN 1
#define _SCENEOBJ_TARGET_ANCHOR 2

class GLGuides_cls;

class SceneObj_cls : public PovSerialize_cls{
 public:
    SceneObj_cls(wxString strObjName, bool bDefaultParam = TRUE, bool bAllParam = TRUE);
    ~SceneObj_cls();

    void SetInitValueTrans(double x, double y, double z);
    void SetInitValueRot(double x, double y, double z);
    void SetInitValueScale(double x, double y, double z);
    void CopyFromP_SceneObj(SceneObj_cls *pCFrom);

    bool mbSelected, mbDragging;
    int  mObjType, mObjIndex;

    ParamGroup_cls *mpCTranslate;
    ParamGroup_cls *mpCRotation;
    ParamGroup_cls *mpCScale;

    ParamGroup_cls *mpCSceneObjParam;
    
    ParamGroup_cls* GetPCParamGroupFromTag(wxString strTag);

    std::vector < double > GetVDirectionVector(double doubleIndex);
    void CalcRelativeVector(float vector[3], double doubleIndex);
    void CalcRelativePosition(float vector[3], double doubleIndex,
			      ParamGroup_cls *pCAnchor = NULL);
    
    static GLGuides_cls* mspCGLGuideLink;
    static GLGuides_cls* mspCGLGuideYPRLink;
    static GLGuides_cls* mspCGLGuideScaleLink;

    virtual void AssignSceneObjParam();

    ConfItemList_cls  mCConfList;
    ConfItemUINT_cls  mCTarget;
    ConfItemBOOL_cls  mCbVisible;

    void Select(bool bSelect);
    virtual void UpdateCurrentObj(double dobuleIndex);
    PositionAndDirection_cls mCCurrentObj;
    PositionAndDirection_cls mCCurrentObjLookingAtCamera;

    void Targetting();

    void GLSetMatrix();
    void GLDrawPath();
   
    void GetStrPovModelView(wxString &strModelView, double doubleIndex,
			    std::vector < double > VAnchor = std::vector < double >());
    void GetStrPovModelViewMatrix(wxString& strModelView);

    //wxString Serialize();
};

#endif
