// "clsTexPropertyGUI.cpp"

#ifndef _TEX_PROPERTY_GUI_H
#define _TEX_PROPERTY_GUI_H

#include "clsSceneObjTexture.h"

#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"

#include <wx/notebook.h>

class FrameMain_cls;

class TexPropertyGUI_cls : public wxDialogEXKey{
public:
    TexPropertyGUI_cls(wxWindow *pC, wxBitmap bitmap);
    ~TexPropertyGUI_cls();

    static TexPropertyGUI_cls *mspCThis;

    SceneObjTexture_cls* mpCTextureLinked;
    MultiInputPanel_cls* mpCMInputTexture;

    wxNotebook *mpCBook1;

    MultiInputPanel_cls* mpCMInputMirror;
    MultiInputPanel_cls* mpCMInputBump;
    MultiInputPanel_cls* mpCMInputInterior;

    wxString mstrTitle;

    unsigned int mDummyShader;
    int          mDummyShininess;
    unsigned int mDummyTransmitType;
    float        mDummyAlpha;

    int   mDummyReflectionType;
    float mDummyReflectionMin, mDummyReflectionMax;

    float mDummyFadeDistance;
    float mDummyIOR;

    unsigned int mDummyNormalPattern[_TEX_NORMAL_MAX];
    float mDummyNormalDegree[_TEX_NORMAL_MAX];
    float mDummyNormalScale[_TEX_NORMAL_MAX];

    int  mIndexShader;
    int  mIndexShininess;
    int  mIndexTransmit, mIndexAlpha;
    
    int  mIndexReflexType;
    int  mIndexReflexMin, mIndexReflexMax;
    int  mIndexNormalPattern[_TEX_NORMAL_MAX];
    int  mIndexNormalDegree[_TEX_NORMAL_MAX];
    int  mIndexNormalScale[_TEX_NORMAL_MAX]; 
    
    int  mIndexFadeDistance;
    int  mIndexIOR;

    void SetMNumParam();
    void SetMNumMirror(wxWindow *pCParent);
    void SetMNumBump(wxWindow *pCParent);
    void SetMNumInterior(wxWindow *pCParent);

    void RecalcSize();

    void ReconnectBase(SceneObjTexture_cls *pCTexture);
    void ReconnectTexture(SceneObjTexture_cls *pCTexture, 
			  wxString strCustomName = wxT(""));
    void ReconnectMirror(SceneObjTexture_cls *pCTexture);
    void ReconnectBump(SceneObjTexture_cls *pCTexture);
    void ReconnectInterior(SceneObjTexture_cls *pCTexture);

    void HideAndShowTexture();
    void HideAndShowMirror();
    void HideAndShowBump();
    void HideAndShowInterior();
    static void HookHideAndShow(void *pUsrdef, void *pEvent);
};

class TexPropertyCtrl_cls : public DialogControl_cls{
 public:
    TexPropertyCtrl_cls(FrameMain_cls* pCParentFrame, wxString strBitmap);
    ~TexPropertyCtrl_cls();
    
    FrameMain_cls *mpCParentFrameLink;
    wxString mstrBitmap;
    //wxBitmap *mpBitmapLink;

    TexPropertyGUI_cls *mpCGUI;

    void InitGUI(wxWindow *pC);
    void UpdateItems(bool bForce = FALSE);
    void ReconnectTexture(SceneObjTexture_cls *pCTexture, wxString strCustomName);
};

#endif
