// -*- c++ -*-
// "clsTimeCtrl.h"

#ifndef _TIME_CTRL_H
#define _TIME_CTRL_H

#include "../CONFITEM/clsConfItem.h"
#include "../UNDO/clsUndoManager.h"
//#include "SRC/PARAMETER/clsParameters.h"
//#include "SRC/WIDGETCTRL/clsMultiNumericalInputs.h"

//extern UndoManager_cls GCUndoList;

#include <wx/wx.h>
#include <wx/stopwatch.h>
#include <fstream>
#include <string>

#define _TIME_CTRL_CURRENT -1

#define _TIME_CTRL_PLAY_TEX    0
#define _TIME_CTRL_PLAY_MEM_XY 1
#define _TIME_CTRL_PLAY_MEM_Z  2
#define _TIME_CTRL_PLAY_FULL   3

class ParamGUICtrl_cls;
class PlayCtrlGUI_cls;
class TimeCtrl_cls;
class TimeCtrlGUI_cls;
class TimeCtrlGUIAA_cls;
class TimeCtrlGUIAtoi_cls;
class TimeCtrlGUIButtons_cls;
class TimeCtrlGUITics_cls;
class TimeCtrlGUIZoom_cls;
class Main_cls;
class ParamGroup_cls;
//class BitmapPanel_cls;

class MotionBlurCtrl_cls{
public:
    MotionBlurCtrl_cls(TimeCtrl_cls *pCTimeCtrl);

    TimeCtrl_cls *mpCTimeCtrlLink;

    bool         mbUseMotionBlur;
    int          mBlurStep;   // ݂̃[Vu[Xebv
    float        mBlurLength;
    int          mBlurQuality;
    
    void   BeginMotionBlur(int direction);
    void   EndMotionBlur();
    bool   Increment(int direction);
    bool   IsInitBluring();
    bool   IsLastBluring();
    bool   IsOutputConditionOK();
    double GetFactor();
    float  GetAlpha();
};

class TimeCtrl_cls{
 public:
    TimeCtrl_cls(Main_cls *pCMain);
    ~TimeCtrl_cls();
    void InstantiateGUIA(wxWindow *pCParent);
    void InstantiateGUIB(wxWindow *pCParent);

    Main_cls *mpCMainLink;
    wxStopWatch mCStopWatchA; // SW for animation
    wxStopWatch mCStopWatchWait; // SW for Wait
    long mClockLastDraw, mWaitDuration;
    bool mbModeShy;
    bool mbPlayTex;
    bool mbUseCustomWA;
    int  mCustomWAMin;
    int  mCustomWAMax;
    int  mPlayMode;
    int  mPlayDirection;
    int  mPrefetchRange;

    std::vector < bool > mVbSnippingTag;
    
    //static DF3SeqGUI_cls *mspCDF3SeqGUI;
    //static DF3SeqCtrl_cls *mspCDF3SeqCtrlLink;
    ParamGroup_cls         *mpCTimeRemap;

    //   wxBitmap mCBitmapExpandPlus;
    //wxBitmap mCBitmapExpandMinus;
    //BitmapPanel_cls        *mpCBtnExpandPlus;
    //BitmapPanel_cls        *mpCBtnExpandMinus;
    
    TimeCtrlGUI_cls        *mpCGUI;
    TimeCtrlGUIAA_cls      *mpCGUIAA;
    TimeCtrlGUIAtoi_cls    *mpCGUIAtoi;
    TimeCtrlGUIButtons_cls *mpCGUIButtons;
    TimeCtrlGUIZoom_cls    *mpCGUIZoom;
    TimeCtrlGUITics_cls    *mpCGUITics;
    PlayCtrlGUI_cls        *mpCGUIPlay;

    ParamGUICtrl_cls    *mpCParamGUICtrlLink;
    
    int          mFrame;      // ݂̃t[
    int          mInterpStep; // ݂̕ԃXebv
    MotionBlurCtrl_cls  mCBlurCtrl;
    
    unsigned int mCustomRegionMin, mCustomRegionMax; //JX^Đ͈

    bool mbUndoGroupOpened;
    void BeginMotionBlur();
    void HideAndShowRemap();
    void SetValueCommand(int target, int valueNew, int valueOld);
    void MoveFrameCommand(int dframe);
    void MoveInterpStepCommand(int dstep);
    void MoveFrameCommandLarge(int dframe);
    void MoveFrameCommandSnip(int direction);
    void SetFrameCommand(int frame, int frameAtClick = _TIME_CTRL_CURRENT);
    void SetFrameFromDoubleCommand(double doubleIndex);
    void SetInterpStepCommand(int step);
    void SetWAMinCommand(int min,   int minAtClick = _TIME_CTRL_CURRENT);
    void SetWAMaxCommand(int max,   int maxAtClick = _TIME_CTRL_CURRENT);
    void SetAAMinCommand(int min,   int minAtClick = _TIME_CTRL_CURRENT);
    void SetAAMaxCommand(int max,   int maxAtClick = _TIME_CTRL_CURRENT);
    void SetRepeatCommand(int repeat, int repeatPrev);
    void SetAnimStepCommand(int animStep, int animStepPrev);
    void SetAnimInterpCommand(int animInterpStep, int animInterpPrev);
    void SetPrefetchCommand(int prefetch, int prefetchPrev);
    void SetMaxFrameCommand(int maxFrame);
    void ExpandAACommand(bool bExpand);
    
    void SetFrameNative(int frame, int updateBit = _COMMAND_UPDATE_DISPLAY_GL | _COMMAND_UPDATE_DISPLAY_TL | _COMMAND_UPDATE_DISPLAY_SB);
    void SetInterpStepNative(int step, int updateBit = _COMMAND_UPDATE_DISPLAY_GL | _COMMAND_UPDATE_DISPLAY_TL);
    void SetWAMinNative (int min);
    void SetWAMaxNative (int max);
    void SetAAMinNative (int min);
    void SetAAMaxNative (int max);
    void SetRepeatNative(int repeat);
    void SetAnimStepNative(int animStep);
    void SetAnimInterpNative(int animInterp);
    void SetPrefetchNative(int prefetch);
    void SetMaxFrameNative(int maxFrame);

    void CheckAfterMaxFrameChange();

    ConfItemList_cls mCConfListTime;
    ConfItemUINT_cls mCMaxFrame; // Ō̃Xebv܂
    ConfItemUINT_cls mCWAMin;
    ConfItemUINT_cls mCWAMax; // Ō̃Xebv܂
    ConfItemUINT_cls mCAAMin;
    ConfItemUINT_cls mCAAMax; // Ō̃Xebv܂

    ConfItemBOOL_cls mCbUseTimeRemap;
    ConfItemBOOL_cls mCbUseMotionBlur;
    ConfItemINT_cls  mCAnimStep;
    ConfItemINT_cls  mCAnimInterp;
    ConfItemBOOL_cls mCbRepeat;

    ConfItemUINT_cls mCSceneLengthType;

    void RefreshGUI();


    void SetWorkingArea(int maxIndex);
    void CheckWorkingArea();

    void RemapParameterKeys(double rate);
    void SetBUseTimeRemap(bool bUse);

    int    GetExpectedPrefetchMax();
    unsigned int GetRemappedIndex(int frame = _TIME_CTRL_CURRENT);
    double GetRemappedIndexDouble(int frame = _TIME_CTRL_CURRENT, 
				  int step  = _TIME_CTRL_CURRENT);
    double GetRemappedInterpStepDouble(int frame = _TIME_CTRL_CURRENT,
				       int step = _TIME_CTRL_CURRENT);
    static int GetInterval(int frameNumber = _TIME_CTRL_CURRENT);
    double GetDoubleIndex(int frame = _TIME_CTRL_CURRENT, double step = 0);
    double GetDoubleIndexWAMin();
    double GetDoubleIndexWAMax();
    double GetDoubleIndexAAMin();
    double GetDoubleIndexAAMax();
    
    int GetOffsetForImgSeq(int frame = -1, int step = -1);
    int RoundFrame(int frame);
    void AdjustFrameByRange(int *frame, 
			    int *interpStep,
			    int increment,
			    bool bForceWA = TRUE, 
			    bool bCheckRepeat = TRUE);
    unsigned int CalcNextFrame(int frame, int increment, 
			       bool bForceWA = TRUE, 
			       bool bCheckRepeat = TRUE);
    int  CalcNextStep(int step, int increment);
    void CalcNextFrameFromStep(int *pFrame, int *pStep, 
			       bool bForceWA = TRUE, bool bCheckRepeat = TRUE);
				       
    unsigned int GetIndexFromDouble(double doubleIndex);

    bool IsTheFrameReady         (int frame, bool bUseInterpolate);
    bool IsTheFrameLoaded        (int frame);
    bool IsWorkingArea           (int frame);
    bool IsPlayConditionSatisfied(int frame);
    void SetIndexWithinWA();
    /*
    void SetMaxFrame(unsigned int maxFrame);
    void CheckAfterMaxFrameChange();
    */
    bool OpenCustomRegionDialog(wxWindow *pC);

    void EmptySnippingTag();
    void UpdateSnippingTag();
    int  GetSnipNext();
    int  GetSnipPrev();
    void SetWAInHere();
    void SetWAOutHere();
    
    void SetIndex(unsigned int index);
    
    void StartPlayCommand(int direction);
    void StartPlay(int direction);
    void StopAnimationAt(int frame);
    void ProcStopPlaying();
    bool ProcPlaying();

    // ---

    wxString Serialize();
    void ReadStrLine(std::wistream &istream, wxString strLine);
};

#endif
