
#ifndef _UNDO_COMMAND_FILTER_PARAM_H_
#define _UNDO_COMMAND_FILTER_PARAM_H_

#include "clsUndoManager.h"

#define _COMMAND_FILTER_FLOAT        0
#define _COMMAND_FILTER_DOUBLE       1
#define _COMMAND_FILTER_INT          2
#define _COMMAND_FILTER_UNSIGNED_INT 3

#define _COMMAND_FILTER_STRING       10

#include <wx/wx.h>

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class FilterCtrl_cls;

class CommandFilterValue_cls : public CommandItem_cls {
 public:
    CommandFilterValue_cls(FilterCtrl_cls *pCTgt, wxString strTag, float value, int updateBit = 0);
    CommandFilterValue_cls(FilterCtrl_cls *pCTgt, wxString strTag, double value, int updateBit = 0);
    CommandFilterValue_cls(FilterCtrl_cls *pCTgt, wxString strTag, unsigned int value, int updateBit = 0);
    CommandFilterValue_cls(FilterCtrl_cls *pCTgt, wxString strTag, int value, int updateBit = 0);
    CommandFilterValue_cls(FilterCtrl_cls *pCTgt, wxString strTag, wxString value, int updateBit = 0);

    FilterCtrl_cls *mpCTgt;
    wxString mstrTag;
    int      mType;
        
    float mValueFloat;
    double mValueDouble;
    unsigned int mValueUnsignedInt;
    int   mValueInt;
    wxString mValueString;

    void Execute(bool bFlag = _COMMAND_REDO);
};

class CommandFilterParamInit_cls : public CommandItem_cls {
 public:
    CommandFilterParamInit_cls(FilterCtrl_cls *pCTgt, wxString strTagFilter, wxString strTagParam, int dimension, double *pValue, int updateBit = 0);
    ~CommandFilterParamInit_cls();
    
    FilterCtrl_cls *mpCTgt;
    wxString mstrTagFilter;
    wxString mstrTagParam;
    int      mDimension;
    double   *mpValue;
    
    void Execute(bool bFlag = _COMMAND_REDO);
};

#endif
