// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsFontProvider.h"

#include "clsFontProvider.h"

#include <wx/textfile.h>

FontFile_cls::
FontFile_cls(wxString strFontName, wxString strFontFile, 
	     wxString strFontFileBold, wxString strFontFileItalic,
	     wxString strFontFileBoldItalic){
    mstrFontName = strFontName;
    mstrFontFile = strFontFile;
    mstrFontFileBold = strFontFileBold;
    mstrFontFileItalic = strFontFileItalic;
    mstrFontFileBoldItalic = strFontFileBoldItalic;
}

wxString FontFile_cls::
GetStrFile(wxString strFontName, bool bBold, bool bItalic){
    wxString strFontFile;
    if (strFontName.IsSameAs(mstrFontName) == FALSE) return strFontFile;
    if (bBold == TRUE && bItalic == TRUE){
	strFontFile = mstrFontFileBoldItalic;
	if (strFontFile.IsEmpty() == TRUE) bItalic = FALSE;
	else return strFontFile;
    }
    if (bBold == TRUE){
	strFontFile = mstrFontFileBold;
	if (strFontFile.IsEmpty() == TRUE) bBold = FALSE;
	else return strFontFile;
    }
    if (bItalic == TRUE){
	strFontFile = mstrFontFileItalic;
	if (strFontFile.IsEmpty() == TRUE) bItalic = FALSE;
	else return strFontFile;
    }
    return mstrFontFile;
}

// -----

void FontProvider_cls::
InitializeStatic(){

    wxScreenDC dc;
    msDDIX = dc.GetPPI().GetWidth();

#ifdef WIN32
    msACFont[0] = wxFont(9 * 96 / msDDIX, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, FALSE, wxT("CI"));
    msACFont[1] = wxFont(12 * 96 / msDDIX, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, FALSE, wxT("CI"));
    msACFont[2] = wxFont(9 * 96 / msDDIX, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, FALSE);
    msACFont[3] = wxFont(12 * 96 / msDDIX, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, FALSE);
    msACFont[4] = wxFont(16 * 96 / msDDIX, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, FALSE, wxT("CI"));
    msACFont[5] = wxFont(24 * 96 / msDDIX, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, FALSE, wxT("CI"));
#else
    msACFont[0] = wxFont(9 * 96 / msDDIX, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, FALSE);
    msACFont[1] = wxFont(12 * 96 / msDDIX, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, FALSE);
    msACFont[2] = wxFont(9 * 96 / msDDIX, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, FALSE);
    msACFont[3] = wxFont(12 * 96 / msDDIX, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, FALSE);
    msACFont[4] = wxFont(16 * 96 / msDDIX, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, FALSE);
    msACFont[5] = wxFont(24 * 96 / msDDIX, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, FALSE);
#endif
    
    wxString strFile = wxT("Resource/FontList.txt");

    wxTextFile CFile(strFile);
    CFile.Open(wxConvFile);
    for (wxString str = CFile.GetFirstLine(); !CFile.Eof();
	 str = CFile.GetNextLine() ){
	int pos;
	pos  = str.Find(wxT(','));
	wxString strFontName = str.Mid(0,pos).Trim(TRUE).Trim(FALSE);
	str.Remove(0, pos+1);
	pos  = str.Find(wxT(','));
	wxString strFontFile = str.Mid(0,pos).Trim(TRUE).Trim(FALSE);
	str.Remove(0, pos+1);
	pos  = str.Find(wxT(','));
	wxString strFontFileBold = str.Mid(0,pos).Trim(TRUE).Trim(FALSE);
	str.Remove(0, pos+1);
	pos  = str.Find(wxT(','));
	wxString strFontFileItalic = str.Mid(0,pos).Trim(TRUE).Trim(FALSE);
	str.Remove(0, pos+1);
	wxString strFontFileBoldItalic = str.Trim(TRUE).Trim(FALSE);
	msVCFontFile.push_back
	    (FontFile_cls(strFontName, strFontFile, strFontFileBold, strFontFileItalic, strFontFileBoldItalic));
    }
}

wxFont& FontProvider_cls::
GetFont(int type){
    return msACFont[type];
}

int FontProvider_cls::
GetScrollBarWidth(){
    if (msDDIX <= 96) return 17;
    return 21;
}

wxString FontProvider_cls::
GetFontFileFromList(wxString strFont, bool bBold, bool bItalic){
    int size = msVCFontFile.size();
    for (int i = 0; i < size; i++){
	wxString strFile = msVCFontFile[i].GetStrFile(strFont, bBold, bItalic);
	if (strFile.IsEmpty() == FALSE) return strFile;
    }
    if (size == 0) return wxEmptyString;
    return msVCFontFile[0].mstrFontFile;
}

wxFont FontProvider_cls::msACFont[6];
int FontProvider_cls::msDDIX;

std::vector < FontFile_cls > FontProvider_cls::msVCFontFile;
