// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsMain.cpp"

#include "myArtProv.h"

#define SETITEM(a,b) SetListItem(wxT(a), wxT(b));

MyArtProvider::
MyArtProvider(){
    SETITEM("wxART_PLAY",          "Play.png");
    SETITEM("wxART_PLAY_BACK",     "PlayBack.png");
    SETITEM("wxART_STEP_FORWARD",  "StepForward.png");
    SETITEM("wxART_STEP_BACKWARD", "StepBackward.png");
    SETITEM("wxART_STARTPOINT",    "StartPoint2.png");
    SETITEM("wxART_ENDPOINT",      "EndPoint2.png");
    SETITEM("wxART_LEFT",          "left.png");
    SETITEM("wxART_LEFT_DISABLED", "leftDisabled.png");
    SETITEM("wxART_LEFT_HOVER",    "leftHover.png");
    SETITEM("wxART_RIGHT",         "right.png");
    SETITEM("wxART_RIGHT_DISABLED","rightDisabled.png");
    SETITEM("wxART_RIGHT_HOVER",   "rightHover.png");
    SETITEM("wxART_EXPAND_PLUS",   "ZoomOut.png");
    SETITEM("wxART_EXPAND_MINUS",  "ZoomIm.png");
    SETITEM("wxART_GRAPH_P",       "GraphP.png");
    SETITEM("wxART_GRAPH_N",       "GraphN.png");

    SETITEM("wxART_OPEN_FOLDER",  "open.png");
    SETITEM("wxART_CLOSE_FOLDER", "close.png");
    SETITEM("wxART_LINKED",       "Linked.png");
    SETITEM("wxART_UNLINKED",     "UnLinked.png");
    SETITEM("wxART_KILROY_HERE",  "KilroyHere.png");
    SETITEM("wxART_KILROY_THERE", "KilroyThere.png");
    SETITEM("wxART_ZOOM_IN", "ZoomIn.png");
    SETITEM("wxART_ZOOM_OUT", "ZoomOut.png");

    SETITEM("wxART_LEFT",         "left.png");
    SETITEM("wxART_LEFT_DISABLED","leftDisabled.png");
    SETITEM("wxART_LEFT_HOVER",   "leftHover.png");
    SETITEM("wxART_RIGHT",        "right.png");
    SETITEM("wxART_RIGHT_DISABLED","rightDisabled.png");
    SETITEM("wxART_RIGHT_HOVER",  "rightHover.png");

    SETITEM("wxART_TIME_P",       "timeP.png");
    SETITEM("wxART_TIME_N",       "timeN.png");
    SETITEM("wxART_TIME_D",       "timeD.png");
    SETITEM("wxART_EYE_P",        "eyeP.png");
    SETITEM("wxART_EYE_N",        "eyeN.png");

    SETITEM("wxART_CAMERA",       "Camera.png");
    SETITEM("wxART_LIGHT",        "LightSource.png");
    SETITEM("wxART_SPOTLIGHT",    "SpotLight.png");
    SETITEM("wxART_STEREOGRAM",   "StereoGram.png");
    SETITEM("wxART_COLOR",        "Color.png");
    SETITEM("wxART_PREFERENCE",   "Preference.png");
    SETITEM("wxART_POVRAY",       "PovRay.png");
    SETITEM("wxART_SCENE",        "Scene.png");
    SETITEM("wxART_TEXTURE",      "Texture.png");
    SETITEM("wxART_PERIODIC",     "PeriodicBoundary.png");

    SETITEM("wxART_MESSAGE_ON",   "MessageOn.png");
    SETITEM("wxART_MESSAGE_OFF",  "MessageOff.png");
    SETITEM("wxART_ITEM_ON",      "ItemOn.png");
    SETITEM("wxART_ITEM_OFF",     "ItemOff.png");
    SETITEM("wxART_GRID_ON",      "GridOn.png");
    SETITEM("wxART_GRID_OFF",     "GridOff.png");
    SETITEM("wxART_NAVIGATOR_ON", "NavigatorOn.png");
    SETITEM("wxART_NAVIGATOR_OFF","NavigatorOff.png");
    SETITEM("wxART_DATA_ON",      "DataOn.png");
    SETITEM("wxART_DATA_OFF",     "DataOff.png");

    SETITEM("wxART_SPLIT_V",      "splitV.png");
    SETITEM("wxART_SPLIT_H",      "splitH.png");
    SETITEM("wxART_SPLIT_4",      "split4.png");
}

void MyArtProvider::
SetListItem(wxString strID, wxString strFile){
    mVstrBtnIDList .push_back(strID);
    mVstrBtnImgList.push_back(strFile);
}

wxBitmap MyArtProvider::
CreateBitmap(const wxArtID& id,
	     const wxArtClient& client,
	     const wxSize& size){

    wxString strDir = wxT("ICONS/");
    for (unsigned int i = 0; i < mVstrBtnIDList.size(); i++){
	if (id == mVstrBtnIDList[i]){
	    wxImage CImg(strDir + mVstrBtnImgList[i], wxBITMAP_TYPE_PNG);
	    wxSize CSize(CImg.GetWidth(), CImg.GetHeight());
	    if (size != wxDefaultSize && CSize != size){
		wxImage CImgSmall = GetSmallImageLinear(CImg, size);
		return wxBitmap(CImgSmall);
	    }
	    return wxBitmap(CImg);
	    //return wxBitmap(strDir + mVstrBtnImgList[i], wxBITMAP_TYPE_PNG);
	}
    }
    
    return wxNullBitmap;
}

int MyArtProvider::
floor(float value){
    float valueNew = value;
    if (value < 0) valueNew *= -1;
    int floor = (int)valueNew;
    if (value < 0) floor = - floor - 1;
    return floor;
}

float MyArtProvider::
GetAverageRed(wxImage &CImage, float fX0, float fY0, float fX1, float fY1){
    float areaSum = 0;
    float valueSum = 0;
    for (float fY = fY0; fY < fY1; fY++){
	float fYMax = (float)floor(fY)+1;
	if (fYMax > fY1) fYMax = fY1;
	float areaDimY = fYMax - fY;
	int iY = (int)fY;
	if (iY >= 0 && iY < CImage.GetHeight())
	    for (float fX = fX0; fX < fX1; fX++){
		float fXMax = (float)floor(fX)+1;
		if (fXMax > fX1) fXMax = fX1;
		float areaDimX = fXMax - fX;
		int iX = (int)fX;
		areaSum += areaDimX*areaDimY;
		valueSum += areaDimX*areaDimY * CImage.GetRed(iX, iY);
	    }
	else
	    areaSum += areaDimY * (fX1 - fX0);
    }
    return valueSum / areaSum;
}

float MyArtProvider::
GetAverageGreen(wxImage &CImage, float fX0, float fY0, float fX1, float fY1){
    float areaSum = 0;
    float valueSum = 0;
    for (float fY = fY0; fY < fY1; fY++){
	float fYMax = (float)floor(fY)+1;
	if (fYMax > fY1) fYMax = fY1;
	float areaDimY = fYMax - fY;
	int iY = (int)fY;
	if (iY >= 0 && iY < CImage.GetHeight())
	    for (float fX = fX0; fX < fX1; fX++){
		float fXMax = (float)floor(fX)+1;
		if (fXMax > fX1) fXMax = fX1;
		float areaDimX = fXMax - fX;
		int iX = (int)fX;
		areaSum += areaDimX*areaDimY;
		valueSum += areaDimX*areaDimY * CImage.GetGreen(iX, iY);
	    }
	else
	    areaSum += areaDimY * (fX1 - fX0);
    }
    return valueSum / areaSum;
}

float MyArtProvider::
GetAverageBlue(wxImage &CImage, float fX0, float fY0, float fX1, float fY1){
    float areaSum = 0;
    float valueSum = 0;
    for (float fY = fY0; fY < fY1; fY++){
	float fYMax = (float)floor(fY)+1;
	if (fYMax > fY1) fYMax = fY1;
	float areaDimY = fYMax - fY;
	int iY = (int)fY;
	if (iY >= 0 && iY < CImage.GetHeight())
	    for (float fX = fX0; fX < fX1; fX++){
		float fXMax = (float)floor(fX)+1;
		if (fXMax > fX1) fXMax = fX1;
		float areaDimX = fXMax - fX;
		int iX = (int)fX;
		areaSum += areaDimX*areaDimY;
		valueSum += areaDimX*areaDimY * CImage.GetBlue(iX, iY);
	    }
	else
	    areaSum += areaDimY * (fX1 - fX0);
    }
    return valueSum / areaSum;
}

float MyArtProvider::
GetAverageAlpha(wxImage &CImage, float fX0, float fY0, float fX1, float fY1){
    float areaSum = 0;
    float valueSum = 0;
    for (float fY = fY0; fY < fY1; fY++){
	float fYMax = (float)floor(fY)+1;
	if (fYMax > fY1) fYMax = fY1;
	float areaDimY = fYMax - fY;
	int iY = (int)fY;
	if (iY >= 0 && iY < CImage.GetHeight())
	    for (float fX = fX0; fX < fX1; fX++){
		float fXMax = (float)floor(fX)+1;
		if (fXMax > fX1) fXMax = fX1;
		float areaDimX = fXMax - fX;
		int iX = (int)fX;
		areaSum += areaDimX*areaDimY;
		valueSum += areaDimX*areaDimY * CImage.GetAlpha(iX, iY);
	    }
	else
	    areaSum += areaDimY * (fX1 - fX0);
    }
    return valueSum / areaSum;
}

void MyArtProvider::
ConvertMaskToAlpha(wxImage& CImg){
    int width  = CImg.GetWidth();
    int height = CImg.GetHeight();
    
    if (CImg.HasMask() == TRUE){

	if (CImg.HasAlpha() == TRUE){
	    printf("!!");
	}

	unsigned char mr = CImg.GetMaskRed();
	unsigned char mg = CImg.GetMaskGreen();
	unsigned char mb = CImg.GetMaskBlue();

	unsigned char *pAlpha = new unsigned char [width * height];
	for (int y = 0; y < height; y++){
	    int indexy = y * width;
	    for (int x = 0; x < width; x++){
		int index = indexy + x;
		if (CImg.GetRed(x,y) == mr && 
		    CImg.GetGreen(x,y) == mg &&
		    CImg.GetBlue(x,y) == mb)
		    pAlpha[index] = 0;
		else
		    pAlpha[index] = 255;
		
	    }
	}
	CImg.SetAlpha(pAlpha);
	CImg.SetMask(FALSE);
    }
}

wxImage MyArtProvider::
GetSmallImageLinear(wxImage &CImage, wxSize sizeNew){
    ConvertMaskToAlpha(CImage);

    int widthNew  = sizeNew.GetWidth();
    int heightNew = sizeNew.GetHeight();
    float aspectNew = (float)widthNew/heightNew;

    int widthOrg = CImage.GetWidth();
    int heightOrg = CImage.GetHeight();
    float aspectOrg = (float)widthOrg/heightOrg;
    
    float factorY = aspectNew / aspectOrg;
    
    unsigned char *pData = (unsigned char*)malloc(3*widthNew*heightNew);
    unsigned char *pAlpha = NULL;

    for (int iY = 0; iY < heightNew; iY++){
	float fY0 = (((float)(iY+0)/heightNew-0.5)*factorY + 0.5) * heightOrg;
	float fY1 = (((float)(iY+1)/heightNew-0.5)*factorY + 0.5) * heightOrg;
	int indexy = iY*widthNew;
	for (int iX = 0; iX < widthNew; iX++){
	    float fX0 = (float)(iX+0)/widthNew * widthOrg;
	    float fX1 = (float)(iX+1)/widthNew * widthOrg;
	    int index = indexy + iX;
	    
	    float fR = GetAverageRed  (CImage, fX0, fY0, fX1, fY1);
	    float fG = GetAverageGreen(CImage, fX0, fY0, fX1, fY1);
	    float fB = GetAverageBlue (CImage, fX0, fY0, fX1, fY1);

	    pData[index*3+0] = (unsigned char)fR;
	    pData[index*3+1] = (unsigned char)fG;
	    pData[index*3+2] = (unsigned char)fB;
	}
    }

    if (CImage.HasAlpha() == TRUE){
	pAlpha = (unsigned char*)malloc(widthNew*heightNew);
	for (int iY = 0; iY < heightNew; iY++){
	    float fY0 = (((float)(iY+0)/heightNew-0.5)*factorY + 0.5)*heightOrg;
	    float fY1 = (((float)(iY+1)/heightNew-0.5)*factorY + 0.5)*heightOrg;
	    int indexy = iY*widthNew;
	    for (int iX = 0; iX < widthNew; iX++){
		float fX0 = (float)(iX+0)/widthNew * widthOrg;
		float fX1 = (float)(iX+1)/widthNew * widthOrg;
		int index = indexy + iX;
		float fA = GetAverageAlpha(CImage, fX0, fY0, fX1, fY1);
		pAlpha[index] = fA;
	    }
	}
    }

    wxImage CImgSmall(widthNew, heightNew, pData, pAlpha);
    return CImgSmall;
}
