// -*- c -*- 
// (setq c-basic-offset 4)
// "clsAtoiTextCtrl.h"

#include "clsSliderInt.h"

SliderInt_cls::
SliderInt_cls(wxWindow *parent, wxWindowID id, int initvalue,
	      int min, int max, 
	      wxPoint pos, wxSize size) 
: wxSliderEX(parent, id, initvalue, min, max, pos, size)
{
    //SetBackgroundColour(wxColour(wxT("WHEAT")));

    //mValue = initvalue;
    mMin = min;
    mMax = max;
    mbTracking = FALSE;
    
    SetPageSize(1);
    
    Connect(GetId(), wxEVT_SCROLL_CHANGED,
	    wxCommandEventHandler(SliderInt_cls::OnScrollChanged));
    Connect(GetId(), wxEVT_SCROLL_THUMBTRACK,
	    wxCommandEventHandler(SliderInt_cls::OnScrollThumbTrack));
    Connect(GetId(), wxEVT_SCROLL_THUMBRELEASE,
	    wxCommandEventHandler(SliderInt_cls::OnScrollThumbRelease));
}

void SliderInt_cls::
UpdateValueFromSlider(){
    int value = GetValue();
    if (!(mMin == 0 && mMax == 0)){
	if (value < mMin) value = mMin;
	if (value > mMax) value = mMax;
	SetValue(value);
    }
}

void SliderInt_cls::
SetRangeSliderWrapperInt(int min, int max){
    mMin = min; mMax = max;
}


void SliderInt_cls::
SetValueInt(int value){
    SetValue(value);
}

void SliderInt_cls::
OnScrollChanged(wxCommandEvent& event){
    UpdateValueFromSlider();
    event.Skip();
    GetParent()->AddPendingEvent(event);
}

void SliderInt_cls::
OnScrollThumbTrack(wxCommandEvent& event){
    if (mbTracking == FALSE)
	GCUndoList.OpenBlock();
    mbTracking = TRUE;

    UpdateValueFromSlider();
    event.Skip();
    //GetParent()->AddPendingEvent(event);
}

void SliderInt_cls::
OnScrollThumbRelease(wxCommandEvent& event){
    event.Skip();

    GCUndoList.CloseBlock();
    mbTracking = FALSE;
}

/* Increment, Decrement$B%\%?%s$rIU$1$h$&$H$7$?$H$-$NL>;D$GK\BN$,(BwxPanel$B!'(B
   $B8=>u$O!"?tCMF~NOB&$N%9%T%s%3%s%H%m!<%k$G9T$C$F$$$k(B
SliderInt_cls::
SliderInt_cls(wxWindow *parent, wxWindowID id, int initvalue,
	      int min, int max, 
	      wxPoint pos, wxSize size) 
    : wxPanel(parent, id, pos, size)
{
    SetBackgroundColour(wxColour(wxT("WHEAT")));

    mValue = initvalue;
    mMin = min;
    mMax = max;
    
    wxBoxSizer       *pBoxSizerSrc   = new wxBoxSizer(wxHORIZONTAL);
    
    mpCSlider = new wxSliderEX(this, wxID_ANY, initvalue, min, max,
			       pos, size);
    mpCSlider->SetPageSize(1);
    
    pBoxSizerSrc->Add(mpCSlider, 1, wxEXPAND);

    Connect(mpCSlider->GetId(), wxEVT_SCROLL_CHANGED,
	    wxCommandEventHandler(SliderInt_cls::OnScrollChanged));

    Connect(mpCSlider->GetId(), wxEVT_SCROLL_THUMBTRACK,
	    wxCommandEventHandler(SliderInt_cls::OnScrollThumb));

    Connect(mpCSlider->GetId(), wxEVT_KEY_DOWN,
	    wxKeyEventHandler(SliderInt_cls::OnKeyDown));

    SetSizerAndFit(pBoxSizerSrc);
}

void SliderInt_cls::
UpdateValueFromSlider(){
    mValue = mpCSlider->GetValue();
    if (!(mMin == 0 && mMax == 0)){
	if (mValue < mMin) mValue = mMin;
	if (mValue > mMax) mValue = mMax;
	UpdateDisplay();
    }
}

void SliderInt_cls::
SetRange(int min, int max){
    mMin = min; mMax = max;
}

void SliderInt_cls::
UpdateDisplay(){
    mpCSlider->SetValue(mValue);
}

void SliderInt_cls::
SetValueInt(int value){
    mValue = value;
    UpdateDisplay();
}

void SliderInt_cls::
OnScrollChanged(wxCommandEvent& event){
    UpdateValueFromSlider();
    event.Skip();
    event.SetId(GetId()); // panel $B$N%$%Y%s%H$H$9$k(B
    GetParent()->AddPendingEvent(event);
}

void SliderInt_cls::
OnScrollThumb(wxCommandEvent& event){
    UpdateValueFromSlider();
    event.Skip();
    event.SetId(GetId()); // panel $B$N%$%Y%s%H$H$9$k(B
    GetParent()->AddPendingEvent(event);
}

void SliderInt_cls::
OnKeyDown(wxKeyEvent& event){
    if (event.GetModifiers() == wxMOD_NONE || event.GetKeyCode() == WXK_TAB)
	event.Skip();
    if (event.GetKeyCode() != WXK_TAB)
	wxPostEvent(GetParent()->GetEventHandler(), event);
}
*/
